/*! twilio-conversations.js 0.13.6

The following license applies to all parts of this software except as
documented below.

    Copyright (c) 2015, Twilio, inc.
    All rights reserved.

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions are
    met:

      1. Redistributions of source code must retain the above copyright
         notice, this list of conditions and the following disclaimer.

      2. Redistributions in binary form must reproduce the above copyright
         notice, this list of conditions and the following disclaimer in
         the documentation and/or other materials provided with the
         distribution.

      3. Neither the name of Twilio nor the names of its contributors may
         be used to endorse or promote products derived from this software
         without specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
    HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This software includes SIP.js under the following license.

    Copyright (c) 2014 Junction Networks, Inc. <http://www.onsip.com>

    License: The MIT License

    Permission is hereby granted, free of charge, to any person obtaining
    a copy of this software and associated documentation files (the
    "Software"), to deal in the Software without restriction, including
    without limitation the rights to use, copy, modify, merge, publish,
    distribute, sublicense, and/or sell copies of the Software, and to
    permit persons to whom the Software is furnished to do so, subject to
    the following conditions:

    The above copyright notice and this permission notice shall be
    included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
    LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
    OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
    WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

SIP.js contains substantial portions of the JsSIP software under the following
license.

    Copyright (c) 2012-2013 José Luis Millán - Versatica <http://www.versatica.com>

    License: The MIT License

    Permission is hereby granted, free of charge, to any person obtaining
    a copy of this software and associated documentation files (the
    "Software"), to deal in the Software without restriction, including
    without limitation the rights to use, copy, modify, merge, publish,
    distribute, sublicense, and/or sell copies of the Software, and to
    permit persons to whom the Software is furnished to do so, subject to
    the following conditions:

    The above copyright notice and this permission notice shall be
    included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
    LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
    OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
    WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

 */
!function(e){var t=function(){var e=1,t=function i(e,t,n){function r(o,a){if(!t[o]){if(!e[o]){var c="function"==typeof require&&require;if(!a&&c)return c(o,!0);if(s)return s(o,!0);var u=new Error("Cannot find module '"+o+"'");throw u.code="MODULE_NOT_FOUND",u}var l=t[o]={exports:{}};e[o][0].call(l.exports,function(t){var i=e[o][1][t];return r(i?i:t)},l,l.exports,i,e,t,n)}return t[o].exports}for(var s="function"==typeof require&&require,o=0;o<n.length;o++)r(n[o]);return r}({1:[function(e,t,i){"use strict";function n(e,t){return new n.Client(e,t)}var r=e("../package").version;Object.defineProperties(n,{Client:{enumerable:!0,value:e("./client")},getUserMedia:{enumerable:!0,value:e("./webrtc/getusermedia")},LocalMedia:{enumerable:!0,value:e("./media/localmedia")},version:{enumerable:!0,value:r}}),t.exports=n},{"../package":106,"./client":2,"./media/localmedia":6,"./webrtc/getusermedia":57}],2:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);"string"==typeof e&&(e=new u(e)),d.call(this),t=T.withDefaults(t,{logLevel:l.DEFAULT_LOG_LEVEL,signaling:"v1"});var i;switch(t.signaling){case"v1":i=v;break;case"v2":i=_;break;default:throw"function"==typeof t.signaling&&(i=t.signaling),new Error('Unknown Signaling version "'+t.signaling+'"')}var r=new Map,s=t.logLevel,o=new g("Client",s),c=new i(e,t);Object.defineProperties(this,{_conversations:{value:r},_log:{value:o},_signaling:{value:c},accessManager:{enumerable:!0,value:e},conversations:{enumerable:!0,get:function(){return new Map(r)}},identity:{enumerable:!0,get:function(){return e.identity}},isListening:{enumerable:!0,get:function(){return"listening"===c.state}}}),a(this,c)}function r(e,t,i){var n=new h(i,t);return e._conversations.set(n.sid,n),i.on("stateChanged",function r(){e._conversations["delete"](n.sid),i.removeListener("stateChanged",r)}),n}function s(e,t,i,n,r){return e._signaling.connect(t,i,r,n)}function o(e,t,i){return t.shouldStopLocalMedia=!t.localMedia&&!t.localStream,f.getLocalMedia(t).then(function(e){var n=i(e);return n["catch"](function(){t.shouldStopLocalMedia&&e.stop()}),n})}function a(e,t){t.on("invite",function(t){var i=new p(t,o.bind(null,e),r.bind(null,e),e._options);e.emit("invite",i)})}var c=e("util").inherits,u=e("twilio-common").AccessManager,l=e("./util/constants"),h=e("./conversation"),d=e("events").EventEmitter,p=e("./incominginvite"),f=e("./media/localmedia"),g=e("./util/log"),m=e("./outgoinginvite"),v=e("./signaling/v1"),_=e("./signaling/v2"),T=e("./util");c(n,d),n.prototype.unlisten=function(){return this._signaling.unlisten(),this},n.prototype.listen=function(){var e=this;return this._signaling.listen().then(function(){return e})},n.prototype.inviteToConversation=function(e,t){e=e||[],e=e instanceof Array?e:[e],t=Object.assign({},this._options,t);var i=t.labelOrSid;return new m(e,o.bind(null,this,t),s.bind(null,this,e,i,t),r.bind(null,this,t))},t.exports=n},{"./conversation":3,"./incominginvite":4,"./media/localmedia":6,"./outgoinginvite":13,"./signaling/v1":26,"./signaling/v2":40,"./util":48,"./util/constants":47,"./util/log":49,events:62,"twilio-common":104,util:66}],3:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);o.call(this),t=Object.assign({logLevel:s.DEFAULT_LOG_LEVEL},t);var i=new c("Conversation",t.logLevel),a=new Map;Object.defineProperties(this,{_log:{value:i},_options:{value:t},_participants:{value:a},_signaling:{value:e},localMedia:{enumerable:!0,value:e.localMedia},participants:{enumerable:!0,get:function(){return new Map(a)}},sid:{enumerable:!0,value:e.sid}}),r(this,e)}function r(e,t){t.on("participantConnected",function(t){var i=new u(t);e._participants.set(i.sid,i),e.emit("participantConnected",i);var n=["trackAdded","trackDimensionsChanged","trackDisabled","trackEnabled","trackEnded","trackRemoved","trackStarted"].map(function(t){function n(){var n=[].slice.call(arguments);n.unshift(t),n.push(i),e.emit.apply(e,n)}return i.on(t,n),[t,n]});i.once("disconnected",function(){e._participants["delete"](i.sid),n.forEach(function(e){i.removeListener(e[0],e[1])}),e.emit("participantDisconnected",i)})}),t.on("participantFailed",function(t){var i=new u(t);e.emit("participantFailed",i)}),t.on("stateChanged",function(t){e.emit(t,e),"disconnected"===t&&e._options.shouldStopLocalMedia&&e.localMedia.stop()})}var s=e("./util/constants"),o=e("events").EventEmitter,a=e("util").inherits,c=e("./util/log"),u=e("./participant");a(n,o),n.prototype.disconnect=function(){return this._signaling.disconnect(),this},n.prototype.invite=function(e){var t=e instanceof Array?e:[e];return t.forEach(function(e){this._signaling.invite(e)},this),this},t.exports=n},{"./participant":14,"./util/constants":47,"./util/log":49,events:62,util:66}],4:[function(e,t,i){"use strict";function n(e,t,i,o){return this instanceof n?(s.call(this),o=Object.assign({},o),Object.defineProperties(this,{_createConversation:{value:i},_getLocalMedia:{value:t},_options:{value:o},_signaling:{value:e},conversationSid:{enumerable:!0,value:e.conversationSid},from:{enumerable:!0,value:e.from},participants:{enumerable:!0,value:e.from?[e.from]:[]},participantSid:{enumerable:!0,value:e.participantSid},status:{enumerable:!0,get:function(){return e.state}}}),void r(this,e)):new n(e,t,i)}function r(e,t){t.on("stateChanged",function(t){e.emit(t,e)})}var s=e("events").EventEmitter,o=e("util").inherits;o(n,s),n.prototype.accept=function(e){e=Object.assign({},this._options,e);var t=this;return this._getLocalMedia(e,function(i){return t._signaling.accept(i,e)}).then(function(i){return t._createConversation(e,i)})},n.prototype.reject=function(){return this._signaling.reject(),this},t.exports=n},{events:62,util:66}],5:[function(e,t,i){"use strict";function n(e){r.call(this),e=e||{};var t=new Map,i=new Map,n=new Set,s=new Map,o=new Map;return Object.defineProperties(this,{_AudioTrackFactory:{value:e.AudioTrackFactory||a},_VideoTrackFactory:{value:e.VideoTrackFactory||c},attachments:{enumerable:!0,value:t},audioTracks:{enumerable:!0,value:i},isMuted:{enumerable:!0,get:function(){var e=!0;return i.forEach(function(t){e=e&&!t.isEnabled}),e}},isPaused:{enumerable:!0,get:function(){var e=!0;return o.forEach(function(t){e=e&&!t.isEnabled}),e}},mediaStreams:{enumerable:!0,value:n},tracks:{enumerable:!0,value:s},videoTracks:{enumerable:!0,value:o}}),this}var r=e("events").EventEmitter,s=e("util").inherits,o=e("./track"),a=e("./track/audiotrack"),c=e("./track/videotrack"),u=n.TRACK_ADDED="trackAdded",l=n.TRACK_DIMENSIONS_CHANGED="trackDimensionsChanged",h=n.TRACK_DISABLED="trackDisabled",d=n.TRACK_ENABLED="trackEnabled",p=n.TRACK_ENDED="trackEnded",f=n.TRACK_REMOVED="trackRemoved",g=n.TRACK_STARTED="trackStarted";s(n,r),n.prototype._addRemoteStream=function(e){return e.getAudioTracks().forEach(function(t){var i=new this._AudioTrackFactory(e,t);this._addTrack(i)},this),e.getVideoTracks().forEach(function(t){var i=new this._VideoTrackFactory(e,t);this._addTrack(i)},this),this},n.prototype._addRemoteTrack=function(e,t){var i="audio"===e.kind?this._AudioTrackFactory:this._VideoTrackFactory,n=new i(t,e);return this._addTrack(n),n},n.prototype._updateMediaStreams=function(){return this.mediaStreams.clear(),this.tracks.forEach(function(e){this.mediaStreams.add(e.mediaStream)},this),this.mediaStreams},n.prototype._addTrack=function(e){return this.tracks.has(e.id)?this:(this.mediaStreams.add(e.mediaStream),this.tracks.set(e.id,e),this._reemitTrackEvent(e,c.DIMENSIONS_CHANGED,l),this._reemitTrackEvent(e,o.DISABLED,h),this._reemitTrackEvent(e,o.ENABLED,d),this._reemitTrackEvent(e,o.ENDED,p),this._reemitTrackEvent(e,o.STARTED,g),"audio"===e.kind?this.audioTracks.set(e.id,e):this.videoTracks.set(e.id,e),this.emit(u,e),this)},n.prototype._reemitTrackEvent=function(e,t,i){var n=this,r="audio"===e.kind?this.audioTracks:this.videoTracks;return e.on(t,function s(){return r.has(e.id)?void n.emit(i,e):e.removeListener(t,s)}),this},n.prototype._refreshTracks=function(){var e=new Set;return this.mediaStreams.forEach(function(t){t.getTracks().forEach(function(t){e.add(t.id)})}),this.tracks.forEach(function(t){e.has(t.id)||this._removeTrack(t)},this),this.mediaStreams.forEach(this._addRemoteStream,this),this._updateMediaStreams(),this},n.prototype._createTrackElement=function(e){return e.attach()},n.prototype._attachTrack=function(e,t,i){var n=this,r=this._createTrackElement(i);return e.appendChild(r),t.set(i,r),i.once("ended",function(){n._detachTrack(t,i)}),this},n.prototype._detachTrack=function(e,t){var i=e.get(t);return i?(t.detach(i),i.parentNode&&i.parentNode.removeChild(i),e["delete"](t),this):this},n.prototype._removeTrack=function(e){return this.tracks.has(e.id)?(this.tracks["delete"](e.id),("audio"===e.kind?this.audioTracks:this.videoTracks)["delete"](e.id),this._updateMediaStreams(),this.emit(f,e),this):this},n.prototype.attach=function(e){return"string"==typeof e?e=this._selectContainer(e):e||(e=this._createContainer()),this._attach(e)},n.prototype._createContainer=function(){return document.createElement("div")},n.prototype._selectContainer=function(e){var t=document.querySelector(e);if(!t)throw new Error("Selector matched no element: "+e);return t},n.prototype._attach=function(e){if(this.attachments.has(e))return e;var t=new Map,i=this;return this.tracks.forEach(function(n){i._attachTrack(e,t,n)}),this.on(u,function n(r){return i.attachments.has(e)?void i._attachTrack(e,t,r):i.removeListener(u,n)}),this.on(f,function r(n){return i.attachments.has(e)?void i._detachTrack(t,n):i.removeListener(f,r)}),this.attachments.set(e,t),e},n.prototype.detach=function(e){var t;return t="string"==typeof e?[this._selectContainer(e)]:e?[e]:this._getAllAttachedContainers(),this._detachContainers(t),e?t[0]:t},n.prototype._detachContainers=function(e){return e.map(this._detachContainer.bind(this))},n.prototype._detachContainer=function(e){if(!this.attachments.has(e))return e;var t=this.attachments.get(e),i=this;return this.attachments["delete"](e),t.forEach(function(e,n){i._detachTrack(t,n)}),e},n.prototype._getAllAttachedContainers=function(){var e=[];return this.attachments.forEach(function(t,i){e.push(i)}),e},t.exports=n},{"./track":8,"./track/audiotrack":7,"./track/videotrack":12,events:62,util:66}],6:[function(e,t,i){"use strict";function n(){return this instanceof n?(c.call(this),this):new n}var r=e("../webrtc/getusermedia"),s=e("util").inherits,o=e("./track/localaudiotrack"),a=e("./track/localvideotrack"),c=e("./");n.getLocalMedia=function(e){if(e=e||{},e.localMedia)return Promise.resolve(e.localMedia);var t=new n;if(e.localStream)return Promise.resolve(t.addStream(e.localStream));var i=e.localStreamConstraints;return i&&i.audio===!1&&i.video===!1?Promise.resolve(t):r(i).then(function(e){return t.addStream(e)})},s(n,c),n.prototype.addTrack=function(e){return-1===e.mediaStream.getTracks().indexOf(e.mediaStreamTrack)&&e.mediaStream.addTrack(e.mediaStreamTrack),c.prototype._addTrack.apply(this,arguments)},n.prototype.addMicrophone=function(){var e=this,t=null;return this.audioTracks.forEach(function(e){t=t||e}),t?Promise.resolve(t):r({audio:!0,video:!1}).then(function(t){var i=t.getAudioTracks(),n=i[0],r=new o(t,n);return e._addTrack(r),r})},n.prototype.removeMicrophone=function(e){var t=null;return this.audioTracks.forEach(function(e){t=t||e}),t?this.removeTrack(t,e):t},n.prototype.addCamera=function(){var e=this,t=null;return this.videoTracks.forEach(function(e){t=t||e}),t?Promise.resolve(t):r({audio:!1,video:!0}).then(function(t){var i=t.getVideoTracks(),n=i[0],r=new a(t,n);return e._addTrack(r),r})},n.prototype.removeCamera=function(e){var t=null;return this.videoTracks.forEach(function(e){t=t||e}),t?this.removeTrack(t,e):t},n.prototype.addStream=function(e){return e.getAudioTracks().forEach(function(t){var i=new o(e,t);this._addTrack(i)},this),e.getVideoTracks().forEach(function(t){var i=new a(e,t);this._addTrack(i)},this),this},n.prototype.removeStream=function(e,t){return e.getTracks().forEach(function(e){var i=this.tracks.get(e.id);i&&this.removeTrack(i,t)},this),this},n.prototype.removeTrack=function(e,t){try{e.mediaStream.removeTrack(e.mediaStreamTrack)}catch(i){}return c.prototype._removeTrack.call(this,e),("boolean"==typeof t?t:!0)&&e.stop(),e},n.prototype.mute=function(e){return e="boolean"==typeof e?e:!0,this.audioTracks.forEach(function(t){t.enable(!e)}),this},n.prototype.pause=function(e){return e="boolean"==typeof e?e:!0,this.videoTracks.forEach(function(t){t.enable(!e)}),this},n.prototype.stop=function(){return this.tracks.forEach(function(e){e.stop()}),this},n.prototype.unmute=function(){return this.mute(!1)},n.prototype.unpause=function(){return this.pause(!1)},t.exports=n},{"../webrtc/getusermedia":57,"./":5,"./track/localaudiotrack":9,"./track/localvideotrack":11,util:66}],7:[function(e,t,i){"use strict";function n(e,t){s.call(this,e,t)}var r=e("util").inherits,s=e("./");r(n,s),n.prototype.attach=s.prototype.attach,n.prototype.detach=s.prototype.detach,t.exports=n},{"./":8,util:66}],8:[function(e,t,i){"use strict";function n(e,t){r.call(this);var i=!0,n=!1,s=!1;Object.defineProperties(this,{_isEnabled:{get:function(){return i},set:function(e){i=e}},_isEnded:{get:function(){return n},set:function(e){n=e}},_isStarted:{get:function(){return s},set:function(e){s=e}},attachments:{value:new Set},id:{enumerable:!0,value:t.id},isEnabled:{get:function(){return i}},isEnded:{get:function(){return"string"==typeof t.readyState?"ended"===t.readyState:n}},isStarted:{get:function(){return s}},kind:{enumerable:!0,value:t.kind},mediaStream:{enumerable:!0,value:e},mediaStreamTrack:{enumerable:!0,value:t}}),this._initialize()}var r=e("events").EventEmitter,s=e("util").inherits,o=n.DISABLED="disabled",a=n.ENABLED="enabled",c=n.ENDED="ended",u=n.STARTED="started";s(n,r),n.prototype._start=function(e){this._isStarted=!0,this._detachElement(e),e.oncanplay=null,this.emit(u,this)},n.prototype._end=function(e){this._detachElement(e),e.oncanplay=null,this.emit(c,this)},n.prototype._initialize=function(){var e=this._createElement();e.muted=!0,e.oncanplay=this._start.bind(this,e),this.mediaStreamTrack.onended=this._end.bind(this,e),this._attach(e)},n.prototype._enable=function(e){return e="boolean"==typeof e?e:!0,this._isEnabled!==e&&(this._isEnabled=e,this.emit(e?a:o,this)),this},n.prototype.attach=function(e){return"string"==typeof e?e=this._selectElement(e):e||(e=this._createElement()),e=this._attach(e),new Promise(function(t){t(e.play())})["catch"](function(){e.autoplay=!0}),e},n.prototype._attach=function(e){if(this.attachments.has(e))return e;if("undefined"==typeof window||"undefined"==typeof navigator)throw new Error("Can not attach track to page: global.navigator and global.window are required.");if("function"==typeof navigator.webkitGetUserMedia){var t=window.URL||window.webkitURL;e.src=t.createObjectURL(this.mediaStream)}else"function"==typeof navigator.mozGetUserMedia&&(e.mozSrcObject=this.mediaStream);return this.attachments.add(e),e},n.prototype._selectElement=function(e){var t=document.querySelector(e);if(!t)throw new Error("Selector matched no element: "+e);return t},n.prototype._createElement=function(){return document.createElement(this.kind)},n.prototype.detach=function(e){var t;return t="string"==typeof e?[this._selectElement(e)]:e?[e]:this._getAllAttachedElements(),this._detachElements(t),e?t[0]:t},n.prototype._detachElements=function(e){return e.map(this._detachElement.bind(this))},n.prototype._detachElement=function(e){return this.attachments.has(e)?(e.removeAttribute("src"),this.attachments["delete"](e),e):e},n.prototype._getAllAttachedElements=function(){var e=[];return this.attachments.forEach(function(t){e.push(t)}),e},t.exports=n},{events:62,util:66}],9:[function(e,t,i){"use strict";function n(e,t){return this instanceof n?void r.call(this,e,t):new n(e,t)}var r=e("./audiotrack"),s=e("util").inherits,o=e("./localtrack");s(n,r),n.prototype.attach=function(e){return e=r.prototype.attach.call(this,e),e.muted=!0,e},n.prototype.disable=o.prototype.disable,n.prototype.enable=o.prototype.enable,n.prototype.stop=o.prototype.stop,t.exports=n},{"./audiotrack":7,"./localtrack":10,util:66}],10:[function(e,t,i){"use strict";function n(){}n.prototype.enable=function(e){return e="boolean"==typeof e?e:!0,this.mediaStreamTrack.enabled=e,this._enable(e)},n.prototype.disable=function(){return this.enable(!1)},n.prototype.stop=function(){return this._isEnded=!0,this.mediaStreamTrack.stop(),this},t.exports=n},{}],11:[function(e,t,i){"use strict";function n(e,t){return this instanceof n?void o.call(this,e,t):new n(e,t)}var r=e("util").inherits,s=e("./localtrack"),o=e("./videotrack");r(n,o),n.prototype.enable=s.prototype.enable,n.prototype.disable=s.prototype.disable,n.prototype.stop=s.prototype.stop,t.exports=n},{"./localtrack":10,"./videotrack":12,util:66}],12:[function(e,t,i){"use strict";function n(e,t){return this instanceof n?(a.call(this,e,t),Object.defineProperties(this,{dimensions:{enumerable:!0,value:{width:null,height:null}}}),e.onaddtrack=function(){this.attachments.forEach(function(t){a.detachAudioOrVideoTrack(this,t),a.attachVideo(t,e)},this)}.bind(this),r(this),this):new n(e,t)}function r(e){if("undefined"==typeof document)throw new Error("document is undefined");var t=document.createElement(e.kind);return t.muted=!0,t.onloadedmetadata=function(){s(e,t)&&(e.dimensions.width=t.videoWidth,e.dimensions.height=t.videoHeight)},t.onresize=function(){s(e,t)&&(e.dimensions.width=t.videoWidth,e.dimensions.height=t.videoHeight,e.isStarted&&e.emit(c,e))},e.once(a.ENDED,function(){e.detach(t),t.onloadedmetadata=null}),e.attach(t)}function s(e,t){return e.dimensions.width!==t.videoWidth||e.dimensions.height!==t.videoHeight}var o=e("util").inherits,a=e("./"),c=n.DIMENSIONS_CHANGED="dimensionsChanged";o(n,a),n.prototype._start=function(e){return this.dimensions.width=e.videoWidth,this.dimensions.height=e.videoHeight,a.prototype._start.call(this,e)},n.prototype.attach=function(e){return e=a.prototype.attach.call(this,e),e.muted=!0,e},n.prototype.detach=a.prototype.detach,t.exports=n},{"./":8,util:66}],13:[function(e,t,i){"use strict";function n(e,t,i,o){function c(e){throw e&&(e.cancel(),e.getConversationSignaling().then(function(e){e.disconnect()})),u}if(!(this instanceof n))return new n(e,t,i,o);s.call(this),Object.defineProperties(this,{_deferred:{value:a.defer()},_isCanceled:{writable:!0,value:!1},_isFailed:{writable:!0,value:!1},_signaling:{writable:!0,value:null},status:{enumerable:!0,get:function(){return this._isCanceled?"canceled":this._isFailed?"failed":this._signaling?this._signaling.state:"pending"}},to:{enumerable:!0,get:function(){return e.slice()}}});var u=new Error("Canceled"),l=this;t(function(e){return"canceled"===l.status&&c(),i(e).then(function(e){return"canceled"===l.status&&c(e),l._signaling=e,r(l,e),e.getConversationSignaling()})}).then(function(e){l._deferred.resolve(o(e))})["catch"](function(e){e!==u&&(l._isFailed=!0,l._signaling||l.emit("failed",l),l._deferred.reject(e))})}function r(e,t){t.on("stateChanged",function(t){e.emit(t,e)})}var s=e("events").EventEmitter,o=e("util").inherits,a=e("./util");o(n,s),n.prototype.cancel=function(){return this._signaling?(this._signaling.cancel(),this):(this._isCanceled=!0,this.emit("canceled",this),this._deferred.reject(new Error("OutgoingInvite canceled")),this)},n.prototype["catch"]=function(){return this._deferred.promise["catch"].apply(this._deferred.promise,arguments)},n.prototype.then=function(){return this._deferred.promise.then.apply(this._deferred.promise,arguments)},t.exports=n},{"./util":48,events:62,util:66}],14:[function(e,t,i){"use strict";function n(e){return this instanceof n?(s.call(this),Object.defineProperties(this,{_signaling:{value:e},identity:{enumerable:!0,value:e.identity},media:{enumerable:!0,value:e.media},sid:{enumerable:!0,value:e.sid}}),void r(this,e)):new n(e)}function r(e,t){["trackAdded","trackDimensionsChanged","trackDisabled","trackEnabled","trackEnded","trackRemoved","trackStarted"].forEach(function(i){t.media.on(i,function(){var t=[].slice.call(arguments);t.unshift(i),e.emit.apply(e,t)})}),t.on("stateChanged",function(t){e.emit(t,e)})}var s=e("events").EventEmitter,o=e("util").inherits;o(n,s),t.exports=n},{events:62,util:66}],15:[function(e,t,i){"use strict";function n(){r.call(this),Object.defineProperties(this,{_queuedEvents:{value:new Map}})}var r=e("events").EventEmitter,s=e("util").inherits;s(n,r),n.prototype.dequeue=function(e){var t=!0;if(!e)return this._queuedEvents.forEach(function(e,i){t=this.dequeue(i)&&t},this),t;var i=this._queuedEvents.get(e)||[];this._queuedEvents["delete"](e);var n=this;return i.reduce(function(t,i){return n.emit.apply(n,[e].concat(i))&&t},t)},n.prototype.queue=function(){var e=[].slice.call(arguments);if(this.emit.apply(this,e))return!0;var t=e[0];return this._queuedEvents.has(t)||this._queuedEvents.set(t,[]),this._queuedEvents.get(t).push(e.slice(1)),!1},t.exports=n},{events:62,util:66}],16:[function(e,t,i){"use strict";function n(e){return!r(e)}function r(e){return e=N.validateOr(N.parseStringOrJSON.bind(null,e),!1),e&&"conversation_state"in e}function s(e){var t=N.parseStringOrJSON(e);return r(t)?g(t):o(t)}function o(e){return a(N.parseStringOrJSON(e))}function a(e){return N.validateObject("Partial Notification",e),{peer_connections:c(e.peer_connections),protocol_version:u(e.protocol_version),event_list:l(e.event_list)}}function c(e){return e}function u(e){if(N.validateString("Protocol version",e),-1===["v1","v2"].indexOf(e.toLowerCase()))throw new Error("Unsupported protocol version: "+e);return e}function l(e){return N.validateOr(N.validateArray.bind(null,"Event list",e),[]).map(d).filter(N.isNotNull)}function h(e){N.validateObject("Conversation Event",e);var t=p(e.event);return e=E(e),e.event=t,e}function d(e){return N.validateOr(h.bind(null,e),null)}function p(e){switch(N.validateString("Conversation Event type",e),e.toLowerCase()){case"participant_connected":case"participant_disconnected":case"participant_failed":case"track_added":case"track_disabled":case"track_enabled":case"track_removed":return e;default:throw new Error("Unknown Conversation Event type: "+e)}}function f(e){return N.validateInteger("Instance version",e)}function g(e){return m(N.parseStringOrJSON(e))}function m(e){N.validateObject("Full Notification",e);var t=e.conversation_state;return e=a(e),e.conversation_state=v(t),e.peer_connections=c(e.peer_connections),e}function v(e){return N.validateObject("Conversation State",e),{instance_version:f(e.instance_version),sid:_(e.sid),participants:T(e.participants)}}function _(e){return N.validateString("Conversation SID",e)}function T(e){return N.validateOr(N.validateArray.bind(null,"Participants",e),[]).map(y).filter(N.isNotNull)}function E(e){return N.validateObject("Participant Info",e),{participant_sid:S(e.participant_sid),address:C(e.address),tracks:R(e.tracks)}}function y(e){return N.validateOr(E.bind(null,e),null)}function S(e){return N.validateString("Participant SID",e)}function C(e){return N.validateString("Participant address",e)}function R(e){return N.validateOr(N.validateArray.bind(null,"Tracks",e),[]).map(I).filter(N.isNotNull)}function A(e){return N.validateObject("Track Info",e),{id:b(e.id),kind:w(e.kind)}}function I(e){return N.validateOr(A.bind(null,e),null)}function b(e){return N.validateString("Track ID",e)}function w(e){switch(N.validateString("Track kind",e),e.toLowerCase()){case"audio":case"video":return e;default:throw new Error("Unknown Track kind: "+e)}}function D(e,t,i){return{protocol_version:O,type:"partial",event_list:[{event:e,time_stamp:(new Date).toUTCString(),participant_sid:t,tracks:[{kind:i.kind,id:i.id}]}]}}var N=e("../util/validation"),O="v1",k=D.bind(null,"track_disabled"),U=D.bind(null,"track_enabled");t.exports.isFullNotification=r,t.exports.isPartialNotification=n,t.exports.parseFullNotification=g,t.exports.parseNotification=s,t.exports.parsePartialNotification=o,t.exports.trackDisabled=k,t.exports.trackEnabled=U},{"../util/validation":55}],17:[function(e,t,i){"use strict";function n(e,t,i,n){n=Object.assign({},n),s.call(this,"connected",o),Object.defineProperties(this,{_options:{value:n},localMedia:{enumerable:!0,value:e},participantSid:{enumerable:!0,value:t},sid:{enumerable:!0,value:i}})}var r=e("util").inherits,s=e("../statemachine"),o={connected:["disconnected"],disconnected:[]};r(n,s),n.prototype.disconnect=function(){this.preempt("disconnected")},n.prototype.invite=function(e){return Promise.resolve()},t.exports=n},{"../statemachine":44,util:66}],18:[function(e,t,i){"use strict";function n(e,t,i,n){n=Object.assign({},n),o.call(this,"pending",a),Object.defineProperties(this,{_options:{value:n},conversationSid:{enumerable:!0,value:e},from:{enumerable:!0,value:t},participantSid:{enumerable:!0,value:i}})}var r=e("./conversation"),s=e("util").inherits,o=e("../statemachine"),a={pending:["rejected","accepting","canceled","failed"],rejected:[],accepting:["accepted","canceled","failed"],accepted:[],canceled:[],failed:[]};s(n,o),n.prototype._accept=function(e,t,i){return t=Object.assign({},this._options,t),new r(e,this.participantSid,this.conversationSid,t)},n.prototype._reject=function(){},n.prototype.accept=function(e,t){var i=this;return this.bracket("accept",function(n){return i.transition("accepting",n),i._accept(e,t,n).then(function(e){return i.transition("accepted",n),e},function(e){throw i.tryTransition("failed",n),e})})},n.prototype.reject=function(){this.preempt("rejected"),this._reject()},t.exports=n},{"../statemachine":44,"./conversation":17,util:66}],19:[function(e,t,i){"use strict";function n(){o.call(this,"closed",a)}var r=e("util").inherits,s=e("./outgoinginvite"),o=e("../statemachine"),a={closed:["opening"],opening:["closed","open"],open:["closed","attemptingToListen","closing"],closing:["closed","open"],attemptingToListen:["closed","open","listening"],listening:["closed","open","attemptingToUnlisten"],attemptingToUnlisten:["closed","listening","open"]};r(n,o),n.prototype._close=function(e){return this.transition("closing",e),this.transition("closed",e),Promise.resolve()},n.prototype._connect=function(e,t,i,n){return t=t||"CV00000000000000000000000000000000",new s(e,t,i,n)},n.prototype._listen=function(e){return this.transition("attemptingToListen",e),this.transition("listening",e),Promise.resolve()},n.prototype._open=function(e){return this.transition("opening",e),this.transition("open",e),Promise.resolve()},n.prototype._unlisten=function(e){return this.transition("attemptingToUnlisten",e),this.transition("open",e),Promise.resolve()},n.prototype.close=function(){var e=this;return this.bracket("close",function t(i){switch(e.state){case"closed":return;case"open":return e._close(i);case"listening":return e._unlisten(i).then(t.bind(null,i),e._close.bind(e,i));default:throw new Error('Unexpected Signaling state "'+e.state+'"')}})},n.prototype.connect=function(e,t,i,n){var r=this;return this.bracket("connect",function s(o){switch(r.state){case"closed":return r._open(o).then(s.bind(null,o));case"open":case"listening":return r.releaseLockCompletely(o),r._connect(e,t,i,n);default:throw new Error('Unexpected Signaling state "'+r.state+'"')}})},n.prototype.listen=function(){var e=this;return this.bracket("listen",function t(i){switch(e.state){case"closed":return e._open(i).then(t.bind(null,i));case"open":return e._listen(i);case"listening":return;default:throw new Error('Unexpected Signaling state "'+e.state+'"')}})},n.prototype.open=function(){var e=this;return this.bracket("open",function(t){switch(e.state){case"closed":return e._open(t);case"open":case"listening":return;default:throw new Error('Unexpected Signaling state "'+e.state+'"')}})},n.prototype.unlisten=function(){var e=this;return this.bracket("unlisten",function(t){switch(e.state){case"closed":case"open":return;case"listening":return e._unlisten(t);default:throw new Error('Unexpected Signaling state "'+e.state+'"')}})},t.exports=n},{"../statemachine":44,"./outgoinginvite":20,util:66}],20:[function(e,t,i){"use strict";function n(e,t,i,n){n=Object.assign({},n);var r=null,c=o.defer(),u=null;s.call(this,"pending",a),Object.defineProperties(this,{_conversationSid:{get:function(){return r},set:function(e){r=e}},_deferred:{value:c},_label:{get:function(){return u},set:function(e){u=e}},_options:{value:n},conversationSid:{enumerable:!0,get:function(){return r}},identities:{enumerable:!0,get:function(){return e.slice()}},label:{enumerable:!0,get:function(){return u}},labelOrSid:{enumerable:!0,value:t},localMedia:{enumerable:!0,value:i}})}var r=e("util").inherits,s=e("../statemachine"),o=e("../util"),a={pending:["rejected","accepted","canceled","failed"],rejected:[],accepted:[],canceled:[],failed:[]};r(n,s),n.prototype.cancel=function(){this.preempt("canceled"),this._cancel()},n.prototype.getConversationSignaling=function(){return this._deferred.promise},t.exports=n},{"../statemachine":44,"../util":48,util:66}],21:[function(e,t,i){"use strict";function n(e,t,i){var n=new s;o.call(this,i,a),Object.defineProperties(this,{identity:{enumerable:!0,value:t},media:{enumerable:!0,value:n},sid:{enumerable:!0,value:e}})}var r=e("util").inherits,s=e("../media"),o=e("../statemachine"),a={failed:[],connected:["disconnected"],disconnected:[]};r(n,o),t.exports=n},{"../media":5,"../statemachine":44,util:66}],22:[function(e,t,i){"use strict";function n(e){var t=c.parseStringOrJSON(e),i=r(t.config),n=s(t.warnings),o={config:i};return n.length&&(o.warnings=n),o}function r(e){return c.validateObject("Config",e)}function s(e){return c.validateOr(c.validateArray.bind(null,"Warnings",e),[]).map(a).filter(c.isNotNull)}function o(e){c.validateObject("Warning",e),c.validateString("Warning message",e.message);var t={message:e.message};return"code"in e&&(c.validateInteger("Warning code",e.code),t.code=e.code),t}function a(e){return c.validateOr(o.bind(null,e),null)}var c=e("../util/validation");t.exports.parseRTCAuthInfo=n},{"../util/validation":55}],23:[function(e,t,i){"use strict";function n(e,t,i,r){return this instanceof n?(r=d.withDefaults({},r,{localMedia:e,logLevel:s.DEFAULT_LOG_LEVEL}),o.call(this,e,t,i,r),Object.defineProperties(this,{_dialogs:{value:new Set},_log:{value:new u("Conversation",r.logLevel)},_trackIdToParticipants:{value:new Map},participants:{enumerable:!0,value:new Map}}),void this.on("stateChanged",this.emit.bind(this))):new n(e,t,i,r)}function r(e,t){function i(e){var i=t.get(e.id)||new Set;i.forEach(function(t){t.media._addTrack(e)})}function n(e){var i=t.get(e.id)||new Set;i.forEach(function(t){t.media._removeTrack(e)}),t["delete"](e.id)}var r=e.remoteMedia;r.tracks.forEach(i),r.on(l.TRACK_ADDED,i),r.on(l.TRACK_REMOVED,n),e.once("ended",function(){r.removeListener(l.TRACK_ADDED,i),r.removeListener(l.TRACK_REMOVED,n)})}var s=e("../../util/constants"),o=e("../conversation"),a=e("../../util/constants").twilioErrors,c=e("util").inherits,u=e("../../util/log"),l=e("../../media"),h=e("./participant"),d=e("../../util");c(n,o),n.prototype._onDialog=function(e){return this._dialogs.has(e)?this:(this._sid=this.sid||e.conversationSid,this._participantSid=this._participantSid||e.participantSid,this._dialogs.add(e),e.once("ended",this._removeDialog.bind(this)),e.on("notification",this._onNotification.bind(this,e)),e.dequeue("notification"),r(e,this._trackIdToParticipants),this)},n.prototype._onInviteServerTransaction=function(e){return e.accept(this._options).then(this._onDialog.bind(this))},n.prototype._connectParticipant=function(e){if(this.participants.has(e.sid))return this;this.participants.set(e.sid,e);var t=this;return setTimeout(function(){t.emit("participantConnected",e),e.media.tracks.forEach(e.emit.bind(e,"trackAdded"))}),this},n.prototype._removeDialog=function(e){return this._dialogs["delete"](e),this._dialogs.size||("disconnected"!==this.state&&this.preempt("disconnected"),this.participants.forEach(this._disconnectParticipant,this)),this},n.prototype._associateParticipantToTrackId=function(e,t){
return d.map.addToMapOfSets(this._trackIdToParticipants,t.id,e),this},n.prototype._associateParticipantToTrackIds=function(e,t){return t.forEach(this._associateParticipantToTrackId.bind(this,e)),this},n.prototype._disassociateParticipantFromTrackId=function(e,t){var i=t.id;d.map.deleteFromMapOfSets(this._trackIdToParticipants,i,e);var n=e.media.tracks.get(i);return n&&e.media._removeTrack(n),this},n.prototype._disassociateParticipantFromTrackIds=function(e,t){return t.forEach(this._disassociateParticipantFromTrackId.bind(this,e)),this},n.prototype._disconnectParticipant=function(e){return e.preempt("disconnected"),e.media.tracks.forEach(function(t){this._disassociateParticipantFromTrackId(e,t.id),e.media._removeTrack(t)},this),this.participants["delete"](e.sid),this.emit("participantDisconnected",e),this},n.prototype._onNotification=function(e,t){var i=t.conversation_state;return i?this.sid!==i.sid?this:this._onFullNotification(e,t):this._onPartialNotification(e,t)},n.prototype._onFullNotification=function(e,t){return t.conversation_state.participants.forEach(this._onParticipantConnected,this),this},n.prototype._onPartialNotification=function(e,t){return t.event_list.forEach(function(e){var t=e.event.toLowerCase();switch(t){case"participant_connected":return void this._onParticipantConnected(e);case"participant_disconnected":return void this._onParticipantDisconnected(e);case"participant_failed":return void this._onParticipantFailed(e)}var i=this.participants.get(e.participant_sid);if(i){switch(t){case"track_added":return void this._associateParticipantToTrackIds(i,e.tracks);case"track_removed":return void this._disassociateParticipantFromTrackIds(i,e.tracks)}i._onConversationEvent(e)}},this),this},n.prototype._onParticipantConnected=function(e){if(this._participantSid===e.participant_sid)return this;var t=this.participants.get(e.participant_sid),i=!1;return t||(t=new h(e.participant_sid,d.getUser(e.address),"connected"),i=!0),this._associateParticipantToTrackIds(t,e.tracks),i&&this._connectParticipant(t),this},n.prototype._onParticipantFailed=function(e){if(this._participantSid===e.participant_sid)return this;var t=this.participants.get(e.participant_sid)||new h(e.participant_sid,d.getUser(e.address),"failed");return this.emit("participantFailed",t),this},n.prototype._onParticipantDisconnected=function(e){if(this._participantSid===e.participant_sid)return this;var t=this.participants.get(e.participant_sid);return t&&this._disconnectParticipant(t),this},n.prototype.disconnect=function(){return this.preempt("disconnected"),this._dialogs.forEach(function(e){e.end()}),this},n.prototype.invite=function(e){e||this._log["throw"](a.INVALID_ARGUMENT,"No Participant identities were provided");var t;if(this._dialogs.forEach(function(e){t=t||e}),!t)return this;var i=e.forEach?e:[e],n=t.userAgent.accessManager;return d.validateAddresses(n._tokenPayload.sub,i),i.forEach(t.refer,t),this},t.exports=n},{"../../media":5,"../../util":48,"../../util/constants":47,"../../util/log":49,"../conversation":17,"./participant":31,util:66}],24:[function(e,t,i){"use strict";function n(e,t,i,n,o,a,l,h){function d(e){if(p.ended)return o.removeListener(c.TRACK_ADDED,m),void o.removeListener(c.TRACK_REMOVED,v);try{l.removeStream(e.mediaStream),l.addStream(e.mediaStream)}catch(t){l.addStream(e.mediaStream)}p._reinvite()}var p=this;s.call(this);var f=!1,g=null;Object.defineProperties(this,{_ended:{set:function(e){f=e}},_sampleInterval:{get:function(){return g},set:function(e){g=e}},callSid:{enumerable:!0,value:n},conversationSid:{enumerable:!0,value:i},participantSid:{enumerable:!0,value:h},ended:{enumerable:!0,get:function(){return f}},localMedia:{enumerable:!0,value:o},peerConnection:{enumerable:!0,value:l},remote:{enumerable:!0,value:t},remoteMedia:{enumerable:!0,value:a},userAgent:{enumerable:!0,value:e}});var m=d,v=d;o.on(c.TRACK_ADDED,m),o.on(c.TRACK_REMOVED,v),o.on(c.TRACK_DISABLED,function T(e){return p.ended?void o.removeListener(c.TRACK_DISABLED,T):void p.publish(u.trackDisabled(p.participantSid,e))}),o.on(c.TRACK_ENABLED,function(e){p.ended||p.publish(u.trackEnabled(p.participantSid,e))});try{r(this,1e3)}catch(_){throw _}return this}function r(e,t){var i=e.peerConnection;e._sampleInterval=setInterval(function(){o(i,function(t,i){t||e.emit("stats",i)})},t),e.once("ended",function(){e._sampleInterval&&(clearInterval(e._sampleInterval),e._sampleInterval=null)})}var s=e("../../queueingeventemitter"),o=e("../../webrtc/getstatistics"),a=e("util").inherits,c=e("../../media"),u=e("../conversation-info"),l=e("../../util");a(n,s),n.prototype.end=function(){return this.ended?this:(this._ended=!0,this.emit("ended",this),this)},n.prototype._reinvite=function(){var e=this,t=l.defer();return setTimeout(function(){t.resolve(e),e.emit("reinvite",e)}),t.promise},n.prototype.refer=function(e){return this._refer(e).then(this._onReferSuccess.bind(this),this._onReferFailure.bind(this))},n.prototype._refer=function(){var e=this,t=l.defer();return setTimeout(function(){t.resolve(e)}),t.promise},n.prototype._onReferSuccess=function(){return this},n.prototype._onReferFailure=function(e){throw e},n.prototype.publish=function(e){return this._publish(e).then(this._onPublishSuccess.bind(this),this._onPublishFailure.bind(this))},n.prototype._publish=function(){var e=this,t=l.defer();return setTimeout(function(){t.resolve(e)}),t.promise},n.prototype._onPublishSuccess=function(){return this},n.prototype._onPublishFailure=function(e){throw e},n.prototype.getStats=function(){var e=this,t=l.defer();return o(this.peerConnection,function(i,n){if(i)return t.reject(i);var r={callsid:e.callSid,samples:[n]};t.resolve(r)}),t.promise},t.exports=n},{"../../media":5,"../../queueingeventemitter":15,"../../util":48,"../../webrtc/getstatistics":56,"../conversation-info":16,util:66}],25:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);t=c.withDefaults({},t,{logLevel:r.DEFAULT_LOG_LEVEL});var i=this,s=null,a=e.conversationSid,u=c.getUser(e.from),l=null,h=[u],d=e.participantSid,p=0,f=c.defer(),g=new Set;g.add(e),o.call(this,a,u,d,t),Object.defineProperties(this,{_conversation:{set:function(e){s=e},get:function(){return s}},_deferred:{value:f},_inviteServerTransaction:{value:e},_inviteServerTransactions:{value:g},_localMedia:{get:function(){return l},set:function(e){l=e}},_logLevel:{value:t.logLevel},_pending:{get:function(){return p},set:function(e){p=e}},_promise:{value:f.promise},participants:{enumerable:!0,value:h}}),e.once("canceled",function(){i.preempt("canceled")}),this.on("stateChanged",this.emit.bind(this))}var r=e("../../util/constants"),s=e("./conversation"),o=e("../incominginvite"),a=e("util").inherits,c=e("../../util");a(n,o),n.prototype._onAcceptFailure=function(e){return this._pending--,"accepting"!==this.state||this._pending||this._deferred.reject(e),this},n.prototype._onDialog=function(e){this._pending--;var t=this._conversation=this._conversation||new s(this._localMedia,this.participantSid,this.conversationSid,this._options);return t._onDialog(e),"accepting"===this.state&&this._deferred.resolve(t),t},n.prototype._onInviteServerTransaction=function(e){switch(this.state){case"canceled":case"rejected":return void e.reject();case"accepting":return this._inviteServerTransactions.has(e)||(this.participants.push(c.getUser(e.from)),this._inviteServerTransactions.add(e)),this._pending++,void e.accept(this._options).then(this._onDialog.bind(this),this._onAcceptFailure.bind(this));case"accepted":return void this._conversation._onInviteServerTransaction(e);default:this._inviteServerTransactions.has(e)||(this.participants.push(c.getUser(e.from)),this._inviteServerTransactions.add(e))}},n.prototype._accept=function(e,t){return Object.assign(this._options,t),this._localMedia=this._options.localMedia=e,this._inviteServerTransactions.forEach(this._onInviteServerTransaction,this),this._promise},n.prototype._reject=function(){return this._inviteServerTransactions.forEach(function(e){e.reject()}),this},t.exports=n},{"../../util":48,"../../util/constants":47,"../incominginvite":18,"./conversation":23,util:66}],26:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);t=v.withDefaults(t,{eventGateway:c.EVENT_GATEWAY,logLevel:c.DEFAULT_LOG_LEVEL,userAgent:g});var i=t.eventGateway,s=new d("[Signaling/v1]",t.logLevel);f.call(this);var u=new Map,l=new Map,h=new Map,p=new Map,m=new Map,_=t.userAgent,T=new _(e,t);Object.defineProperties(this,{_accessManager:{value:e},_canceledOutgoingInvites:{value:l},_conversations:{value:h},_dialogs:{value:T.dialogs},_eventGateway:{value:i},_incomingInvites:{value:p},_log:{value:s},_outgoingInvites:{value:u},_rejectedIncomingInvites:{value:m},_userAgent:{value:T}}),r(this,e),o(this),a(this)}function r(e,t){t.on("tokenUpdated",function(){e._userAgent.isRegistered&&e._userAgent.register()})}function s(e,t){function i(t){e._log.info("Adding "+t.kind+" Track "+t.id+" to Conversation"),s._addTrack(t)}function n(t){e._log.info("Removing "+t.kind+" Track "+t.id+" from Conversation"),s._removeTrack(t)}var r=t.conversationSid,s=e._conversations.get(r);if(!s)return void e._log.warn("Could not find Conversation "+r);t.on("notification",function(i){var n=i.conversation_state,r=n?n.sid:t.conversationSid;e._log.info("Received "+(n?"full":"partial")+" Conversation Info for Conversation "+r);var s=e._conversations.get(r);if(!s)return void e._log.warn("Could not find Conversation "+r);var o=n?s._onFullNotification:s._onPartialNotification;o.call(s,i)}),t.dequeue("notification");var o=t.remoteMedia;o.tracks.forEach(i),o.on("trackAdded",i),o.on("trackRemoved",n),t.once("ended",function(){o.removeListener("trackAdded",i),o.removeListener("trackRemoved",n)})}function o(e){e.on("disconnected",function(){e._unregisterIfNoLongerRequired()})}function a(e){e._userAgent.on("invite",function(t){e._log.info("Received InviteServerTransaction for Conversation "+t.conversationSid);var i=t.cookie,n=e._outgoingInvites.get(i)||e._canceledOutgoingInvites.get(i);if(n)return n._onInviteServerTransaction(t);var r=t.key,s=e._incomingInvites.get(r)||e._rejectedIncomingInvites.get(r);if(s)return s._onInviteServerTransaction(t);var o=e._conversations.get(t.conversationSid);return o?o._onInviteServerTransaction(t):void e._onInviteServerTransaction(t)}),e._userAgent.on("dialogCreated",function(t){new m(e._eventGateway,t,e._log.logLevel)}),e._userAgent.on("keepAliveTimeout",function(){e.emit("error",u.GATEWAY_DISCONNECTED)})}var c=e("../../util/constants"),u=c.twilioErrors,l=e("./incominginvite"),h=e("util").inherits,d=e("../../util/log"),p=e("./outgoinginvite"),f=e("../"),g=e("./sipjsuseragent"),m=e("../../statsreporter"),v=e("../../util");h(n,f),n.prototype._close=function(e){var t=this;return this.transition("closing",e),this._userAgent.disconnect().then(function(){t.transition("closed",e)},function(i){throw t.tryTransition("open",e),i})},n.prototype._handleConversation=function(e){this._conversations.set(e.sid,e),this._dialogs.forEach(function(t){t.conversationSid===e.sid&&s(this,t)},this)},n.prototype._listen=function(e){var t=this;return this.transition("attemptingToListen",e),this._userAgent.register().then(function(){t.transition("listening",e)},function(i){throw t.tryTransition("open",e),i})},n.prototype._onInviteServerTransaction=function(e){if("listening"!==this.state)return void this._log.info("Ignoring InviteServerTransaction");this._log.info("Creating new IncomingInvite");var t=new l(e,this._options),i=e.key;this._incomingInvites.set(i,t);var n=this;t.once("accepted",function(){n._incomingInvites["delete"](i);var e=t._conversation;n._conversations.set(e.sid,e),e.once("disconnected",function(){n._conversations["delete"](e.sid),n._unregisterIfNoLongerRequired()})}),t.once("canceled",function(){n._incomingInvites["delete"](i),n._unregisterIfNoLongerRequired()}),t.once("rejected",function(){n._incomingInvites["delete"](i),n._rejectedIncomingInvites.set(i,t),setTimeout(function(){n._rejectedIncomingInvites["delete"](i)},3*c.DEFAULT_CALL_TIMEOUT),n._unregisterIfNoLongerRequired()}),this.emit("invite",t)},n.prototype._open=function(e){var t=this;return this.transition("opening",e),this._userAgent.connect().then(function(){t.transition("open",e)},function(i){throw t.tryTransition("closed",e),i})},n.prototype._unlisten=function(e){var t=this;return this.transition("attemptingToUnlisten",e),this._unregisterIfNoLongerRequired().then(function(){t.transition("open",e)},function(i){throw t.tryTransition("listening",e),i})},n.prototype._unregisterIfNoLongerRequired=function(){return"listening"===this.state||this._outgoingInvites.size||this._incomingInvites.size||this._conversations.size?Promise.resolve():this._userAgent.unregister()},n.prototype._connect=function(e,t,i,n){var r=this;if(!e||e instanceof Array&&!e.length)return Promise.reject(new Error("Must specify one or more Participant identities"));e=e instanceof Array?e:[e],this._log.info("Connecting to a Conversation and inviting Participants: "+e.join(", "));var s=new p(this._userAgent,e,i,n);return this._outgoingInvites.set(s._cookie,s),r._log.info("Created OutgoingInvite with cookie "+s._cookie),s.once("accepted",function(){r._log.info("OutgoingInvite with cookie "+s._cookie+" was accepted"),r._outgoingInvites["delete"](s._cookie);var e=s._conversation;r._conversations.set(e.sid,e),e.once("disconnected",function(){r._conversations["delete"](e.sid),r._unregisterIfNoLongerRequired()})}),s.once("canceled",function(){r._log.info("OutgoingInvite with cookie "+s._cookie+" was canceled"),r._outgoingInvites["delete"](s._cookie),r._canceledOutgoingInvites.set(s._cookie,s),setTimeout(function(){r._canceledOutgoingInvites["delete"](s._cookie)},3*c.DEFAULT_CALL_TIMEOUT),r._unregisterIfNoLongerRequired()}),s.once("rejected",function(){r._log.info("OutgoingInvite with cookie "+s._cookie+" was rejected"),r._outgoingInvites["delete"](s._cookie),r._unregisterIfNoLongerRequired()}),Promise.resolve(s)},t.exports=n},{"../":19,"../../statsreporter":45,"../../util":48,"../../util/constants":47,"../../util/log":49,"./incominginvite":25,"./outgoinginvite":30,"./sipjsuseragent":36,util:66}],27:[function(e,t,i){"use strict";function n(e,t,i){i=o.withDefaults({},i),s.call(this,e);var n=i.localMedia;Object.defineProperties(this,{_media:{set:function(e){n=e}},media:{enumerable:!0,get:function(){return n}},to:{enumerable:!0,value:t}})}var r=e("util").inherits,s=e("./invitetransaction"),o=e("../../util");r(n,s),n.prototype.cancel=function(e){var t=e?this._setFailed:this._setCanceled;if(!t.call(this))throw new Error("InviteClientTransaction already in state: "+this._state);return this._deferred.reject(this),this},t.exports=n},{"../../util":48,"./invitetransaction":29,util:66}],28:[function(e,t,i){"use strict";function n(e,t,i,n,r,o){return s.call(this,e),Object.defineProperties(this,{callSid:{enumerable:!0,value:n},conversationSid:{enumerable:!0,value:i},cookie:{enumerable:!0,value:o},from:{enumerable:!0,value:t},key:{enumerable:!0,value:i+" "+r},participantSid:{value:r}}),this}var r=e("util").inherits,s=e("./invitetransaction");r(n,s),n.prototype.accept=function(){var e=this;return new Promise(function(t,i){e._setAccepted()?(e._deferred.resolve(e.dialog),t()):i(new Error("InviteServerTransaction already in state: "+e._state))})},n.prototype.reject=function(){if(!this._setRejected())throw new Error("InviteServerTransaction already in state: "+this._state);return this._deferred.reject(this),this},t.exports=n},{"./invitetransaction":29,util:66}],29:[function(e,t,i){"use strict";function n(e){var t=this;r.call(this);var i=o.defer(),n=null,s=a.STATE_PENDING,c=i.promise.then(function(e){return n=e,t.emit("accepted",n),n},function(e){var i=s===a.STATE_PENDING?"failed":s;throw t.emit(i,e),e});return Object.defineProperties(this,{_deferred:{value:i},_promise:{value:c},_state:{get:function(){return s},set:function(e){s=e}},dialog:{enumerable:!0,get:function(){return n}},isAccepted:{enumerable:!0,get:function(){return s===a.STATE_ACCEPTED}},isCanceled:{enumerable:!0,get:function(){return s===a.STATE_CANCELED}},isFailed:{enumerable:!0,get:function(){return s===a.STATE_FAILED}},isPending:{enumerable:!0,get:function(){return s===a.STATE_PENDING}},isRejected:{enumerable:!0,get:function(){return s===a.STATE_REJECTED}},state:{enumerable:!0,get:function(){return s}},userAgent:{enumerable:!0,value:e}}),this}var r=e("events").EventEmitter,s=e("util").inherits,o=e("../../util"),a={STATE_PENDING:"pending",STATE_ACCEPTED:"accepted",STATE_REJECTED:"rejected",STATE_CANCELED:"canceled",STATE_FAILED:"failed",FINAL_STATES:["accepted","rejected","canceled","failed"]};n.PENDING=a.STATE_PENDING,n.ACCEPTED=a.STATE_ACCEPTED,n.REJECTED=a.STATE_REJECTED,n.CANCELED=a.STATE_CANCELED,n.FAILED=a.STATE_FAILED,s(n,r),n.prototype._setState=function(e){if(!e||!e.length)throw new Error('Parameter "state" is required');if(-1===a.FINAL_STATES.indexOf(e))throw new Error("InviteTransaction states must be one of: ["+a.FINAL_STATES.join(", ")+"]");return this.state===a.STATE_PENDING?(this._state=e,!0):!1},n.prototype._setAccepted=function(){return this._setState(a.STATE_ACCEPTED)},n.prototype._setCanceled=function(){return this._setState(a.STATE_CANCELED)},n.prototype._setFailed=function(){return this._setState(a.STATE_FAILED)},n.prototype._setRejected=function(){return this._setState(a.STATE_REJECTED)},n.prototype.then=function(e,t){return this._promise.then(e,t)},Object.freeze(n.prototype),t.exports=n},{"../../util":48,events:62,util:66}],30:[function(e,t,i){"use strict";function n(e,t,i,s){function c(){return e.isRegistered?Promise.resolve():e.register()}function p(){return"pending"!==S.state&&"accepted"!==S.state?null:(s.cookie=y,m=e.invite(t,s))}function f(e){if(e&&("pending"===S.state||"accepted"===S.state)){var t=e.conversationSid,n=e.participantSid,r=S._conversation||new o(i,n,t,s);S._conversation=r,r._onDialog(e),"accepted"!==S.state&&S.preempt("accepted"),v.resolve(r)}}function g(e){if(e instanceof u){if(t.length>1)return;var i;switch(e.state){case"canceled":i=a.CONVERSATION_INVITE_CANCELED;break;case"rejected":"pending"===S.state&&S.preempt("rejected"),i=a.CONVERSATION_INVITE_REJECTED;break;case"failed":default:"pending"===S.state&&S.preempt("failed"),i=a.CONVERSATION_INVITE_FAILED}return void v.reject(i)}return e instanceof Error&&["PermissionDeniedError","PERMISSION_DENIED"].indexOf(e.name)>-1?("pending"===S.state&&S.preempt("failed"),void v.reject(a.MEDIA_ACCESS_DENIED)):void v.reject(e)}if(!(this instanceof n))return new n(e,t,i,s);s=d.withDefaults({localMedia:i},s),l.call(this,t,null,i,s);var m,v=d.defer(),_=new h(v.promise),T=new r(_),E=null,y=d.makeUUID(),S=this;this.on("stateChanged",function(e){S.emit(e,S)}),T.then(this._deferred.resolve,function(e){_.isTimedOut?e=a.CONVERSATION_INVITE_FAILED:T.isCanceled&&(e=a.CONVERSATION_INVITE_CANCELED),S._deferred.reject(e)}),Object.defineProperties(this,{_cancelablePromise:{value:T},_conversation:{get:function(){return E},set:function(e){E=e}},_cookie:{value:y},_onReceiveInvite:{value:f},_timeoutPromise:{value:_},to:{enumerable:!0,value:t}}),c().then(p).then(f,g),_.once("timedOut",function(){S.preempt("failed"),m&&m.cancel(!0)}),T.once("canceled",function(){S.preempt("canceled"),m&&m.cancel()})}var r=e("../../util/cancelablepromise"),s=e("../../util/constants"),o=e("./conversation"),a=s.twilioErrors,c=e("util").inherits,u=e("./inviteclienttransaction"),l=e("../outgoinginvite"),h=e("../../util/timeoutpromise"),d=e("../../util");c(n,l),n.prototype._onInviteServerTransaction=function(e){return"pending"!==this.state&&"accepted"!==this.state?(e.reject(),this):(e.accept(this._options).then(this._onReceiveInvite)["catch"](function(){}),this)},n.prototype.cancel=function(){return this._cancelablePromise.cancel(),this},t.exports=n},{"../../util":48,"../../util/cancelablepromise":46,"../../util/constants":47,"../../util/timeoutpromise":53,"../outgoinginvite":20,"./conversation":23,"./inviteclienttransaction":27,util:66}],31:[function(e,t,i){"use strict";function n(e,t,i){if(!(this instanceof n))return new n(e,t,i);o.call(this,e,t,i);var r=this.media;return r.on(s.TRACK_ADDED,this.emit.bind(this,a)),r.on(s.TRACK_DIMENSIONS_CHANGED,this.emit.bind(this,c)),r.on(s.TRACK_DISABLED,this.emit.bind(this,u)),r.on(s.TRACK_ENABLED,this.emit.bind(this,l)),r.on(s.TRACK_ENDED,this.emit.bind(this,h)),r.on(s.TRACK_REMOVED,this.emit.bind(this,d)),r.on(s.TRACK_STARTED,this.emit.bind(this,p)),Object.defineProperties(this,{identity:{enumerable:!0,value:t},media:{enumerable:!0,value:r},sid:{enumerable:!0,value:e}}),this}var r=e("util").inherits,s=e("../../media"),o=e("../participant"),a=n.TRACK_ADDED=s.TRACK_ADDED,c=n.TRACK_DIMENSIONS_CHANGED=s.TRACK_DIMENSIONS_CHANGED,u=n.TRACK_DISABLED=s.TRACK_DISABLED,l=n.TRACK_ENABLED=s.TRACK_ENABLED,h=n.TRACK_ENDED=s.TRACK_ENDED,d=n.TRACK_REMOVED=s.TRACK_REMOVED,p=n.TRACK_STARTED=s.TRACK_STARTED;r(n,o),n.prototype._onConversationEvent=function(e){return e.participant_sid!==this.sid?this:(e.tracks.forEach(function(t){var i=t.id,n=this.media.tracks.get(i);if(n)switch(e.event.toLowerCase()){case"track_disabled":n._enable(!1);break;case"track_enabled":n._enable(!0);break;case"track_removed":this.media._removeTrack(n)}},this),this)},t.exports=n},{"../../media":5,"../participant":21,util:66}],32:[function(e,t,i){"use strict";function n(e,t,i,o,a,u,l,h,d,p){if(!(this instanceof n))return new n(e,t,i,o,a,u,l,h,d,p);var f=this;return s.call(this,e,t,i,o,a,u,l,h),Object.defineProperties(this,{inviteTo180:{enumerable:!0,value:p},session:{enumerable:!0,value:d}}),l.oniceconnectionstatechange=function(){switch(l.iceConnectionState){case"failed":return f.emit("failed",c.ICE_CONNECT_FAILED);case"disconnected":return f.emit("disconnected",c.ICE_DISCONNECTED)}},d.on("notify",function(e){if("application/conversation-info+json"===e.getHeader("Content-Type")){var t;try{t=r.parseNotification(e.body)}catch(i){return}f.queue("notification",t)}}),d.once("failed",function(){f._ended=!0,f.emit("failed",f)}),d.once("bye",function(){f._ended=!0,f.emit("ended",f)}),d.mediaHandler.on("getDescription",function(){f.remoteMedia._refreshTracks()}),d.mediaHandler.on("notification",this.queue.bind(this,"notification")),d.mediaHandler.dequeue("notification"),this}var r=e("../conversation-info"),s=e("./dialog"),o=e("util").inherits,a=e("../../util/constants"),c=a.twilioErrors,u=e("sip.js"),l=e("../../util");o(n,s),n.prototype.end=function(){return this.ended?this:(this.session.bye(),this._ended=!0,this.emit("ended",this),this)},n.prototype._reinvite=function(){this.session.mediaHandler.RTCConstraints=a.DEFAULT_OFFER_OPTIONS,this.session.sendReinvite()},n.prototype._refer=function(e){if("string"!=typeof e)throw new Error("Target is not a string");var t=this,i=l.defer(),n=["Contact: "+this.session.contact,"Allow: "+u.UA.C.ALLOWED_METHODS.toString(),"Refer-To: "+this.session.ua.normalizeTarget(e),"Allow-Events: refer","Event: refer;id="+Math.floor(1e3*Math.random()+1)];return t.session.sendRequest("REFER",{extraHeaders:n,receiveResponse:function(e){202===e.status_code?i.resolve(t):i.reject(e)}}),i.promise},n.prototype._publish=function(e){var t=this;return new Promise(function(i,n){function r(e){switch(Math.floor(e.status_code/100)){case 2:i(t);break;default:n(e)}}t.session.sendRequest("PUBLISH",{body:JSON.stringify(e),extraHeaders:["Content-Type: application/conversation-info+json","Event: conversation"],receiveResponse:r})})},Object.freeze(n.prototype),t.exports=n},{"../../util":48,"../../util/constants":47,"../conversation-info":16,"./dialog":24,"sip.js":102,util:66}],33:[function(e,t,i){"use strict";function n(e,t,i){if(!(this instanceof n))return new n(e,t,i);var s=this;i=i||{},o.call(this,e,i);var a=t.length>1,u=!1,f=null;return e.connect().then(function(){return p.getLocalMedia(i)}).then(function(n){if(s._media=n,s.isCanceled)return s._deferred.reject(s);f=r(e,t,i,n);var o=Date.now(),p=null;f.on("progress",function(e){180===e.statusCode&&(p=Date.now())}),f.once("accepted",function(i){var r=i.getHeader("X-Twilio-CallSid"),a=f.mediaHandler.peerConnection,u=new d;f.mediaHandler.on("addStream",function(e){u._addRemoteStream(e.stream)});var g=p?p-o:null,m=h.parseConversationSIDFromContactHeader(i.getHeader("Contact")),v=i.getHeader(l.X_TWILIO_PARTICIPANTSID);v=v?v.split(";"):null;var _=v?v[0]:null,T=new c(e,t[0],m,r,n,u,a,_,f,g);s._deferred.resolve(T)}),f.once("rejected",function(e){return a?void(u=!0):void(e&&600===e.status_code&&s._setRejected()?s._deferred.reject(s):s._setFailed()&&s._deferred.reject(s))}),f.once("failed",function(){u||s._setFailed()&&s._deferred.reject(s)})}).then(null,function(){s._setFailed()&&s._deferred.reject(s)}),Object.defineProperties(this,{_cookie:{value:i.cookie},session:{enumerable:!0,get:function(){return f}}}),this}function r(e,t,i,n){function r(e,t){var i=new u(e,t);return i.createPeerConnection(f),i}var s=e.accessManager.token,o=t.slice(),c=o.shift(),l=[h.selectTokenHeader(s)+": "+s,a.headers.X_TWILIO_CLIENT+": "+JSON.stringify({p:"browser"}),a.headers.X_TWILIO_CLIENTVERSION+": "+a.CLIENT_VERSION];if(o.length){var d=o.join(",")+";cookie="+i.cookie;l.push(a.headers.X_TWILIO_PARTICIPANTS+": "+d)}l.push("Session-Expires: 120");var p=[];n.mediaStreams.forEach(function(e){p.push(e)});var f={iceServers:e.iceServers,iceTransportPolicy:e.iceTransportPolicy};return"iceServers"in i&&(f.iceServers=i.iceServers),"iceTransportPolicy"in i&&(f.iceTransportPolicy=i.iceTransportPolicy),r.isSupported=u.defaultFactory.isSupported,e._ua.invite(c,{extraHeaders:l,inviteWithoutSdp:i.inviteWithoutSdp,media:{stream:p[0]},mediaHandlerFactory:r,RTCConstraints:a.DEFAULT_OFFER_OPTIONS})}var s=e("util").inherits,o=e("./inviteclienttransaction"),a=e("../../util/constants"),c=e("./sipjsdialog"),u=e("./sipjsmediahandler"),l=e("../../util/constants").headers,h=e("../../util"),d=e("../../media"),p=e("../../media/localmedia");s(n,o),n.prototype.cancel=function(e){var t=e?this._setFailed:this._setCanceled;if(!t.call(this))throw new Error("SIPJSInviteClientTransaction already in state: "+this._state);return this._deferred.reject(this),this.session&&this.session.terminate(),this},Object.freeze(n.prototype),t.exports=n},{"../../media":5,"../../media/localmedia":6,"../../util":48,"../../util/constants":47,"./inviteclienttransaction":27,"./sipjsdialog":32,"./sipjsmediahandler":35,util:66}],34:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);var i=t.request,o=i.from.uri.toString(),c=u.parseConversationSIDFromContactHeader(i.getHeader("Contact")),l=i.getHeader(s.X_TWILIO_CALLSID),h=i.getHeader(s.X_TWILIO_PARTICIPANTSID);h=h?h.split(";"):null;var d=h?h[0]:null,p=/^cookie=([^\s]+)/i,f=h&&h[1]&&p.test(h[1])&&h[1].match(p)[1];a.call(this,e,o,c,l,d,f),Object.defineProperties(this,{session:{enumerable:!0,value:t}});var g=this;return t.once("cancel",function(){if(g._setCanceled()){var e=r.CONVERSATION_JOIN_FAILED.clone("Incoming Invite was canceled by the sender");g._deferred.reject(e)}}),t.once("failed",function(e){if(g._setFailed()){var t=u.getOrNull(e,"headers.X-Twilio-Error.0.raw")||"An unknown error occurred",i=r.CONVERSATION_JOIN_FAILED.clone(t);g._deferred.reject(i)}}),this}var r=e("../../util/constants").twilioErrors,s=e("../../util/constants").headers,o=e("util").inherits,a=e("./inviteservertransaction"),c=e("./sipjsdialog"),u=e("../../util"),l=e("../../media"),h=e("../../media/localmedia");o(n,a),n.prototype.accept=function(e){e=u.withDefaults(e,{media:{}});var t=h.getLocalMedia(e),i=null,n=this,r=n.session,s={iceServers:this.userAgent.iceServers,iceTransportPolicy:this.userAgent.iceTransportPolicy};"iceServers"in e&&(s.iceServers=e.iceServers),"iceTransportPolicy"in e&&(s.iceTransportPolicy=e.iceTransportPolicy),r.mediaHandler.createPeerConnection(s);var o=r.request.parseHeader("Supported")||[];return o.indexOf("timer")>=0&&(e.extraHeaders=["Session-Expires: 120;refresher=uas","Require: timer"]),t.then(function(t){function s(){function e(){setTimeout(function(){if(n._setAccepted()){var e=new c(n.userAgent,n.from,n.conversationSid,n.callSid,i,s,t,n.participantSid,n.session);n._deferred.resolve(e)}})}var t=r.mediaHandler.peerConnection,s=new l;r.mediaHandler.on("addStream",function(e){e&&s._addRemoteStream(e.stream)});var o=t.getRemoteStreams()||[];o.forEach(s._addRemoteStream,s),r.once("confirmed",e)}i=t;var o=[];i.mediaStreams.forEach(function(e){o.push(e)}),e.media.stream=o[0],r.once("accepted",s);try{r.accept(e)}catch(a){r.removeListener("accepted",s)}return n._promise})},n.prototype.reject=function(){if(!this._setRejected())throw new Error("SIPJSInviteServerTransaction already in state: "+this._state);return this._deferred.reject(this),this.session&&this.session.reject({statusCode:600}),this},Object.freeze(n.prototype),t.exports=n},{"../../media":5,"../../media/localmedia":6,"../../util":48,"../../util/constants":47,"./inviteservertransaction":28,"./sipjsdialog":32,util:66}],35:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);t=t||{},l.call(this);var i=e.ua.configuration||{},r=null,s=i.iceCheckingTimeout,o=null,a=null,c=!0,u=null,h="stable";Object.defineProperties(this,{_deferredPeerConnection:{value:f.defer()},_iceGathering:{value:f.defer()},_iceGatheringTimer:{get:function(){return r},set:function(e){r=e}},_iceGatheringTimeout:{value:s},_peerConnection:{get:function(){return a},set:function(e){a=e}},_ready:{get:function(){return c},set:function(e){c=e}},_remoteOffer:{get:function(){return u},set:function(e){u=e}},_signalingState:{get:function(){return h},set:function(e){h=e}},localMedia:{enumerable:!0,get:function(){return o},set:function(e){o=e}},peerConnection:{enumerable:!0,get:function(){return a}}})}function r(e){var t,i=e.getHeader("Content-Type");if(!i)return null;if("application/conversation-info+json"===i?t=e.body:/^multipart\//.test(i)&&(t=d.getConversationInfo(d.parse(i,e.body))),t)try{return u.parseNotification(t)}catch(n){}return null}function s(e){var t=e.getHeader("Content-Type");return t?"application/sdp"===t?e.body:/^multipart\//.test(t)?d.getSDP(d.parse(t,e.body)):null:null}function o(e){var t=e.match(/a=msid: *([^ ]+) +([^ ]+) *\r\n/);return t?[t[1],t[2]]:null}function a(e){var t=e.split("\r\nm="),i=t[0],n=t.slice(1).map(function(e){e="m="+e;var t=o(e);if(!t)return e.replace(/\r\n$/,"");e.match(/\r\n$/)||(e+="\r\n");var i=e.match(/a=ssrc: *[^ ]*.*\r\n/g)||[];e=e.replace(/\r\n$/,"");var n={};return i.forEach(function(i){var r=i.match(/a=ssrc: *([^ ]*).*\r\n/);if(r){var s=r[1];n[s]||(n[s]=s,e+="\r\na=ssrc:"+s+" msid:"+t.join(" "))}}),e});return i+"\r\n"+n.join("\r\n")+"\r\n"}var c=e("../../util/constants"),u=e("../conversation-info"),l=e("../../queueingeventemitter"),h=e("util").inherits,d=e("../../util/multipart"),p=e("sip.js"),f=e("../../util");h(n,l),n.defaultFactory=function(e,t){return new n(e,t)},n.defaultFactory.isSupported=function(){return p.WebRTC.isSupported()},n.prototype.createPeerConnection=function(e){function t(){i._iceGatheringTimer||(i._iceGatheringTimer=setTimeout(function(){i._iceGathering.resolve(i)},i._iceGatheringTimeout))}var i=this;this._iceGathering.promise.then(function(e){i.emit("iceGatheringComplete",e),i._iceGatheringTimer&&(clearTimeout(i._iceGatheringTimer),i._iceGatheringTimer=null)}),"object"==typeof navigator&&"function"==typeof navigator.webkitGetUserMedia&&e.iceTransportPolicy&&(e.iceTransports=e.iceTransportPolicy),e.iceServers&&(e.iceServers=e.iceServers.map(function(e){var t=Object.assign({},e);return t.url&&!t.urls&&(t.urls=[t.url],delete t.url),t}));var n=new p.WebRTC.RTCPeerConnection(e);n.onaddstream=function(e){i.emit("addStream",e)},n.onicecandidate=function(e){i.emit("iceCandidate",e),e.candidate?t():i._iceGathering.resolve(i)},n.oniceconnectionstatechange=function(){var e;switch(this.iceConnectionState){case"new":e="iceConnection";break;case"checking":e="iceConnectionChecking";break;case"connected":e="iceConnectionConnected";break;case"completed":e="iceConnectionCompleted";
break;case"failed":e="iceConnectionFailed";break;case"disconnected":e="iceConnectionDisconnected";break;case"closed":e="iceConnectionClosed"}i.emit(e,this)},this._deferredPeerConnection.resolve(),this._peerConnection=n},n.prototype.getPeerConnection=function(){var e=this;return this._deferredPeerConnection.promise.then(function(){return e.peerConnection})},n.prototype.close=function(){this.peerConnection&&"closed"!==this.peerConnection.state&&this.peerConnection.close()},n.prototype.hold=function(){},n.prototype.unhold=function(){},n.prototype.getDescription=function(e){var t=this;if(!this.peerConnection)return this.getPeerConnection().then(function(){return t.getDescription(e)});if(this._remoteOffer){var i=this._remoteOffer;return this._remoteOffer=null,new Promise(function(e,n){return t.peerConnection.setRemoteDescription(i,e,n)}).then(function(){return t.getDescription(e)})}return!this.localMedia&&e.stream&&(this.peerConnection.addStream(e.stream),this.localMedia=e.stream),this._ready=!1,new Promise(function(e,i){"stable"===t._signalingState?t.peerConnection.createOffer(e,i,c.DEFAULT_OFFER_OPTIONS):t.peerConnection.createAnswer(e,i)}).then(function(e){return new Promise(function(i,n){t.peerConnection.setLocalDescription(e,i,n)})}).then(function(){return t._signalingState="stable"===t._signalingState?"have-local-offer":"stable",t._iceGathering.promise}).then(function(){var e=t.peerConnection.localDescription.sdp;return"undefined"!=typeof mozRTCPeerConnection&&(e=a(e)),e=p.Hacks.Chrome.needsExplicitlyInactiveSDP(e),e=p.Hacks.AllBrowsers.unmaskDtls(e),e=p.Hacks.Firefox.hasMissingCLineInSDP(e),t.emit("getDescription",{type:t.peerConnection.localDescription.type,sdp:e}),t._ready=!0,{body:e,contentType:"application/sdp"}})["catch"](function(e){throw t._ready=!0,new p.Exceptions.GetDescriptionError(e)})},n.prototype.getLocalStreams=function(){return this.peerConnection.getLocalStreams()},n.prototype.isReady=function(){return this._ready},n.prototype.getRemoteStreams=function(){return this.peerConnection.getRemoteStreams()},n.prototype.hasDescription=function(e){var t=r(e),i=!!s(e);return t&&!i&&this.queue("notification",t),i},n.prototype.isMuted=function(){return{audio:!1,video:!1}},n.prototype.mute=function(){},n.prototype.render=function(){},n.prototype.setDescription=function(e){var t=r(e);t&&this.queue("notification",t);var i=s(e);i=p.Hacks.Firefox.cannotHandleExtraWhitespace(i),i=p.Hacks.AllBrowsers.maskDtls(i);var n={type:"stable"===this._signalingState?"offer":"answer",sdp:i};this.emit("setDescription",n);var o=this;return new Promise(function(e,t){var i=new p.WebRTC.RTCSessionDescription(n);return o.peerConnection?o.peerConnection.setRemoteDescription(i,e,t):(o._remoteOffer=i,void e())}).then(function(){o._signalingState="stable"===o._signalingState?"have-remote-offer":"stable"})},n.prototype.unmute=function(){},n.prototype.updateIceServers=function(){},t.exports=n},{"../../queueingeventemitter":15,"../../util":48,"../../util/constants":47,"../../util/multipart":51,"../conversation-info":16,"sip.js":102,util:66}],36:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);var i=e._tokenPayload.sub,o=p.makeSIPURI(i,e.identity);t=p.withDefaults(t,{inviteClientTransactionFactory:u,logLevel:s.DEFAULT_LOG_LEVEL,registrarServer:s.REGISTRAR_SERVER(i),uaFactory:c.UA});var a=t.wsServer||s.WS_SERVER(i),l="debug"===t.logLevel,f=["conversation-events"],g=/^wss:\/\//.test(a),m=t.uaFactory,v=r.call(this,new m({autostart:!1,log:{builtinEnabled:l},extraSupported:f,hackAllowUnregisteredOptionTags:!0,keepAliveInterval:30,mediaHandlerFactory:h.defaultFactory,register:!1,registrarServer:t.registrarServer,traceSip:l,uri:o,wsServers:a,hackWssInTransport:g}));return Object.defineProperties(this,{_ua:{value:v}}),d.call(this,e,t),this}function r(e){var t=this;return e.on("invite",function(e){var i=new l(t,e);t._handleInviteServerTransaction(i)}),e.on("keepAliveTimeout",function(){t.emit("keepAliveTimeout")}),e}var s=e("../../util/constants"),o=e("util").inherits,a=e("../rtc-auth-info"),c=e("sip.js"),u=e("./sipjsinviteclienttransaction.js"),l=e("./sipjsinviteservertransaction"),h=e("./sipjsmediahandler"),d=e("./useragent"),p=e("../../util");o(n,d),n.prototype._register=function(e){function t(){var t=p.makeRegisterHeaders(e);i._ua.register({extraHeaders:t,closeWithHeaders:!0})}var i=this;return p.promiseFromEvents(t,this._ua,"registered","registrationFailed").then(function(e){var t;try{t=a.parseRTCAuthInfo(e.body)}catch(n){}if(t){var r=t.config.networkTraversalService;r&&(i._iceServers=r.ice_servers)}return i})},n.prototype._unregister=function(){function e(){var e=p.makeRegisterHeaders(i);t._ua.unregister({extraHeaders:e})}var t=this,i=this.accessManager.token;return p.promiseFromEvents(e,this._ua,"unregistered").then(function(){return t})},n.prototype._connect=function(){function e(){t._ua.start()}var t=this;return p.promiseFromEvents(e,this._ua,"connected","disconnected").then(function(){return t})},n.prototype._disconnect=function(){this._ua.stop(),this._ua.transport.disconnect();var e=p.defer();return setTimeout(e.resolve.bind(null,this)),e.promise},Object.freeze(n.prototype),t.exports=n},{"../../util":48,"../../util/constants":47,"../rtc-auth-info":22,"./sipjsinviteclienttransaction.js":33,"./sipjsinviteservertransaction":34,"./sipjsmediahandler":35,"./useragent":37,"sip.js":102,util:66}],37:[function(e,t,i){"use strict";function n(e,t){r.call(this),t=a.withDefaults(t,{inviteClientTransactionFactory:o});var i=!1,n=!1,s=[],c=t.iceServers||null,u=t.iceTransportPolicy||"all",l=t.callTimeout,h=null;return Object.defineProperties(this,{_iceServers:{get:function(){return s},set:function(e){s=e}},_iceServersOverride:{get:function(){return c},set:function(e){c=e}},_inviteClientTransactionFactory:{value:t.inviteClientTransactionFactory},_isConnected:{set:function(e){n=e}},_isRegistered:{set:function(e){i=e}},_token:{get:function(){return h},set:function(e){h=e}},accessManager:{enumerable:!0,value:e},callTimeout:{value:l},dialogs:{enumerable:!0,value:new Set},iceServers:{enumerable:!0,get:function(){return c||s}},iceTransportPolicy:{enumerable:!0,value:u},inviteClientTransactions:{enumerable:!0,value:new Set},inviteServerTransactions:{enumerable:!0,value:new Set},isConnected:{enumerable:!0,get:function(){return n}},isRegistered:{enumerable:!0,get:function(){return i}},token:{enumerable:!0,get:function(){return h}}}),this}var r=e("events").EventEmitter,s=e("util").inherits,o=e("./inviteclienttransaction"),a=e("../../util");s(n,r),n.prototype.connect=function(){if(this.isConnected){var e=a.defer();return setTimeout(e.resolve.bind(null,this)),e.promise}return this._connect().then(this._onConnectSuccess.bind(this),this._onConnectFailure.bind(this))},n.prototype._connect=function(){var e=a.defer();return setTimeout(e.resolve),e.promise},n.prototype._onConnectSuccess=function(){return this.emit("connected",this),this._isConnected=!0,this},n.prototype._onConnectFailure=function(e){throw e},n.prototype.disconnect=function(){if(!this.isConnected){var e=a.defer();return setTimeout(e.resolve.bind(null,this)),e.promise}return this._disconnect().then(this._onDisconnectSuccess.bind(this),this._onDisconnectFailure.bind(this))},n.prototype._disconnect=function(){var e=a.defer();return setTimeout(e.resolve),e.promise},n.prototype._onDisconnectSuccess=function(){return this.emit("disconnected",this),this._isConnected=!1,this},n.prototype._onDisconnectFailure=function(e){throw e},n.prototype.register=function(){return this.isRegistered&&this.accessManager.token===this.token?Promise.resolve(this):this.connect().then(this._register.bind(this,this.accessManager.token)).then(this._onRegisterSuccess.bind(this,this.accessManager.token),this._onRegisterFailure.bind(this))},n.prototype._register=function(){var e=a.defer();return setTimeout(e.resolve.bind(null,this)),e.promise},n.prototype._onRegisterSuccess=function(e){return this._isRegistered=!0,this._token=e,this.emit("registered",this),this},n.prototype._onRegisterFailure=function(e){throw this.emit("registrationFailed",this),e},n.prototype.unregister=function(){return this.isRegistered?this.connect().then(this._unregister.bind(this)).then(this._onUnregisterSuccess.bind(this),this._onUnregisterFailure.bind(this)):Promise.resolve(this)},n.prototype._unregister=function(){var e=a.defer();return setTimeout(e.resolve.bind(null,this)),e.promise},n.prototype._onUnregisterSuccess=function(){return this._isRegistered=!1,this.emit("unregistered",this),this},n.prototype._onUnregisterFailure=function(e){throw e},n.prototype.invite=function(e,t){var i=this;t=a.extend({callTimeout:this.callTimeout,iceServers:this.iceServers,iceTransportPolicy:this.iceTransportPolicy},t);var n=e.map?e:[e];n=n.map(function(e){return"sip:"+a.makeSIPURI(this.accessManager._tokenPayload.sub,e)},this);var r=new this._inviteClientTransactionFactory(this,n,t);return this.inviteClientTransactions.add(r),r.then(i._onInviteSuccess.bind(i,r),i._onInviteFailure.bind(i,r)),r},n.prototype._onInviteSuccess=function(e,t){return this.inviteClientTransactions["delete"](e),this._dialogCreated(t)},n.prototype._onInviteFailure=function(e){this.inviteClientTransactions["delete"](e)},n.prototype._handleInviteServerTransaction=function(e){this.inviteServerTransactions.add(e),e.then(this._onAcceptSuccess.bind(this,e),this._onAcceptFailure.bind(this,e)),setTimeout(this.emit.bind(this,"invite",e))},n.prototype._onAcceptSuccess=function(e,t){return this.inviteServerTransactions["delete"](e),this._dialogCreated(t)},n.prototype._dialogCreated=function(e){var t=this;return this.dialogs.add(e),e.once("disconnected",function(){t.emit("dialogDisconnected",e)}),e.once("failed",function(){t.dialogs["delete"](e),t.emit("dialogFailed",e)}),e.once("ended",function(){t.dialogs["delete"](e),t.emit("dialogEnded",e)}),this.emit("dialogCreated",e),e},n.prototype._onAcceptFailure=function(e){this.inviteServerTransactions["delete"](e)},t.exports=n},{"../../util":48,"./inviteclienttransaction":27,events:62,util:66}],38:[function(e,t,i){"use strict";function n(e,t,i,r,o){return this instanceof n?(c.call(this,e,t,i,o),Object.defineProperties(this,{_participants:{value:new Map},_session:{value:r},_trackIdToParticipants:{value:new Map}}),a(this,r),void s(this,e)):new n(e,t,i,r,o)}function r(e,t){return new Promise(function(i,n){function r(e){switch(Math.floor(e.status_code/100)){case 2:i();break;default:n(e)}}e.sendRequest("INFO",{body:JSON.stringify(t),extraHeaders:["Content-Type: application/conversation-info+json","Event: conversation","Info-Package: conversation-events"],receiveResponse:r})})}function s(e,t){function i(){a.renegotiate(t.mediaStreams).then(function(){var e=a.getConversationInfo();return e?r(o,e):void 0})}function n(t){r(o,u.trackDisabled(e._participantSid,t))}function s(t){r(o,u.trackEnabled(e._participantSid,t))}var o=e._session,a=o.mediaHandler.peerConnectionManager;t.on("trackAdded",i),t.on("trackRemoved",i),t.on("trackDisabled",n),t.on("trackEnabled",s),e.once("disconnected",function(){e.removeListener("trackAdded",i),e.removeListener("trackRemoved",i),e.removeListener("trackEnabled",s),e.removeListener("trackDisabled",n)})}function o(e,t,i,n){if(!(n instanceof h.OutgoingRequest)&&"application/conversation-info+json"===n.getHeader("Content-Type")){var s;try{s=u.parseNotification(n.body)}catch(o){return}e._onNotification(s),i.update(s).then(function(){var e=i.getConversationInfo();return e?r(t,e):void 0})}}function a(e,t){var i=t.mediaHandler.peerConnectionManager,n=i.getConversationInfo();n&&r(t,n);var s=o.bind(null,e,t,i);t.on("info",s),t.on("notify",s),t.mediaHandler.on("conversationInfo",function a(a){e._onNotification(a,!1)}),t.mediaHandler.dequeue("conversationInfo"),t.mediaHandler.peerConnectionManager.on("trackAdded",function(t,i){var n=e._trackIdToParticipants.get(t.id);n&&n.forEach(function(e){e.media._addRemoteTrack(t,i)})}),t.mediaHandler.peerConnectionManager.dequeue("trackAdded"),t.mediaHandler.peerConnectionManager.on("trackRemoved",function(t){var i=e._trackIdToParticipants.get(t.id);i&&i.forEach(function(e){var i=e.media.tracks.get(t.id);i&&e.media._removeTrack(i)})}),t.mediaHandler.peerConnectionManager.dequeue("trackRemoved")}var c=e("../conversation"),u=e("../conversation-info"),l=e("../v1/participant"),h=e("sip.js"),d=e("util").inherits,p=e("../../util");d(n,c),n.prototype._associateParticipantToTrackId=function(e,t){return p.map.addToMapOfSets(this._trackIdToParticipants,t.id,e),this},n.prototype._associateParticipantToTrackIds=function(e,t){return t.forEach(this._associateParticipantToTrackId.bind(this,e)),this},n.prototype._connectParticipant=function(e){if(this._participants.has(e.sid))return this;this._participants.set(e.sid,e);var t=this;return setTimeout(function(){t.emit("participantConnected",e),e.media.tracks.forEach(e.emit.bind(e,"trackAdded"))}),this},n.prototype._disassociateParticipantFromTrackId=function(e,t){var i=t.id;p.map.deleteFromMapOfSets(this._trackIdToParticipants,i,e);var n=e.media.tracks.get(i);return n&&e.media._removeTrack(n),this},n.prototype._disassociateParticipantFromTrackIds=function(e,t){return t.forEach(this._disassociateParticipantFromTrackId.bind(this,e)),this},n.prototype.disconnect=function(){this.preempt("disconnected"),this._session.terminate()},n.prototype._disconnectParticipant=function(e){return e.preempt("disconnected"),e.media.tracks.forEach(function(t){this._disassociateParticipantFromTrackId(e,t.id),e.media._removeTrack(t)},this),this._participants["delete"](e.sid),this.emit("participantDisconnected",e),this},n.prototype._onFullNotification=function(e){return e.conversation_state.participants.forEach(this._onParticipantConnected,this),this},n.prototype._onNotification=function(e){var t=e.conversation_state;return t?this.sid!==t.sid?this:this._onFullNotification(e):this._onPartialNotification(e)},n.prototype._onPartialNotification=function(e){return e.event_list.forEach(function(e){var t=e.event.toLowerCase();switch(t){case"participant_connected":return void this._onParticipantConnected(e);case"participant_disconnected":return void this._onParticipantDisconnected(e);case"participant_failed":return void this._onParticipantFailed(e)}var i=this._participants.get(e.participant_sid);if(i){switch(t){case"track_added":return void this._associateParticipantToTrackIds(i,e.tracks);case"track_removed":return void this._disassociateParticipantFromTrackIds(i,e.tracks)}i._onConversationEvent(e)}},this),this},n.prototype._onParticipantConnected=function(e){if(this.participantSid===e.participant_sid)return this;var t=this._participants.get(e.participant_sid),i=!1;return t||(t=new l(e.participant_sid,p.getUser(e.address),"connected"),i=!0),this._associateParticipantToTrackIds(t,e.tracks),i&&this._connectParticipant(t),this},n.prototype._onParticipantDisconnected=function(e){if(this.participantSid===e.participant_sid)return this;var t=this._participants.get(e.participant_sid);return t&&this._disconnectParticipant(t),this},n.prototype._onParticipantFailed=function(e){if(this.participantSid===e.participant_sid)return this;var t=this._participants.get(e.participant_sid)||new l(e.participant_sid,p.getUser(e.address),"failed");return this.emit("participantFailed",t),this},n.prototype.invite=function(e){var t=e,i=["Contact: "+this._session.contact,"Allow: "+h.UA.C.ALLOWED_METHODS.toString(),"Refer-To: "+this._session.ua.normalizeTarget(t),"Allow-Events: refer","Event: refer;id="+Math.floor(1e3*Math.random()+1)],n=this;return new Promise(function(e,t){n._session.sendRequest("REFER",{extraHeaders:i,receiveResponse:function(i){202===i.status_code?e():t(i)}})})},t.exports=n},{"../../util":48,"../conversation":17,"../conversation-info":16,"../v1/participant":31,"sip.js":102,util:66}],39:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);t=Object.assign({},t);var i=e.request,s=u.parseConversationSIDFromContactHeader(i.getHeader("Contact")),c=u.getUser(i.from.uri.toString()),l=i.getHeader(o.X_TWILIO_PARTICIPANTSID);l=l?l.split(";"):null;var h=l?l[0]:null;a.call(this,s,c,h,t),Object.defineProperties(this,{_session:{value:e}}),r(this,e)}function r(e,t){t.once("canceled",function(){e.preempt("canceled")}),t.once("failed",function(){try{e.preempt("failed")}catch(t){}})}var s=e("./conversation"),o=e("../../util/constants").headers,a=e("../incominginvite"),c=e("util").inherits,u=e("../../util");c(n,a),n.prototype._accept=function(e,t){t=Object.assign({},this._options,t),e.mediaStreams.forEach(function(e){this._session.mediaHandler.peerConnectionManager.addStream(e)},this);var i=this;return this._session.mediaHandler.peerConnectionManager.setConfiguration(t).then(function(){return new Promise(function(n,r){function o(){var r=new s(e,i.participantSid,i.conversationSid,i._session,t);n(r)}function a(){switch(i.state){case"canceled":return r(new Error("IncomingInvite canceled"));case"failed":return r(new Error("IncomingInvite failed"));case"rejected":return r(new Error("IncomingInvite rejected"))}}i._session.once("accepted",o),i._session.once("failed",a),i._session.accept({media:{stream:{}},infoHandler:function(e){i._session.emit("info",e),e.reply(200)}})})})},n.prototype._reject=function(){this._session.terminate()},t.exports=n},{"../../util":48,"../../util/constants":47,"../incominginvite":18,"./conversation":38,util:66}],40:[function(e,t,i){"use strict";function n(e,t){var i=e._tokenPayload.sub,n="debug"===t.logLevel,a=f.makeSIPURI(i,e.identity),c=t.wsServer.startsWith("wss://");t=Object.assign({registrarServer:o.REGISTRAR_SERVER(i),wsServer:o.WS_SERVER(i)},t);var u=new d.UA({autostart:!1,log:{builtinEnabled:n},extraSupported:["conversation-events-v2"],hackAllowUnregisteredOptionTags:!0,keepAliveInterval:30,mediaHandlerFactory:p.defaultFactory,register:!1,registrarServer:t.registrarServer,traceSip:n,uri:a,wsServers:t.wsServer,hackWssInTransport:c});h.call(this),Object.defineProperties(this,{_accessManager:{value:e},_iceServers:{value:[],writable:!0},_options:{value:t},_ua:{value:u}}),r(this,e),s(this)}function r(e,t){t.on("tokenUpdated",function(){return"listening"===e.state?e._register():void 0})}function s(e){e._ua.on("invite",function(t){var i=Object.assign({iceServers:e._iceServers},e._options),n=new a(t,i);e.emit("invite",n)})}var o=e("../../util/constants"),a=e("./incominginvite"),c=e("util").inherits,u=e("./outgoinginvite"),l=e("../rtc-auth-info"),h=e("../"),d=e("sip.js"),p=e("./sipjsmediahandler"),f=e("../../util");c(n,h),n.prototype._close=function(e){return this.transition("closing",e),this._ua.stop(),this._ua.transport.disconnect(),this.transition("closed",e),Promise.resolve(this)},n.prototype._listen=function(e){var t=this;return this.transition("attemptingToListen",e),this._register().then(function(){return t.transition("listening",e),t})},n.prototype._open=function(e){function t(){i._ua.start()}var i=this;return this.transition("opening",e),f.promiseFromEvents(t,this._ua,"connected","disconnected").then(function(){return i.transition("open",e),i})},n.prototype._unlisten=function(e){function t(){var e=f.makeRegisterHeaders(n);i._ua.unregister({extraHeaders:e})}var i=this,n=this._accessManager.token;return this.transition("attemptingToUnlisten",e),f.promiseFromEvents(t,this._ua,"unregistered").then(function(){return i.transition("open",e),i})},n.prototype._register=function(){function e(){var e=f.makeRegisterHeaders(i);t._ua.register({extraHeaders:e,closeWithHeaders:!0})}var t=this,i=this._accessManager.token;return f.promiseFromEvents(e,this._ua,"registered","registrationFailed").then(function(e){var i;try{i=l.parseRTCAuthInfo(e.body)}catch(n){return}var r=i.config.networkTraversalService;r&&(t._iceServers=r.ice_servers)})},n.prototype._connect=function(e,t,i,n){n=Object.assign({iceServers:this._iceServers},this._options,n);var r=this._ua,s=this._accessManager.token,o=this._accessManager._tokenPayload.sub;return new u(o,s,r,e,t,i,n)},t.exports=n},{"../":19,"../../util":48,"../../util/constants":47,"../rtc-auth-info":22,"./incominginvite":39,"./outgoinginvite":41,"./sipjsmediahandler":43,"sip.js":102,util:66}],41:[function(e,t,i){"use strict";function n(e,t,i,o,a,c,u){if(!(this instanceof n))return new n(e,t,i,o,a,c,u);u=Object.assign({},u),l.call(this,o,a,c,u),Object.defineProperties(this,{_session:{value:null,writable:!0}});var h=this;r(this,e,t,i,a).then(function(e){e&&(h._session=e,s(h,e))})}function r(e,t,i,n,r){var s=e.identities.map(function(e){return"sip:"+p.makeSIPURI(t,e)}),a="sip:"+p.makeSIPURI(t,"orchestrator"),c=[p.selectTokenHeader(i)+": "+i,o.headers.X_TWILIO_CLIENT+": "+JSON.stringify({p:"browser"}),o.headers.X_TWILIO_PARTICIPANTS+": "+s.join(",")+(r?";label="+r:""),"Session-Expires: 120"],u=e._options,l=e.localMedia,f=new h;return l.mediaStreams.forEach(f.addStream,f),f.setConfiguration(u).then(function(){if("canceled"===e.state)return null;var t=n.invite(a,{extraHeaders:c,media:{stream:{}},mediaHandlerFactory:function(){return new d(f)},infoHandler:function(e){t.emit("info",e),e.reply(200)}});return t})}function s(e,t){t.once("accepted",function(i){e.preempt("accepted");var n=i.getHeader(c.X_TWILIO_PARTICIPANTSID);n=n?n.split(";"):null;var r=n?n[0]:null,s=p.parseConversationSIDFromContactHeader(i.getHeader("Contact")),o=new a(e.localMedia,r,s,t,e._options);e._deferred.resolve(o)}),t.once("canceled",function(){e.preempt("canceled"),e._deferred.reject(new Error("OutgoingInvite canceled"))}),t.once("failed",function(){try{e.preempt("failed"),e._deferred.reject(new Error("OutgoingInvite failed"))}catch(t){}}),t.once("rejected",function(){e.preempt("rejected"),e._deferred.reject(new Error("OutgoingInvite rejected"))})}var o=e("../../util/constants"),a=e("./conversation"),c=e("../../util/constants").headers,u=e("util").inherits,l=e("../outgoinginvite"),h=e("./peerconnectionmanager"),d=e("./sipjsmediahandler"),p=e("../../util");u(n,l),n.prototype._cancel=function(){this._session&&this._session.terminate()},t.exports=n},{"../../util":48,"../../util/constants":47,"../outgoinginvite":20,"./conversation":38,"./peerconnectionmanager":42,"./sipjsmediahandler":43,util:66}],42:[function(e,t,i){"use strict";function n(e){return this instanceof n?(s.call(this),o.WebRTC.isSupported(),e=Object.assign({iceGatheringTimeout:c,initialOffers:u,RTCPeerConnection:o.WebRTC.RTCPeerConnection,RTCSessionDescription:o.WebRTC.RTCSessionDescription},e),void Object.defineProperties(this,{_changedPeerConnections:{value:new Set},_configurationIsSet:{value:!1,writable:!0},_iceGatheringTimeout:{value:e.iceGatheringTimeout},_iceServers:{value:null,writable:!0},_iceTransportPolicy:{value:null,writable:!0},_initialOffers:{value:e.initialOffers},_isInitiator:{value:null,writable:!0},_localStreams:{value:new Set},_peerConnections:{value:new Map},_pendingCreateOffers:{value:new Set},_pendingRemoteOffers:{value:new Map},_remoteTracks:{value:new Map},_RTCPeerConnection:{value:e.RTCPeerConnection},_RTCSessionDescription:{value:e.RTCSessionDescription}})):new n}var r=e("util").inherits,s=e("../../queueingeventemitter"),o=e("sip.js"),a=e("../../util"),c=1e4,u=1;r(n,s),n.prototype._addRemoteTrack=function(e,t){this._remoteTracks.set(e.id,e),this.queue("trackAdded",e,t)},n.prototype._close=function(e){var t=this._get(e);t.close(),this._changedPeerConnections["delete"](e),this._peerConnections["delete"](e)},n.prototype._create=function(e){if(null!==e&&"undefined"!=typeof e||(e=a.makeUUID()),this._has(e))throw new Error("PeerConnection "+e+" already exists");var t=this._getConfiguration(),i=new this._RTCPeerConnection(t);this._localStreams.forEach(function(e){i.addStream(e)}),this._peerConnections.set(e,i)},n.prototype._createAnswer=function(e){var t=this;return new Promise(function(i,n){var r=t._get(e);r.createAnswer(i,n)}).then(function(i){return t._setLocalDescription(e,i)})},n.prototype._createOffer=function(e){var t=this;return new Promise(function(i,n){var r=t._get(e);r.createOffer(i,n,{offerToReceiveAudio:!0,offerToReceiveVideo:!0})}).then(function(i){return t._setLocalDescription(e,i)})},n.prototype._getConfiguration=function(){if(!this._configurationIsSet)throw new Error("Call setConfiguration first");var e={iceServers:this._iceServers};return this._iceTransportPolicy&&(e.iceTransportPolicy=this._iceTransportPolicy),"object"==typeof navigator&&"function"==typeof navigator.webkitGetUserMedia&&e.iceTransportPolicy&&(e.iceTransports=e.iceTransportPolicy),e.iceServers&&(e.iceServers=e.iceServers.map(function(e){var t=Object.assign({},e);return t.url&&!t.urls&&(t.urls=[t.url],delete t.url),t})),e},n.prototype._get=function(e){var t=this._peerConnections.get(e);if(!t)throw new Error("PeerConnection "+e+" does not exist");return t},n.prototype._has=function(e){return this._peerConnections.has(e)},n.prototype._removeRemoteTrack=function(e){this._remoteTracks["delete"](e.id),this.emit("trackRemoved",e)},n.prototype._setLocalDescription=function(e,t){var i,n=this;return new Promise(function(r,s){i=n._get(e),i.setLocalDescription(t,r,s)}).then(function(){return new Promise(function(e){return"complete"===i.iceGatheringState?void e():(i.onicecandidate=function(t){t.candidate||e()},void setTimeout(e,n._iceGatheringTimeout))})}).then(function(){n._changedPeerConnections.add(e)})},n.prototype._setRemoteDescription=function(e,t){var i,n=this;return new Promise(function(r,s){i=n._get(e);var o=new n._RTCSessionDescription(t);i.setRemoteDescription(o,r,s)}).then(function(){return"have-remote-offer"===i.signalingState?n._createAnswer(e):void 0})},n.prototype._updateRemoteTracks=function(){var e=new Map;this._peerConnections.forEach(function(t){t.getRemoteStreams().forEach(function(t){t.getTracks().forEach(function(i){e.set(i.id,i),this._remoteTracks.has(i.id)||this._addRemoteTrack(i,t)},this)},this)},this),this._remoteTracks.forEach(function(t,i){e.has(i)||this._removeRemoteTrack(t)},this)},n.prototype.addStream=function(e){this._localStreams.add(e),this._peerConnections.forEach(function(t){t.addStream(e)})},n.prototype.close=function(){Array.from(this._peerConnections.keys()).forEach(this._close,this)},n.prototype.getConversationInfo=function(){if(!this._changedPeerConnections.size)return null;var e=[];return this._changedPeerConnections.forEach(function(t){var i=this._get(t),n=i.localDescription;n&&e.push({id:t,description:{type:n.type,sdp:n.sdp}})},this),{protocol_version:"v2",peer_connections:e}},n.prototype.removeStream=function(e){this._localStreams["delete"](e),this._peerConnections.forEach(function(t){try{t.removeStream(e)}catch(i){}})},n.prototype.renegotiate=function(e){return this._localStreams.forEach(this.removeStream,this),(e||this._localStreams).forEach(this.addStream,this),Promise.all(Array.from(this._peerConnections.keys()).map(this._createOffer,this)).then(function(){})},n.prototype.setConfiguration=function(e){if(this._iceServers=e.iceServers,"iceTransportPolicy"in e&&(this._iceTransportPolicy=e.iceTransportPolicy),!this._configurationIsSet&&(this._configurationIsSet=!0,this._isInitiator=null===this._isInitiator?!0:this._isInitiator,this._isInitiator))for(var t=0;t<this._initialOffers;t++)this._pendingCreateOffers.add(a.makeUUID());var i=[],n=this;return this._pendingCreateOffers.forEach(function(e){i.push(new Promise(function(t){n._create(e),t(n._createOffer(e))}))}),this._pendingCreateOffers.clear(),this._pendingRemoteOffers.forEach(function(e,t){i.push(new Promise(function(i){n._create(t),i(n._setRemoteDescription(t,e))}))}),this._pendingRemoteOffers.clear(),Promise.all(i).then(function(){n._updateRemoteTracks(n._peerConnections)})},n.prototype.update=function(e){if(this._isInitiator=null===this._isInitiator?!1:this._isInitiator,this._changedPeerConnections.clear(),"object"!=typeof e)return Promise.resolve();var t=e.peer_connections;if(!(t instanceof Array))return Promise.resolve();var i=this;return Promise.all(t.map(function(e){if("object"==typeof e){var t=e.description;if("object"==typeof t){var i=e.id;switch(t.type){case"create-offer":if(!this._has(i)){if(!this._configurationIsSet)return this._pendingCreateOffers.add(i);this._create(i)}return this._createOffer(i);case"offer":if(!this._has(i)){if(!this._configurationIsSet)return this._pendingRemoteOffers.set(i,t);this._create(i)}return this._setRemoteDescription(i,t);case"answer":return this._setRemoteDescription(i,t);case"close":return this._close(i)}}}},this)).then(function(){i._updateRemoteTracks(i._peerConnections)})},t.exports=n},{"../../queueingeventemitter":15,"../../util":48,"sip.js":102,util:66}],43:[function(e,t,i){"use strict";function n(e){return this instanceof n?(c.call(this),e=e||new a,void Object.defineProperties(this,{peerConnectionManager:{enumerable:!0,value:e}})):new n(e)}function r(e){if("application/conversation-info+json"!==e.getHeader("Content-Type"))return null;try{return s.parseNotification(e.body)}catch(t){return null}}var s=e("../conversation-info"),o=e("util").inherits,a=e("./peerconnectionmanager"),c=e("../../queueingeventemitter"),u=e("sip.js");o(n,c),n.defaultFactory=function(){return new n(new a)},n.defaultFactory.isSupported=function(){return u.WebRTC.isSupported()},n.prototype.close=function(){this.peerConnectionManager.close()},n.prototype.getDescription=function(){return Promise.resolve({body:JSON.stringify(this.peerConnectionManager.getConversationInfo()),contentType:"application/conversation-info+json"})},n.prototype.hasDescription=function(){return!0},n.prototype.hold=function(){},n.prototype.isReady=function(){return!0},n.prototype.isMuted=function(){return{audio:!1,video:!1}},n.prototype.mute=function(){},n.prototype.render=function(){},n.prototype.setDescription=function(e){var t=r(e);return t&&this.queue("conversationInfo",t),this.peerConnectionManager.update(t)},n.prototype.unhold=function(){},n.prototype.unmute=function(){},n.prototype.updateIceServers=function(){},t.exports=n},{"../../queueingeventemitter":15,"../conversation-info":16,"./peerconnectionmanager":42,"sip.js":102,util:66}],44:[function(e,t,i){"use strict";function n(e,t){o.call(this);var i=null,n=e;t=s(t),Object.defineProperties(this,{_lock:{get:function(){return i},set:function(e){i=e}},_state:{get:function(){return n},set:function(e){n=e}},_states:{value:t},isLocked:{enumerable:!0,get:function(){return null!==i}},state:{enumerable:!0,get:function(){return n}}})}function r(e){var t=c.defer();return t.name=e,t.depth=0,t}function s(e){var t=new Map;for(var i in e)t.set(i,new Set(e[i]));return t}var o=e("events").EventEmitter,a=e("util").inherits,c=e("./util");a(n,o),n.prototype.bracket=function(e,t){function i(e){if(r.hasLock(n)&&r.releaseLockCompletely(n),e)throw e}var n,r=this;return this.takeLock(e).then(function(e){return n=e,t(n)}).then(function(e){return i(),e},i)},n.prototype.hasLock=function(e){return this._lock===e},n.prototype.preempt=function(e,t){if(!this.valid(e))throw new Error('Cannot transition from "'+this.state+'" to "'+e+'"');var i;this.isLocked&&(i=this._lock,this._lock=null);var n,r=null;null===t||"undefined"==typeof t?i&&(n=new Error(i.name+" was preempted")):(i&&(n=new Error(i.name+" was preempted by "+t)),r=this.takeLockSync(t));var s=r?null:this.takeLockSync("preemption");return this.transition(e,r||s),i&&i.reject(n),s&&this.releaseLock(s),r},n.prototype.releaseLock=function(e){if(!this.isLocked)throw new Error("Could not release the lock for "+e.name+" because the StateMachine is not locked");if(!this.hasLock(e))throw new Error("Could not release the lock for "+e.name+" because "+this._lock.name+" has the lock");0===e.depth?(this._lock=null,e.resolve()):e.depth--},n.prototype.releaseLockCompletely=function(e){if(!this.isLocked)throw new Error("Could not release the lock for "+e.name+" because the StateMachine is not locked");if(!this.hasLock(e))throw new Error("Could not release the lock for "+e.name+" because "+this._lock.name+" has the lock");e.depth=0,this._lock=null,e.resolve()},n.prototype.takeLock=function u(e){if("object"==typeof e){var t=e,i=this;return new Promise(function(e){
e(i.takeLockSync(t))})}var n=e;if(this.isLocked){var u=this.takeLock.bind(this,n);return this._lock.promise.then(u,u)}return Promise.resolve(this.takeLockSync(n))},n.prototype.takeLockSync=function(e){var t="string"==typeof e?null:e,i=t?t.name:e;if(t&&!this.hasLock(t)||!t&&this.isLocked)throw new Error("Could not take the lock for "+i+" because the lock for "+this._lock.name+" was not released");if(t)return t.depth++,t;var n=r(i);return this._lock=n,n},n.prototype.transition=function(e,t){if(this.isLocked){if(!t)throw new Error("You must provide the key in order to transition");if(!this.hasLock(t))throw new Error("Could not transition using the key for "+t.name+" because "+this._lock.name+" has the lock")}else if(t)throw new Error("Key provided for "+t.name+", but the StateMachine was not locked (possibly due to preemption)");if(!this.valid(e))throw new Error('Cannot transition from "'+this.state+'" to "'+e+'"');this._state=e,this.emit("stateChanged",e)},n.prototype.tryTransition=function(e,t){try{this.transition(e,t)}catch(i){return!1}return!0},n.prototype.valid=function(e){var t=this._states.get(this.state);return t.has(e)},t.exports=n},{"./util":48,events:62,util:66}],45:[function(e,t,i){(function(i){"use strict";function n(e,t,i){function o(e){return u.post(e)}function h(){if(f&&m.length){var e=m.splice(0,m.length);r(i.post,p,e)}}if(!(this instanceof n))return new n(e,t,i);i=l.extend({logLevel:a.DEFAULT_LOG_LEVEL,post:o},i);var d=new c("StatsReporter",i.logLevel),p=this,f=!1,g=t.userAgent.accessManager,m=[];Object.defineProperties(this,{_log:{value:d},_samples:{value:m},accessManager:{enumerable:!0,value:g},dialog:{enumerable:!0,value:t},eventGateway:{enumerable:!0,value:e}}),t.on("stats",function(e){m.push(e),m.length>=10&&h()}),t.once("ended",h),s(i.post,this).then(function(){f=!0,(m.length>=10||t.ended)&&h()})}function r(e,t,i){var n="https://"+t.eventGateway+"/v1/Calls/"+t.dialog.callSid+"/Statistics",r={callsid:t.dialog.callSid,samples:i},s=t._log;return o(e,n,t.accessManager.token,r).then(s.debug.bind(s,"Post to gateway succeeded"),s.debug.bind(s,"Post to gateway failed"))}function s(e,t){var i="https://"+t.eventGateway+"/v1/Calls",n={callsid:t.dialog.callSid,sip:{invite_to_180:t.dialog.inviteTo180},platform:{name:d.name,version:d.version,media_engine:"WebRTC",sdk:h,user_agent:p}},r=t._log;return o(e,i,t.accessManager.token,n).then(r.debug.bind(r,"Initial post to gateway succeeded"),r.debug.bind(r,"Initial post to gateway failed"))}function o(e,t,i,n){var r={url:t,body:n,headers:{"Content-Type":"application/json","X-Twilio-Token":i}};return e(r)}var a=e("./util/constants"),c=e("./util/log"),u=e("./util/request"),l=e("./util"),h=e("../package.json").version,d={name:"Unknown",version:"0.0"},p="Unknown";"undefined"!=typeof navigator&&navigator.userAgent?(p=navigator.userAgent,d=l.parseUserAgent(navigator.userAgent)):"undefined"!=typeof i&&(d={name:"Node",version:i.versions.node}),t.exports=n}).call(this,e("_process"))},{"../package.json":106,"./util":48,"./util/constants":47,"./util/log":49,"./util/request":52,_process:64}],46:[function(e,t,i){"use strict";function n(e){if(!(this instanceof n))return new n(e);r.call(this);var t=new Error("Canceled"),i=o.defer(),s=!0,a=!1;e.then(function(){s=!1,i.resolve.apply(i.promise,arguments)},function(){s=!1,i.reject.apply(i.promise,arguments)}),Object.defineProperties(this,{_cancel:{value:i.reject.bind(i,t)},_isCancelable:{get:function(){return s}},_isCanceled:{get:function(){return a},set:function(e){a=e}},_promise:{value:i.promise},isCanceled:{enumerable:!0,get:function(){return a}}})}var r=e("events").EventEmitter,s=e("util").inherits,o=e("./");s(n,r),n.prototype.cancel=function(){if(!this._isCancelable||this.isCanceled)throw new Error("Cancellation failed");return this._isCanceled=!0,this.emit("canceled",this),this._cancel(),this},n.prototype["catch"]=function(){return this._promise["catch"].apply(this._promise,arguments)},n.prototype.then=function(){return this._promise.then.apply(this._promise,arguments)},t.exports=n},{"./":48,events:62,util:66}],47:[function(e,t,i){"use strict";t.exports.CLIENT_VERSION=2,t.exports.DEFAULT_LOG_LEVEL="warn",t.exports.EVENT_GATEWAY="eventgw.twilio.com",t.exports.REGISTRAR_SERVER=function(e){return e+".endpoint.twilio.com"},t.exports.WS_SERVER=function(e){return"wss://"+e+".endpoint.twilio.com"},t.exports.DEFAULT_CALL_TIMEOUT=5e4,t.exports.MAX_ADDRESS_LENGTH=256;var n={};"undefined"!=typeof navigator&&navigator.mozGetUserMedia?n={offerToReceiveAudio:!0,offerToReceiveVideo:!0}:n.mandatory={OfferToReceiveAudio:!0,OfferToReceiveVideo:!0},t.exports.DEFAULT_OFFER_OPTIONS=n,t.exports.headers={X_TWILIO_ACCESSTOKEN:"X-Twilio-AccessToken",X_TWILIO_ACCOUNTSID:"X-Twilio-Accountsid",X_TWILIO_CALLSID:"X-Twilio-Callsid",X_TWILIO_CLIENT:"X-Twilio-Client",X_TWILIO_CLIENTVERSION:"X-Twilio-Clientversion",X_TWILIO_PARTICIPANTS:"X-Twilio-Participants",X_TWILIO_PARTICIPANTSID:"X-Twilio-ParticipantSid",X_TWILIO_TOKEN:"X-Twilio-Token"};var r=e("./twilioerror");t.exports.twilioErrors=Array.prototype.reduce.call([{name:"GATEWAY_CONNECTION_FAILED",message:"Could not connect to Twilio's servers"},{name:"GATEWAY_DISCONNECTED",message:"Connection to Twilio's servers was lost"},{name:"INVALID_ARGUMENT",message:"One or more arguments passed were invalid"},{name:"INVALID_TOKEN",message:"The token is invalid or malformed"},{name:"LISTEN_FAILED",message:"Failed to listen with the supplied token"},{name:"TOKEN_EXPIRED",message:"Client's active token has expired"},{name:"CONVERSATION_CREATE_FAILED",message:"Failed to create Conversation"},{name:"CONVERSATION_INVITE_FAILED",message:"Failed to add Participant to Conversation"},{name:"CONVERSATION_INVITE_TIMEOUT",message:"Invite to Participant timed out"},{name:"CONVERSATION_INVITE_REJECTED",message:"Invite was rejected by Participant"},{name:"CONVERSATION_INVITE_CANCELED",message:"Invite to Participant was canceled"},{name:"CONVERSATION_JOIN_FAILED",message:"Failed to join Conversation"},{name:"CONVERSATION_JOIN_CANCELED",message:"Incoming Invite was canceled by the sender"},{name:"SDP_NEGOTIATION_FAILED",message:"Failed to negotiate media with Participant(s)"},{name:"ICE_CONNECT_FAILED",message:"Could not find match for all candidates"},{name:"ICE_DISCONNECTED",message:"Liveliness check has failed; may be recoverable"},{name:"MEDIA_ACCESS_DENIED",message:"Could not get access to microphone or camera"}],function(e,t){return e[t.name]=new r(t),e},{})},{"./twilioerror":54}],48:[function(e,t,i){(function(i,n){"use strict";function r(){return i.env.SDK_VERSION||"unknown"}function s(){var e=r(),t="undefined"==typeof navigator?{}:navigator;return{p:"browser",v:e,browser:{userAgent:t.userAgent||"unknown",platform:t.platform||"unknown"},plugin:"rtc"}}function o(e){var t=e.length%4;if(t>0){var i=4-t;e+=new Array(i+1).join("=")}return e=e.replace(/-/g,"+").replace(/_/g,"/"),a(e)}function a(e){return"function"==typeof atob?atob(e):new n(e,"base64").toString()}function c(e){var t,i=e.split(".");try{t=JSON.parse(o(i[0]))}catch(n){return A.X_TWILIO_ACCESSTOKEN}return"string"==typeof t.cty&&t.cty.match(/^twilio-fpa/)?A.X_TWILIO_ACCESSTOKEN:A.X_TWILIO_TOKEN}function u(e){var t=s(),i=[c(e)+": "+e,A.X_TWILIO_CLIENT+": "+JSON.stringify(t),A.X_TWILIO_CLIENTVERSION+": "+R.CLIENT_VERSION];return i}function l(e,t){return encodeURIComponent(encodeURIComponent(t))+"@"+R.REGISTRAR_SERVER(e)}function h(t){var i=e("sip.js"),n=i.Grammar.parse(t,"Contact");return-1!==n&&n[0]?n[0].parsed.uri.user:null}function d(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0,i="x"===e?t:3&t|8;return i.toString(16)})}function p(e,t){return e=e||{},t=Array.prototype.slice.call(arguments,1),t.forEach(function(t){f(e,t)}),e}function f(e,t){for(var i in t)i in e||(e[i]=t[i]);return e}function g(e,t){return e=e||{},t=Array.prototype.slice.call(arguments,1),t.forEach(function(t){m(e,t)}),e}function m(e,t){for(var i in t)e[i]=t[i];return e}function v(e,t,i,n){return new Promise(function(r,s){function o(){var e=[].slice.call(arguments);n&&t.removeListener(n,a),r.apply(null,e)}function a(){var e=[].slice.call(arguments);t.removeListener(i,o),s.apply(null,e)}t.once(i,o),n&&t.once(n,a),e()})}function _(e){var t=e.match(/<sip:(.*)@(.*)$/);return t?t[1]:null}function T(e,t){return t.split(".").reduce(function(e,t){return e?e[t]:null},e)}function E(e){var t,i=e.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)\.(\d+)/i)||[],n={name:i[1],version:"undefined"!=typeof i[2]&&"undefined"!=typeof i[3]&&i[2]+"."+i[3]};return/trident/i.test(n.name)?(t=/\brv[ :]+(\d+)\.(\d+)/g.exec(e)||[],{name:"IE",version:t[1]?t[1]+"."+t[2]:"Unknown"}):"Chrome"===n.name&&(t=e.match(/\b(OPR|Edge)\/(\d+)\.(\d+)/),null!==t)?{name:"Opera",version:t[2]+"."+t[3]}:("MSIE"===n.name&&(n.name="IE"),{name:n.name||"Unknown",version:n.version||"Unknown"})}function y(e,t){e.splice(0,e.length),t.forEach(function(t){e.push(t)})}function S(e,t){var i=(t.forEach?t:[t]).map(l.bind(e)).filter(function(e){return e.length>R.MAX_ADDRESS_LENGTH});if(i.length)throw new Error("Addresses must not exceed "+R.MAX_ADDRESS_LENGTH+" characters: "+i)}function C(){var e={};return e.promise=new Promise(function(t,i){e.resolve=t,e.reject=i}),e}var R=e("./constants"),A=R.headers,I=e("./map");t.exports.makeRegisterHeaders=u,t.exports.makeSIPURI=l,t.exports.getUser=h,t.exports.makeUUID=d,t.exports.withDefaults=p,t.exports.extend=g,t.exports.promiseFromEvents=v,t.exports.parseConversationSIDFromContactHeader=_,t.exports.getOrNull=T,t.exports.parseUserAgent=E,t.exports.overwriteArray=y,t.exports.map=I,t.exports.validateAddresses=S,t.exports.selectTokenHeader=c,t.exports.defer=C}).call(this,e("_process"),e("buffer").Buffer)},{"./constants":47,"./map":50,_process:64,buffer:58,"sip.js":102}],49:[function(e,t,i){"use strict";function n(e,t){return this instanceof n?(t=t?n.getLevelByName(t):n.INFO,void Object.defineProperties(this,{logLevel:{value:t},name:{value:e}})):new n(e,t)}var r=e("./constants").twilioErrors;Object.defineProperties(n,{DEBUG:{value:0},INFO:{value:1},WARN:{value:2},ERROR:{value:3},OFF:{value:4},_levels:{value:[{name:"DEBUG",logFn:console.log},{name:"INFO",logFn:console.info},{name:"WARN",logFn:console.warn},{name:"ERROR",logFn:console.error}]}}),n.getLevelByName=function(e){if(!isNaN(e))return parseInt(e,10);if(e=e.toUpperCase(),-1===["OFF","ERROR","WARN","INFO","DEBUG"].indexOf(e)){var t='Log level must be one of: ["off", "error", "warn", "info", "debug"]';throw r.INVALID_ARGUMENT.clone(t)}return n[e]},n.prototype.log=function(e,t){var i=n._levels[e];if(!i)throw r.INVALID_ARGUMENT.clone("Invalid log level");if(this.logLevel<=e){var s=i.name,o=[this.name,s];i.logFn.apply(console,o.concat(t))}return this},n.prototype.debug=function(){return this.log(n.DEBUG,[].slice.call(arguments))},n.prototype.info=function(){return this.log(n.INFO,[].slice.call(arguments))},n.prototype.warn=function(){return this.log(n.WARN,[].slice.call(arguments))},n.prototype.error=function(){return this.log(n.ERROR,[].slice.call(arguments))},n.prototype["throw"]=function(e,t){throw e.clone&&(e=e.clone(t)),this.log(n.ERROR,e),e},t.exports=n},{"./constants":47}],50:[function(e,t,i){"use strict";function n(e,t,i){return e.has(t)||e.set(t,new Set),e.get(t).add(i),e}function r(e,t,i){if(!e.has(t))return e;var n=e.get(t);return n["delete"](i),n.size||e["delete"](n),e}t.exports.addToMapOfSets=n,t.exports.deleteFromMapOfSets=r},{}],51:[function(e,t,i){"use strict";function n(e,t){for(var i=e.split(";").slice(1),n=0;n<i.length;n++){var r=i[n],s=r.indexOf("=");if(-1!==s){var o=r.slice(0,s).replace(/^ */,"").replace(/ *$/,"");if(o===t){var a=r.slice(s+1).replace(/^ */,"").replace(/ *$/,""),c=a.match(/^"(.*)"$/);return c?c[1].replace(/\\"/,'"'):a}}}return null}function r(e,t){var i=n(e,"boundary");if(!i)return[];var r="\r\n--"+i,s=("\r\n"+t).split(r);s=s.slice(1,s.length-1);var o=[];return s.forEach(function(e){var t=e.match(/\r\nContent-Type: (.*)\r\n/);if(t){var i=t[1].replace(/^ */,"").replace(/ *$/,""),n=e.indexOf("\r\n\r\n");if(-1!==n){var r=e.slice(n+4);o.push({contentType:i,body:r})}}}),o}function s(e,t){for(var i=0;i<t.length;i++){var n=t[i];if(n.contentType===e)return n.body;if(/^multipart\//.test(n.contentType)){var o=s(e,r(n.contentType,n.body));if(o)return o}}return null}var o=s.bind(null,"application/conversation-info+json"),a=s.bind(null,"application/sdp");t.exports.getConversationInfo=o,t.exports.getSDP=a,t.exports.parse=r},{}],52:[function(e,t,i){"use strict";function n(e,t,i){i=r.extend({xmlHttpRequestFactory:s},i);var n=r.defer(),o=new i.xmlHttpRequestFactory;o.open(e,t.url,!0),o.onreadystatechange=function(){4===o.readyState&&(200<=o.status&&o.status<300?n.resolve(o.responseText):n.reject(new Error(o.responseText)))};for(var a in t.headers)o.setRequestHeader(a,t.headers[a]);return o.send(JSON.stringify(t.body)),n.promise}var r=e("./"),s="undefined"==typeof XMLHttpRequest?e("xmlhttprequest").XMLHttpRequest:XMLHttpRequest,o=n;o.get=function(e,t){return new this("GET",e,t)},o.post=function(e,t){return new this("POST",e,t)},t.exports=o},{"./":48,xmlhttprequest:107}],53:[function(e,t,i){"use strict";function n(e,t){if(!(this instanceof n))return new n(e,t);r.call(this);var i=o.defer(),s=!1,a=new Error("Timed out"),c=null,u=null;Object.defineProperties(this,{_deferred:{value:i},_isTimedOut:{get:function(){return s},set:function(e){s=e}},_timedOut:{value:a},_timeout:{get:function(){return c},set:function(e){c=e}},_timer:{get:function(){return u},set:function(e){u=e}},_promise:{value:i.promise},isTimedOut:{enumerable:!0,get:function(){return s}},timeout:{enumerable:!0,get:function(){return c}}});var l=this;e.then(function(){clearTimeout(l._timer),i.resolve.apply(i.promise,arguments)},function(){clearTimeout(l._timer),i.reject.apply(i.promise,arguments)}),t&&this.start(t)}var r=e("events").EventEmitter,s=e("util").inherits,o=e("./");s(n,r),n.prototype["catch"]=function(){return this._promise["catch"].apply(this._promise,arguments)},n.prototype.start=function(e){if(this._timer)return this;var t=this;return this._timeout=e,this._timer=setTimeout(function(){t._timer&&(t._isTimedOut=!0,t.emit("timedOut",t),t._deferred.reject(t._timedOut))},this.timeout),this},n.prototype.then=function(){return this._promise.then.apply(this._promise,arguments)},t.exports=n},{"./":48,events:62,util:66}],54:[function(e,t,i){"use strict";function n(e,t){Object.defineProperties(this,{_errorData:{value:e},name:{value:e.name},message:{value:t||e.message}})}var r=e("util").inherits;r(n,Error),n.prototype.toString=function(){return[this.name,this.message].join(" | ")},n.prototype.clone=function(e){return new n(this._errorData,e)},t.exports=n},{util:66}],55:[function(e,t,i){"use strict";function n(e){return null!==e}function r(e){var t=JSON.parse(e);return u("Full or Partial Notification",t)}function s(e){return"object"==typeof e?e:r(e)}function o(e,t,i,n){if(!(e instanceof t))throw new Error(i+" is not "+n+": "+e);return e}function a(e,t){return o(t,Array,e,"an array")}function c(e,t){if(!Number.isInteger(t))throw new Error(e+" is not an integer: "+t);return t}function u(e,t){return o(t,Object,e,"an object")}function l(e,t){if("string"!=typeof t)throw new Error(e+" is not a string: "+t);return t}function h(e,t){try{return e()}catch(i){return t}}t.exports.isNotNull=n,t.exports.parseJSON=r,t.exports.parseStringOrJSON=s,t.exports.validateInstanceOf=o,t.exports.validateArray=a,t.exports.validateInteger=c,t.exports.validateObject=u,t.exports.validateString=l,t.exports.validateOr=h},{}],56:[function(e,t,i){"use strict";function n(e,t){var i=new Error("WebRTC statistics are unsupported");return null===e||"undefined"==typeof navigator||"function"!=typeof e.getStats?void t(i):navigator.webkitGetUserMedia?void e.getStats(p(r,t),t):navigator.mozGetUserMedia?void e.getStats(null,p(a,t),t):void t(i)}function r(e,t){var i=[],n=null,r=[],a=e.result(),c=null;a.forEach(function(e){var t=null;switch(e.type){case"googCandidatePair":t=s(e),t&&(n=n||t.known);break;case"ssrc":t=o(e),i.push(t.known);break;default:r.push(e)}t&&t.known&&t.known.timestamp&&(c=c||t.known.timestamp,delete t.known.timestamp)});var u={timestamp:c,tracks:i,transport:n};t(null,u)}function s(e){for(var t={},i={},n=e.names(),r=e.timestamp?Math.floor(e.timestamp/1e3):null,s=0;s<n.length;s++){var o,a=n[s],c=e.stat(a);switch(a){case"googActiveConnection":if("true"!==c)return null;break;case"googChannelId":t.connection=c;break;case"googLocalAddress":c.split&&(o=c.split(":"),g(t,"local","address",o[0]),g(t,"local","port",Number(o[1])));break;case"googLocalCandidateType":g(t,"local","type",c);break;case"googRemoteAddress":c.split&&(o=c.split(":"),g(t,"remote","address",o[0]),g(t,"remote","port",Number(o[1])));break;case"googRemoteCandidateType":g(t,"remote","type",c);break;case"googRtt":t.rtt=Number(c);break;case"":break;default:i[a]=c}}return t.timestamp=r,l(t,i)}function o(e){var t={},i={},n=e.names(),r=null,s=null,o=e.timestamp?Math.floor(e.timestamp/1e3):null;return n.forEach(function(n){var o=e.stat(n);switch(n){case"audioInputLevel":s="audio",g(t,"audio","inlvl",Number(o));break;case"audioOutputLevel":s="audio",g(t,"audio","outlvl",Number(o));break;case"bytesReceived":r="receiving",g(t,"bytes","recv",Number(o));break;case"bytesSent":r="sending",g(t,"bytes","sent",Number(o));break;case"googCodecName":var a=o;""!==a&&(t.codecName=o);break;case"googFrameHeightReceived":r="receiving",s="video",g(t,"video","height_recv",Number(o));break;case"googFrameHeightSent":r="sending",s="video",g(t,"video","height_sent",Number(o));break;case"googFrameWidthReceived":r="receiving",s="video",g(t,"video","width_recv",Number(o));break;case"googFrameWidthSent":r="sending",s="video",g(t,"video","width_sent",Number(o));break;case"googFrameRateDecoded":r="receiving",s="video",g(t,"video","fps_recv",Number(o));break;case"googFrameRateSent":r="sending",s="video",g(t,"video","fps_sent",Number(o));break;case"googJitterBufferMs":t.googJitterBufferMs=Number(o);break;case"googJitterReceived":var c=Number(o);-1!==c&&(t.jitter=c);break;case"googRtt":var u=Number(o);-1!==u&&(t.rtt=u);break;case"packetsLost":r="sending";var l=Number(o);-1!==l&&g(t,"packets","lost",Number(o));break;case"packetsReceived":r="receiving",g(t,"packets","recv",Number(o));break;case"packetsSent":r="sending",g(t,"packets","sent",Number(o));break;case"ssrc":t[n]=o;break;case"transportId":t.connection=o;break;default:i[n]=o}}),r&&(t.direction=r),s&&(t.media=s),t.timestamp=o,l(t,i)}function a(e,t){var i,n=[],r=[],s=null,o={},a={};if(e.forEach(function(e){var t=null;switch(e.type){case"inboundrtp":t=u(e);break;case"outboundrtp":e.isRemote===!1&&(t=c(e));break;case"candidatepair":var l=i&&i.componentId;!e.selected||l&&-1!==l.indexOf("video")||(i=e);break;case"localcandidate":o[e.id]=e;break;case"remotecandidate":a[e.id]=e;break;default:r.push(e)}t&&(s=s||t.known.timestamp,delete t.known.timestamp,n.push(t))}),0===n.length||0===(n=h(n)).length)return t(null,{timestamp:s,ssrcs:[]});var l=o[i.localCandidateId],d=a[i.remoteCandidateId],p={local:{address:l.ipAddress,port:l.portNumber,type:"host"===l.candidateType?"local":l.candidateType},remote:{address:d.ipAddress,port:d.portNumber,type:"host"===d.candidateType?"local":d.candidateType}},g={timestamp:s,tracks:n.map(f),transport:p};t(null,g)}function c(e){var t={direction:"sending"},i={};for(var n in e){var r=e[n];switch(n){case"timestamp":t[n]=Math.floor(r/1e3);break;case"mediaType":t.media=r;break;case"bytesSent":case"packetsSent":case"ssrc":t[n]=r;break;default:i[n]=r}}return l(t,i)}function u(e){var t={direction:"receiving"},i={};for(var n in e){var r=e[n];switch(n){case"mozRtt":t.rtt=r;break;case"timestamp":t[n]=Math.floor(r/1e3);break;case"jitter":t[n]=1e3*r;break;case"framerateMean":t.fps=Math.round(r);break;case"mediaType":t.media=r;break;case"bytesReceived":case"packetsLost":case"packetsReceived":case"ssrc":t[n]=r;break;default:i[n]=r}}return l(t,i)}function l(e,t){var i=null;return d(e)||(i=i||{},i.known=e),d(t)||(i=i||{},i.unknown=t),i}function h(e){for(var t=[],i=0;i<e.length;i++){var n=e[i];n.known&&t.push(n.known)}return t}function d(e){if(!e)return!0;for(var t in e)return!1;return!0}function p(e,t){return function(){var i=Array.prototype.slice.call(arguments);return i.push(t),e.apply(null,i)}}function f(e){var t={ssrc:e.ssrc,media:e.media,direction:e.direction,codecName:e.codecName,packets:{lost:e.packetsLost,recvtot:e.packetsReceived,senttot:e.packetsSent},bytes:{recvtot:e.bytesReceived,senttot:e.bytesSent},jitter:e.jitter,rtt:e.rtt};return("audioInputLevel"in e||"audioOutputLevel"in e)&&(t.audio={inlvl:e.audioInputLevel,outlvl:e.audioOutputLevel}),("fps"in e||"width"in e||"height"in e)&&(t.video={fps:e.fps,width:e.width,height:e.height}),t}function g(){var e=[].slice.call(arguments,0),t=e[0],i=e.slice(1,e.length-1),n=e[e.length-1],r=t;return i.forEach(function(e,t){var s=t===i.length-1?n:{};r=r[e]=r[e]||s}),t}t.exports=n},{}],57:[function(e,t,i){"use strict";function n(e){return new Promise(function(t,i){r(e||{audio:!0,video:!0},t,i)})}function r(e,t,i){return"undefined"!=typeof window&&"undefined"!=typeof navigator?void("object"==typeof navigator.mediaDevices&&"function"==typeof navigator.mediaDevices.getUserMedia?navigator.mediaDevices.getUserMedia(e).then(t,i):"function"==typeof navigator.webkitGetUserMedia?navigator.webkitGetUserMedia(e,t,i):"function"==typeof navigator.mozGetUserMedia&&navigator.mozGetUserMedia(e,t,i)):void i(new Error("getUserMedia is not supported"))}t.exports=n},{}],58:[function(e,t,i){(function(t){"use strict";function n(){function e(){}try{var t=new Uint8Array(1);return t.foo=function(){return 42},t.constructor=e,42===t.foo()&&t.constructor===e&&"function"==typeof t.subarray&&0===t.subarray(1,1).byteLength}catch(i){return!1}}function r(){return s.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function s(e){return this instanceof s?(s.TYPED_ARRAY_SUPPORT||(this.length=0,this.parent=void 0),"number"==typeof e?o(this,e):"string"==typeof e?a(this,e,arguments.length>1?arguments[1]:"utf8"):c(this,e)):arguments.length>1?new s(e,arguments[1]):new s(e)}function o(e,t){if(e=g(e,0>t?0:0|m(t)),!s.TYPED_ARRAY_SUPPORT)for(var i=0;t>i;i++)e[i]=0;return e}function a(e,t,i){"string"==typeof i&&""!==i||(i="utf8");var n=0|_(t,i);return e=g(e,n),e.write(t,i),e}function c(e,t){if(s.isBuffer(t))return u(e,t);if(J(t))return l(e,t);if(null==t)throw new TypeError("must start with number, buffer, array or string");if("undefined"!=typeof ArrayBuffer){if(t.buffer instanceof ArrayBuffer)return h(e,t);if(t instanceof ArrayBuffer)return d(e,t)}return t.length?p(e,t):f(e,t)}function u(e,t){var i=0|m(t.length);return e=g(e,i),t.copy(e,0,0,i),e}function l(e,t){var i=0|m(t.length);e=g(e,i);for(var n=0;i>n;n+=1)e[n]=255&t[n];return e}function h(e,t){var i=0|m(t.length);e=g(e,i);for(var n=0;i>n;n+=1)e[n]=255&t[n];return e}function d(e,t){return s.TYPED_ARRAY_SUPPORT?(t.byteLength,e=s._augment(new Uint8Array(t))):e=h(e,new Uint8Array(t)),e}function p(e,t){var i=0|m(t.length);e=g(e,i);for(var n=0;i>n;n+=1)e[n]=255&t[n];return e}function f(e,t){var i,n=0;"Buffer"===t.type&&J(t.data)&&(i=t.data,n=0|m(i.length)),e=g(e,n);for(var r=0;n>r;r+=1)e[r]=255&i[r];return e}function g(e,t){s.TYPED_ARRAY_SUPPORT?(e=s._augment(new Uint8Array(t)),e.__proto__=s.prototype):(e.length=t,e._isBuffer=!0);var i=0!==t&&t<=s.poolSize>>>1;return i&&(e.parent=z),e}function m(e){if(e>=r())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+r().toString(16)+" bytes");return 0|e}function v(e,t){if(!(this instanceof v))return new v(e,t);var i=new s(e,t);return delete i.parent,i}function _(e,t){"string"!=typeof e&&(e=""+e);var i=e.length;if(0===i)return 0;for(var n=!1;;)switch(t){case"ascii":case"binary":case"raw":case"raws":return i;case"utf8":case"utf-8":return j(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*i;case"hex":return i>>>1;case"base64":return W(e).length;default:if(n)return j(e).length;t=(""+t).toLowerCase(),n=!0}}function T(e,t,i){var n=!1;if(t=0|t,i=void 0===i||i===1/0?this.length:0|i,e||(e="utf8"),0>t&&(t=0),i>this.length&&(i=this.length),t>=i)return"";for(;;)switch(e){case"hex":return O(this,t,i);case"utf8":case"utf-8":return b(this,t,i);case"ascii":return D(this,t,i);case"binary":return N(this,t,i);case"base64":return I(this,t,i);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return k(this,t,i);default:if(n)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),n=!0}}function E(e,t,i,n){i=Number(i)||0;var r=e.length-i;n?(n=Number(n),n>r&&(n=r)):n=r;var s=t.length;if(s%2!==0)throw new Error("Invalid hex string");n>s/2&&(n=s/2);for(var o=0;n>o;o++){var a=parseInt(t.substr(2*o,2),16);if(isNaN(a))throw new Error("Invalid hex string");e[i+o]=a}return o}function y(e,t,i,n){return V(j(t,e.length-i),e,i,n)}function S(e,t,i,n){return V(G(t),e,i,n)}function C(e,t,i,n){return S(e,t,i,n)}function R(e,t,i,n){return V(W(t),e,i,n)}function A(e,t,i,n){return V(B(t,e.length-i),e,i,n)}function I(e,t,i){return 0===t&&i===e.length?K.fromByteArray(e):K.fromByteArray(e.slice(t,i))}function b(e,t,i){i=Math.min(e.length,i);for(var n=[],r=t;i>r;){var s=e[r],o=null,a=s>239?4:s>223?3:s>191?2:1;if(i>=r+a){var c,u,l,h;switch(a){case 1:128>s&&(o=s);break;case 2:c=e[r+1],128===(192&c)&&(h=(31&s)<<6|63&c,h>127&&(o=h));break;case 3:c=e[r+1],u=e[r+2],128===(192&c)&&128===(192&u)&&(h=(15&s)<<12|(63&c)<<6|63&u,h>2047&&(55296>h||h>57343)&&(o=h));break;case 4:c=e[r+1],u=e[r+2],l=e[r+3],128===(192&c)&&128===(192&u)&&128===(192&l)&&(h=(15&s)<<18|(63&c)<<12|(63&u)<<6|63&l,h>65535&&1114112>h&&(o=h))}}null===o?(o=65533,a=1):o>65535&&(o-=65536,n.push(o>>>10&1023|55296),o=56320|1023&o),n.push(o),r+=a}return w(n)}function w(e){var t=e.length;if(Z>=t)return String.fromCharCode.apply(String,e);for(var i="",n=0;t>n;)i+=String.fromCharCode.apply(String,e.slice(n,n+=Z));return i}function D(e,t,i){var n="";i=Math.min(e.length,i);for(var r=t;i>r;r++)n+=String.fromCharCode(127&e[r]);return n}function N(e,t,i){var n="";i=Math.min(e.length,i);for(var r=t;i>r;r++)n+=String.fromCharCode(e[r]);return n}function O(e,t,i){var n=e.length;(!t||0>t)&&(t=0),(!i||0>i||i>n)&&(i=n);for(var r="",s=t;i>s;s++)r+=F(e[s]);return r}function k(e,t,i){for(var n=e.slice(t,i),r="",s=0;s<n.length;s+=2)r+=String.fromCharCode(n[s]+256*n[s+1]);return r}function U(e,t,i){if(e%1!==0||0>e)throw new RangeError("offset is not uint");if(e+t>i)throw new RangeError("Trying to access beyond buffer length")}function $(e,t,i,n,r,o){if(!s.isBuffer(e))throw new TypeError("buffer must be a Buffer instance");if(t>r||o>t)throw new RangeError("value is out of bounds");if(i+n>e.length)throw new RangeError("index out of range")}function X(e,t,i,n){0>t&&(t=65535+t+1);for(var r=0,s=Math.min(e.length-i,2);s>r;r++)e[i+r]=(t&255<<8*(n?r:1-r))>>>8*(n?r:1-r)}function P(e,t,i,n){0>t&&(t=4294967295+t+1);for(var r=0,s=Math.min(e.length-i,4);s>r;r++)e[i+r]=t>>>8*(n?r:3-r)&255}function x(e,t,i,n,r,s){if(t>r||s>t)throw new RangeError("value is out of bounds");if(i+n>e.length)throw new RangeError("index out of range");if(0>i)throw new RangeError("index out of range")}function M(e,t,i,n,r){return r||x(e,t,i,4,3.4028234663852886e38,-3.4028234663852886e38),Y.write(e,t,i,n,23,4),i+4}function L(e,t,i,n,r){return r||x(e,t,i,8,1.7976931348623157e308,-1.7976931348623157e308),Y.write(e,t,i,n,52,8),i+8}function H(e){if(e=q(e).replace(ee,""),e.length<2)return"";for(;e.length%4!==0;)e+="=";return e}function q(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function F(e){return 16>e?"0"+e.toString(16):e.toString(16)}function j(e,t){t=t||1/0;for(var i,n=e.length,r=null,s=[],o=0;n>o;o++){if(i=e.charCodeAt(o),i>55295&&57344>i){if(!r){if(i>56319){(t-=3)>-1&&s.push(239,191,189);continue}if(o+1===n){(t-=3)>-1&&s.push(239,191,189);continue}r=i;continue}if(56320>i){(t-=3)>-1&&s.push(239,191,189),r=i;continue}i=(r-55296<<10|i-56320)+65536}else r&&(t-=3)>-1&&s.push(239,191,189);if(r=null,128>i){if((t-=1)<0)break;s.push(i)}else if(2048>i){if((t-=2)<0)break;s.push(i>>6|192,63&i|128)}else if(65536>i){if((t-=3)<0)break;s.push(i>>12|224,i>>6&63|128,63&i|128)}else{if(!(1114112>i))throw new Error("Invalid code point");if((t-=4)<0)break;s.push(i>>18|240,i>>12&63|128,i>>6&63|128,63&i|128)}}return s}function G(e){for(var t=[],i=0;i<e.length;i++)t.push(255&e.charCodeAt(i));return t}function B(e,t){for(var i,n,r,s=[],o=0;o<e.length&&!((t-=2)<0);o++)i=e.charCodeAt(o),n=i>>8,r=i%256,s.push(r),s.push(n);return s}function W(e){return K.toByteArray(H(e))}function V(e,t,i,n){for(var r=0;n>r&&!(r+i>=t.length||r>=e.length);r++)t[r+i]=e[r];return r}var K=e("base64-js"),Y=e("ieee754"),J=e("isarray");i.Buffer=s,i.SlowBuffer=v,i.INSPECT_MAX_BYTES=50,s.poolSize=8192;var z={};s.TYPED_ARRAY_SUPPORT=void 0!==t.TYPED_ARRAY_SUPPORT?t.TYPED_ARRAY_SUPPORT:n(),s.TYPED_ARRAY_SUPPORT?(s.prototype.__proto__=Uint8Array.prototype,s.__proto__=Uint8Array):(s.prototype.length=void 0,s.prototype.parent=void 0),s.isBuffer=function(e){return!(null==e||!e._isBuffer)},s.compare=function(e,t){if(!s.isBuffer(e)||!s.isBuffer(t))throw new TypeError("Arguments must be Buffers");if(e===t)return 0;for(var i=e.length,n=t.length,r=0,o=Math.min(i,n);o>r&&e[r]===t[r];)++r;return r!==o&&(i=e[r],n=t[r]),n>i?-1:i>n?1:0},s.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},s.concat=function(e,t){if(!J(e))throw new TypeError("list argument must be an Array of Buffers.");if(0===e.length)return new s(0);var i;if(void 0===t)for(t=0,i=0;i<e.length;i++)t+=e[i].length;var n=new s(t),r=0;for(i=0;i<e.length;i++){var o=e[i];o.copy(n,r),r+=o.length}return n},s.byteLength=_,s.prototype.toString=function(){var e=0|this.length;return 0===e?"":0===arguments.length?b(this,0,e):T.apply(this,arguments)},s.prototype.equals=function(e){if(!s.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e?!0:0===s.compare(this,e)},s.prototype.inspect=function(){var e="",t=i.INSPECT_MAX_BYTES;return this.length>0&&(e=this.toString("hex",0,t).match(/.{2}/g).join(" "),this.length>t&&(e+=" ... ")),"<Buffer "+e+">"},s.prototype.compare=function(e){if(!s.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e?0:s.compare(this,e)},s.prototype.indexOf=function(e,t){function i(e,t,i){for(var n=-1,r=0;i+r<e.length;r++)if(e[i+r]===t[-1===n?0:r-n]){if(-1===n&&(n=r),r-n+1===t.length)return i+n}else n=-1;return-1}if(t>2147483647?t=2147483647:-2147483648>t&&(t=-2147483648),t>>=0,0===this.length)return-1;if(t>=this.length)return-1;if(0>t&&(t=Math.max(this.length+t,0)),"string"==typeof e)return 0===e.length?-1:String.prototype.indexOf.call(this,e,t);if(s.isBuffer(e))return i(this,e,t);if("number"==typeof e)return s.TYPED_ARRAY_SUPPORT&&"function"===Uint8Array.prototype.indexOf?Uint8Array.prototype.indexOf.call(this,e,t):i(this,[e],t);throw new TypeError("val must be string, number or Buffer")},s.prototype.get=function(e){return console.log(".get() is deprecated. Access using array indexes instead."),this.readUInt8(e)},s.prototype.set=function(e,t){return console.log(".set() is deprecated. Access using array indexes instead."),this.writeUInt8(e,t)},s.prototype.write=function(e,t,i,n){if(void 0===t)n="utf8",i=this.length,t=0;else if(void 0===i&&"string"==typeof t)n=t,i=this.length,t=0;else if(isFinite(t))t=0|t,isFinite(i)?(i=0|i,void 0===n&&(n="utf8")):(n=i,i=void 0);else{var r=n;n=t,t=0|i,i=r}var s=this.length-t;if((void 0===i||i>s)&&(i=s),e.length>0&&(0>i||0>t)||t>this.length)throw new RangeError("attempt to write outside buffer bounds");n||(n="utf8");for(var o=!1;;)switch(n){case"hex":return E(this,e,t,i);case"utf8":case"utf-8":return y(this,e,t,i);case"ascii":return S(this,e,t,i);case"binary":return C(this,e,t,i);case"base64":return R(this,e,t,i);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return A(this,e,t,i);default:if(o)throw new TypeError("Unknown encoding: "+n);
n=(""+n).toLowerCase(),o=!0}},s.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var Z=4096;s.prototype.slice=function(e,t){var i=this.length;e=~~e,t=void 0===t?i:~~t,0>e?(e+=i,0>e&&(e=0)):e>i&&(e=i),0>t?(t+=i,0>t&&(t=0)):t>i&&(t=i),e>t&&(t=e);var n;if(s.TYPED_ARRAY_SUPPORT)n=s._augment(this.subarray(e,t));else{var r=t-e;n=new s(r,void 0);for(var o=0;r>o;o++)n[o]=this[o+e]}return n.length&&(n.parent=this.parent||this),n},s.prototype.readUIntLE=function(e,t,i){e=0|e,t=0|t,i||U(e,t,this.length);for(var n=this[e],r=1,s=0;++s<t&&(r*=256);)n+=this[e+s]*r;return n},s.prototype.readUIntBE=function(e,t,i){e=0|e,t=0|t,i||U(e,t,this.length);for(var n=this[e+--t],r=1;t>0&&(r*=256);)n+=this[e+--t]*r;return n},s.prototype.readUInt8=function(e,t){return t||U(e,1,this.length),this[e]},s.prototype.readUInt16LE=function(e,t){return t||U(e,2,this.length),this[e]|this[e+1]<<8},s.prototype.readUInt16BE=function(e,t){return t||U(e,2,this.length),this[e]<<8|this[e+1]},s.prototype.readUInt32LE=function(e,t){return t||U(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},s.prototype.readUInt32BE=function(e,t){return t||U(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},s.prototype.readIntLE=function(e,t,i){e=0|e,t=0|t,i||U(e,t,this.length);for(var n=this[e],r=1,s=0;++s<t&&(r*=256);)n+=this[e+s]*r;return r*=128,n>=r&&(n-=Math.pow(2,8*t)),n},s.prototype.readIntBE=function(e,t,i){e=0|e,t=0|t,i||U(e,t,this.length);for(var n=t,r=1,s=this[e+--n];n>0&&(r*=256);)s+=this[e+--n]*r;return r*=128,s>=r&&(s-=Math.pow(2,8*t)),s},s.prototype.readInt8=function(e,t){return t||U(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},s.prototype.readInt16LE=function(e,t){t||U(e,2,this.length);var i=this[e]|this[e+1]<<8;return 32768&i?4294901760|i:i},s.prototype.readInt16BE=function(e,t){t||U(e,2,this.length);var i=this[e+1]|this[e]<<8;return 32768&i?4294901760|i:i},s.prototype.readInt32LE=function(e,t){return t||U(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},s.prototype.readInt32BE=function(e,t){return t||U(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},s.prototype.readFloatLE=function(e,t){return t||U(e,4,this.length),Y.read(this,e,!0,23,4)},s.prototype.readFloatBE=function(e,t){return t||U(e,4,this.length),Y.read(this,e,!1,23,4)},s.prototype.readDoubleLE=function(e,t){return t||U(e,8,this.length),Y.read(this,e,!0,52,8)},s.prototype.readDoubleBE=function(e,t){return t||U(e,8,this.length),Y.read(this,e,!1,52,8)},s.prototype.writeUIntLE=function(e,t,i,n){e=+e,t=0|t,i=0|i,n||$(this,e,t,i,Math.pow(2,8*i),0);var r=1,s=0;for(this[t]=255&e;++s<i&&(r*=256);)this[t+s]=e/r&255;return t+i},s.prototype.writeUIntBE=function(e,t,i,n){e=+e,t=0|t,i=0|i,n||$(this,e,t,i,Math.pow(2,8*i),0);var r=i-1,s=1;for(this[t+r]=255&e;--r>=0&&(s*=256);)this[t+r]=e/s&255;return t+i},s.prototype.writeUInt8=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,1,255,0),s.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),this[t]=255&e,t+1},s.prototype.writeUInt16LE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,2,65535,0),s.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):X(this,e,t,!0),t+2},s.prototype.writeUInt16BE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,2,65535,0),s.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):X(this,e,t,!1),t+2},s.prototype.writeUInt32LE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,4,4294967295,0),s.TYPED_ARRAY_SUPPORT?(this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e):P(this,e,t,!0),t+4},s.prototype.writeUInt32BE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,4,4294967295,0),s.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):P(this,e,t,!1),t+4},s.prototype.writeIntLE=function(e,t,i,n){if(e=+e,t=0|t,!n){var r=Math.pow(2,8*i-1);$(this,e,t,i,r-1,-r)}var s=0,o=1,a=0>e?1:0;for(this[t]=255&e;++s<i&&(o*=256);)this[t+s]=(e/o>>0)-a&255;return t+i},s.prototype.writeIntBE=function(e,t,i,n){if(e=+e,t=0|t,!n){var r=Math.pow(2,8*i-1);$(this,e,t,i,r-1,-r)}var s=i-1,o=1,a=0>e?1:0;for(this[t+s]=255&e;--s>=0&&(o*=256);)this[t+s]=(e/o>>0)-a&255;return t+i},s.prototype.writeInt8=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,1,127,-128),s.TYPED_ARRAY_SUPPORT||(e=Math.floor(e)),0>e&&(e=255+e+1),this[t]=255&e,t+1},s.prototype.writeInt16LE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,2,32767,-32768),s.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8):X(this,e,t,!0),t+2},s.prototype.writeInt16BE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,2,32767,-32768),s.TYPED_ARRAY_SUPPORT?(this[t]=e>>>8,this[t+1]=255&e):X(this,e,t,!1),t+2},s.prototype.writeInt32LE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,4,2147483647,-2147483648),s.TYPED_ARRAY_SUPPORT?(this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24):P(this,e,t,!0),t+4},s.prototype.writeInt32BE=function(e,t,i){return e=+e,t=0|t,i||$(this,e,t,4,2147483647,-2147483648),0>e&&(e=4294967295+e+1),s.TYPED_ARRAY_SUPPORT?(this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e):P(this,e,t,!1),t+4},s.prototype.writeFloatLE=function(e,t,i){return M(this,e,t,!0,i)},s.prototype.writeFloatBE=function(e,t,i){return M(this,e,t,!1,i)},s.prototype.writeDoubleLE=function(e,t,i){return L(this,e,t,!0,i)},s.prototype.writeDoubleBE=function(e,t,i){return L(this,e,t,!1,i)},s.prototype.copy=function(e,t,i,n){if(i||(i=0),n||0===n||(n=this.length),t>=e.length&&(t=e.length),t||(t=0),n>0&&i>n&&(n=i),n===i)return 0;if(0===e.length||0===this.length)return 0;if(0>t)throw new RangeError("targetStart out of bounds");if(0>i||i>=this.length)throw new RangeError("sourceStart out of bounds");if(0>n)throw new RangeError("sourceEnd out of bounds");n>this.length&&(n=this.length),e.length-t<n-i&&(n=e.length-t+i);var r,o=n-i;if(this===e&&t>i&&n>t)for(r=o-1;r>=0;r--)e[r+t]=this[r+i];else if(1e3>o||!s.TYPED_ARRAY_SUPPORT)for(r=0;o>r;r++)e[r+t]=this[r+i];else e._set(this.subarray(i,i+o),t);return o},s.prototype.fill=function(e,t,i){if(e||(e=0),t||(t=0),i||(i=this.length),t>i)throw new RangeError("end < start");if(i!==t&&0!==this.length){if(0>t||t>=this.length)throw new RangeError("start out of bounds");if(0>i||i>this.length)throw new RangeError("end out of bounds");var n;if("number"==typeof e)for(n=t;i>n;n++)this[n]=e;else{var r=j(e.toString()),s=r.length;for(n=t;i>n;n++)this[n]=r[n%s]}return this}},s.prototype.toArrayBuffer=function(){if("undefined"!=typeof Uint8Array){if(s.TYPED_ARRAY_SUPPORT)return new s(this).buffer;for(var e=new Uint8Array(this.length),t=0,i=e.length;i>t;t+=1)e[t]=this[t];return e.buffer}throw new TypeError("Buffer.toArrayBuffer not supported in this browser")};var Q=s.prototype;s._augment=function(e){return e.constructor=s,e._isBuffer=!0,e._set=e.set,e.get=Q.get,e.set=Q.set,e.write=Q.write,e.toString=Q.toString,e.toLocaleString=Q.toString,e.toJSON=Q.toJSON,e.equals=Q.equals,e.compare=Q.compare,e.indexOf=Q.indexOf,e.copy=Q.copy,e.slice=Q.slice,e.readUIntLE=Q.readUIntLE,e.readUIntBE=Q.readUIntBE,e.readUInt8=Q.readUInt8,e.readUInt16LE=Q.readUInt16LE,e.readUInt16BE=Q.readUInt16BE,e.readUInt32LE=Q.readUInt32LE,e.readUInt32BE=Q.readUInt32BE,e.readIntLE=Q.readIntLE,e.readIntBE=Q.readIntBE,e.readInt8=Q.readInt8,e.readInt16LE=Q.readInt16LE,e.readInt16BE=Q.readInt16BE,e.readInt32LE=Q.readInt32LE,e.readInt32BE=Q.readInt32BE,e.readFloatLE=Q.readFloatLE,e.readFloatBE=Q.readFloatBE,e.readDoubleLE=Q.readDoubleLE,e.readDoubleBE=Q.readDoubleBE,e.writeUInt8=Q.writeUInt8,e.writeUIntLE=Q.writeUIntLE,e.writeUIntBE=Q.writeUIntBE,e.writeUInt16LE=Q.writeUInt16LE,e.writeUInt16BE=Q.writeUInt16BE,e.writeUInt32LE=Q.writeUInt32LE,e.writeUInt32BE=Q.writeUInt32BE,e.writeIntLE=Q.writeIntLE,e.writeIntBE=Q.writeIntBE,e.writeInt8=Q.writeInt8,e.writeInt16LE=Q.writeInt16LE,e.writeInt16BE=Q.writeInt16BE,e.writeInt32LE=Q.writeInt32LE,e.writeInt32BE=Q.writeInt32BE,e.writeFloatLE=Q.writeFloatLE,e.writeFloatBE=Q.writeFloatBE,e.writeDoubleLE=Q.writeDoubleLE,e.writeDoubleBE=Q.writeDoubleBE,e.fill=Q.fill,e.inspect=Q.inspect,e.toArrayBuffer=Q.toArrayBuffer,e};var ee=/[^+\/0-9A-Za-z-_]/g}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"base64-js":59,ieee754:60,isarray:61}],59:[function(e,t,i){var n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";!function(e){"use strict";function t(e){var t=e.charCodeAt(0);return t===o||t===h?62:t===a||t===d?63:c>t?-1:c+10>t?t-c+26+26:l+26>t?t-l:u+26>t?t-u+26:void 0}function i(e){function i(e){u[h++]=e}var n,r,o,a,c,u;if(e.length%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var l=e.length;c="="===e.charAt(l-2)?2:"="===e.charAt(l-1)?1:0,u=new s(3*e.length/4-c),o=c>0?e.length-4:e.length;var h=0;for(n=0,r=0;o>n;n+=4,r+=3)a=t(e.charAt(n))<<18|t(e.charAt(n+1))<<12|t(e.charAt(n+2))<<6|t(e.charAt(n+3)),i((16711680&a)>>16),i((65280&a)>>8),i(255&a);return 2===c?(a=t(e.charAt(n))<<2|t(e.charAt(n+1))>>4,i(255&a)):1===c&&(a=t(e.charAt(n))<<10|t(e.charAt(n+1))<<4|t(e.charAt(n+2))>>2,i(a>>8&255),i(255&a)),u}function r(e){function t(e){return n.charAt(e)}function i(e){return t(e>>18&63)+t(e>>12&63)+t(e>>6&63)+t(63&e)}var r,s,o,a=e.length%3,c="";for(r=0,o=e.length-a;o>r;r+=3)s=(e[r]<<16)+(e[r+1]<<8)+e[r+2],c+=i(s);switch(a){case 1:s=e[e.length-1],c+=t(s>>2),c+=t(s<<4&63),c+="==";break;case 2:s=(e[e.length-2]<<8)+e[e.length-1],c+=t(s>>10),c+=t(s>>4&63),c+=t(s<<2&63),c+="="}return c}var s="undefined"!=typeof Uint8Array?Uint8Array:Array,o="+".charCodeAt(0),a="/".charCodeAt(0),c="0".charCodeAt(0),u="a".charCodeAt(0),l="A".charCodeAt(0),h="-".charCodeAt(0),d="_".charCodeAt(0);e.toByteArray=i,e.fromByteArray=r}("undefined"==typeof i?this.base64js={}:i)},{}],60:[function(e,t,i){i.read=function(e,t,i,n,r){var s,o,a=8*r-n-1,c=(1<<a)-1,u=c>>1,l=-7,h=i?r-1:0,d=i?-1:1,p=e[t+h];for(h+=d,s=p&(1<<-l)-1,p>>=-l,l+=a;l>0;s=256*s+e[t+h],h+=d,l-=8);for(o=s&(1<<-l)-1,s>>=-l,l+=n;l>0;o=256*o+e[t+h],h+=d,l-=8);if(0===s)s=1-u;else{if(s===c)return o?NaN:(p?-1:1)*(1/0);o+=Math.pow(2,n),s-=u}return(p?-1:1)*o*Math.pow(2,s-n)},i.write=function(e,t,i,n,r,s){var o,a,c,u=8*s-r-1,l=(1<<u)-1,h=l>>1,d=23===r?Math.pow(2,-24)-Math.pow(2,-77):0,p=n?0:s-1,f=n?1:-1,g=0>t||0===t&&0>1/t?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(a=isNaN(t)?1:0,o=l):(o=Math.floor(Math.log(t)/Math.LN2),t*(c=Math.pow(2,-o))<1&&(o--,c*=2),t+=o+h>=1?d/c:d*Math.pow(2,1-h),t*c>=2&&(o++,c/=2),o+h>=l?(a=0,o=l):o+h>=1?(a=(t*c-1)*Math.pow(2,r),o+=h):(a=t*Math.pow(2,h-1)*Math.pow(2,r),o=0));r>=8;e[i+p]=255&a,p+=f,a/=256,r-=8);for(o=o<<r|a,u+=r;u>0;e[i+p]=255&o,p+=f,o/=256,u-=8);e[i+p-f]|=128*g}},{}],61:[function(e,t,i){var n={}.toString;t.exports=Array.isArray||function(e){return"[object Array]"==n.call(e)}},{}],62:[function(e,t,i){function n(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function r(e){return"function"==typeof e}function s(e){return"number"==typeof e}function o(e){return"object"==typeof e&&null!==e}function a(e){return void 0===e}t.exports=n,n.EventEmitter=n,n.prototype._events=void 0,n.prototype._maxListeners=void 0,n.defaultMaxListeners=10,n.prototype.setMaxListeners=function(e){if(!s(e)||0>e||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},n.prototype.emit=function(e){var t,i,n,s,c,u;if(this._events||(this._events={}),"error"===e&&(!this._events.error||o(this._events.error)&&!this._events.error.length)){if(t=arguments[1],t instanceof Error)throw t;throw TypeError('Uncaught, unspecified "error" event.')}if(i=this._events[e],a(i))return!1;if(r(i))switch(arguments.length){case 1:i.call(this);break;case 2:i.call(this,arguments[1]);break;case 3:i.call(this,arguments[1],arguments[2]);break;default:for(n=arguments.length,s=new Array(n-1),c=1;n>c;c++)s[c-1]=arguments[c];i.apply(this,s)}else if(o(i)){for(n=arguments.length,s=new Array(n-1),c=1;n>c;c++)s[c-1]=arguments[c];for(u=i.slice(),n=u.length,c=0;n>c;c++)u[c].apply(this,s)}return!0},n.prototype.addListener=function(e,t){var i;if(!r(t))throw TypeError("listener must be a function");if(this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,r(t.listener)?t.listener:t),this._events[e]?o(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,o(this._events[e])&&!this._events[e].warned){var i;i=a(this._maxListeners)?n.defaultMaxListeners:this._maxListeners,i&&i>0&&this._events[e].length>i&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),"function"==typeof console.trace&&console.trace())}return this},n.prototype.on=n.prototype.addListener,n.prototype.once=function(e,t){function i(){this.removeListener(e,i),n||(n=!0,t.apply(this,arguments))}if(!r(t))throw TypeError("listener must be a function");var n=!1;return i.listener=t,this.on(e,i),this},n.prototype.removeListener=function(e,t){var i,n,s,a;if(!r(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;if(i=this._events[e],s=i.length,n=-1,i===t||r(i.listener)&&i.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(o(i)){for(a=s;a-- >0;)if(i[a]===t||i[a].listener&&i[a].listener===t){n=a;break}if(0>n)return this;1===i.length?(i.length=0,delete this._events[e]):i.splice(n,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},n.prototype.removeAllListeners=function(e){var t,i;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[e]&&delete this._events[e],this;if(0===arguments.length){for(t in this._events)"removeListener"!==t&&this.removeAllListeners(t);return this.removeAllListeners("removeListener"),this._events={},this}if(i=this._events[e],r(i))this.removeListener(e,i);else for(;i.length;)this.removeListener(e,i[i.length-1]);return delete this._events[e],this},n.prototype.listeners=function(e){var t;return t=this._events&&this._events[e]?r(this._events[e])?[this._events[e]]:this._events[e].slice():[]},n.listenerCount=function(e,t){var i;return i=e._events&&e._events[t]?r(e._events[t])?1:e._events[t].length:0}},{}],63:[function(e,t,i){"function"==typeof Object.create?t.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:t.exports=function(e,t){e.super_=t;var i=function(){};i.prototype=t.prototype,e.prototype=new i,e.prototype.constructor=e}},{}],64:[function(e,t,i){function n(){if(!a){a=!0;for(var e,t=o.length;t;){e=o,o=[];for(var i=-1;++i<t;)e[i]();t=o.length}a=!1}}function r(){}var s=t.exports={},o=[],a=!1;s.nextTick=function(e){o.push(e),a||setTimeout(n,0)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=r,s.addListener=r,s.once=r,s.off=r,s.removeListener=r,s.removeAllListeners=r,s.emit=r,s.binding=function(e){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(e){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}},{}],65:[function(e,t,i){t.exports=function(e){return e&&"object"==typeof e&&"function"==typeof e.copy&&"function"==typeof e.fill&&"function"==typeof e.readUInt8}},{}],66:[function(e,t,i){(function(t,n){function r(e,t){var n={seen:[],stylize:o};return arguments.length>=3&&(n.depth=arguments[2]),arguments.length>=4&&(n.colors=arguments[3]),g(t)?n.showHidden=t:t&&i._extend(n,t),y(n.showHidden)&&(n.showHidden=!1),y(n.depth)&&(n.depth=2),y(n.colors)&&(n.colors=!1),y(n.customInspect)&&(n.customInspect=!0),n.colors&&(n.stylize=s),c(n,e,n.depth)}function s(e,t){var i=r.styles[t];return i?"["+r.colors[i][0]+"m"+e+"["+r.colors[i][1]+"m":e}function o(e,t){return e}function a(e){var t={};return e.forEach(function(e,i){t[e]=!0}),t}function c(e,t,n){if(e.customInspect&&t&&I(t.inspect)&&t.inspect!==i.inspect&&(!t.constructor||t.constructor.prototype!==t)){var r=t.inspect(n,e);return T(r)||(r=c(e,r,n)),r}var s=u(e,t);if(s)return s;var o=Object.keys(t),g=a(o);if(e.showHidden&&(o=Object.getOwnPropertyNames(t)),A(t)&&(o.indexOf("message")>=0||o.indexOf("description")>=0))return l(t);if(0===o.length){if(I(t)){var m=t.name?": "+t.name:"";return e.stylize("[Function"+m+"]","special")}if(S(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(R(t))return e.stylize(Date.prototype.toString.call(t),"date");if(A(t))return l(t)}var v="",_=!1,E=["{","}"];if(f(t)&&(_=!0,E=["[","]"]),I(t)){var y=t.name?": "+t.name:"";v=" [Function"+y+"]"}if(S(t)&&(v=" "+RegExp.prototype.toString.call(t)),R(t)&&(v=" "+Date.prototype.toUTCString.call(t)),A(t)&&(v=" "+l(t)),0===o.length&&(!_||0==t.length))return E[0]+v+E[1];if(0>n)return S(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special");e.seen.push(t);var C;return C=_?h(e,t,n,g,o):o.map(function(i){return d(e,t,n,g,i,_)}),e.seen.pop(),p(C,v,E)}function u(e,t){if(y(t))return e.stylize("undefined","undefined");if(T(t)){var i="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(i,"string")}return _(t)?e.stylize(""+t,"number"):g(t)?e.stylize(""+t,"boolean"):m(t)?e.stylize("null","null"):void 0}function l(e){return"["+Error.prototype.toString.call(e)+"]"}function h(e,t,i,n,r){for(var s=[],o=0,a=t.length;a>o;++o)O(t,String(o))?s.push(d(e,t,i,n,String(o),!0)):s.push("");return r.forEach(function(r){r.match(/^\d+$/)||s.push(d(e,t,i,n,r,!0))}),s}function d(e,t,i,n,r,s){var o,a,u;if(u=Object.getOwnPropertyDescriptor(t,r)||{value:t[r]},u.get?a=u.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):u.set&&(a=e.stylize("[Setter]","special")),O(n,r)||(o="["+r+"]"),a||(e.seen.indexOf(u.value)<0?(a=m(i)?c(e,u.value,null):c(e,u.value,i-1),a.indexOf("\n")>-1&&(a=s?a.split("\n").map(function(e){return"  "+e}).join("\n").substr(2):"\n"+a.split("\n").map(function(e){return"   "+e}).join("\n"))):a=e.stylize("[Circular]","special")),y(o)){if(s&&r.match(/^\d+$/))return a;o=JSON.stringify(""+r),o.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(o=o.substr(1,o.length-2),o=e.stylize(o,"name")):(o=o.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),o=e.stylize(o,"string"))}return o+": "+a}function p(e,t,i){var n=0,r=e.reduce(function(e,t){return n++,t.indexOf("\n")>=0&&n++,e+t.replace(/\u001b\[\d\d?m/g,"").length+1},0);return r>60?i[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+i[1]:i[0]+t+" "+e.join(", ")+" "+i[1]}function f(e){return Array.isArray(e)}function g(e){return"boolean"==typeof e}function m(e){return null===e}function v(e){return null==e}function _(e){return"number"==typeof e}function T(e){return"string"==typeof e}function E(e){return"symbol"==typeof e}function y(e){return void 0===e}function S(e){return C(e)&&"[object RegExp]"===w(e)}function C(e){return"object"==typeof e&&null!==e}function R(e){return C(e)&&"[object Date]"===w(e)}function A(e){return C(e)&&("[object Error]"===w(e)||e instanceof Error)}function I(e){return"function"==typeof e}function b(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||"undefined"==typeof e}function w(e){return Object.prototype.toString.call(e)}function D(e){return 10>e?"0"+e.toString(10):e.toString(10)}function N(){var e=new Date,t=[D(e.getHours()),D(e.getMinutes()),D(e.getSeconds())].join(":");return[e.getDate(),X[e.getMonth()],t].join(" ")}function O(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var k=/%[sdj%]/g;i.format=function(e){if(!T(e)){for(var t=[],i=0;i<arguments.length;i++)t.push(r(arguments[i]));return t.join(" ")}for(var i=1,n=arguments,s=n.length,o=String(e).replace(k,function(e){if("%%"===e)return"%";if(i>=s)return e;switch(e){case"%s":return String(n[i++]);case"%d":return Number(n[i++]);case"%j":try{return JSON.stringify(n[i++])}catch(t){return"[Circular]"}default:return e}}),a=n[i];s>i;a=n[++i])o+=m(a)||!C(a)?" "+a:" "+r(a);return o},i.deprecate=function(e,r){function s(){if(!o){if(t.throwDeprecation)throw new Error(r);t.traceDeprecation?console.trace(r):console.error(r),o=!0}return e.apply(this,arguments)}if(y(n.process))return function(){return i.deprecate(e,r).apply(this,arguments)};if(t.noDeprecation===!0)return e;var o=!1;return s};var U,$={};i.debuglog=function(e){if(y(U)&&(U=t.env.NODE_DEBUG||""),e=e.toUpperCase(),!$[e])if(new RegExp("\\b"+e+"\\b","i").test(U)){var n=t.pid;$[e]=function(){var t=i.format.apply(i,arguments);console.error("%s %d: %s",e,n,t)}}else $[e]=function(){};return $[e]},i.inspect=r,r.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},r.styles={special:"cyan",number:"yellow","boolean":"yellow",undefined:"grey","null":"bold",string:"green",date:"magenta",regexp:"red"},i.isArray=f,i.isBoolean=g,i.isNull=m,i.isNullOrUndefined=v,i.isNumber=_,i.isString=T,i.isSymbol=E,i.isUndefined=y,i.isRegExp=S,i.isObject=C,i.isDate=R,i.isError=A,i.isFunction=I,i.isPrimitive=b,i.isBuffer=e("./support/isBuffer");var X=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];i.log=function(){console.log("%s - %s",N(),i.format.apply(i,arguments))},i.inherits=e("inherits"),i._extend=function(e,t){if(!t||!C(t))return e;for(var i=Object.keys(t),n=i.length;n--;)e[i[n]]=t[i[n]];return e}}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./support/isBuffer":65,_process:64,inherits:63}],67:[function(e,t,i){t.exports={name:"sip.js",title:"SIP.js",description:"A simple, intuitive, and powerful JavaScript signaling library",version:"0.7.5",main:"src/index.js",browser:{"./src/environment.js":"./src/environment_browser.js"},homepage:"http://sipjs.com",author:{name:"OnSIP",email:"developer@onsip.com",url:"http://sipjs.com/authors/"},contributors:[{url:"https://github.com/onsip/SIP.js/blob/master/THANKS.md"}],repository:{type:"git",url:"git+https://github.com/onsip/SIP.js.git"},keywords:["sip","websocket","webrtc","library","javascript"],devDependencies:{beefy:"^2.1.5",browserify:"^4.1.8",grunt:"~0.4.0","grunt-browserify":"^4.0.1","grunt-cli":"~0.1.6","grunt-contrib-copy":"^0.5.0","grunt-contrib-jasmine":"^0.9.2","grunt-contrib-jshint":">0.5.0","grunt-contrib-uglify":"~0.2.0","grunt-peg":"~1.3.1","grunt-trimtrailingspaces":"^0.4.0"},engines:{node:">=0.8"},license:"MIT",scripts:{repl:"beefy test/repl.js --open",build:"grunt build",postinstall:"cd src/Grammar && mkdir -p dist && pegjs --extra-options-file peg.json src/Grammar.pegjs dist/Grammar.js",test:"grunt travis --verbose"},dependencies:{pegjs:"^0.8.0",ws:"^0.6.4",promiscuous:"^0.6.0"},optionalDependencies:{promiscuous:"^0.6.0"},gitHead:"342d3b78e2922adf6ff51e5b6efc804b92566b0d",readme:'# SIP.js\n\n[![Build Status](https://travis-ci.org/onsip/SIP.js.png?branch=master)](https://travis-ci.org/onsip/SIP.js)\n\nA JavaScript SIP stack for WebRTC, instant messaging, and more!\n\n\n## Website and Documentation\n\n* [SIPjs.com](http://sipjs.com)\n* [Mailing List](https://groups.google.com/forum/#!forum/sip_js)\n* [Issue Tracking](https://github.com/onsip/sip.js/issues)\n\n\n## Download\n\n* [sipjs.com/download](http://sipjs.com/download/)\n* Bower: `bower install sip.js`\n* npm: `npm install sip.js`\n\n## Authors\n\n### James Criscuolo\n\n* <james@onsip.com>\n\n### Joseph Frazier\n\n* <joseph@onsip.com>\n\n### Eric Green\n\n* <eric.green@onsip.com>\n\n### Will Mitchell\n\n* <wakamoleguy@gmail.com>\n* GitHub [@wakamoleguy](http://github.com/wakamoleguy)\n* Twitter [@wakamoleguy](http://twitter.com/wakamoleguy)\n\n### JsSIP Authors\n\nSIP.js contains substantial portions of the JsSIP software. JsSIP\'s authors at time of fork are listed below. For up to date information about JsSIP, please visit [jssip.net](http://jssip.net)\n\n* Jos\xe9 Luis Mill\xe1n\n* I\xf1aki Baz Castillo\n* Sa\xfal Ibarra Corretg\xe9\n\n## License\n\nSIP.js is released under the [MIT license](http://sipjs.com/license).\n\nSIP.js contains substantial portions of the JsSIP software, under the following license:\n\n~~~\nCopyright (c) 2012-2013 Jos\xe9 Luis Mill\xe1n - Versatica <http://www.versatica.com>\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n"Software"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.\n\n~~~\n',readmeFilename:"README.md",bugs:{url:"https://github.com/onsip/SIP.js/issues"},_id:"sip.js@0.7.5",_shasum:"b34b8dce557de8f2f3a1c240d11ab195525be2d4",_from:"git+https://github.com/twilio/SIP.js.git#342d3b78e2922adf6ff51e5b6efc804b92566b0d",_resolved:"git+https://github.com/twilio/SIP.js.git#342d3b78e2922adf6ff51e5b6efc804b92566b0d"}},{}],68:[function(e,t,i){"use strict";t.exports=function(e){var t;t=function(t,i,n,r){var s=n;if(void 0===n)throw new TypeError("Not enough arguments");if(this.ua=t,this.logger=t.getLogger("sip.clientcontext"),this.method=i,n=t.normalizeTarget(n),!n)throw new TypeError("Invalid target: "+s);r=Object.create(r||Object.prototype),r.extraHeaders=(r.extraHeaders||[]).slice(),r.contentType&&(this.contentType=r.contentType,r.extraHeaders.push("Content-Type: "+this.contentType)),this.request=new e.OutgoingRequest(this.method,n,this.ua,r.params,r.extraHeaders),r.body&&(this.body=r.body,this.request.body=this.body),this.localIdentity=this.request.from,this.remoteIdentity=this.request.to,this.data={}},t.prototype=Object.create(e.EventEmitter.prototype),t.prototype.send=function(){return new e.RequestSender(this,this.ua).send(),this},t.prototype.cancel=function(t){t=t||{};var i=e.Utils.getCancelReason(t.status_code,t.reason_phrase);this.request.cancel(i),this.emit("cancel")},t.prototype.receiveResponse=function(t){var i=e.Utils.getReasonPhrase(t.status_code);switch(!0){case/^1[0-9]{2}$/.test(t.status_code):this.emit("progress",t,i);break;case/^2[0-9]{2}$/.test(t.status_code):this.ua.applicants[this]&&delete this.ua.applicants[this],this.emit("accepted",t,i);break;default:this.ua.applicants[this]&&delete this.ua.applicants[this],this.emit("rejected",t,i),this.emit("failed",t,i)}},t.prototype.onRequestTimeout=function(){this.emit("failed",null,e.C.causes.REQUEST_TIMEOUT)},t.prototype.onTransportError=function(){this.emit("failed",null,e.C.causes.CONNECTION_ERROR)},e.ClientContext=t}},{}],69:[function(e,t,i){"use strict";t.exports=function(e,t){return{USER_AGENT:e+"/"+t,SIP:"sip",SIPS:"sips",causes:{CONNECTION_ERROR:"Connection Error",REQUEST_TIMEOUT:"Request Timeout",SIP_FAILURE_CODE:"SIP Failure Code",INTERNAL_ERROR:"Internal Error",BUSY:"Busy",REJECTED:"Rejected",REDIRECTED:"Redirected",UNAVAILABLE:"Unavailable",NOT_FOUND:"Not Found",ADDRESS_INCOMPLETE:"Address Incomplete",INCOMPATIBLE_SDP:"Incompatible SDP",AUTHENTICATION_ERROR:"Authentication Error",DIALOG_ERROR:"Dialog Error",WEBRTC_NOT_SUPPORTED:"WebRTC Not Supported",WEBRTC_ERROR:"WebRTC Error",CANCELED:"Canceled",NO_ANSWER:"No Answer",EXPIRES:"Expires",NO_ACK:"No ACK",NO_PRACK:"No PRACK",USER_DENIED_MEDIA_ACCESS:"User Denied Media Access",BAD_MEDIA_DESCRIPTION:"Bad Media Description",RTP_TIMEOUT:"RTP Timeout"},supported:{UNSUPPORTED:"none",SUPPORTED:"supported",REQUIRED:"required"},SIP_ERROR_CAUSES:{REDIRECTED:[300,301,302,305,380],BUSY:[486,600],REJECTED:[403,603],NOT_FOUND:[404,604],UNAVAILABLE:[480,410,408,430],ADDRESS_INCOMPLETE:[484],INCOMPATIBLE_SDP:[488,606],AUTHENTICATION_ERROR:[401,407]},ACK:"ACK",BYE:"BYE",CANCEL:"CANCEL",INFO:"INFO",INVITE:"INVITE",MESSAGE:"MESSAGE",NOTIFY:"NOTIFY",OPTIONS:"OPTIONS",REGISTER:"REGISTER",UPDATE:"UPDATE",SUBSCRIBE:"SUBSCRIBE",REFER:"REFER",PRACK:"PRACK",REASON_PHRASE:{100:"Trying",180:"Ringing",181:"Call Is Being Forwarded",182:"Queued",183:"Session Progress",199:"Early Dialog Terminated",200:"OK",202:"Accepted",204:"No Notification",300:"Multiple Choices",301:"Moved Permanently",302:"Moved Temporarily",305:"Use Proxy",380:"Alternative Service",400:"Bad Request",401:"Unauthorized",402:"Payment Required",403:"Forbidden",404:"Not Found",405:"Method Not Allowed",406:"Not Acceptable",407:"Proxy Authentication Required",408:"Request Timeout",410:"Gone",412:"Conditional Request Failed",413:"Request Entity Too Large",414:"Request-URI Too Long",415:"Unsupported Media Type",416:"Unsupported URI Scheme",417:"Unknown Resource-Priority",420:"Bad Extension",421:"Extension Required",422:"Session Interval Too Small",423:"Interval Too Brief",428:"Use Identity Header",429:"Provide Referrer Identity",430:"Flow Failed",433:"Anonymity Disallowed",436:"Bad Identity-Info",437:"Unsupported Certificate",438:"Invalid Identity Header",439:"First Hop Lacks Outbound Support",440:"Max-Breadth Exceeded",469:"Bad Info Package",470:"Consent Needed",478:"Unresolvable Destination",480:"Temporarily Unavailable",481:"Call/Transaction Does Not Exist",482:"Loop Detected",483:"Too Many Hops",484:"Address Incomplete",485:"Ambiguous",486:"Busy Here",487:"Request Terminated",488:"Not Acceptable Here",489:"Bad Event",491:"Request Pending",493:"Undecipherable",494:"Security Agreement Required",500:"Internal Server Error",501:"Not Implemented",502:"Bad Gateway",503:"Service Unavailable",504:"Server Time-out",505:"Version Not Supported",513:"Message Too Large",580:"Precondition Failure",600:"Busy Everywhere",603:"Decline",604:"Does Not Exist Anywhere",606:"Not Acceptable"},OPTION_TAGS:{"100rel":!0,199:!0,answermode:!0,"early-session":!0,eventlist:!0,explicitsub:!0,"from-change":!0,"geolocation-http":!0,"geolocation-sip":!0,gin:!0,gruu:!0,histinfo:!0,ice:!0,join:!0,"multiple-refer":!0,norefersub:!0,nosub:!0,outbound:!0,path:!0,policy:!0,precondition:!0,pref:!0,privacy:!0,"recipient-list-invite":!0,"recipient-list-message":!0,"recipient-list-subscribe":!0,replaces:!0,"resource-priority":!0,"sdp-anat":!0,"sec-agree":!0,tdialog:!0,timer:!0,uui:!0}}}},{}],70:[function(e,t,i){"use strict";t.exports=function(e){var t;return t=function(e,t,i){this.dialog=e,this.applicant=t,this.request=i,this.reattempt=!1,this.reattemptTimer=null},t.prototype={send:function(){var t=this,i=new e.RequestSender(this,this.dialog.owner.ua);i.send(),this.request.method===e.C.INVITE&&i.clientTransaction.state!==e.Transactions.C.STATUS_TERMINATED&&(this.dialog.uac_pending_reply=!0,i.clientTransaction.on("stateChanged",function n(){this.state!==e.Transactions.C.STATUS_ACCEPTED&&this.state!==e.Transactions.C.STATUS_COMPLETED&&this.state!==e.Transactions.C.STATUS_TERMINATED||(this.removeListener("stateChanged",n),t.dialog.uac_pending_reply=!1,t.dialog.uas_pending_reply===!1&&t.dialog.owner.onReadyToReinvite())}))},onRequestTimeout:function(){this.applicant.onRequestTimeout()},onTransportError:function(){this.applicant.onTransportError()},receiveResponse:function(t){var i=this;408===t.status_code||481===t.status_code?this.applicant.onDialogError(t):t.method===e.C.INVITE&&491===t.status_code?this.reattempt?this.applicant.receiveResponse(t):(this.request.cseq.value=this.dialog.local_seqnum+=1,this.reattemptTimer=e.Timers.setTimeout(function(){i.applicant.owner.status!==e.Session.C.STATUS_TERMINATED&&(i.reattempt=!0,
i.request_sender.send())},this.getReattemptTimeout())):this.applicant.receiveResponse(t)}},t}},{}],71:[function(e,t,i){"use strict";t.exports=function(t){var i,n=e("./Dialog/RequestSender")(t),r={STATUS_EARLY:1,STATUS_CONFIRMED:2};i=function(e,i,n,s){var o;return this.uac_pending_reply=!1,this.uas_pending_reply=!1,i.hasHeader("contact")?(s=i instanceof t.IncomingResponse?i.status_code<200?r.STATUS_EARLY:r.STATUS_CONFIRMED:s||r.STATUS_CONFIRMED,o=i.parseHeader("contact"),"UAS"===n?(this.id={call_id:i.call_id,local_tag:i.to_tag,remote_tag:i.from_tag,toString:function(){return this.call_id+this.local_tag+this.remote_tag}},this.state=s,this.remote_seqnum=i.cseq,this.local_uri=i.parseHeader("to").uri,this.remote_uri=i.parseHeader("from").uri,this.remote_target=o.uri,this.route_set=i.getHeaders("record-route"),this.invite_seqnum=i.cseq,this.local_seqnum=i.cseq):"UAC"===n&&(this.id={call_id:i.call_id,local_tag:i.from_tag,remote_tag:i.to_tag,toString:function(){return this.call_id+this.local_tag+this.remote_tag}},this.state=s,this.invite_seqnum=i.cseq,this.local_seqnum=i.cseq,this.local_uri=i.parseHeader("from").uri,this.pracked=[],this.remote_uri=i.parseHeader("to").uri,this.remote_target=o.uri,this.route_set=i.getHeaders("record-route").reverse(),this.state!==r.STATUS_EARLY||e.hasOffer||(this.mediaHandler=e.mediaHandlerFactory(e))),this.logger=e.ua.getLogger("sip.dialog",this.id.toString()),this.owner=e,e.ua.dialogs[this.id.toString()]=this,this.logger.log("new "+n+" dialog created with status "+(this.state===r.STATUS_EARLY?"EARLY":"CONFIRMED")),void e.emit("dialog",this)):{error:"unable to create a Dialog without Contact header field"}},i.prototype={update:function(e,t){this.state=r.STATUS_CONFIRMED,this.logger.log("dialog "+this.id.toString()+"  changed to CONFIRMED state"),"UAC"===t&&(this.route_set=e.getHeaders("record-route").reverse())},terminate:function(){this.logger.log("dialog "+this.id.toString()+" deleted"),this.mediaHandler&&this.state!==r.STATUS_CONFIRMED&&this.mediaHandler.peerConnection.close(),delete this.owner.ua.dialogs[this.id.toString()]},createRequest:function(e,i,n){var r,s;return i=(i||[]).slice(),this.local_seqnum||(this.local_seqnum=Math.floor(1e4*Math.random())),r=e===t.C.CANCEL||e===t.C.ACK?this.invite_seqnum:this.local_seqnum+=1,s=new t.OutgoingRequest(e,this.remote_target,this.owner.ua,{cseq:r,call_id:this.id.call_id,from_uri:this.local_uri,from_tag:this.id.local_tag,to_uri:this.remote_uri,to_tag:this.id.remote_tag,route_set:this.route_set},i,n),s.dialog=this,s},checkInDialogRequest:function(e){var i=this;if(this.remote_seqnum){if(e.cseq<this.remote_seqnum)return e.method!==t.C.ACK&&e.reply(500),e.cseq===this.invite_seqnum;e.cseq>this.remote_seqnum&&(this.remote_seqnum=e.cseq)}else this.remote_seqnum=e.cseq;switch(e.method){case t.C.INVITE:if(this.uac_pending_reply===!0)e.reply(491);else{if(this.uas_pending_reply===!0){var n=(10*Math.random()|0)+1;return e.reply(500,null,["Retry-After:"+n]),!1}this.uas_pending_reply=!0,e.server_transaction.on("stateChanged",function r(){this.state!==t.Transactions.C.STATUS_ACCEPTED&&this.state!==t.Transactions.C.STATUS_COMPLETED&&this.state!==t.Transactions.C.STATUS_TERMINATED||(this.removeListener("stateChanged",r),i.uas_pending_reply=!1,i.uac_pending_reply===!1&&i.owner.onReadyToReinvite())})}e.hasHeader("contact")&&e.server_transaction.on("stateChanged",function(){this.state===t.Transactions.C.STATUS_ACCEPTED&&(i.remote_target=e.parseHeader("contact").uri)});break;case t.C.NOTIFY:e.hasHeader("contact")&&e.server_transaction.on("stateChanged",function(){this.state===t.Transactions.C.STATUS_COMPLETED&&(i.remote_target=e.parseHeader("contact").uri)})}return!0},sendRequest:function(e,t,i){i=i||{};var r=(i.extraHeaders||[]).slice(),s=i.body||null,o=this.createRequest(t,r,s),a=new n(this,e,o);return a.send(),o},receiveRequest:function(e){this.checkInDialogRequest(e)&&this.owner.receiveRequest(e)}},i.C=r,t.Dialog=i}},{"./Dialog/RequestSender":70}],72:[function(e,t,i){"use strict";t.exports=function(e){var t;return t=function(e){this.logger=e.getLogger("sipjs.digestauthentication"),this.username=e.configuration.authorizationUser,this.password=e.configuration.password,this.cnonce=null,this.nc=0,this.ncHex="00000000",this.response=null},t.prototype.authenticate=function(t,i){if(this.algorithm=i.algorithm,this.realm=i.realm,this.nonce=i.nonce,this.opaque=i.opaque,this.stale=i.stale,this.algorithm){if("MD5"!==this.algorithm)return this.logger.warn('challenge with Digest algorithm different than "MD5", authentication aborted'),!1}else this.algorithm="MD5";if(!this.realm)return this.logger.warn("challenge without Digest realm, authentication aborted"),!1;if(!this.nonce)return this.logger.warn("challenge without Digest nonce, authentication aborted"),!1;if(i.qop)if(i.qop.indexOf("auth")>-1)this.qop="auth";else{if(!(i.qop.indexOf("auth-int")>-1))return this.logger.warn('challenge without Digest qop different than "auth" or "auth-int", authentication aborted'),!1;this.qop="auth-int"}else this.qop=null;return this.method=t.method,this.uri=t.ruri,this.cnonce=e.createRandomToken(12),this.nc+=1,this.updateNcHex(),4294967296===this.nc&&(this.nc=1,this.ncHex="00000001"),this.calculateResponse(),!0},t.prototype.calculateResponse=function(){var t,i;t=e.calculateMD5(this.username+":"+this.realm+":"+this.password),"auth"===this.qop?(i=e.calculateMD5(this.method+":"+this.uri),this.response=e.calculateMD5(t+":"+this.nonce+":"+this.ncHex+":"+this.cnonce+":auth:"+i)):"auth-int"===this.qop?(i=e.calculateMD5(this.method+":"+this.uri+":"+e.calculateMD5(this.body?this.body:"")),this.response=e.calculateMD5(t+":"+this.nonce+":"+this.ncHex+":"+this.cnonce+":auth-int:"+i)):null===this.qop&&(i=e.calculateMD5(this.method+":"+this.uri),this.response=e.calculateMD5(t+":"+this.nonce+":"+i))},t.prototype.toString=function(){var e=[];if(!this.response)throw new Error("response field does not exist, cannot generate Authorization header");return e.push("algorithm="+this.algorithm),e.push('username="'+this.username+'"'),e.push('realm="'+this.realm+'"'),e.push('nonce="'+this.nonce+'"'),e.push('uri="'+this.uri+'"'),e.push('response="'+this.response+'"'),this.opaque&&e.push('opaque="'+this.opaque+'"'),this.qop&&(e.push("qop="+this.qop),e.push('cnonce="'+this.cnonce+'"'),e.push("nc="+this.ncHex)),"Digest "+e.join(", ")},t.prototype.updateNcHex=function(){var e=Number(this.nc).toString(16);this.ncHex="00000000".substr(0,8-e.length)+e},t}},{}],73:[function(e,t,i){"use strict";var n=e("events").EventEmitter;t.exports=function(e){function t(){n.call(this)}return t.prototype=Object.create(n.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),t.prototype.off=function(t,i){var n="";return n+="SIP.EventEmitter#off is deprecated and may be removed in future SIP.js versions.\n",n+="Please use removeListener or removeAllListeners instead.\n",n+="See here for more details:\n",n+="http://nodejs.org/api/events.html#events_emitter_removelistener_event_listener",e.warn(n),arguments.length<2?this.removeAllListeners.apply(this,arguments):this.removeListener(t,i)},t}},{events:62}],74:[function(e,t,i){"use strict";t.exports={ConfigurationError:function(){var e=function(e,t){this.code=1,this.name="CONFIGURATION_ERROR",this.parameter=e,this.value=t,this.message=this.value?"Invalid value "+JSON.stringify(this.value)+' for parameter "'+this.parameter+'"':"Missing parameter: "+this.parameter};return e.prototype=new Error,e}(),InvalidStateError:function(){var e=function(e){this.code=2,this.name="INVALID_STATE_ERROR",this.status=e,this.message="Invalid status: "+e};return e.prototype=new Error,e}(),NotSupportedError:function(){var e=function(e){this.code=3,this.name="NOT_SUPPORTED_ERROR",this.message=e};return e.prototype=new Error,e}(),GetDescriptionError:function(){var e=function(e){this.code=4,this.name="GET_DESCRIPTION_ERROR",this.message=e};return e.prototype=new Error,e}()}},{}],75:[function(e,t,i){"use strict";var n=e("./Grammar/dist/Grammar");t.exports=function(e){return{parse:function(t,i){var r={startRule:i,SIP:e};try{n.parse(t,r)}catch(s){r.data=-1}return r.data}}}},{"./Grammar/dist/Grammar":76}],76:[function(e,t,i){t.exports=function(){function e(e,t){function i(){this.constructor=e}i.prototype=t.prototype,e.prototype=new i}function t(e,t,i,n,r,s){this.message=e,this.expected=t,this.found=i,this.offset=n,this.line=r,this.column=s,this.name="SyntaxError"}function i(e){function i(){return e.substring(_,v)}function n(){return _}function r(t){function i(t,i,n){var r,s;for(r=i;n>r;r++)s=e.charAt(r),"\n"===s?(t.seenCR||t.line++,t.column=1,t.seenCR=!1):"\r"===s||"\u2028"===s||"\u2029"===s?(t.line++,t.column=1,t.seenCR=!0):(t.column++,t.seenCR=!1)}return T!==t&&(T>t&&(T=0,E={line:1,column:1,seenCR:!1}),i(E,T,t),T=t),E}function s(e){y>v||(v>y&&(y=v,S=[]),S.push(e))}function o(i,n,s){function o(e){var t=1;for(e.sort(function(e,t){return e.description<t.description?-1:e.description>t.description?1:0});t<e.length;)e[t-1]===e[t]?e.splice(t,1):t++}function a(e,t){function i(e){function t(e){return e.charCodeAt(0).toString(16).toUpperCase()}return e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+t(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+t(e)}).replace(/[\u0180-\u0FFF]/g,function(e){return"\\u0"+t(e)}).replace(/[\u1080-\uFFFF]/g,function(e){return"\\u"+t(e)})}var n,r,s,o=new Array(e.length);for(s=0;s<e.length;s++)o[s]=e[s].description;return n=e.length>1?o.slice(0,-1).join(", ")+" or "+o[e.length-1]:o[0],r=t?'"'+i(t)+'"':"end of input","Expected "+n+" but "+r+" found."}var c=r(s),u=s<e.length?e.charAt(s):null;return null!==n&&o(n),new t(null!==i?i:a(n,u),n,u,s,c.line,c.column)}function a(e){var t,i=new Array(e.length);for(t=0;t<e.length;t++)i[t]=e.charCodeAt(t)-32;return i}function c(t){function i(e){return"[object Array]"===Object.prototype.toString.apply(e)?[]:e}for(var n,r,o=m[t],a=0,u=[],l=o.length,h=[],p=[];;){for(;l>a;)switch(o[a]){case 0:p.push(i(g[o[a+1]])),a+=2;break;case 1:p.push(v),a++;break;case 2:p.pop(),a++;break;case 3:v=p.pop(),a++;break;case 4:p.length-=o[a+1],a+=2;break;case 5:p.splice(-2,1),a++;break;case 6:p[p.length-2].push(p.pop()),a++;break;case 7:p.push(p.splice(p.length-o[a+1],o[a+1])),a+=2;break;case 8:p.pop(),p.push(e.substring(p[p.length-1],v)),a++;break;case 9:h.push(l),u.push(a+3+o[a+1]+o[a+2]),p[p.length-1]?(l=a+3+o[a+1],a+=3):(l=a+3+o[a+1]+o[a+2],a+=3+o[a+1]);break;case 10:h.push(l),u.push(a+3+o[a+1]+o[a+2]),p[p.length-1]===d?(l=a+3+o[a+1],a+=3):(l=a+3+o[a+1]+o[a+2],a+=3+o[a+1]);break;case 11:h.push(l),u.push(a+3+o[a+1]+o[a+2]),p[p.length-1]!==d?(l=a+3+o[a+1],a+=3):(l=a+3+o[a+1]+o[a+2],a+=3+o[a+1]);break;case 12:p[p.length-1]!==d?(h.push(l),u.push(a),l=a+2+o[a+1],a+=2):a+=2+o[a+1];break;case 13:h.push(l),u.push(a+3+o[a+1]+o[a+2]),e.length>v?(l=a+3+o[a+1],a+=3):(l=a+3+o[a+1]+o[a+2],a+=3+o[a+1]);break;case 14:h.push(l),u.push(a+4+o[a+2]+o[a+3]),e.substr(v,g[o[a+1]].length)===g[o[a+1]]?(l=a+4+o[a+2],a+=4):(l=a+4+o[a+2]+o[a+3],a+=4+o[a+2]);break;case 15:h.push(l),u.push(a+4+o[a+2]+o[a+3]),e.substr(v,g[o[a+1]].length).toLowerCase()===g[o[a+1]]?(l=a+4+o[a+2],a+=4):(l=a+4+o[a+2]+o[a+3],a+=4+o[a+2]);break;case 16:h.push(l),u.push(a+4+o[a+2]+o[a+3]),g[o[a+1]].test(e.charAt(v))?(l=a+4+o[a+2],a+=4):(l=a+4+o[a+2]+o[a+3],a+=4+o[a+2]);break;case 17:p.push(e.substr(v,o[a+1])),v+=o[a+1],a+=2;break;case 18:p.push(g[o[a+1]]),v+=g[o[a+1]].length,a+=2;break;case 19:p.push(d),0===C&&s(g[o[a+1]]),a+=2;break;case 20:_=p[p.length-1-o[a+1]],a+=2;break;case 21:_=v,a++;break;case 22:for(n=o.slice(a+4,a+4+o[a+3]),r=0;r<o[a+3];r++)n[r]=p[p.length-1-n[r]];p.splice(p.length-o[a+2],o[a+2],g[o[a+1]].apply(null,n)),a+=4+o[a+3];break;case 23:p.push(c(o[a+1])),a+=2;break;case 24:C++,a++;break;case 25:C--,a++;break;default:throw new Error("Invalid opcode: "+o[a]+".")}if(!(h.length>0))break;l=h.pop(),a=u.pop()}return p[0]}function u(e,t){return[e].concat(t)}var l,h=arguments.length>1?arguments[1]:{},d={},p={Contact:118,Name_Addr_Header:155,Record_Route:175,Request_Response:81,SIP_URI:45,Subscription_State:185,Supported:190,Require:181,Via:193,absoluteURI:84,Call_ID:117,Content_Disposition:129,Content_Length:134,Content_Type:135,CSeq:145,displayName:121,Event:148,From:150,host:52,Max_Forwards:153,Min_SE:212,Proxy_Authenticate:156,quoted_string:40,Refer_To:177,Replaces:178,Session_Expires:209,stun_URI:216,To:191,turn_URI:223,uuid:226,WWW_Authenticate:208,challenge:157},f=118,g=["\r\n",{type:"literal",value:"\r\n",description:'"\\r\\n"'},/^[0-9]/,{type:"class",value:"[0-9]",description:"[0-9]"},/^[a-zA-Z]/,{type:"class",value:"[a-zA-Z]",description:"[a-zA-Z]"},/^[0-9a-fA-F]/,{type:"class",value:"[0-9a-fA-F]",description:"[0-9a-fA-F]"},/^[\0-\xFF]/,{type:"class",value:"[\\0-\\xFF]",description:"[\\0-\\xFF]"},/^["]/,{type:"class",value:'["]',description:'["]'}," ",{type:"literal",value:" ",description:'" "'},"	",{type:"literal",value:"	",description:'"\\t"'},/^[a-zA-Z0-9]/,{type:"class",value:"[a-zA-Z0-9]",description:"[a-zA-Z0-9]"},";",{type:"literal",value:";",description:'";"'},"/",{type:"literal",value:"/",description:'"/"'},"?",{type:"literal",value:"?",description:'"?"'},":",{type:"literal",value:":",description:'":"'},"@",{type:"literal",value:"@",description:'"@"'},"&",{type:"literal",value:"&",description:'"&"'},"=",{type:"literal",value:"=",description:'"="'},"+",{type:"literal",value:"+",description:'"+"'},"$",{type:"literal",value:"$",description:'"$"'},",",{type:"literal",value:",",description:'","'},"-",{type:"literal",value:"-",description:'"-"'},"_",{type:"literal",value:"_",description:'"_"'},".",{type:"literal",value:".",description:'"."'},"!",{type:"literal",value:"!",description:'"!"'},"~",{type:"literal",value:"~",description:'"~"'},"*",{type:"literal",value:"*",description:'"*"'},"'",{type:"literal",value:"'",description:'"\'"'},"(",{type:"literal",value:"(",description:'"("'},")",{type:"literal",value:")",description:'")"'},d,"%",{type:"literal",value:"%",description:'"%"'},null,[],function(){return" "},function(){return":"},/^[!-~]/,{type:"class",value:"[!-~]",description:"[!-~]"},/^[\x80-\uFFFF]/,{type:"class",value:"[\\x80-\\uFFFF]",description:"[\\x80-\\uFFFF]"},/^[\x80-\xBF]/,{type:"class",value:"[\\x80-\\xBF]",description:"[\\x80-\\xBF]"},/^[a-f]/,{type:"class",value:"[a-f]",description:"[a-f]"},"`",{type:"literal",value:"`",description:'"`"'},"<",{type:"literal",value:"<",description:'"<"'},">",{type:"literal",value:">",description:'">"'},"\\",{type:"literal",value:"\\",description:'"\\\\"'},"[",{type:"literal",value:"[",description:'"["'},"]",{type:"literal",value:"]",description:'"]"'},"{",{type:"literal",value:"{",description:'"{"'},"}",{type:"literal",value:"}",description:'"}"'},function(){return"*"},function(){return"/"},function(){return"="},function(){return"("},function(){return")"},function(){return">"},function(){return"<"},function(){return","},function(){return";"},function(){return":"},function(){return'"'},/^[!-']/,{type:"class",value:"[!-']",description:"[!-']"},/^[*-[]/,{type:"class",value:"[*-[]",description:"[*-[]"},/^[\]-~]/,{type:"class",value:"[\\]-~]",description:"[\\]-~]"},function(e){return e},/^[#-[]/,{type:"class",value:"[#-[]",description:"[#-[]"},/^[\0-\t]/,{type:"class",value:"[\\0-\\t]",description:"[\\0-\\t]"},/^[\x0B-\f]/,{type:"class",value:"[\\x0B-\\f]",description:"[\\x0B-\\f]"},/^[\x0E-]/,{type:"class",value:"[\\x0E-]",description:"[\\x0E-]"},function(){h.data.uri=new h.SIP.URI(h.data.scheme,h.data.user,h.data.host,h.data.port),delete h.data.scheme,delete h.data.user,delete h.data.host,delete h.data.host_type,delete h.data.port},function(){h.data.uri=new h.SIP.URI(h.data.scheme,h.data.user,h.data.host,h.data.port,h.data.uri_params,h.data.uri_headers),delete h.data.scheme,delete h.data.user,delete h.data.host,delete h.data.host_type,delete h.data.port,delete h.data.uri_params,"SIP_URI"===h.startRule&&(h.data=h.data.uri)},"sips",{type:"literal",value:"sips",description:'"sips"'},"sip",{type:"literal",value:"sip",description:'"sip"'},function(e){h.data.scheme=e},function(){h.data.user=decodeURIComponent(i().slice(0,-1))},function(){h.data.password=i()},function(){return h.data.host=i(),h.data.host},function(){return h.data.host_type="domain",i()},/^[a-zA-Z0-9_\-]/,{type:"class",value:"[a-zA-Z0-9_\\-]",description:"[a-zA-Z0-9_\\-]"},/^[a-zA-Z0-9\-]/,{type:"class",value:"[a-zA-Z0-9\\-]",description:"[a-zA-Z0-9\\-]"},function(){return h.data.host_type="IPv6",i()},"::",{type:"literal",value:"::",description:'"::"'},function(){return h.data.host_type="IPv6",i()},function(){return h.data.host_type="IPv4",i()},"25",{type:"literal",value:"25",description:'"25"'},/^[0-5]/,{type:"class",value:"[0-5]",description:"[0-5]"},"2",{type:"literal",value:"2",description:'"2"'},/^[0-4]/,{type:"class",value:"[0-4]",description:"[0-4]"},"1",{type:"literal",value:"1",description:'"1"'},/^[1-9]/,{type:"class",value:"[1-9]",description:"[1-9]"},function(e){return e=parseInt(e.join("")),h.data.port=e,e},"transport=",{type:"literal",value:"transport=",description:'"transport="'},"udp",{type:"literal",value:"udp",description:'"udp"'},"tcp",{type:"literal",value:"tcp",description:'"tcp"'},"sctp",{type:"literal",value:"sctp",description:'"sctp"'},"tls",{type:"literal",value:"tls",description:'"tls"'},function(e){h.data.uri_params||(h.data.uri_params={}),h.data.uri_params.transport=e.toLowerCase()},"user=",{type:"literal",value:"user=",description:'"user="'},"phone",{type:"literal",value:"phone",description:'"phone"'},"ip",{type:"literal",value:"ip",description:'"ip"'},function(e){h.data.uri_params||(h.data.uri_params={}),h.data.uri_params.user=e.toLowerCase()},"method=",{type:"literal",value:"method=",description:'"method="'},function(e){h.data.uri_params||(h.data.uri_params={}),h.data.uri_params.method=e},"ttl=",{type:"literal",value:"ttl=",description:'"ttl="'},function(e){h.data.params||(h.data.params={}),h.data.params.ttl=e},"maddr=",{type:"literal",value:"maddr=",description:'"maddr="'},function(e){h.data.uri_params||(h.data.uri_params={}),h.data.uri_params.maddr=e},"lr",{type:"literal",value:"lr",description:'"lr"'},function(){h.data.uri_params||(h.data.uri_params={}),h.data.uri_params.lr=void 0},function(e,t){h.data.uri_params||(h.data.uri_params={}),t=null===t?void 0:t[1],h.data.uri_params[e.toLowerCase()]=t&&t.toLowerCase()},function(e,t){e=e.join("").toLowerCase(),t=t.join(""),h.data.uri_headers||(h.data.uri_headers={}),h.data.uri_headers[e]?h.data.uri_headers[e].push(t):h.data.uri_headers[e]=[t]},function(){"Refer_To"===h.startRule&&(h.data.uri=new h.SIP.URI(h.data.scheme,h.data.user,h.data.host,h.data.port,h.data.uri_params,h.data.uri_headers),delete h.data.scheme,delete h.data.user,delete h.data.host,delete h.data.host_type,delete h.data.port,delete h.data.uri_params)},"//",{type:"literal",value:"//",description:'"//"'},function(){h.data.scheme=i()},{type:"literal",value:"SIP",description:'"SIP"'},function(){h.data.sip_version=i()},"INVITE",{type:"literal",value:"INVITE",description:'"INVITE"'},"ACK",{type:"literal",value:"ACK",description:'"ACK"'},"VXACH",{type:"literal",value:"VXACH",description:'"VXACH"'},"OPTIONS",{type:"literal",value:"OPTIONS",description:'"OPTIONS"'},"BYE",{type:"literal",value:"BYE",description:'"BYE"'},"CANCEL",{type:"literal",value:"CANCEL",description:'"CANCEL"'},"REGISTER",{type:"literal",value:"REGISTER",description:'"REGISTER"'},"SUBSCRIBE",{type:"literal",value:"SUBSCRIBE",description:'"SUBSCRIBE"'},"NOTIFY",{type:"literal",value:"NOTIFY",description:'"NOTIFY"'},"REFER",{type:"literal",value:"REFER",description:'"REFER"'},function(){return h.data.method=i(),h.data.method},function(e){h.data.status_code=parseInt(e.join(""))},function(){h.data.reason_phrase=i()},function(){h.data=i()},function(){var e,t;for(t=h.data.multi_header.length,e=0;t>e;e++)if(null===h.data.multi_header[e].parsed){h.data=null;break}null!==h.data?h.data=h.data.multi_header:h.data=-1},function(){var e;h.data.multi_header||(h.data.multi_header=[]);try{e=new h.SIP.NameAddrHeader(h.data.uri,h.data.displayName,h.data.params),delete h.data.uri,delete h.data.displayName,delete h.data.params}catch(t){e=null}h.data.multi_header.push({position:v,offset:n(),parsed:e})},function(e){e=i().trim(),'"'===e[0]&&(e=e.substring(1,e.length-1)),h.data.displayName=e},"q",{type:"literal",value:"q",description:'"q"'},function(e){h.data.params||(h.data.params={}),h.data.params.q=e},"expires",{type:"literal",value:"expires",description:'"expires"'},function(e){h.data.params||(h.data.params={}),h.data.params.expires=e},function(e){return parseInt(e.join(""))},"0",{type:"literal",value:"0",description:'"0"'},function(){return parseFloat(i())},function(e,t){h.data.params||(h.data.params={}),t=null===t?void 0:t[1],h.data.params[e.toLowerCase()]=t},"render",{type:"literal",value:"render",description:'"render"'},"session",{type:"literal",value:"session",description:'"session"'},"icon",{type:"literal",value:"icon",description:'"icon"'},"alert",{type:"literal",value:"alert",description:'"alert"'},function(){"Content_Disposition"===h.startRule&&(h.data.type=i().toLowerCase())},"handling",{type:"literal",value:"handling",description:'"handling"'},"optional",{type:"literal",value:"optional",description:'"optional"'},"required",{type:"literal",value:"required",description:'"required"'},function(e){h.data=parseInt(e.join(""))},function(){h.data=i()},"text",{type:"literal",value:"text",description:'"text"'},"image",{type:"literal",value:"image",description:'"image"'},"audio",{type:"literal",value:"audio",description:'"audio"'},"video",{type:"literal",value:"video",description:'"video"'},"application",{type:"literal",value:"application",description:'"application"'},"message",{type:"literal",value:"message",description:'"message"'},"multipart",{type:"literal",value:"multipart",description:'"multipart"'},"x-",{type:"literal",value:"x-",description:'"x-"'},function(e){h.data.value=parseInt(e.join(""))},function(e){h.data=e},function(e){h.data.event=e.toLowerCase()},function(){var e=h.data.tag;h.data=new h.SIP.NameAddrHeader(h.data.uri,h.data.displayName,h.data.params),e&&h.data.setParam("tag",e)},"tag",{type:"literal",value:"tag",description:'"tag"'},function(e){h.data.tag=e},function(e){h.data=parseInt(e.join(""))},function(e){h.data=e},function(){h.data=new h.SIP.NameAddrHeader(h.data.uri,h.data.displayName,h.data.params)},"digest",{type:"literal",value:"Digest",description:'"Digest"'},"realm",{type:"literal",value:"realm",description:'"realm"'},function(e){h.data.realm=e},"domain",{type:"literal",value:"domain",description:'"domain"'},"nonce",{type:"literal",value:"nonce",description:'"nonce"'},function(e){h.data.nonce=e},"opaque",{type:"literal",value:"opaque",description:'"opaque"'},function(e){h.data.opaque=e},"stale",{type:"literal",value:"stale",description:'"stale"'},"true",{type:"literal",value:"true",description:'"true"'},function(){h.data.stale=!0},"false",{type:"literal",value:"false",description:'"false"'},function(){h.data.stale=!1},"algorithm",{type:"literal",value:"algorithm",description:'"algorithm"'},"md5",{type:"literal",value:"MD5",description:'"MD5"'},"md5-sess",{type:"literal",value:"MD5-sess",description:'"MD5-sess"'},function(e){h.data.algorithm=e.toUpperCase()},"qop",{type:"literal",value:"qop",description:'"qop"'},"auth-int",{type:"literal",value:"auth-int",description:'"auth-int"'},"auth",{type:"literal",value:"auth",description:'"auth"'},function(e){h.data.qop||(h.data.qop=[]),h.data.qop.push(e.toLowerCase())},function(e){h.data.value=parseInt(e.join(""))},function(){var e,t;for(t=h.data.multi_header.length,e=0;t>e;e++)if(null===h.data.multi_header[e].parsed){h.data=null;break}null!==h.data?h.data=h.data.multi_header:h.data=-1},function(){var e;h.data.multi_header||(h.data.multi_header=[]);try{e=new h.SIP.NameAddrHeader(h.data.uri,h.data.displayName,h.data.params),delete h.data.uri,delete h.data.displayName,delete h.data.params}catch(t){e=null}h.data.multi_header.push({position:v,offset:n(),parsed:e})},function(){h.data=new h.SIP.NameAddrHeader(h.data.uri,h.data.displayName,h.data.params)},function(){h.data.replaces_from_tag&&h.data.replaces_to_tag||(h.data=-1)},function(){h.data={call_id:h.data}},"from-tag",{type:"literal",value:"from-tag",description:'"from-tag"'},function(e){h.data.replaces_from_tag=e},"to-tag",{type:"literal",value:"to-tag",description:'"to-tag"'},function(e){h.data.replaces_to_tag=e},"early-only",{type:"literal",value:"early-only",description:'"early-only"'},function(){h.data.early_only=!0},function(e){return e},function(e,t){return u(e,t)},function(e){"Require"===h.startRule&&(h.data=e||[])},function(e){h.data.value=parseInt(e.join(""))},"active",{type:"literal",value:"active",description:'"active"'},"pending",{type:"literal",value:"pending",description:'"pending"'},"terminated",{type:"literal",value:"terminated",description:'"terminated"'},function(){h.data.state=i()},"reason",{type:"literal",value:"reason",description:'"reason"'},function(e){"undefined"!=typeof e&&(h.data.reason=e)},function(e){"undefined"!=typeof e&&(h.data.expires=e)},"retry_after",{type:"literal",value:"retry_after",description:'"retry_after"'},function(e){"undefined"!=typeof e&&(h.data.retry_after=e)},"deactivated",{type:"literal",value:"deactivated",description:'"deactivated"'},"probation",{type:"literal",value:"probation",description:'"probation"'},"rejected",{type:"literal",value:"rejected",description:'"rejected"'},"timeout",{type:"literal",value:"timeout",description:'"timeout"'},"giveup",{type:"literal",value:"giveup",description:'"giveup"'},"noresource",{type:"literal",value:"noresource",description:'"noresource"'},"invariant",{type:"literal",value:"invariant",description:'"invariant"'},function(e){"Supported"===h.startRule&&(h.data=e||[])},function(){var e=h.data.tag;h.data=new h.SIP.NameAddrHeader(h.data.uri,h.data.displayName,h.data.params),e&&h.data.setParam("tag",e)},"ttl",{type:"literal",value:"ttl",description:'"ttl"'},function(e){h.data.ttl=e},"maddr",{type:"literal",value:"maddr",description:'"maddr"'},function(e){h.data.maddr=e},"received",{type:"literal",value:"received",description:'"received"'},function(e){h.data.received=e},"branch",{type:"literal",value:"branch",description:'"branch"'},function(e){h.data.branch=e},"rport",{type:"literal",value:"rport",description:'"rport"'},function(){"undefined"!=typeof response_port&&(h.data.rport=response_port.join(""))},function(e){h.data.protocol=e},{type:"literal",value:"UDP",description:'"UDP"'},{type:"literal",value:"TCP",description:'"TCP"'},{type:"literal",value:"TLS",description:'"TLS"'},{type:"literal",value:"SCTP",description:'"SCTP"'},function(e){h.data.transport=e},function(){h.data.host=i()},function(e){h.data.port=parseInt(e.join(""))},function(e){return parseInt(e.join(""))},function(e){"Session_Expires"===h.startRule&&(h.data.deltaSeconds=e)},"refresher",{type:"literal",value:"refresher",description:'"refresher"'},"uas",{type:"literal",value:"uas",description:'"uas"'},"uac",{type:"literal",value:"uac",description:'"uac"'},function(e){"Session_Expires"===h.startRule&&(h.data.refresher=e)},function(e){"Min_SE"===h.startRule&&(h.data=e)},"stuns",{type:"literal",value:"stuns",description:'"stuns"'},"stun",{type:"literal",value:"stun",description:'"stun"'},function(e){h.data.scheme=e},function(e){h.data.host=e},"?transport=",{type:"literal",value:"?transport=",description:'"?transport="'},"turns",{type:"literal",value:"turns",description:'"turns"'},"turn",{type:"literal",value:"turn",description:'"turn"'},function(){h.data.transport=transport},function(){h.data=i()}],m=[a('. ""2 3!'),a('0"""1!3#'),a('0$""1!3%'),a('0&""1!3\''),a("7'*# \"7("),a('0(""1!3)'),a('0*""1!3+'),a('.,""2,3-'),a('..""2.3/'),a('00""1!31'),a('.2""2233*\x89 ".4""2435*} ".6""2637*q ".8""2839*e ".:""2:3;*Y ".<""2<3=*M ".>""2>3?*A ".@""2@3A*5 ".B""2B3C*) ".D""2D3E'),a('7)*# "7,'),a('.F""2F3G*} ".H""2H3I*q ".J""2J3K*e ".L""2L3M*Y ".N""2N3O*M ".P""2P3Q*A ".R""2R3S*5 ".T""2T3U*) ".V""2V3W'),a('!!.Y""2Y3Z+7$7#+-%7#+#%\'#%$## X$"# X"# X+! (%'),a('!! \\7$,#&7$"+-$7 +#%\'"%$"# X"# X*# " [+@$ \\7$+&$,#&7$""" X+\'%4"6]" %$"# X"# X'),a('7.*# " ['),a('! \\7\'*# "7(,)&7\'*# "7("+A$.8""2839+1%7/+\'%4#6^# %$## X$"# X"# X'),a('!! \\72+&$,#&72""" X+o$ \\! \\7.,#&7."+-$72+#%\'"%$"# X"# X,@&! \\7.,#&7."+-$72+#%\'"%$"# X"# X"+#%\'"%$"# X"# X+! (%'),a('0_""1!3`*# "73'),a('0a""1!3b'),a('0c""1!3d'),a('7!*) "0e""1!3f'),a('! \\7)*\x95 ".F""2F3G*\x89 ".J""2J3K*} ".L""2L3M*q ".Y""2Y3Z*e ".P""2P3Q*Y ".H""2H3I*M ".@""2@3A*A ".g""2g3h*5 ".R""2R3S*) ".N""2N3O+\x9e$,\x9b&7)*\x95 ".F""2F3G*\x89 ".J""2J3K*} ".L""2L3M*q ".Y""2Y3Z*e ".P""2P3Q*Y ".H""2H3I*M ".@""2@3A*A ".g""2g3h*5 ".R""2R3S*) ".N""2N3O""" X+! (%'),a('! \\7)*\x89 ".F""2F3G*} ".L""2L3M*q ".Y""2Y3Z*e ".P""2P3Q*Y ".H""2H3I*M ".@""2@3A*A ".g""2g3h*5 ".R""2R3S*) ".N""2N3O+\x92$,\x8f&7)*\x89 ".F""2F3G*} ".L""2L3M*q ".Y""2Y3Z*e ".P""2P3Q*Y ".H""2H3I*M ".@""2@3A*A ".g""2g3h*5 ".R""2R3S*) ".N""2N3O""" X+! (%'),a('.T""2T3U*\xe3 ".V""2V3W*\xd7 ".i""2i3j*\xcb ".k""2k3l*\xbf ".:""2:3;*\xb3 ".D""2D3E*\xa7 ".2""2233*\x9b ".8""2839*\x8f ".m""2m3n*\x83 "7&*} ".4""2435*q ".o""2o3p*e ".q""2q3r*Y ".6""2637*M ".>""2>3?*A ".s""2s3t*5 ".u""2u3v*) "7\'*# "7('),a('! \\7)*\u012b ".F""2F3G*\u011f ".J""2J3K*\u0113 ".L""2L3M*\u0107 ".Y""2Y3Z*\xfb ".P""2P3Q*\xef ".H""2H3I*\xe3 ".@""2@3A*\xd7 ".g""2g3h*\xcb ".R""2R3S*\xbf ".N""2N3O*\xb3 ".T""2T3U*\xa7 ".V""2V3W*\x9b ".i""2i3j*\x8f ".k""2k3l*\x83 ".8""2839*w ".m""2m3n*k "7&*e ".4""2435*Y ".o""2o3p*M ".q""2q3r*A ".6""2637*5 ".s""2s3t*) ".u""2u3v+\u0134$,\u0131&7)*\u012b ".F""2F3G*\u011f ".J""2J3K*\u0113 ".L""2L3M*\u0107 ".Y""2Y3Z*\xfb ".P""2P3Q*\xef ".H""2H3I*\xe3 ".@""2@3A*\xd7 ".g""2g3h*\xcb ".R""2R3S*\xbf ".N""2N3O*\xb3 ".T""2T3U*\xa7 ".V""2V3W*\x9b ".i""2i3j*\x8f ".k""2k3l*\x83 ".8""2839*w ".m""2m3n*k "7&*e ".4""2435*Y ".o""2o3p*M ".q""2q3r*A ".6""2637*5 ".s""2s3t*) ".u""2u3v""" X+! (%'),a('!7/+A$.P""2P3Q+1%7/+\'%4#6w# %$## X$"# X"# X'),a('!7/+A$.4""2435+1%7/+\'%4#6x# %$## X$"# X"# X'),a('!7/+A$.>""2>3?+1%7/+\'%4#6y# %$## X$"# X"# X'),a('!7/+A$.T""2T3U+1%7/+\'%4#6z# %$## X$"# X"# X'),a('!7/+A$.V""2V3W+1%7/+\'%4#6{# %$## X$"# X"# X'),a('!.k""2k3l+1$7/+\'%4"6|" %$"# X"# X'),a('!7/+7$.i""2i3j+\'%4"6}" %$"# X"# X'),a('!7/+A$.D""2D3E+1%7/+\'%4#6~# %$## X$"# X"# X'),a('!7/+A$.2""2233+1%7/+\'%4#6# %$## X$"# X"# X'),a('!7/+A$.8""2839+1%7/+\'%4#6\x80# %$## X$"# X"# X'),a('!7/+1$7&+\'%4"6\x81" %$"# X"# X'),a('!7&+1$7/+\'%4"6\x81" %$"# X"# X'),a('!7=+W$ \\7G*) "7K*# "7F,/&7G*) "7K*# "7F"+-%7>+#%\'#%$## X$"# X"# X'),a('0\x82""1!3\x83*A "0\x84""1!3\x85*5 "0\x86""1!3\x87*) "73*# "7.'),a('!!7/+U$7&+K% \\7J*# "7K,)&7J*# "7K"+-%7&+#%\'$%$$# X$## X$"# X"# X+! (%'),a('!7/+`$7&+V%! \\7J*# "7K,)&7J*# "7K"+! (%+2%7&+(%4$6\x88$!!%$$# X$## X$"# X"# X'),a('7.*G ".L""2L3M*; "0\x89""1!3\x8a*/ "0\x86""1!3\x87*# "73'),a('!.m""2m3n+K$0\x8b""1!3\x8c*5 "0\x8d""1!3\x8e*) "0\x8f""1!3\x90+#%\'"%$"# X"# X'),a('!7N+Q$.8""2839+A%7O*# " [+1%7S+\'%4$6\x91$ %$$# X$## X$"# X"# X'),a('!7N+k$.8""2839+[%7O*# " [+K%7S+A%7_+7%7l*# " [+\'%4&6\x92& %$&# X$%# X$$# X$## X$"# X"# X'),a('!/\x93""1$3\x94*) "/\x95""1#3\x96+\' 4!6\x97!! %'),a('!7P+b$!.8""2839+-$7R+#%\'"%$"# X"# X*# " [+7%.:""2:3;+\'%4#6\x98# %$## X$"# X"# X'),a(' \\7+*) "7-*# "7Q+2$,/&7+*) "7-*# "7Q""" X'),a('.<""2<3=*q ".>""2>3?*e ".@""2@3A*Y ".B""2B3C*M ".D""2D3E*A ".2""2233*5 ".6""2637*) ".4""2435'),a('! \\7+*_ "7-*Y ".<""2<3=*M ".>""2>3?*A ".@""2@3A*5 ".B""2B3C*) ".D""2D3E,e&7+*_ "7-*Y ".<""2<3=*M ".>""2>3?*A ".@""2@3A*5 ".B""2B3C*) ".D""2D3E"+& 4!6\x99! %'),a('!7T+N$!.8""2839+-$7^+#%\'"%$"# X"# X*# " [+#%\'"%$"# X"# X'),a('!7U*) "7\\*# "7X+& 4!6\x9a! %'),a('! \\!7V+3$.J""2J3K+#%\'"%$"# X"# X,>&!7V+3$.J""2J3K+#%\'"%$"# X"# X"+G$7W+=%.J""2J3K*# " [+\'%4#6\x9b# %$## X$"# X"# X'),a(' \\0\x9c""1!3\x9d+,$,)&0\x9c""1!3\x9d""" X'),a('!0$""1!3%+A$ \\0\x9e""1!3\x9f,)&0\x9e""1!3\x9f"+#%\'"%$"# X"# X'),a('!.o""2o3p+A$7Y+7%.q""2q3r+\'%4#6\xa0# %$## X$"# X"# X'),a('!!7Z+\xbf$.8""2839+\xaf%7Z+\xa5%.8""2839+\x95%7Z+\x8b%.8""2839+{%7Z+q%.8""2839+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\'-%$-# X$,# X$+# X$*# X$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0838 "!.\xa1""2\xa13\xa2+\xaf$7Z+\xa5%.8""2839+\x95%7Z+\x8b%.8""2839+{%7Z+q%.8""2839+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\',%$,# X$+# X$*# X$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0795 "!.\xa1""2\xa13\xa2+\x95$7Z+\x8b%.8""2839+{%7Z+q%.8""2839+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\'*%$*# X$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u070c "!.\xa1""2\xa13\xa2+{$7Z+q%.8""2839+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\'(%$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u069d "!.\xa1""2\xa13\xa2+a$7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\'&%$&# X$%# X$$# X$## X$"# X"# X*\u0648 "!.\xa1""2\xa13\xa2+G$7Z+=%.8""2839+-%7[+#%\'$%$$# X$## X$"# X"# X*\u060d "!.\xa1""2\xa13\xa2+-$7[+#%\'"%$"# X"# X*\u05ec "!.\xa1""2\xa13\xa2+-$7Z+#%\'"%$"# X"# X*\u05cb "!7Z+\xa5$.\xa1""2\xa13\xa2+\x95%7Z+\x8b%.8""2839+{%7Z+q%.8""2839+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\'+%$+# X$*# X$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0538 "!7Z+\xb6$!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\x8b%.\xa1""2\xa13\xa2+{%7Z+q%.8""2839+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\'*%$*# X$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0494 "!7Z+\xc7$!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\x9c%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+q%.\xa1""2\xa13\xa2+a%7Z+W%.8""2839+G%7Z+=%.8""2839+-%7[+#%\')%$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u03df "!7Z+\xd8$!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\xad%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\x82%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+W%.\xa1""2\xa13\xa2+G%7Z+=%.8""2839+-%7[+#%\'(%$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0319 "!7Z+\xe9$!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\xbe%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\x93%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+h%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+=%.\xa1""2\xa13\xa2+-%7[+#%\'\'%$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0242 "!7Z+\u0114$!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\xe9%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\xbe%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\x93%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+h%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+=%.\xa1""2\xa13\xa2+-%7Z+#%\'(%$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X*\u0140 "!7Z+\u0135$!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\u010a%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\xdf%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\xb4%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+\x89%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+^%!.8""2839+-$7Z+#%\'"%$"# X"# X*# " [+3%.\xa1""2\xa13\xa2+#%\'(%$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X+& 4!6\xa3! %'),a('!7#+S$7#*# " [+C%7#*# " [+3%7#*# " [+#%\'$%$$# X$## X$"# X"# X'),a('!7Z+=$.8""2839+-%7Z+#%\'#%$## X$"# X"# X*# "7\\'),a('!7]+u$.J""2J3K+e%7]+[%.J""2J3K+K%7]+A%.J""2J3K+1%7]+\'%4\'6\xa4\' %$\'# X$&# X$%# X$$# X$## X$"# X"# X'),a('!.\xa5""2\xa53\xa6+3$0\xa7""1!3\xa8+#%\'"%$"# X"# X*\xa0 "!.\xa9""2\xa93\xaa+=$0\xab""1!3\xac+-%7!+#%\'#%$## X$"# X"# X*o "!.\xad""2\xad3\xae+7$7!+-%7!+#%\'#%$## X$"# X"# X*D "!0\xaf""1!3\xb0+-$7!+#%\'"%$"# X"# X*# "7!'),a('!!7!*# " [+c$7!*# " [+S%7!*# " [+C%7!*# " [+3%7!*# " [+#%\'%%$%# X$$# X$## X$"# X"# X+\' 4!6\xb1!! %'),a(' \\!.2""2233+-$7`+#%\'"%$"# X"# X,>&!.2""2233+-$7`+#%\'"%$"# X"# X"'),a('7a*A "7b*; "7c*5 "7d*/ "7e*) "7f*# "7g'),a('!/\xb2""1*3\xb3+b$/\xb4""1#3\xb5*G "/\xb6""1#3\xb7*; "/\xb8""1$3\xb9*/ "/\xba""1#3\xbb*# "76+(%4"6\xbc"! %$"# X"# X'),a('!/\xbd""1%3\xbe+J$/\xbf""1%3\xc0*/ "/\xc1""1"3\xc2*# "76+(%4"6\xc3"! %$"# X"# X'),a('!/\xc4""1\'3\xc5+2$7\x8f+(%4"6\xc6"! %$"# X"# X'),a('!/\xc7""1$3\xc8+2$7\xef+(%4"6\xc9"! %$"# X"# X'),a('!/\xca""1&3\xcb+2$7T+(%4"6\xcc"! %$"# X"# X'),a('!/\xcd""1"3\xce+R$!.>""2>3?+-$76+#%\'"%$"# X"# X*# " [+\'%4"6\xcf" %$"# X"# X'),a('!7h+T$!.>""2>3?+-$7i+#%\'"%$"# X"# X*# " [+)%4"6\xd0""! %$"# X"# X'),a('! \\7j+&$,#&7j""" X+! (%'),a('! \\7j+&$,#&7j""" X+! (%'),a('7k*) "7+*# "7-'),a('.o""2o3p*e ".q""2q3r*Y ".4""2435*M ".8""2839*A ".<""2<3=*5 ".@""2@3A*) ".B""2B3C'),a('!.6""2637+u$7m+k% \\!.<""2<3=+-$7m+#%\'"%$"# X"# X,>&!.<""2<3=+-$7m+#%\'"%$"# X"# X"+#%\'#%$## X$"# X"# X'),a('!7n+C$.>""2>3?+3%7o+)%4#6\xd1#"" %$## X$"# X"# X'),a(' \\7p*) "7+*# "7-+2$,/&7p*) "7+*# "7-""" X'),a(' \\7p*) "7+*# "7-,/&7p*) "7+*# "7-"'),a('.o""2o3p*e ".q""2q3r*Y ".4""2435*M ".6""2637*A ".8""2839*5 ".@""2@3A*) ".B""2B3C'),a('7\x90*# "7r'),a("!7\x8f+K$7'+A%7s+7%7'+-%7\x84+#%'%%$%# X$$# X$## X$\"# X\"# X"),a('7M*# "7t'),a('!7+G$.8""2839+7%7u*# "7x+\'%4#6\xd2# %$## X$"# X"# X'),a('!7v*# "7w+N$!.6""2637+-$7\x83+#%\'"%$"# X"# X*# " [+#%\'"%$"# X"# X'),a('!.\xd3""2\xd33\xd4+=$7\x80+3%7w*# " [+#%\'#%$## X$"# X"# X'),a('!.4""2435+-$7{+#%\'"%$"# X"# X'),a('!7z+5$ \\7y,#&7y"+#%\'"%$"# X"# X'),a('7**) "7+*# "7-'),a('7+*\x8f "7-*\x89 ".2""2233*} ".6""2637*q ".8""2839*e ".:""2:3;*Y ".<""2<3=*M ".>""2>3?*A ".@""2@3A*5 ".B""2B3C*) ".D""2D3E'),a('!7|+k$ \\!.4""2435+-$7|+#%\'"%$"# X"# X,>&!.4""2435+-$7|+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('! \\7~,#&7~"+k$ \\!.2""2233+-$7}+#%\'"%$"# X"# X,>&!.2""2233+-$7}+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a(' \\7~,#&7~"'),a('7+*w "7-*q ".8""2839*e ".:""2:3;*Y ".<""2<3=*M ".>""2>3?*A ".@""2@3A*5 ".B""2B3C*) ".D""2D3E'),a('!7"+\x8d$ \\7"*G "7!*A ".@""2@3A*5 ".F""2F3G*) ".J""2J3K,M&7"*G "7!*A ".@""2@3A*5 ".F""2F3G*) ".J""2J3K"+\'%4"6\xd5" %$"# X"# X'),a('7\x81*# "7\x82'),a('!!7O+3$.:""2:3;+#%\'"%$"# X"# X*# " [+-$7S+#%\'"%$"# X"# X*# " ['),a(' \\7+*\x83 "7-*} ".B""2B3C*q ".D""2D3E*e ".2""2233*Y ".8""2839*M ".:""2:3;*A ".<""2<3=*5 ".>""2>3?*) ".@""2@3A+\x8c$,\x89&7+*\x83 "7-*} ".B""2B3C*q ".D""2D3E*e ".2""2233*Y ".8""2839*M ".:""2:3;*A ".<""2<3=*5 ".>""2>3?*) ".@""2@3A""" X'),a(' \\7y,#&7y"'),a('!/\x95""1#3\xd6+y$.4""2435+i% \\7!+&$,#&7!""" X+P%.J""2J3K+@% \\7!+&$,#&7!""" X+\'%4%6\xd7% %$%# X$$# X$## X$"# X"# X'),a('.\xd8""2\xd83\xd9'),a('.\xda""2\xda3\xdb'),a('.\xdc""2\xdc3\xdd'),a('.\xde""2\xde3\xdf'),a('.\xe0""2\xe03\xe1'),a('.\xe2""2\xe23\xe3'),a('.\xe4""2\xe43\xe5'),a('.\xe6""2\xe63\xe7'),a('.\xe8""2\xe83\xe9'),a('.\xea""2\xea3\xeb'),a('!7\x85*S "7\x86*M "7\x88*G "7\x89*A "7\x8a*; "7\x8b*5 "7\x8c*/ "7\x8d*) "7\x8e*# "76+& 4!6\xec! %'),a("!7\x84+K$7'+A%7\x91+7%7'+-%7\x93+#%'%%$%# X$$# X$## X$\"# X\"# X"),a("!7\x92+' 4!6\xed!! %"),a('!7!+7$7!+-%7!+#%\'#%$## X$"# X"# X'),a('! \\7**A "7+*; "7-*5 "73*/ "74*) "7\'*# "7(,G&7**A "7+*; "7-*5 "73*/ "74*) "7\'*# "7("+& 4!6\xee! %'),a('!7\xb5+_$ \\!7A+-$7\xb5+#%\'"%$"# X"# X,8&!7A+-$7\xb5+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('!79+R$!.:""2:3;+-$79+#%\'"%$"# X"# X*# " [+\'%4"6\xef" %$"# X"# X'),a('!7:*j "!7\x97+_$ \\!7A+-$7\x97+#%\'"%$"# X"# X,8&!7A+-$7\x97+#%\'"%$"# X"# X"+#%\'"%$"# X"# X+& 4!6\xf0! %'),a('!7L*# "7\x98+c$ \\!7B+-$7\x9a+#%\'"%$"# X"# X,8&!7B+-$7\x9a+#%\'"%$"# X"# X"+\'%4"6\xf1" %$"# X"# X'),a('!7\x99*# " [+A$7@+7%7M+-%7?+#%\'$%$$# X$## X$"# X"# X'),a('!!76+_$ \\!7.+-$76+#%\'"%$"# X"# X,8&!7.+-$76+#%\'"%$"# X"# X"+#%\'"%$"# X"# X*# "7H+\' 4!6\xf2!! %'),a('7\x9b*) "7\x9c*# "7\x9f'),a('!/\xf3""1!3\xf4+<$7<+2%7\x9e+(%4#6\xf5#! %$## X$"# X"# X'),a('!/\xf6""1\'3\xf7+<$7<+2%7\x9d+(%4#6\xf8#! %$## X$"# X"# X'),a('! \\7!+&$,#&7!""" X+\' 4!6\xf9!! %'),a('!.\xfa""2\xfa3\xfb+x$!.J""2J3K+S$7!*# " [+C%7!*# " [+3%7!*# " [+#%\'$%$$# X$## X$"# X"# X*# " [+\'%4"6\xfc" %$"# X"# X'),a('!76+N$!7<+-$7\xa0+#%\'"%$"# X"# X*# " [+)%4"6\xfd""! %$"# X"# X'),a('76*) "7T*# "7H'),a('!7\xa2+_$ \\!7B+-$7\xa3+#%\'"%$"# X"# X,8&!7B+-$7\xa3+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('!/\xfe""1&3\xff*G "/\u0100""1\'3\u0101*; "/\u0102""1$3\u0103*/ "/\u0104""1%3\u0105*# "76+& 4!6\u0106! %'),a('7\xa4*# "7\x9f'),a('!/\u0107""1(3\u0108+O$7<+E%/\u0109""1(3\u010a*/ "/\u010b""1(3\u010c*# "76+#%\'#%$## X$"# X"# X'),a('!76+_$ \\!7A+-$76+#%\'"%$"# X"# X,8&!7A+-$76+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('! \\7!+&$,#&7!""" X+\' 4!6\u010d!! %'),a("!7\xa8+& 4!6\u010e! %"),a('!7\xa9+s$7;+i%7\xae+_% \\!7B+-$7\xaf+#%\'"%$"# X"# X,8&!7B+-$7\xaf+#%\'"%$"# X"# X"+#%\'$%$$# X$## X$"# X"# X'),a('7\xaa*# "7\xab'),a('/\u010f""1$3\u0110*S "/\u0111""1%3\u0112*G "/\u0113""1%3\u0114*; "/\u0115""1%3\u0116*/ "/\u0117""1+3\u0118*# "7\xac'),a('/\u0119""1\'3\u011a*/ "/\u011b""1)3\u011c*# "7\xac'),a('76*# "7\xad'),a('!/\u011d""1"3\u011e+-$76+#%\'"%$"# X"# X'),a('7\xac*# "76'),a('!76+7$7<+-%7\xb0+#%\'#%$## X$"# X"# X'),a('76*# "7H'),a('!7\xb2+7$7.+-%7\x8f+#%\'#%$## X$"# X"# X'),a('! \\7!+&$,#&7!""" X+\' 4!6\u011f!! %'),a("!7\x9d+' 4!6\u0120!! %"),a('!7\xb5+d$ \\!7B+-$7\x9f+#%\'"%$"# X"# X,8&!7B+-$7\x9f+#%\'"%$"# X"# X"+(%4"6\u0121"!!%$"# X"# X'),a('!!77+k$ \\!.J""2J3K+-$77+#%\'"%$"# X"# X,>&!.J""2J3K+-$77+#%\'"%$"# X"# X"+#%\'"%$"# X"# X+! (%'),a('!7L*# "7\x98+c$ \\!7B+-$7\xb7+#%\'"%$"# X"# X,8&!7B+-$7\xb7+#%\'"%$"# X"# X"+\'%4"6\u0122" %$"# X"# X'),a('7\xb8*# "7\x9f'),a('!/\u0123""1#3\u0124+<$7<+2%76+(%4#6\u0125#! %$## X$"# X"# X'),a('! \\7!+&$,#&7!""" X+\' 4!6\u0126!! %'),a("!7\x9d+' 4!6\u0127!! %"),a('! \\7\x99,#&7\x99"+\x81$7@+w%7M+m%7?+c% \\!7B+-$7\x9f+#%\'"%$"# X"# X,8&!7B+-$7\x9f+#%\'"%$"# X"# X"+\'%4%6\u0128% %$%# X$$# X$## X$"# X"# X'),a("7\xbd"),a('!/\u0129""1&3\u012a+s$7.+i%7\xc0+_% \\!7A+-$7\xc0+#%\'"%$"# X"# X,8&!7A+-$7\xc0+#%\'"%$"# X"# X"+#%\'$%$$# X$## X$"# X"# X*# "7\xbe'),a('!76+s$7.+i%7\xbf+_% \\!7A+-$7\xbf+#%\'"%$"# X"# X,8&!7A+-$7\xbf+#%\'"%$"# X"# X"+#%\'$%$$# X$## X$"# X"# X'),a('!76+=$7<+3%76*# "7H+#%\'#%$## X$"# X"# X'),a('7\xc1*G "7\xc3*A "7\xc5*; "7\xc7*5 "7\xc8*/ "7\xc9*) "7\xca*# "7\xbf'),a('!/\u012b""1%3\u012c+7$7<+-%7\xc2+#%\'#%$## X$"# X"# X'),a("!7I+' 4!6\u012d!! %"),a('!/\u012e""1&3\u012f+\xa5$7<+\x9b%7D+\x91%7\xc4+\x87% \\! \\7\'+&$,#&7\'""" X+-$7\xc4+#%\'"%$"# X"# X,G&! \\7\'+&$,#&7\'""" X+-$7\xc4+#%\'"%$"# X"# X"+-%7E+#%\'&%$&# X$%# X$$# X$## X$"# X"# X'),a('7t*# "7w'),a('!/\u0130""1%3\u0131+7$7<+-%7\xc6+#%\'#%$## X$"# X"# X'),a("!7I+' 4!6\u0132!! %"),a('!/\u0133""1&3\u0134+<$7<+2%7I+(%4#6\u0135#! %$## X$"# X"# X'),a('!/\u0136""1%3\u0137+_$7<+U%!/\u0138""1$3\u0139+& 4!6\u013a! %*4 "!/\u013b""1%3\u013c+& 4!6\u013d! %+#%\'#%$## X$"# X"# X'),a('!/\u013e""1)3\u013f+T$7<+J%/\u0140""1#3\u0141*/ "/\u0142""1(3\u0143*# "76+(%4#6\u0144#! %$## X$"# X"# X'),a('!/\u0145""1#3\u0146+\x9e$7<+\x94%7D+\x8a%!7\xcb+k$ \\!.D""2D3E+-$7\xcb+#%\'"%$"# X"# X,>&!.D""2D3E+-$7\xcb+#%\'"%$"# X"# X"+#%\'"%$"# X"# X+-%7E+#%\'%%$%# X$$# X$## X$"# X"# X'),a('!/\u0147""1(3\u0148*/ "/\u0149""1$3\u014a*# "76+\' 4!6\u014b!! %'),a('!76+_$ \\!7A+-$76+#%\'"%$"# X"# X,8&!7A+-$76+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('!7\xce+K$7.+A%7\xce+7%7.+-%7\x8f+#%\'%%$%# X$$# X$## X$"# X"# X'),a('! \\7!+&$,#&7!""" X+\' 4!6\u014c!! %'),a('!7\xd0+c$ \\!7A+-$7\xd0+#%\'"%$"# X"# X,8&!7A+-$7\xd0+#%\'"%$"# X"# X"+\'%4"6\u014d" %$"# X"# X'),a('!7\x98+c$ \\!7B+-$7\x9f+#%\'"%$"# X"# X,8&!7B+-$7\x9f+#%\'"%$"# X"# X"+\'%4"6\u014e" %$"# X"# X'),a('!7L*T "7\x98*N "!7@*# " [+=$7t+3%7?*# " [+#%\'#%$## X$"# X"# X+c$ \\!7B+-$7\x9f+#%\'"%$"# X"# X,8&!7B+-$7\x9f+#%\'"%$"# X"# X"+\'%4"6\u014f" %$"# X"# X'),a('!7\xd3+c$ \\!7B+-$7\xd4+#%\'"%$"# X"# X,8&!7B+-$7\xd4+#%\'"%$"# X"# X"+\'%4"6\u0150" %$"# X"# X'),a("!7\x95+& 4!6\u0151! %"),a('!/\u0152""1(3\u0153+<$7<+2%76+(%4#6\u0154#! %$## X$"# X"# X*j "!/\u0155""1&3\u0156+<$7<+2%76+(%4#6\u0157#! %$## X$"# X"# X*: "!/\u0158""1*3\u0159+& 4!6\u015a! %*# "7\x9f'),a('!!76+o$ \\!7A+2$76+(%4"6\u015b"! %$"# X"# X,=&!7A+2$76+(%4"6\u015b"! %$"# X"# X"+)%4"6\u015c""! %$"# X"# X*# " [+\' 4!6\u015d!! %'),a('!7\xd7+_$ \\!7A+-$7\xd7+#%\'"%$"# X"# X,8&!7A+-$7\xd7+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('!7\x98+_$ \\!7B+-$7\x9f+#%\'"%$"# X"# X,8&!7B+-$7\x9f+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('! \\7!+&$,#&7!""" X+\' 4!6\u015e!! %'),a('!7\xda+_$ \\!7B+-$7\xdb+#%\'"%$"# X"# X,8&!7B+-$7\xdb+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('!/\u015f""1&3\u0160*; "/\u0161""1\'3\u0162*/ "/\u0163""1*3\u0164*# "76+& 4!6\u0165! %'),a('!/\u0166""1&3\u0167+<$7<+2%7\xdc+(%4#6\u0168#! %$## X$"# X"# X*\x83 "!/\xf6""1\'3\xf7+<$7<+2%7\x9d+(%4#6\u0169#! %$## X$"# X"# X*S "!/\u016a""1+3\u016b+<$7<+2%7\x9d+(%4#6\u016c#! %$## X$"# X"# X*# "7\x9f'),a('/\u016d""1+3\u016e*k "/\u016f""1)3\u0170*_ "/\u0171""1(3\u0172*S "/\u0173""1\'3\u0174*G "/\u0175""1&3\u0176*; "/\u0177""1*3\u0178*/ "/\u0179""1)3\u017a*# "76'),a('71*# " ['),a('!!76+o$ \\!7A+2$76+(%4"6\u015b"! %$"# X"# X,=&!7A+2$76+(%4"6\u015b"! %$"# X"# X"+)%4"6\u015c""! %$"# X"# X*# " [+\' 4!6\u017b!! %'),a('!7L*# "7\x98+c$ \\!7B+-$7\xe0+#%\'"%$"# X"# X,8&!7B+-$7\xe0+#%\'"%$"# X"# X"+\'%4"6\u017c" %$"# X"# X'),a('7\xb8*# "7\x9f'),a('!7\xe2+_$ \\!7A+-$7\xe2+#%\'"%$"# X"# X,8&!7A+-$7\xe2+#%\'"%$"# X"# X"+#%\'"%$"# X"# X'),a('!7\xe9+s$7.+i%7\xec+_% \\!7B+-$7\xe3+#%\'"%$"# X"# X,8&!7B+-$7\xe3+#%\'"%$"# X"# X"+#%\'$%$$# X$## X$"# X"# X'),a('7\xe4*; "7\xe5*5 "7\xe6*/ "7\xe7*) "7\xe8*# "7\x9f'),a('!/\u017d""1#3\u017e+<$7<+2%7\xef+(%4#6\u017f#! %$## X$"# X"# X'),a('!/\u0180""1%3\u0181+<$7<+2%7T+(%4#6\u0182#! %$## X$"# X"# X'),a('!/\u0183""1(3\u0184+B$7<+8%7\\*# "7Y+(%4#6\u0185#! %$## X$"# X"# X'),a('!/\u0186""1&3\u0187+<$7<+2%76+(%4#6\u0188#! %$## X$"# X"# X'),a('!/\u0189""1%3\u018a+T$!7<+5$ \\7!,#&7!"+#%\'"%$"# X"# X*# " [+\'%4"6\u018b" %$"# X"# X'),a('!7\xea+K$7;+A%76+7%7;+-%7\xeb+#%\'%%$%# X$$# X$## X$"# X"# X'),a('!/\x95""1#3\xd6*# "76+\' 4!6\u018c!! %'),a('!/\xb4""1#3\u018d*G "/\xb6""1#3\u018e*; "/\xba""1#3\u018f*/ "/\xb8""1$3\u0190*# "76+\' 4!6\u0191!! %'),a('!7\xed+H$!7C+-$7\xee+#%\'"%$"# X"# X*# " [+#%\'"%$"# X"# X'),a('!7U*) "7\\*# "7X+& 4!6\u0192! %'),a('!!7!*# " [+c$7!*# " [+S%7!*# " [+C%7!*# " [+3%7!*# " [+#%\'%%$%# X$$# X$## X$"# X"# X+\' 4!6\u0193!! %'),a('!!7!+C$7!*# " [+3%7!*# " [+#%\'#%$## X$"# X"# X+\' 4!6\u0194!! %'),a("7\xbd"),a('!7\x9d+d$ \\!7B+-$7\xf2+#%\'"%$"# X"# X,8&!7B+-$7\xf2+#%\'"%$"# X"# X"+(%4"6\u0195"!!%$"# X"# X'),a('7\xf3*# "7\x9f'),a('!.\u0196""2\u01963\u0197+N$7<+D%.\u0198""2\u01983\u0199*) ".\u019a""2\u019a3\u019b+(%4#6\u019c#! %$## X$"# X"# X'),a('!7\x9d+d$ \\!7B+-$7\x9f+#%\'"%$"# X"# X,8&!7B+-$7\x9f+#%\'"%$"# X"# X"+(%4"6\u019d"!!%$"# X"# X'),a('!76+7$70+-%7\xf6+#%\'#%$## X$"# X"# X'),a(' \\72*) "74*# "7.,/&72*) "74*# "7."'),a(' \\7%,#&7%"'),a('!7\xf9+=$.8""2839+-%7\xfa+#%\'#%$## X$"# X"# X'),a('!/\u019e""1%3\u019f*) "/\u01a0""1$3\u01a1+\' 4!6\u01a2!! %'),a('!7\xfb+N$!.8""2839+-$7^+#%\'"%$"# X"# X*# " [+#%\'"%$"# X"# X'),a('!7\\*) "7X*# "7\x82+\' 4!6\u01a3!! %'),a('! \\7\xfd*) "7-*# "7\xfe,/&7\xfd*) "7-*# "7\xfe"+! (%'),a('7"*S "7!*M ".F""2F3G*A ".J""2J3K*5 ".H""2H3I*) ".N""2N3O'),a('.L""2L3M*\x95 ".B""2B3C*\x89 ".<""2<3=*} ".R""2R3S*q ".T""2T3U*e ".V""2V3W*Y ".P""2P3Q*M ".@""2@3A*A ".D""2D3E*5 ".2""2233*) ".>""2>3?'),a('!7\u0100+h$.8""2839+X%7\xfa+N%!.\u01a4""2\u01a43\u01a5+-$7\xeb+#%\'"%$"# X"# X*# " [+#%\'$%$$# X$## X$"# X"# X'),a('!/\u01a6""1%3\u01a7*) "/\u01a8""1$3\u01a9+\' 4!6\u01a2!! %'),a('!7\xeb+Q$/\xb4""1#3\xb5*7 "/\xb6""1#3\xb7*+ " \\7+,#&7+"+\'%4"6\u01aa" %$"# X"# X'),a('!7\u0104+\x8f$.F""2F3G+%7\u0103+u%.F""2F3G+e%7\u0103+[%.F""2F3G+K%7\u0103+A%.F""2F3G+1%7\u0105+\'%4)6\u01ab) %$)# X$(# X$\'# X$&# X$%# X$$# X$## X$"# X"# X'),a('!7#+A$7#+7%7#+-%7#+#%\'$%$$# X$## X$"# X"# X'),a('!7\u0103+-$7\u0103+#%\'"%$"# X"# X'),a('!7\u0103+7$7\u0103+-%7\u0103+#%\'#%$## X$"# X"# X')],v=0,_=0,T=0,E={
line:1,column:1,seenCR:!1},y=0,S=[],C=0;if("startRule"in h){if(!(h.startRule in p))throw new Error("Can't start parsing from rule \""+h.startRule+'".');f=p[h.startRule]}if(h.data={},l=c(f),l!==d&&v===e.length)return l;throw l!==d&&v<e.length&&s({type:"end",description:"end of input"}),o(null,S,y)}return e(t,Error),{SyntaxError:t,parse:i}}()},{}],77:[function(e,t,i){"use strict";t.exports=function(e){e=e;var t={AllBrowsers:{maskDtls:function(e){return e&&(e=e.replace(/ UDP\/TLS\/RTP\/SAVP/gim," RTP/SAVP")),e},unmaskDtls:function(e){return e.replace(/ RTP\/SAVP/gim," UDP/TLS/RTP/SAVP")}},Firefox:{isFirefox:function(){return"undefined"!=typeof mozRTCPeerConnection},cannotHandleExtraWhitespace:function(e){return this.isFirefox()&&e&&(e=e.replace(/ \r\n/g,"\r\n")),e},hasMissingCLineInSDP:function(e){var t,i;if(e.indexOf("c=")>e.indexOf("m=")){i=e.match(/m=.*\r\n.*/g);for(var n=0;n<i.length;n++)i[n].toString().search(/i=.*/)>=0?(t=e.indexOf(i[n].toString())+i[n].toString().length,"c="!==e.substr(t,2)&&(e=e.substr(0,t)+"\r\nc=IN IP4 0.0.0.0"+e.substr(t))):i[n].toString().search(/c=.*/)<0&&(t=e.indexOf(i[n].toString().match(/.*/))+i[n].toString().match(/.*/).toString().length,e=e.substr(0,t)+"\r\nc=IN IP4 0.0.0.0"+e.substr(t))}return e}},Chrome:{needsExplicitlyInactiveSDP:function(e){var i,n;return t.Firefox.isFirefox()&&(n=e.indexOf("m=video 0"),-1!==n)?(i=e.substr(n),i=i.replace(/\r\nc=IN IP4.*\r\n$/,"\r\nc=IN IP4 0.0.0.0\r\na=inactive\r\n"),e.substr(0,n)+i):e},getsConfusedAboutGUM:function(e){e.mediaHandler&&e.mediaHandler.close()}}};return t}},{}],78:[function(e,t,i){"use strict";var n={error:0,warn:1,log:2,debug:3};t.exports=function(e){function t(e,t,i){this.logger=e,this.category=t,this.label=i}var i=function(){var e,t=2,i=!0,r=null;this.loggers={},e=this.getLogger("sip.loggerfactory"),Object.defineProperties(this,{builtinEnabled:{get:function(){return i},set:function(t){"boolean"==typeof t?i=t:e.error('invalid "builtinEnabled" parameter value: '+JSON.stringify(t))}},level:{get:function(){return t},set:function(i){i>=0&&3>=i?t=i:i>3?t=3:n.hasOwnProperty(i)?t=n[i]:e.error('invalid "level" parameter value: '+JSON.stringify(i))}},connector:{get:function(){return r},set:function(t){null===t||""===t||void 0===t?r=null:"function"==typeof t?r=t:e.error('invalid "connector" parameter value: '+JSON.stringify(t))}}})};return i.prototype.print=function(t,i,n,r){if("string"==typeof r){var s=[new Date,i];n&&s.push(n),r=s.concat(r).join(" | ")}t.call(e,r)},Object.keys(n).forEach(function(r){t.prototype[r]=function(e){this.logger[r](this.category,this.label,e)},i.prototype[r]=function(t,i,s){this.level>=n[r]&&(this.builtinEnabled&&this.print(e[r],t,i,s),this.connector&&this.connector(r,t,i,s))}}),i.prototype.getLogger=function(e,i){var n;return i&&3===this.level?new t(this,e,i):this.loggers[e]?this.loggers[e]:(n=new t(this,e),this.loggers[e]=n,n)},i}},{}],79:[function(e,t,i){"use strict";t.exports=function(e){var t=function(e,t){e=e,t=t};return t.prototype=Object.create(e.prototype,{isReady:{value:function(){}},close:{value:function(){}},getDescription:{value:function(e){e=e}},hasDescription:{value:function(e){e=e}},setDescription:{value:function(e){e=e}}}),t}},{}],80:[function(e,t,i){"use strict";t.exports=function(e){var t;t=function(t,i,n){var r;if(!(t&&t instanceof e.URI))throw new TypeError('missing or invalid "uri" parameter');this.uri=t,this.parameters={};for(r in n)this.setParam(r,n[r]);Object.defineProperties(this,{friendlyName:{get:function(){return this.displayName||t.aor}},displayName:{get:function(){return i},set:function(e){i=0===e?"0":e}}})},t.prototype={setParam:function(e,t){e&&(this.parameters[e.toLowerCase()]="undefined"==typeof t||null===t?null:t.toString())},getParam:e.URI.prototype.getParam,hasParam:e.URI.prototype.hasParam,deleteParam:e.URI.prototype.deleteParam,clearParams:e.URI.prototype.clearParams,clone:function(){return new t(this.uri.clone(),this.displayName,JSON.parse(JSON.stringify(this.parameters)))},toString:function(){var e,t;e=this.displayName||0===this.displayName?'"'+this.displayName+'" ':"",e+="<"+this.uri.toString()+">";for(t in this.parameters)e+=";"+t,null!==this.parameters[t]&&(e+="="+this.parameters[t]);return e}},t.parse=function(t){return t=e.Grammar.parse(t,"Name_Addr_Header"),-1!==t?t:void 0},e.NameAddrHeader=t}},{}],81:[function(e,t,i){"use strict";t.exports=function(e){function t(e,t){var i=t,n=0,r=0;if(e.substring(i,i+2).match(/(^\r\n)/))return-2;for(;0===n;){if(r=e.indexOf("\r\n",i),-1===r)return r;!e.substring(r+2,r+4).match(/(^\r\n)/)&&e.charAt(r+2).match(/(^\s+)/)?i=r+2:n=r}return n}function i(t,i,n,r){var s,o,a,c,u=i.indexOf(":",n),l=i.substring(n,u).trim(),h=i.substring(u+1,r).trim();switch(l.toLowerCase()){case"via":case"v":t.addHeader("via",h),1===t.getHeaders("via").length?(c=t.parseHeader("Via"),c&&(t.via=c,t.via_branch=c.branch)):c=0;break;case"from":case"f":t.setHeader("from",h),c=t.parseHeader("from"),c&&(t.from=c,t.from_tag=c.getParam("tag"));break;case"to":case"t":t.setHeader("to",h),c=t.parseHeader("to"),c&&(t.to=c,t.to_tag=c.getParam("tag"));break;case"record-route":if(c=e.Grammar.parse(h,"Record_Route"),-1===c){c=void 0;break}for(a=c.length,o=0;a>o;o++)s=c[o],t.addHeader("record-route",h.substring(s.position,s.offset)),t.headers["Record-Route"][t.getHeaders("record-route").length-1].parsed=s.parsed;break;case"call-id":case"i":t.setHeader("call-id",h),c=t.parseHeader("call-id"),c&&(t.call_id=h);break;case"contact":case"m":if(c=e.Grammar.parse(h,"Contact"),-1===c){c=void 0;break}for(a=c.length,o=0;a>o;o++)s=c[o],t.addHeader("contact",h.substring(s.position,s.offset)),t.headers.Contact[t.getHeaders("contact").length-1].parsed=s.parsed;break;case"content-length":case"l":t.setHeader("content-length",h),c=t.parseHeader("content-length");break;case"content-type":case"c":t.setHeader("content-type",h),c=t.parseHeader("content-type");break;case"cseq":t.setHeader("cseq",h),c=t.parseHeader("cseq"),c&&(t.cseq=c.value),t instanceof e.IncomingResponse&&(t.method=c.method);break;case"max-forwards":t.setHeader("max-forwards",h),c=t.parseHeader("max-forwards");break;case"www-authenticate":t.setHeader("www-authenticate",h),c=t.parseHeader("www-authenticate");break;case"proxy-authenticate":t.setHeader("proxy-authenticate",h),c=t.parseHeader("proxy-authenticate");break;case"refer-to":case"r":t.setHeader("refer-to",h),c=t.parseHeader("refer-to"),c&&(t.refer_to=c);break;default:t.setHeader(l,h),c=0}return void 0===c?{error:'error parsing header "'+l+'"'}:!0}var n;n={},n.parseMessage=function(n,r){var s,o,a,c,u,l=0,h=n.indexOf("\r\n"),d=r.getLogger("sip.parser");if(-1===h)return void d.warn("no CRLF found, not a SIP message, discarded");if(o=n.substring(0,h),u=e.Grammar.parse(o,"Request_Response"),-1===u)return void d.warn('error parsing first line of SIP message: "'+o+'"');for(u.status_code?(s=new e.IncomingResponse(r),s.status_code=u.status_code,s.reason_phrase=u.reason_phrase):(s=new e.IncomingRequest(r),s.method=u.method,s.ruri=u.uri),s.data=n,l=h+2;;){if(h=t(n,l),-2===h){c=l+2;break}if(-1===h)return void d.error("malformed message");if(u=i(s,n,l,h),u!==!0)return void d.error(u.error);l=h+2}return s.hasHeader("content-length")?(a=s.getHeader("content-length"),s.body=n.substr(c,a)):s.body=n.substring(c),s},e.Parser=n}},{}],82:[function(e,t,i){var n=90;t.exports=function(e){function t(e){var t=e.parseHeader("Supported")||[],i=e.parseHeader("Session-Expires")||{};return t.indexOf("timer")>=0&&i.deltaSeconds<n}function i(t,i,n,r){t.sessionTimerState=t.sessionTimerState||{},e.clearTimeout(t.sessionTimerState.timeout);var s="string"==typeof i;s&&(i=n(i,r));var o=i.parseHeader("Session-Expires");if(!o)return void(t.sessionTimerState=null);var a=o.deltaSeconds,c=s===("uas"===o.refresher);t.sessionTimerState={interval:a,isRefresher:c};var u=1e3*a,l=this;if(c)t.sessionTimerState.timeout=e.setInterval(function(){var i=t.owner.ua.dialogs[t.id.toString()]||!1;i?t.sendRequest(l,"UPDATE",{extraHeaders:["Session-Expires: "+a]}):e.clearInterval(t.sessionTimerState.timeout)},u/2);else{var h=Math.min(32e3,u/3);t.sessionTimerState.timeout=e.setTimeout(function(){},u-h)}}function r(e){}function s(e){}return{localMinSE:n,hasSmallMinSE:t,updateState:i,receiveResponse:r,onDialogError:s}}},{}],83:[function(e,t,i){"use strict";t.exports=function(e){var t;t=function(t){var i={},n=1;this.registrar=t.configuration.registrarServer,this.expires=t.configuration.registerExpires,this.contact=t.contact.toString(),n&&(this.contact+=";reg-id="+n,this.contact+=';+sip.instance="<urn:uuid:'+t.configuration.instanceId+'>"'),this.call_id=e.Utils.createRandomToken(22),this.cseq=80,this.to_uri=t.configuration.uri,i.to_uri=this.to_uri,i.to_displayName=t.configuration.displayName,i.call_id=this.call_id,i.cseq=this.cseq,e.Utils.augment(this,e.ClientContext,[t,"REGISTER",this.registrar,{params:i}]),this.registrationTimer=null,this.registrationExpiredTimer=null,this.registered=!1,this.logger=t.getLogger("sip.registercontext")},t.prototype={register:function(t){var i,n=this;this.options=t||{},i=(this.options.extraHeaders||[]).slice(),i.push("Contact: "+this.contact+";expires="+this.expires),i.push("Allow: "+e.UA.C.ALLOWED_METHODS.toString()),this.closeHeaders=this.options.closeWithHeaders?(this.options.extraHeaders||[]).slice():[],this.receiveResponse=function(t){var i,r,s,o=t.getHeaders("contact").length;if(t.cseq===this.cseq)switch(null!==this.registrationTimer&&(e.Timers.clearTimeout(this.registrationTimer),this.registrationTimer=null),!0){case/^1[0-9]{2}$/.test(t.status_code):this.emit("progress",t);break;case/^2[0-9]{2}$/.test(t.status_code):if(this.emit("accepted",t),t.hasHeader("expires")&&(r=t.getHeader("expires")),null!==this.registrationExpiredTimer&&(e.Timers.clearTimeout(this.registrationExpiredTimer),this.registrationExpiredTimer=null),!o){this.logger.warn("no Contact header in response to REGISTER, response ignored");break}for(;o--;){if(i=t.parseHeader("contact",o),i.uri.user===this.ua.contact.uri.user){r=i.getParam("expires");break}i=null}if(!i){this.logger.warn("no Contact header pointing to us, response ignored");break}r||(r=this.expires),this.registrationTimer=e.Timers.setTimeout(function(){n.registrationTimer=null,n.register(n.options)},1e3*r-3e3),this.registrationExpiredTimer=e.Timers.setTimeout(function(){n.logger.warn("registration expired"),n.registered&&n.unregistered(null,e.C.causes.EXPIRES)},1e3*r),i.hasParam("temp-gruu")&&(this.ua.contact.temp_gruu=e.URI.parse(i.getParam("temp-gruu").replace(/"/g,""))),i.hasParam("pub-gruu")&&(this.ua.contact.pub_gruu=e.URI.parse(i.getParam("pub-gruu").replace(/"/g,""))),this.registered=!0,this.emit("registered",t||null);break;case/^423$/.test(t.status_code):t.hasHeader("min-expires")?(this.expires=t.getHeader("min-expires"),this.register(this.options)):(this.logger.warn("423 response received for REGISTER without Min-Expires"),this.registrationFailure(t,e.C.causes.SIP_FAILURE_CODE));break;default:s=e.Utils.sipErrorCause(t.status_code),this.registrationFailure(t,s)}},this.onRequestTimeout=function(){this.registrationFailure(null,e.C.causes.REQUEST_TIMEOUT)},this.onTransportError=function(){this.registrationFailure(null,e.C.causes.CONNECTION_ERROR)},this.cseq++,this.request.cseq=this.cseq,this.request.setHeader("cseq",this.cseq+" REGISTER"),this.request.extraHeaders=i,this.send()},registrationFailure:function(e,t){this.emit("failed",e||null,t||null)},onTransportClosed:function(){this.registered_before=this.registered,null!==this.registrationTimer&&(e.Timers.clearTimeout(this.registrationTimer),this.registrationTimer=null),null!==this.registrationExpiredTimer&&(e.Timers.clearTimeout(this.registrationExpiredTimer),this.registrationExpiredTimer=null),this.registered&&this.unregistered(null,e.C.causes.CONNECTION_ERROR)},onTransportConnected:function(){this.register(this.options)},close:function(){var e={all:!1,extraHeaders:this.closeHeaders};this.registered_before=this.registered,this.unregister(e)},unregister:function(t){var i;return t=t||{},this.registered||t.all?(i=(t.extraHeaders||[]).slice(),this.registered=!1,null!==this.registrationTimer&&(e.Timers.clearTimeout(this.registrationTimer),this.registrationTimer=null),t.all?(i.push("Contact: *"),i.push("Expires: 0")):i.push("Contact: "+this.contact+";expires=0"),this.receiveResponse=function(t){var i;switch(!0){case/^1[0-9]{2}$/.test(t.status_code):this.emit("progress",t);break;case/^2[0-9]{2}$/.test(t.status_code):this.emit("accepted",t),null!==this.registrationExpiredTimer&&(e.Timers.clearTimeout(this.registrationExpiredTimer),this.registrationExpiredTimer=null),this.unregistered(t);break;default:i=e.Utils.sipErrorCause(t.status_code),this.unregistered(t,i)}},this.onRequestTimeout=function(){},this.onTransportError=function(){},this.cseq++,this.request.cseq=this.cseq,this.request.setHeader("cseq",this.cseq+" REGISTER"),this.request.extraHeaders=i,void this.send()):void this.logger.warn("already unregistered")},unregistered:function(e,t){this.registered=!1,this.emit("unregistered",e||null,t||null)}},e.RegisterContext=t}},{}],84:[function(e,t,i){"use strict";t.exports=function(e){var t;t=function(t,i){this.logger=i.getLogger("sip.requestsender"),this.ua=i,this.applicant=t,this.method=t.request.method,this.request=t.request,this.credentials=null,this.challenged=!1,this.staled=!1,i.status!==e.UA.C.STATUS_USER_CLOSED||this.method===e.C.BYE&&this.method===e.C.ACK||this.onTransportError()},t.prototype={send:function(){switch(this.method){case"INVITE":this.clientTransaction=new e.Transactions.InviteClientTransaction(this,this.request,this.ua.transport);break;case"ACK":this.clientTransaction=new e.Transactions.AckClientTransaction(this,this.request,this.ua.transport);break;default:this.clientTransaction=new e.Transactions.NonInviteClientTransaction(this,this.request,this.ua.transport)}return this.clientTransaction.send(),this.clientTransaction},onRequestTimeout:function(){this.applicant.onRequestTimeout()},onTransportError:function(){this.applicant.onTransportError()},receiveResponse:function(t){var i,n,r,s=t.status_code;if(401===s||407===s){if(401===t.status_code?(n=t.parseHeader("www-authenticate"),r="authorization"):(n=t.parseHeader("proxy-authenticate"),r="proxy-authorization"),!n)return this.logger.warn(t.status_code+" with wrong or missing challenge, cannot authenticate"),void this.applicant.receiveResponse(t);if(!this.challenged||!this.staled&&n.stale===!0){if(this.credentials||(this.credentials=this.ua.configuration.authenticationFactory(this.ua)),!this.credentials.authenticate(this.request,n))return void this.applicant.receiveResponse(t);this.challenged=!0,n.stale&&(this.staled=!0),t.method===e.C.REGISTER?i=this.applicant.cseq+=1:this.request.dialog?i=this.request.dialog.local_seqnum+=1:(i=this.request.cseq+1,this.request.cseq=i),this.request.setHeader("cseq",i+" "+this.method),this.request.setHeader(r,this.credentials.toString()),this.send()}else this.applicant.receiveResponse(t)}else this.applicant.receiveResponse(t)}},e.RequestSender=t}},{}],85:[function(e,t,i){"use strict";t.exports=function(t){var i=e("../package.json"),n=Object.defineProperties({},{version:{get:function(){return i.version}},name:{get:function(){return i.title}}});return e("./Utils")(n,t),n.LoggerFactory=e("./LoggerFactory")(t.console),n.EventEmitter=e("./EventEmitter")(t.console),n.C=e("./Constants")(n.name,n.version),n.Exceptions=e("./Exceptions"),n.Timers=e("./Timers")(t.timers),n.Transport=t.Transport(n,t.WebSocket),e("./Parser")(n),e("./SIPMessage")(n),e("./URI")(n),e("./NameAddrHeader")(n),e("./Transactions")(n),e("./Dialogs")(n),e("./RequestSender")(n),e("./RegisterContext")(n),n.MediaHandler=e("./MediaHandler")(n.EventEmitter),e("./ClientContext")(n),e("./ServerContext")(n),e("./Session")(n,t),e("./Subscription")(n),n.WebRTC=e("./WebRTC")(n,t),e("./UA")(n,t),n.Hacks=e("./Hacks")(n),e("./SanityCheck")(n),n.DigestAuthentication=e("./DigestAuthentication")(n.Utils),n.Grammar=e("./Grammar")(n),n}},{"../package.json":67,"./ClientContext":68,"./Constants":69,"./Dialogs":71,"./DigestAuthentication":72,"./EventEmitter":73,"./Exceptions":74,"./Grammar":75,"./Hacks":77,"./LoggerFactory":78,"./MediaHandler":79,"./NameAddrHeader":80,"./Parser":81,"./RegisterContext":83,"./RequestSender":84,"./SIPMessage":86,"./SanityCheck":87,"./ServerContext":88,"./Session":89,"./Subscription":91,"./Timers":92,"./Transactions":93,"./UA":95,"./URI":96,"./Utils":97,"./WebRTC":98}],86:[function(e,t,i){"use strict";t.exports=function(e){function t(t){var i=t.ua.configuration.hackAllowUnregisteredOptionTags,n=[],r={};return t.method===e.C.REGISTER?n.push("path","gruu"):t.method===e.C.INVITE&&(t.ua.contact.pub_gruu||t.ua.contact.temp_gruu)&&n.push("gruu"),t.ua.configuration.rel100===e.C.supported.SUPPORTED&&n.push("100rel"),t.ua.configuration.replaces===e.C.supported.SUPPORTED&&n.push("replaces"),n.push("outbound"),n=n.concat(t.ua.configuration.extraSupported),n=n.filter(function(t){var n=e.C.OPTION_TAGS[t],s=!r[t];return r[t]=!0,(n||i)&&s}),"Supported: "+n.join(", ")+"\r\n"}var i,n,r,s;i=function(t,i,n,r,s,o){var a,c,u,l,h,d;return r=r||{},t&&i&&n?(this.logger=n.getLogger("sip.sipmessage"),this.ua=n,this.headers={},this.method=t,this.ruri=i,this.body=o,this.extraHeaders=(s||[]).slice(),this.statusCode=r.status_code,this.reasonPhrase=r.reason_phrase,r.route_set?this.setHeader("route",r.route_set):n.configuration.usePreloadedRoute&&this.setHeader("route",n.transport.server.sip_uri),this.setHeader("via",""),this.setHeader("max-forwards",e.UA.C.MAX_FORWARDS),h=r.to_uri||i,a=r.to_displayName||0===r.to_displayName?'"'+r.to_displayName+'" ':"",a+="<"+(h&&h.toRaw?h.toRaw():h)+">",a+=r.to_tag?";tag="+r.to_tag:"",this.to=new e.NameAddrHeader.parse(a),this.setHeader("to",a),d=r.from_uri||n.configuration.uri,c=r.from_displayName||0===r.from_displayName?'"'+r.from_displayName+'" ':n.configuration.displayName?'"'+n.configuration.displayName+'" ':"",c+="<"+(d&&d.toRaw?d.toRaw():d)+">;tag=",c+=r.from_tag||e.Utils.newTag(),this.from=new e.NameAddrHeader.parse(c),this.setHeader("from",c),u=r.call_id||n.configuration.sipjsId+e.Utils.createRandomToken(15),this.call_id=u,this.setHeader("call-id",u),l=r.cseq||Math.floor(1e4*Math.random()),this.cseq=l,void this.setHeader("cseq",l+" "+t)):null},i.prototype={setHeader:function(t,i){this.headers[e.Utils.headerize(t)]=i instanceof Array?i:[i]},getHeader:function(t){var i,n,r=this.extraHeaders.length,s=this.headers[e.Utils.headerize(t)];if(s){if(s[0])return s[0]}else for(i=new RegExp("^\\s*"+t+"\\s*:","i"),n=0;r>n;n++)if(s=this.extraHeaders[n],i.test(s))return s.substring(s.indexOf(":")+1).trim()},getHeaders:function(t){var i,n,r,s=this.headers[e.Utils.headerize(t)],o=[];if(s){for(n=s.length,i=0;n>i;i++)o.push(s[i]);return o}for(n=this.extraHeaders.length,r=new RegExp("^\\s*"+t+"\\s*:","i"),i=0;n>i;i++)s=this.extraHeaders[i],r.test(s)&&o.push(s.substring(s.indexOf(":")+1).trim());return o},hasHeader:function(t){var i,n,r=this.extraHeaders.length;if(this.headers[e.Utils.headerize(t)])return!0;for(i=new RegExp("^\\s*"+t+"\\s*:","i"),n=0;r>n;n++)if(i.test(this.extraHeaders[n]))return!0;return!1},toString:function(){var i,n,r,s="";s+=this.method+" "+(this.ruri.toRaw?this.ruri.toRaw():this.ruri)+" SIP/2.0\r\n";for(i in this.headers)for(n=this.headers[i].length,r=0;n>r;r++)s+=i+": "+this.headers[i][r]+"\r\n";for(n=this.extraHeaders.length,r=0;n>r;r++)s+=this.extraHeaders[r].trim()+"\r\n";return s+=t(this),s+="User-Agent: "+this.ua.configuration.userAgentString+"\r\n",this.body?(n=e.Utils.str_utf8_length(this.body),s+="Content-Length: "+n+"\r\n\r\n",s+=this.body):s+="Content-Length: 0\r\n\r\n",s}},n=function(){this.data=null,this.headers=null,this.method=null,this.via=null,this.via_branch=null,this.call_id=null,this.cseq=null,this.from=null,this.from_tag=null,this.to=null,this.to_tag=null,this.body=null},n.prototype={addHeader:function(t,i){var n={raw:i};t=e.Utils.headerize(t),this.headers[t]?this.headers[t].push(n):this.headers[t]=[n]},getHeader:function(t){var i=this.headers[e.Utils.headerize(t)];if(i)return i[0]?i[0].raw:void 0},getHeaders:function(t){var i,n,r=this.headers[e.Utils.headerize(t)],s=[];if(!r)return[];for(n=r.length,i=0;n>i;i++)s.push(r[i].raw);return s},hasHeader:function(t){return!!this.headers[e.Utils.headerize(t)]},parseHeader:function(t,i){var n,r,s;return t=e.Utils.headerize(t),i=i||0,this.headers[t]?i>=this.headers[t].length?void this.logger.log('not so many "'+t+'" headers present'):(n=this.headers[t][i],r=n.raw,n.parsed?n.parsed:(s=e.Grammar.parse(r,t.replace(/-/g,"_")),-1===s?(this.headers[t].splice(i,1),void this.logger.warn('error parsing "'+t+'" header field with value "'+r+'"')):(n.parsed=s,s))):void this.logger.log('header "'+t+'" not present')},s:function(e,t){return this.parseHeader(e,t)},setHeader:function(t,i){var n={raw:i};this.headers[e.Utils.headerize(t)]=[n]},toString:function(){return this.data}},r=function(e){this.logger=e.getLogger("sip.sipmessage"),this.ua=e,this.headers={},this.ruri=null,this.transport=null,this.server_transaction=null},r.prototype=new n,r.prototype.reply=function(i,n,r,s,o,a){var c,u,l,h,d,p=this.getHeader("To"),f=0,g=0;if(d=e.Utils.buildStatusLine(i,n),r=(r||[]).slice(),this.method===e.C.INVITE&&i>100&&200>=i)for(c=this.getHeaders("record-route"),l=c.length,f;l>f;f++)d+="Record-Route: "+c[f]+"\r\n";for(u=this.getHeaders("via"),l=u.length,g;l>g;g++)d+="Via: "+u[g]+"\r\n";for(!this.to_tag&&i>100?p+=";tag="+e.Utils.newTag():this.to_tag&&!this.s("to").hasParam("tag")&&(p+=";tag="+this.to_tag),d+="To: "+p+"\r\n",d+="From: "+this.getHeader("From")+"\r\n",d+="Call-ID: "+this.call_id+"\r\n",d+="CSeq: "+this.cseq+" "+this.method+"\r\n",l=r.length,h=0;l>h;h++)d+=r[h].trim()+"\r\n";return d+=t(this),d+="User-Agent: "+this.ua.configuration.userAgentString+"\r\n",s?(l=e.Utils.str_utf8_length(s),d+="Content-Type: application/sdp\r\n",d+="Content-Length: "+l+"\r\n\r\n",d+=s):d+="Content-Length: 0\r\n\r\n",this.server_transaction.receiveResponse(i,d).then(o,a),d},r.prototype.reply_sl=function(t,i){var n,r,s=0,o=this.getHeaders("via"),a=o.length;for(r=e.Utils.buildStatusLine(t,i),s;a>s;s++)r+="Via: "+o[s]+"\r\n";n=this.getHeader("To"),!this.to_tag&&t>100?n+=";tag="+e.Utils.newTag():this.to_tag&&!this.s("to").hasParam("tag")&&(n+=";tag="+this.to_tag),r+="To: "+n+"\r\n",r+="From: "+this.getHeader("From")+"\r\n",r+="Call-ID: "+this.call_id+"\r\n",r+="CSeq: "+this.cseq+" "+this.method+"\r\n",r+="User-Agent: "+this.ua.configuration.userAgentString+"\r\n",r+="Content-Length: 0\r\n\r\n",this.transport.send(r)},s=function(e){this.logger=e.getLogger("sip.sipmessage"),this.headers={},this.status_code=null,this.reason_phrase=null},s.prototype=new n,e.OutgoingRequest=i,e.IncomingRequest=r,e.IncomingResponse=s}},{}],87:[function(e,t,i){"use strict";t.exports=function(e){function t(t){var i,n=e.Utils.buildStatusLine(t),r=h.getHeaders("via"),s=r.length,o=0;for(o;s>o;o++)n+="Via: "+r[o]+"\r\n";i=h.getHeader("To"),h.to_tag||(i+=";tag="+e.Utils.newTag()),n+="To: "+i+"\r\n",n+="From: "+h.getHeader("From")+"\r\n",n+="Call-ID: "+h.call_id+"\r\n",n+="CSeq: "+h.cseq+" "+h.method+"\r\n",n+="\r\n",p.send(n)}function i(){return h.ruri&&"sip"===h.ruri.scheme?void 0:(t(416),!1)}function n(){return h.to_tag||h.call_id.substr(0,5)!==d.configuration.sipjsId?void 0:(t(482),!1)}function r(){var i=e.Utils.str_utf8_length(h.body),n=h.getHeader("content-length");return n>i?(t(400),!1):void 0}function s(){var i,n,r=h.from_tag,s=h.call_id,o=h.cseq;if(!h.to_tag)if(h.method===e.C.INVITE){if(i=d.transactions.ist[h.via_branch])return;for(n in d.transactions.ist)if(i=d.transactions.ist[n],i.request.from_tag===r&&i.request.call_id===s&&i.request.cseq===o)return t(482),!1}else{if(i=d.transactions.nist[h.via_branch])return;for(n in d.transactions.nist)if(i=d.transactions.nist[n],i.request.from_tag===r&&i.request.call_id===s&&i.request.cseq===o)return t(482),!1}}function o(){return h.getHeaders("via").length>1?(l.warn("More than one Via header field present in the response. Dropping the response"),!1):void 0}function a(){var t=e.Utils.str_utf8_length(h.body),i=h.getHeader("content-length");return i>t?(l.warn("Message body length is lower than the value in Content-Length header field. Dropping the response"),!1):void 0}function c(){for(var e=["from","to","call_id","cseq","via"],t=e.length;t--;)if(!h.hasHeader(e[t]))return l.warn("Missing mandatory header field : "+e[t]+". Dropping the response"),!1}var u,l,h,d,p,f=[],g=[],m=[];f.push(i),f.push(n),f.push(r),f.push(s),g.push(o),g.push(a),m.push(c),u=function(t,i,n){var r,s;for(h=t,d=i,p=n,l=d.getLogger("sip.sanitycheck"),r=m.length;r--;)if(s=m[r](h),s===!1)return!1;if(h instanceof e.IncomingRequest){for(r=f.length;r--;)if(s=f[r](h),s===!1)return!1}else if(h instanceof e.IncomingResponse)for(r=g.length;r--;)if(s=g[r](h),s===!1)return!1;return!0},e.sanityCheck=u}},{}],88:[function(e,t,i){"use strict";t.exports=function(e){var t;t=function(t,i){this.ua=t,this.logger=t.getLogger("sip.servercontext"),this.request=i,i.method===e.C.INVITE?this.transaction=new e.Transactions.InviteServerTransaction(i,t):this.transaction=new e.Transactions.NonInviteServerTransaction(i,t),i.body&&(this.body=i.body),i.hasHeader("Content-Type")&&(this.contentType=i.getHeader("Content-Type")),this.method=i.method,this.data={},this.localIdentity=i.to,this.remoteIdentity=i.from},t.prototype=Object.create(e.EventEmitter.prototype),t.prototype.progress=function(e){return e=Object.create(e||Object.prototype),e.statusCode||(e.statusCode=180),e.minCode=100,e.maxCode=199,e.events=["progress"],this.reply(e)},t.prototype.accept=function(e){return e=Object.create(e||Object.prototype),e.statusCode||(e.statusCode=200),e.minCode=200,e.maxCode=299,e.events=["accepted"],this.reply(e)},t.prototype.reject=function(e){return e=Object.create(e||Object.prototype),e.statusCode||(e.statusCode=480),e.minCode=300,e.maxCode=699,e.events=["rejected","failed"],this.reply(e)},t.prototype.reply=function(t){t=t||{};var i,n=t.statusCode||100,r=t.minCode||100,s=t.maxCode||699,o=e.Utils.getReasonPhrase(n,t.reasonPhrase),a=t.extraHeaders||[],c=t.body,u=t.events||[];if(r>n||n>s)throw new TypeError("Invalid statusCode: "+n);return i=this.request.reply(n,o,a,c),u.forEach(function(e){this.emit(e,i,o)},this),this},t.prototype.onRequestTimeout=function(){this.emit("failed",null,e.C.causes.REQUEST_TIMEOUT)},t.prototype.onTransportError=function(){this.emit("failed",null,e.C.causes.CONNECTION_ERROR)},e.ServerContext=t}},{}],89:[function(e,t,i){"use strict";t.exports=function(t,i){var n,r,s,o=e("./Session/DTMF")(t),a=e("./RFC4028")(t.Timers),c={STATUS_NULL:0,STATUS_INVITE_SENT:1,STATUS_1XX_RECEIVED:2,STATUS_INVITE_RECEIVED:3,STATUS_WAITING_FOR_ANSWER:4,STATUS_ANSWERED:5,STATUS_WAITING_FOR_PRACK:6,STATUS_WAITING_FOR_ACK:7,STATUS_CANCELED:8,STATUS_TERMINATED:9,STATUS_ANSWERED_WAITING_FOR_PRACK:10,STATUS_EARLY_MEDIA:11,STATUS_CONFIRMED:12};n=function(e){this.status=c.STATUS_NULL,this.dialog=null,this.earlyDialogs={},this.mediaHandlerFactory=e||t.WebRTC.MediaHandler.defaultFactory,this.hasOffer=!1,this.hasAnswer=!1,this.timers={ackTimer:null,expiresTimer:null,invite2xxTimer:null,userNoAnswerTimer:null,rel1xxTimer:null,prackTimer:null},this.startTime=null,this.endTime=null,this.tones=null,this.local_hold=!1,this.remote_hold=!1,this.pending_actions={actions:[],length:function(){return this.actions.length},isPending:function(e){var t=0,i=this.actions.length;for(t;i>t;t++)if(this.actions[t].name===e)return!0;return!1},shift:function(){return this.actions.shift()},push:function(e){this.actions.push({name:e})},pop:function(e){var t=0,i=this.actions.length;for(t;i>t;t++)this.actions[t].name===e&&(this.actions.splice(t,1),i--,t--)}},this.early_sdp=null,this.rel100=t.C.supported.UNSUPPORTED},n.prototype={dtmf:function(e,i){var n,r=[],s=this;if(i=i||{},void 0===e)throw new TypeError("Not enough arguments");if(this.status!==c.STATUS_CONFIRMED&&this.status!==c.STATUS_WAITING_FOR_ACK)throw new t.Exceptions.InvalidStateError(this.status);if("string"!=typeof e&&"number"!=typeof e||!e.toString().match(/^[0-9A-D#*,]+$/i))throw new TypeError("Invalid tones: "+e);for(e=e.toString().split("");e.length>0;)r.push(new o(this,e.shift(),i));if(this.tones)return this.tones=this.tones.concat(r),this;var a=function(){var e,r;return s.status!==c.STATUS_TERMINATED&&s.tones&&0!==s.tones.length?(e=s.tones.shift(),","===n?r=2e3:(e.on("failed",function(){s.tones=null}),e.send(i),r=e.duration+e.interToneGap),void t.Timers.setTimeout(a,r)):(s.tones=null,this)};return this.tones=r,a(),this},bye:function(e){e=Object.create(e||Object.prototype);var i=e.statusCode;if(this.status===c.STATUS_TERMINATED)return this.logger.error("Error: Attempted to send BYE in a terminated session."),this;if(this.logger.log("terminating Session"),i&&(200>i||i>=700))throw new TypeError("Invalid statusCode: "+i);return e.receiveResponse=function(){},this.sendRequest(t.C.BYE,e).terminated()},refer:function(e,i){i=i||{};var n=(i.extraHeaders||[]).slice(),r=e instanceof t.InviteServerContext||e instanceof t.InviteClientContext,s=e;if(void 0===e)throw new TypeError("Not enough arguments");if(this.status!==c.STATUS_CONFIRMED)throw new t.Exceptions.InvalidStateError(this.status);if(r)e='"'+e.remoteIdentity.friendlyName+'" <'+e.dialog.remote_target.toString()+"?Replaces="+e.dialog.id.call_id+"%3Bto-tag%3D"+e.dialog.id.remote_tag+"%3Bfrom-tag%3D"+e.dialog.id.local_tag+">";else{try{e=t.Grammar.parse(e,"Refer_To").uri||e}catch(o){this.logger.debug(".refer() cannot parse Refer_To from",e),this.logger.debug("...falling through to normalizeTarget()")}if(e=this.ua.normalizeTarget(e),!e)throw new TypeError("Invalid target: "+s)}return n.push("Contact: "+this.contact),n.push("Allow: "+t.UA.C.ALLOWED_METHODS.toString()),n.push("Refer-To: "+e),this.sendRequest(t.C.REFER,{extraHeaders:n,body:i.body,receiveResponse:function(t){/^2[0-9]{2}$/.test(t.status_code)&&(r||e.scheme&&e.scheme.match("^sips?$"))&&this.terminate()}.bind(this)}),this},followRefer:function(e){return function(e,n){var r=n.parseHeader("refer-to"),s=r.uri;if(!s.scheme.match("^sips?$")){var o=s.toString();return void("function"==typeof i.open?i.open(o):this.logger.warn("referred to non-SIP URI but `open` isn't in the environment: "+o))}var a=[],c=s.getHeader("Replaces");void 0!==c&&a.push("Replaces: "+decodeURIComponent(c)),s.clearHeaders();var u=this.mediaHandler.getReferMedia,l=u?u.call(this.mediaHandler):this.mediaHint;t.Hacks.Chrome.getsConfusedAboutGUM(this);var h=this.ua.invite(s,{media:l,params:{to_displayName:r.friendlyName},extraHeaders:a});e.call(this,n,h),this.terminate()}.bind(this,e)},sendRequest:function(e,i){i=i||{};var n=this,r=new t.OutgoingRequest(e,this.dialog.remote_target,this.ua,{cseq:i.cseq||(this.dialog.local_seqnum+=1),call_id:this.dialog.id.call_id,from_uri:this.dialog.local_uri,from_tag:this.dialog.id.local_tag,to_uri:this.dialog.remote_uri,to_tag:this.dialog.id.remote_tag,route_set:this.dialog.route_set,statusCode:i.statusCode,reasonPhrase:i.reasonPhrase},i.extraHeaders||[],i.body);return new t.RequestSender({request:r,onRequestTimeout:function(){n.onRequestTimeout()},onTransportError:function(){n.onTransportError()},receiveResponse:i.receiveResponse||function(e){n.receiveNonInviteResponse(e)}},this.ua).send(),this.emit(e.toLowerCase(),r),this},close:function(){var e;if(this.status===c.STATUS_TERMINATED)return this;this.logger.log("closing INVITE session "+this.id),this.mediaHandler&&this.mediaHandler.close();for(e in this.timers)t.Timers.clearTimeout(this.timers[e]);this.dialog&&(this.dialog.terminate(),delete this.dialog);for(e in this.earlyDialogs)this.earlyDialogs[e].terminate(),delete this.earlyDialogs[e];return this.status=c.STATUS_TERMINATED,delete this.ua.sessions[this.id],this},createDialog:function(e,i,n){var r,s,o=e["UAS"===i?"to_tag":"from_tag"],a=e["UAS"===i?"from_tag":"to_tag"],c=e.call_id+o+a;if(s=this.earlyDialogs[c],n)return s?!0:(s=new t.Dialog(this,e,i,t.Dialog.C.STATUS_EARLY),s.error?(this.logger.error(s.error),this.failed(e,t.C.causes.INTERNAL_ERROR),
!1):(this.earlyDialogs[c]=s,!0));if(s){s.update(e,i),this.dialog=s,delete this.earlyDialogs[c];for(var u in this.earlyDialogs)this.earlyDialogs[u].terminate(),delete this.earlyDialogs[u];return!0}return r=new t.Dialog(this,e,i),r.error?(this.logger.error(r.error),this.failed(e,t.C.causes.INTERNAL_ERROR),!1):(this.to_tag=e.to_tag,this.dialog=r,!0)},isReadyToReinvite:function(){return this.mediaHandler.isReady()&&!this.dialog.uac_pending_reply&&!this.dialog.uas_pending_reply},mute:function(e){var t=this.mediaHandler.mute(e);t&&this.onmute(t)},unmute:function(e){var t=this.mediaHandler.unmute(e);t&&this.onunmute(t)},hold:function(e){if(this.status!==c.STATUS_WAITING_FOR_ACK&&this.status!==c.STATUS_CONFIRMED)throw new t.Exceptions.InvalidStateError(this.status);return this.mediaHandler.hold(),this.isReadyToReinvite()?void(this.local_hold!==!0&&(this.onhold("local"),this.sendReinvite(e))):void(this.pending_actions.isPending("unhold")?this.pending_actions.pop("unhold"):this.pending_actions.isPending("hold")||this.pending_actions.push("hold"))},unhold:function(e){if(this.status!==c.STATUS_WAITING_FOR_ACK&&this.status!==c.STATUS_CONFIRMED)throw new t.Exceptions.InvalidStateError(this.status);return this.mediaHandler.unhold(),this.isReadyToReinvite()?void(this.local_hold!==!1&&(this.onunhold("local"),this.sendReinvite(e))):void(this.pending_actions.isPending("hold")?this.pending_actions.pop("hold"):this.pending_actions.isPending("unhold")||this.pending_actions.push("unhold"))},isOnHold:function(){return{local:this.local_hold,remote:this.remote_hold}},receiveReinvite:function(e){var i=this;return this.mediaHandler.hasDescription(e)?void this.mediaHandler.setDescription(e).then(this.mediaHandler.getDescription.bind(this.mediaHandler,this.mediaHint)).then(function(n){var r=["Contact: "+i.contact];r=r.concat(t.Utils.getDescriptionHeaders(n)),e.reply(200,null,r,n.body,function(){i.status=c.STATUS_WAITING_FOR_ACK,i.setInvite2xxTimer(e,n),i.setACKTimer(),i.remote_hold&&!i.mediaHandler.remote_hold?i.onunhold("remote"):!i.remote_hold&&i.mediaHandler.remote_hold&&i.onhold("remote")})})["catch"](function(n){var r;n instanceof t.Exceptions.GetDescriptionError?r=500:(i.logger.error(n),r=488),e.reply(r)}):(this.logger.warn("invalid Content-Type"),void e.reply(415))},sendReinvite:function(e){e=e||{};var i,n=this,r=(e.extraHeaders||[]).slice(),s=e.eventHandlers||{};s.succeeded&&(i=s.succeeded),this.reinviteSucceeded=function(){t.Timers.clearTimeout(n.timers.ackTimer),t.Timers.clearTimeout(n.timers.invite2xxTimer),n.status=c.STATUS_CONFIRMED,i&&i.apply(this,arguments)},s.failed?this.reinviteFailed=s.failed:this.reinviteFailed=function(){},r.push("Contact: "+this.contact),r.push("Allow: "+t.UA.C.ALLOWED_METHODS.toString()),this.receiveResponse=this.receiveReinviteResponse,this.mediaHandler.getDescription(n.mediaHint).then(function(e){r=r.concat(t.Utils.getDescriptionHeaders(e)),n.dialog.sendRequest(n,t.C.INVITE,{extraHeaders:r,body:e.body})},function(){n.isReadyToReinvite()&&n.onReadyToReinvite(),n.reinviteFailed()})},receiveRequest:function(e){switch(e.method){case t.C.BYE:e.reply(200),this.status===c.STATUS_CONFIRMED&&(this.emit("bye",e),this.terminated(e,t.C.causes.BYE));break;case t.C.INVITE:this.status===c.STATUS_CONFIRMED&&(this.logger.log("re-INVITE received"),this.receiveReinvite(e));break;case t.C.INFO:if(this.status===c.STATUS_CONFIRMED||this.status===c.STATUS_WAITING_FOR_ACK){if(this.infoHandler)return this.infoHandler(e);var i,n,r,s=e.getHeader("content-type"),a=/^(Signal\s*?=\s*?)([0-9A-D#*]{1})(\s)?.*/,u=/^(Duration\s?=\s?)([0-9]{1,4})(\s)?.*/;s&&(s.match(/^application\/dtmf-relay/i)?(e.body&&(i=e.body.split("\r\n",2),2===i.length&&(a.test(i[0])&&(n=i[0].replace(a,"$2")),u.test(i[1])&&(r=parseInt(i[1].replace(u,"$2"),10)))),new o(this,n,{duration:r}).init_incoming(e)):e.reply(415,null,["Accept: application/dtmf-relay"]))}break;case t.C.REFER:if(this.status===c.STATUS_CONFIRMED){this.logger.log("REFER received");var l,h=this.listeners("refer").length;h?(e.reply(202,"Accepted"),l="SIP/2.0 100 Trying",this.sendRequest(t.C.NOTIFY,{extraHeaders:["Event: refer","Subscription-State: terminated","Content-Type: message/sipfrag"],body:l,receiveResponse:function(){}}),this.emit("refer",e)):e.reply(603,"Declined")}break;case t.C.NOTIFY:e.reply(200,"OK"),this.emit("notify",e)}},receiveReinviteResponse:function(e){var i=this;if(this.status!==c.STATUS_TERMINATED)switch(!0){case/^1[0-9]{2}$/.test(e.status_code):break;case/^2[0-9]{2}$/.test(e.status_code):if(this.status=c.STATUS_CONFIRMED,this.sendRequest(t.C.ACK,{cseq:e.cseq}),!this.mediaHandler.hasDescription(e)){this.reinviteFailed();break}this.mediaHandler.setDescription(e).then(function(){i.reinviteSucceeded()},function(){i.reinviteFailed()});break;default:this.reinviteFailed()}},acceptAndTerminate:function(e,i,n){var r=[];return i&&r.push("Reason: "+t.Utils.getReasonHeaderValue(i,n)),(this.dialog||this.createDialog(e,"UAC"))&&(this.sendRequest(t.C.ACK,{cseq:e.cseq}),this.sendRequest(t.C.BYE,{extraHeaders:r})),this},setInvite2xxTimer:function(e,i){var n=this,r=t.Timers.T1;this.timers.invite2xxTimer=t.Timers.setTimeout(function s(){if(n.status===c.STATUS_WAITING_FOR_ACK){n.logger.log("no ACK received, attempting to retransmit OK");var o=["Contact: "+n.contact];o=o.concat(t.Utils.getDescriptionHeaders(i)),e.reply(200,null,o,i.body),r=Math.min(2*r,t.Timers.T2),n.timers.invite2xxTimer=t.Timers.setTimeout(s,r)}},r)},setACKTimer:function(){var e=this;this.timers.ackTimer=t.Timers.setTimeout(function(){e.status===c.STATUS_WAITING_FOR_ACK&&(e.logger.log("no ACK received for an extended period of time, terminating the call"),t.Timers.clearTimeout(e.timers.invite2xxTimer),e.sendRequest(t.C.BYE),e.terminated(null,t.C.causes.NO_ACK))},t.Timers.TIMER_H)},onReadyToReinvite:function(){var e=this.pending_actions.shift();e&&this[e.name]&&this[e.name]()},onTransportError:function(){this.status!==c.STATUS_CONFIRMED&&this.status!==c.STATUS_TERMINATED&&this.failed(null,t.C.causes.CONNECTION_ERROR)},onRequestTimeout:function(){this.status===c.STATUS_CONFIRMED?this.terminated(null,t.C.causes.REQUEST_TIMEOUT):this.status!==c.STATUS_TERMINATED&&(this.failed(null,t.C.causes.REQUEST_TIMEOUT),this.terminated(null,t.C.causes.REQUEST_TIMEOUT))},onDialogError:function(e){this.status===c.STATUS_CONFIRMED?this.terminated(e,t.C.causes.DIALOG_ERROR):this.status!==c.STATUS_TERMINATED&&(this.failed(e,t.C.causes.DIALOG_ERROR),this.terminated(e,t.C.causes.DIALOG_ERROR))},onhold:function(e){this["local"===e?"local_hold":"remote_hold"]=!0,this.emit("hold",{originator:e})},onunhold:function(e){this["local"===e?"local_hold":"remote_hold"]=!1,this.emit("unhold",{originator:e})},onmute:function(e){this.emit("muted",{audio:e.audio,video:e.video})},onunmute:function(e){this.emit("unmuted",{audio:e.audio,video:e.video})},failed:function(e,t){return this.status===c.STATUS_TERMINATED?this:(this.emit("failed",e||null,t||null),this)},rejected:function(e,t){return this.emit("rejected",e||null,t||null),this},canceled:function(){return this.emit("cancel"),this},accepted:function(e,i){return i=t.Utils.getReasonPhrase(e&&e.status_code,i),this.startTime=new Date,this.replacee&&(this.replacee.emit("replaced",this),this.replacee.terminate()),e&&a.updateState(this.dialog,e,t.Parser.parseMessage,this.ua),this.emit("accepted",e,i),this},terminated:function(e,t){return this.status===c.STATUS_TERMINATED?this:(this.endTime=new Date,this.close(),this.emit("terminated",e||null,t||null),this)},connecting:function(e){return this.emit("connecting",{request:e}),this}},n.desugar=function(e){return i.HTMLMediaElement&&e instanceof i.HTMLMediaElement&&(e={media:{constraints:{audio:!0,video:"VIDEO"===e.tagName},render:{remote:e}}}),e||{}},n.C=c,t.Session=n,r=function(e,i){function n(e,t){i.hasHeader(e)&&i.getHeader(e).toLowerCase().indexOf("100rel")>=0&&(o.rel100=t)}function r(){var e={extraHeaders:["Contact: "+o.contact]};o.rel100!==t.C.supported.REQUIRED&&o.progress(e),o.status=c.STATUS_WAITING_FOR_ANSWER,o.timers.userNoAnswerTimer=t.Timers.setTimeout(function(){i.reply(408),o.failed(i,t.C.causes.NO_ANSWER),o.terminated(i,t.C.causes.NO_ANSWER)},o.ua.configuration.noAnswerTimeout),s&&(o.timers.expiresTimer=t.Timers.setTimeout(function(){o.status===c.STATUS_WAITING_FOR_ANSWER&&(i.reply(487),o.failed(i,t.C.causes.EXPIRES),o.terminated(i,t.C.causes.EXPIRES))},s)),o.emit("invite",i)}var s,o=this,u=i.getHeader("Content-Type"),l=i.parseHeader("Content-Disposition");if(t.Utils.augment(this,t.ServerContext,[e,i]),t.Utils.augment(this,t.Session,[e.configuration.mediaHandlerFactory]),this.mediaHandler=this.mediaHandlerFactory(this,{RTCConstraints:{optional:[{DtlsSrtpKeyAgreement:"true"}]}}),!l&&!this.mediaHandler.hasDescription(i)||l&&"render"===l.type)this.renderbody=i.body,this.rendertype=u;else if(!this.mediaHandler.hasDescription(i)&&l&&"session"===l.type)return void i.reply(415);return a.hasSmallMinSE(i)?void i.reply(422,null,["Min-SE: "+a.localMinSE]):(this.status=c.STATUS_INVITE_RECEIVED,this.from_tag=i.from_tag,this.id=i.call_id+this.from_tag,this.request=i,this.contact=this.ua.contact.toString(),this.receiveNonInviteResponse=function(){},this.logger=e.getLogger("sip.inviteservercontext",this.id),this.ua.sessions[this.id]=this,i.hasHeader("expires")&&(s=1e3*i.getHeader("expires")),n("require",t.C.supported.REQUIRED),n("supported",t.C.supported.SUPPORTED),i.to_tag=t.Utils.newTag(),this.createDialog(i,"UAS",!0)?(this.mediaHandler&&this.mediaHandler.getRemoteStreams&&(this.getRemoteStreams=this.mediaHandler.getRemoteStreams.bind(this.mediaHandler),this.getLocalStreams=this.mediaHandler.getLocalStreams.bind(this.mediaHandler)),void(!this.mediaHandler.hasDescription(i)||this.renderbody?t.Timers.setTimeout(r,0):(this.hasOffer=!0,this.mediaHandler.setDescription(i).then(r,function(e){o.logger.warn("invalid description"),o.logger.warn(e),i.reply(488)})))):void i.reply(500,"Missing Contact header field"))},r.prototype={reject:function(e){if(this.status===c.STATUS_TERMINATED)throw new t.Exceptions.InvalidStateError(this.status);return this.logger.log("rejecting RTCSession"),t.ServerContext.prototype.reject.call(this,e),this.terminated()},terminate:function(e){e=e||{};var i,n=(e.extraHeaders||[]).slice(),r=e.body,s=this;return this.status===c.STATUS_WAITING_FOR_ACK&&this.request.server_transaction.state!==t.Transactions.C.STATUS_TERMINATED?(i=this.dialog,this.receiveRequest=function(e){e.method===t.C.ACK&&(this.request(t.C.BYE,{extraHeaders:n,body:r}),i.terminate())},this.request.server_transaction.on("stateChanged",function(){this.state===t.Transactions.C.STATUS_TERMINATED&&(this.request=new t.OutgoingRequest(t.C.BYE,this.dialog.remote_target,this.ua,{cseq:this.dialog.local_seqnum+=1,call_id:this.dialog.id.call_id,from_uri:this.dialog.local_uri,from_tag:this.dialog.id.local_tag,to_uri:this.dialog.remote_uri,to_tag:this.dialog.id.remote_tag,route_set:this.dialog.route_set},n,r),new t.RequestSender({request:this.request,onRequestTimeout:function(){s.onRequestTimeout()},onTransportError:function(){s.onTransportError()},receiveResponse:function(){}},this.ua).send(),i.terminate())}),this.emit("bye",this.request),this.terminated(),this.dialog=i,this.ua.dialogs[i.id.toString()]=i):this.status===c.STATUS_CONFIRMED?this.bye(e):this.reject(e),this},progress:function(e){function i(){o=e.statusCode||183,this.status=c.STATUS_WAITING_FOR_PRACK,u.push("Contact: "+this.contact),u.push("Require: 100rel"),u.push("RSeq: "+Math.floor(1e4*Math.random())),this.mediaHint=e.media,this.mediaHandler.getDescription(e.media).then(function(e){if(!this.isCanceled&&this.status!==c.STATUS_TERMINATED){this.early_sdp=e.body,this[this.hasOffer?"hasAnswer":"hasOffer"]=!0,u=u.concat(t.Utils.getDescriptionHeaders(e));var i=t.Timers.T1;this.timers.rel1xxTimer=t.Timers.setTimeout(function n(){this.request.reply(o,null,u,e.body),i*=2,this.timers.rel1xxTimer=t.Timers.setTimeout(n.bind(this),i)}.bind(this),i),this.timers.prackTimer=t.Timers.setTimeout(function(){this.status===c.STATUS_WAITING_FOR_PRACK&&(this.logger.log("no PRACK received, rejecting the call"),t.Timers.clearTimeout(this.timers.rel1xxTimer),this.request.reply(504),this.terminated(null,t.C.causes.NO_PRACK))}.bind(this),64*t.Timers.T1),s=this.request.reply(o,a,u,e.body),this.emit("progress",s,a)}}.bind(this),function(){this.request.reply(480),this.failed(null,t.C.causes.WEBRTC_ERROR),this.terminated(null,t.C.causes.WEBRTC_ERROR)}.bind(this))}function n(){s=this.request.reply(o,a,u,d),this.emit("progress",s,a)}e=e||{};var r,s,o=e.statusCode||180,a=e.reasonPhrase,u=(e.extraHeaders||[]).slice(),l=e.stunServers||null,h=e.turnServers||null,d=e.body;if(100>o||o>199)throw new TypeError("Invalid statusCode: "+o);if(this.isCanceled||this.status===c.STATUS_TERMINATED)return this;if(l||h){if(l){if(r=t.UA.configuration_check.optional.stunServers(l),!r)throw new TypeError("Invalid stunServers: "+l);this.stunServers=r}if(h){if(r=t.UA.configuration_check.optional.turnServers(h),!r)throw new TypeError("Invalid turnServers: "+h);this.turnServers=r}this.mediaHandler.updateIceServers({stunServers:this.stunServers,turnServers:this.turnServers})}return 100!==e.statusCode&&(this.rel100===t.C.supported.REQUIRED||this.rel100===t.C.supported.SUPPORTED&&e.rel100||this.rel100===t.C.supported.SUPPORTED&&this.ua.configuration.rel100===t.C.supported.REQUIRED)?i.apply(this):n.apply(this),this},accept:function(e){e=Object.create(n.desugar(e)),t.Utils.optionsOverride(e,"media","mediaConstraints",!0,this.logger,this.ua.configuration.media),this.mediaHint=e.media,this.infoHandler=e.infoHandler;var i,r=this,s=this.request,o=(e.extraHeaders||[]).slice(),a=e.stunServers||null,u=e.turnServers||null,l=function(e){var i,n=function(){r.status=c.STATUS_WAITING_FOR_ACK,r.setInvite2xxTimer(s,e),r.setACKTimer()},a=function(){r.failed(null,t.C.causes.CONNECTION_ERROR),r.terminated(null,t.C.causes.CONNECTION_ERROR)};r.mediaHandler.render(),o.push("Contact: "+r.contact),o.push("Allow: "+t.UA.C.ALLOWED_METHODS.toString());var u=s.parseHeader("Supported")||[],l=s.parseHeader("Session-Expires")||{},h=l.deltaSeconds;if(h){var d=l.refresher||"uas";o.push("Session-Expires: "+h+";"+d),("uac"===d||u.indexOf("timer")>=0)&&o.push("Require: timer")}o=o.concat(t.Utils.getDescriptionHeaders(e)),r.hasOffer?r.hasAnswer=!0:r.hasOffer=!0,i=s.reply(200,null,o,e.body,n,a),r.status!==c.STATUS_TERMINATED&&r.accepted(i,t.Utils.getReasonPhrase(200))},h=function(){r.status!==c.STATUS_TERMINATED&&(r.request.reply(480),r.failed(null,t.C.causes.WEBRTC_ERROR),r.terminated(null,t.C.causes.WEBRTC_ERROR))};if(this.status===c.STATUS_WAITING_FOR_PRACK)return this.status=c.STATUS_ANSWERED_WAITING_FOR_PRACK,this;if(this.status===c.STATUS_WAITING_FOR_ANSWER)this.status=c.STATUS_ANSWERED;else if(this.status!==c.STATUS_EARLY_MEDIA)throw new t.Exceptions.InvalidStateError(this.status);if((a||u)&&this.status!==c.STATUS_EARLY_MEDIA&&this.status!==c.STATUS_ANSWERED_WAITING_FOR_PRACK){if(a){if(i=t.UA.configuration_check.optional.stunServers(a),!i)throw new TypeError("Invalid stunServers: "+a);this.stunServers=i}if(u){if(i=t.UA.configuration_check.optional.turnServers(u),!i)throw new TypeError("Invalid turnServers: "+u);this.turnServers=i}this.mediaHandler.updateIceServers({stunServers:this.stunServers,turnServers:this.turnServers})}return this.createDialog(s,"UAS")?(t.Timers.clearTimeout(this.timers.userNoAnswerTimer),this.status===c.STATUS_EARLY_MEDIA?l({}):this.mediaHandler.getDescription(r.mediaHint).then(l,h),this):(s.reply(500,"Missing Contact header field"),this)},receiveRequest:function(e){function i(){var i;t.Timers.clearTimeout(this.timers.ackTimer),t.Timers.clearTimeout(this.timers.invite2xxTimer),this.status=c.STATUS_CONFIRMED,this.unmute(),i=e.getHeader("Content-Type"),this.mediaHandler.hasDescription(e)||(this.renderbody=e.body,this.rendertype=i),this.emit("confirmed",e)}switch(e.method){case t.C.CANCEL:this.status!==c.STATUS_WAITING_FOR_ANSWER&&this.status!==c.STATUS_WAITING_FOR_PRACK&&this.status!==c.STATUS_ANSWERED_WAITING_FOR_PRACK&&this.status!==c.STATUS_EARLY_MEDIA&&this.status!==c.STATUS_ANSWERED||(this.status=c.STATUS_CANCELED,this.request.reply(487),this.canceled(e),this.rejected(e,t.C.causes.CANCELED),this.failed(e,t.C.causes.CANCELED),this.terminated(e,t.C.causes.CANCELED));break;case t.C.ACK:this.status===c.STATUS_WAITING_FOR_ACK&&(this.hasAnswer?i.apply(this):this.mediaHandler.hasDescription(e)?(this.hasAnswer=!0,this.mediaHandler.setDescription(e).then(i.bind(this),function(i){this.logger.warn(i),this.terminate({statusCode:"488",reasonPhrase:"Bad Media Description"}),this.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION),this.terminated(e,t.C.causes.BAD_MEDIA_DESCRIPTION)}.bind(this))):this.early_sdp?i.apply(this):(this.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION),this.terminated(e,t.C.causes.BAD_MEDIA_DESCRIPTION)));break;case t.C.PRACK:this.status===c.STATUS_WAITING_FOR_PRACK||this.status===c.STATUS_ANSWERED_WAITING_FOR_PRACK?this.hasAnswer?(t.Timers.clearTimeout(this.timers.rel1xxTimer),t.Timers.clearTimeout(this.timers.prackTimer),e.reply(200),this.status===c.STATUS_ANSWERED_WAITING_FOR_PRACK&&(this.status=c.STATUS_EARLY_MEDIA,this.accept()),this.status=c.STATUS_EARLY_MEDIA,this.mute()):this.mediaHandler.hasDescription(e)?(this.hasAnswer=!0,this.mediaHandler.setDescription(e).then(function(){t.Timers.clearTimeout(this.timers.rel1xxTimer),t.Timers.clearTimeout(this.timers.prackTimer),e.reply(200),this.status===c.STATUS_ANSWERED_WAITING_FOR_PRACK&&(this.status=c.STATUS_EARLY_MEDIA,this.accept()),this.status=c.STATUS_EARLY_MEDIA,this.mute()}.bind(this),function(i){this.logger.warn(i),this.terminate({statusCode:"488",reasonPhrase:"Bad Media Description"}),this.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION),this.terminated(e,t.C.causes.BAD_MEDIA_DESCRIPTION)}.bind(this))):(this.terminate({statusCode:"488",reasonPhrase:"Bad Media Description"}),this.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION),this.terminated(e,t.C.causes.BAD_MEDIA_DESCRIPTION)):this.status===c.STATUS_EARLY_MEDIA&&e.reply(200);break;default:n.prototype.receiveRequest.apply(this,[e])}},onTransportError:function(){this.status!==c.STATUS_CONFIRMED&&this.status!==c.STATUS_TERMINATED&&this.failed(null,t.C.causes.CONNECTION_ERROR)},onRequestTimeout:function(){this.status===c.STATUS_CONFIRMED?this.terminated(null,t.C.causes.REQUEST_TIMEOUT):this.status!==c.STATUS_TERMINATED&&(this.failed(null,t.C.causes.REQUEST_TIMEOUT),this.terminated(null,t.C.causes.REQUEST_TIMEOUT))}},t.InviteServerContext=r,s=function(e,i,r){r=Object.create(n.desugar(r)),r.params=Object.create(r.params||Object.prototype);var s,o=(r.extraHeaders||[]).slice(),a=r.stunServers||null,u=r.turnServers||null,l=r.mediaHandlerFactory||e.configuration.mediaHandlerFactory,h=l.isSupported;if(h&&!h())throw new t.Exceptions.NotSupportedError("Media not supported");if(this.RTCConstraints=r.RTCConstraints||{},this.inviteWithoutSdp=r.inviteWithoutSdp||!1,this.anonymous=r.anonymous||!1,this.renderbody=r.renderbody||null,this.rendertype=r.rendertype||"text/plain",r.params.from_tag=this.from_tag,this.contact=e.contact.toString({anonymous:this.anonymous,outbound:this.anonymous?!e.contact.temp_gruu:!e.contact.pub_gruu}),this.anonymous&&(r.params.from_displayName="Anonymous",r.params.from_uri="sip:anonymous@anonymous.invalid",o.push("P-Preferred-Identity: "+e.configuration.uri.toString()),o.push("Privacy: id")),o.push("Contact: "+this.contact),o.push("Allow: "+t.UA.C.ALLOWED_METHODS.toString()),this.inviteWithoutSdp&&this.renderbody&&(o.push("Content-Type: "+this.rendertype),o.push("Content-Disposition: render;handling=optional")),e.configuration.rel100===t.C.supported.REQUIRED&&o.push("Require: 100rel"),e.configuration.replaces===t.C.supported.REQUIRED&&o.push("Require: replaces"),r.extraHeaders=o,t.Utils.augment(this,t.ClientContext,[e,t.C.INVITE,i,r]),t.Utils.augment(this,t.Session,[l]),this.status!==c.STATUS_NULL)throw new t.Exceptions.InvalidStateError(this.status);if(this.from_tag=t.Utils.newTag(),this.isCanceled=!1,this.received_100=!1,this.method=t.C.INVITE,this.receiveNonInviteResponse=this.receiveResponse,this.receiveResponse=this.receiveInviteResponse,this.logger=e.getLogger("sip.inviteclientcontext"),a){if(s=t.UA.configuration_check.optional.stunServers(a),!s)throw new TypeError("Invalid stunServers: "+a);this.stunServers=s}if(u){if(s=t.UA.configuration_check.optional.turnServers(u),!s)throw new TypeError("Invalid turnServers: "+u);this.turnServers=s}e.applicants[this]=this,this.id=this.request.call_id+this.from_tag,this.mediaHandler=this.mediaHandlerFactory(this,{RTCConstraints:this.RTCConstraints,stunServers:this.stunServers,turnServers:this.turnServers}),this.mediaHandler&&this.mediaHandler.getRemoteStreams&&(this.getRemoteStreams=this.mediaHandler.getRemoteStreams.bind(this.mediaHandler),this.getLocalStreams=this.mediaHandler.getLocalStreams.bind(this.mediaHandler)),t.Utils.optionsOverride(r,"media","mediaConstraints",!0,this.logger,this.ua.configuration.media),this.mediaHint=r.media,this.infoHandler=r.infoHandler},s.prototype={invite:function(){var e=this;return this.ua.sessions[this.id]=this,this.inviteWithoutSdp?(this.request.body=e.renderbody,this.status=c.STATUS_INVITE_SENT,this.send()):this.mediaHandler.getDescription(e.mediaHint).then(function(i){e.isCanceled||e.status===c.STATUS_TERMINATED||(e.hasOffer=!0,e.request.body=i.body,e.status=c.STATUS_INVITE_SENT,e.request.extraHeaders=e.request.extraHeaders.concat(t.Utils.getDescriptionHeaders(i)),e.send())},function(){e.status!==c.STATUS_TERMINATED&&(e.failed(null,t.C.causes.WEBRTC_ERROR),e.terminated(null,t.C.causes.WEBRTC_ERROR))}),this},receiveInviteResponse:function(e){var i,n=this,r=e.call_id+e.from_tag+e.to_tag,s=[],o={};if(this.status!==c.STATUS_TERMINATED&&e.method===t.C.INVITE){if(this.dialog&&e.status_code>=200&&e.status_code<=299){if(r!==this.dialog.id.toString()){if(!this.createDialog(e,"UAC",!0))return;return this.earlyDialogs[r].sendRequest(this,t.C.ACK,{body:t.Utils.generateFakeSDP(e.body)}),this.earlyDialogs[r].sendRequest(this,t.C.BYE),void(this.status!==c.STATUS_CONFIRMED&&(this.failed(e,t.C.causes.WEBRTC_ERROR),this.terminated(e,t.C.causes.WEBRTC_ERROR)))}if(this.status===c.STATUS_CONFIRMED)return void this.sendRequest(t.C.ACK,{cseq:e.cseq});if(!this.hasAnswer)return}if(this.dialog&&e.status_code<200){if(-1!==this.dialog.pracked.indexOf(e.getHeader("rseq"))||this.dialog.pracked[this.dialog.pracked.length-1]>=e.getHeader("rseq")&&this.dialog.pracked.length>0)return;if(!this.earlyDialogs[r]&&!this.createDialog(e,"UAC",!0))return;if(-1!==this.earlyDialogs[r].pracked.indexOf(e.getHeader("rseq"))||this.earlyDialogs[r].pracked[this.earlyDialogs[r].pracked.length-1]>=e.getHeader("rseq")&&this.earlyDialogs[r].pracked.length>0)return;return s.push("RAck: "+e.getHeader("rseq")+" "+e.getHeader("cseq")),this.earlyDialogs[r].pracked.push(e.getHeader("rseq")),void this.earlyDialogs[r].sendRequest(this,t.C.PRACK,{extraHeaders:s,body:t.Utils.generateFakeSDP(e.body)})}if(this.isCanceled)return void(e.status_code>=100&&e.status_code<200?(this.request.cancel(this.cancelReason),this.canceled(null)):e.status_code>=200&&e.status_code<299?(this.acceptAndTerminate(e),this.emit("bye",this.request)):e.status_code>=300&&(i=t.C.REASON_PHRASE[e.status_code]||t.C.causes.CANCELED,this.rejected(e,i),this.failed(e,i),this.terminated(e,i)));switch(!0){case/^100$/.test(e.status_code):this.received_100=!0,this.emit("progress",e);break;case/^1[0-9]{2}$/.test(e.status_code):if(!e.to_tag){this.logger.warn("1xx response received without to tag");break}if(e.hasHeader("contact")&&!this.createDialog(e,"UAC",!0))break;if(this.status=c.STATUS_1XX_RECEIVED,e.hasHeader("require")&&-1!==e.getHeader("require").indexOf("100rel")){if(this.dialog||!this.earlyDialogs[r])break;if(-1!==this.earlyDialogs[r].pracked.indexOf(e.getHeader("rseq"))||this.earlyDialogs[r].pracked[this.earlyDialogs[r].pracked.length-1]>=e.getHeader("rseq")&&this.earlyDialogs[r].pracked.length>0)return;if(this.mediaHandler.hasDescription(e))if(this.hasOffer){if(!this.createDialog(e,"UAC"))break;this.hasAnswer=!0,this.dialog.pracked.push(e.getHeader("rseq")),this.mediaHandler.setDescription(e).then(function(){s.push("RAck: "+e.getHeader("rseq")+" "+e.getHeader("cseq")),n.sendRequest(t.C.PRACK,{extraHeaders:s,receiveResponse:function(){}}),n.status=c.STATUS_EARLY_MEDIA,n.mute(),n.emit("progress",e)},function(i){n.logger.warn(i),n.acceptAndTerminate(e,488,"Not Acceptable Here"),n.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION)})}else{var a=this.earlyDialogs[r],u=a.mediaHandler;a.pracked.push(e.getHeader("rseq")),u.setDescription(e).then(u.getDescription.bind(u,n.mediaHint)).then(function(i){s=s.concat(t.Utils.getDescriptionHeaders(i)),s.push("RAck: "+e.getHeader("rseq")+" "+e.getHeader("cseq")),a.sendRequest(n,t.C.PRACK,{extraHeaders:s,body:i.body}),n.status=c.STATUS_EARLY_MEDIA,n.emit("progress",e)})["catch"](function(i){if(i instanceof t.Exceptions.GetDescriptionError){if(a.pracked.push(e.getHeader("rseq")),n.status===c.STATUS_TERMINATED)return;n.failed(null,t.C.causes.WEBRTC_ERROR),n.terminated(null,t.C.causes.WEBRTC_ERROR)}else a.pracked.splice(a.pracked.indexOf(e.getHeader("rseq")),1),n.logger.warn("invalid description"),n.logger.warn(i)})}else s.push("RAck: "+e.getHeader("rseq")+" "+e.getHeader("cseq")),this.earlyDialogs[r].pracked.push(e.getHeader("rseq")),this.earlyDialogs[r].sendRequest(this,t.C.PRACK,{extraHeaders:s}),this.emit("progress",e)}else this.emit("progress",e);break;case/^2[0-9]{2}$/.test(e.status_code):var l=this.request.cseq+" "+this.request.method;if(l!==e.getHeader("cseq"))break;if(this.status===c.STATUS_EARLY_MEDIA&&this.dialog){this.status=c.STATUS_CONFIRMED,this.unmute(),o={},this.renderbody&&(s.push("Content-Type: "+this.rendertype),o.extraHeaders=s,o.body=this.renderbody),o.cseq=e.cseq,this.sendRequest(t.C.ACK,o),this.accepted(e);break}if(this.dialog)break;if(this.hasOffer)if(this.hasAnswer)this.renderbody&&(s.push("Content-Type: "+n.rendertype),o.extraHeaders=s,o.body=this.renderbody),this.sendRequest(t.C.ACK,o);else{if(!this.mediaHandler.hasDescription(e)){this.acceptAndTerminate(e,400,"Missing session description"),this.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION);break}if(!this.createDialog(e,"UAC"))break;this.hasAnswer=!0,this.mediaHandler.setDescription(e).then(function(){var i={};n.status=c.STATUS_CONFIRMED,n.unmute(),n.renderbody&&(s.push("Content-Type: "+n.rendertype),i.extraHeaders=s,i.body=n.renderbody),i.cseq=e.cseq,n.sendRequest(t.C.ACK,i),n.accepted(e)},function(i){n.logger.warn(i),n.acceptAndTerminate(e,488,"Not Acceptable Here"),n.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION)})}else if(this.earlyDialogs[r]&&this.earlyDialogs[r].mediaHandler.localMedia){if(this.hasOffer=!0,this.hasAnswer=!0,this.mediaHandler=this.earlyDialogs[r].mediaHandler,!this.createDialog(e,"UAC"))break;this.status=c.STATUS_CONFIRMED,this.sendRequest(t.C.ACK,{cseq:e.cseq}),this.unmute(),this.accepted(e)}else{if(!this.mediaHandler.hasDescription(e)){this.acceptAndTerminate(e,400,"Missing session description"),this.failed(e,t.C.causes.BAD_MEDIA_DESCRIPTION);break}if(!this.createDialog(e,"UAC"))break;this.hasOffer=!0,this.mediaHandler.setDescription(e).then(this.mediaHandler.getDescription.bind(this.mediaHandler,this.mediaHint)).then(function(i){n.isCanceled||n.status===c.STATUS_TERMINATED||(n.status=c.STATUS_CONFIRMED,n.hasAnswer=!0,n.unmute(),n.sendRequest(t.C.ACK,{body:i.body,extraHeaders:t.Utils.getDescriptionHeaders(i),cseq:e.cseq}),n.accepted(e))})["catch"](function(i){i instanceof t.Exceptions.GetDescriptionError?n.logger.warn("there was a problem"):(n.logger.warn("invalid description"),n.logger.warn(i),e.reply(488))})}break;default:i=t.Utils.sipErrorCause(e.status_code),this.rejected(e,i),this.failed(e,i),this.terminated(e,i)}}},cancel:function(e){if(e=e||{},this.status===c.STATUS_TERMINATED||this.status===c.STATUS_CONFIRMED)throw new t.Exceptions.InvalidStateError(this.status);this.logger.log("canceling RTCSession");var i=t.Utils.getCancelReason(e.status_code,e.reason_phrase);return this.status===c.STATUS_NULL||this.status===c.STATUS_INVITE_SENT&&!this.received_100?(this.isCanceled=!0,this.cancelReason=i):this.status!==c.STATUS_INVITE_SENT&&this.status!==c.STATUS_1XX_RECEIVED&&this.status!==c.STATUS_EARLY_MEDIA||this.request.cancel(i),this.canceled()},terminate:function(e){return this.status===c.STATUS_TERMINATED?this:(this.status===c.STATUS_WAITING_FOR_ACK||this.status===c.STATUS_CONFIRMED?this.bye(e):this.cancel(e),this)},receiveRequest:function(e){return e.method===t.C.CANCEL,e.method===t.C.ACK&&this.status===c.STATUS_WAITING_FOR_ACK&&(t.Timers.clearTimeout(this.timers.ackTimer),t.Timers.clearTimeout(this.timers.invite2xxTimer),this.status=c.STATUS_CONFIRMED,this.unmute(),this.accepted()),n.prototype.receiveRequest.apply(this,[e])},onTransportError:function(){this.status!==c.STATUS_CONFIRMED&&this.status!==c.STATUS_TERMINATED&&this.failed(null,t.C.causes.CONNECTION_ERROR)},onRequestTimeout:function(){this.status===c.STATUS_CONFIRMED?this.terminated(null,t.C.causes.REQUEST_TIMEOUT):this.status!==c.STATUS_TERMINATED&&(this.failed(null,t.C.causes.REQUEST_TIMEOUT),this.terminated(null,t.C.causes.REQUEST_TIMEOUT))}},t.InviteClientContext=s}},{"./RFC4028":82,"./Session/DTMF":90}],90:[function(e,t,i){"use strict";t.exports=function(e){var t,i={MIN_DURATION:70,MAX_DURATION:6e3,DEFAULT_DURATION:100,MIN_INTER_TONE_GAP:50,DEFAULT_INTER_TONE_GAP:500};return t=function(i,n,r){var s,o;if(void 0===n)throw new TypeError("Not enough arguments");if(this.logger=i.ua.getLogger("sip.invitecontext.dtmf",i.id),this.owner=i,this.direction=null,r=r||{},s=r.duration||null,o=r.interToneGap||null,"string"==typeof n)n=n.toUpperCase();else{if("number"!=typeof n)throw new TypeError("Invalid tone: "+n);n=n.toString()}if(!n.match(/^[0-9A-D#*]$/))throw new TypeError("Invalid tone: "+n);if(this.tone=n,s&&!e.Utils.isDecimal(s))throw new TypeError("Invalid tone duration: "+s);if(s?s<t.C.MIN_DURATION?(this.logger.warn('"duration" value is lower than the minimum allowed, setting it to '+t.C.MIN_DURATION+" milliseconds"),s=t.C.MIN_DURATION):s>t.C.MAX_DURATION?(this.logger.warn('"duration" value is greater than the maximum allowed, setting it to '+t.C.MAX_DURATION+" milliseconds"),s=t.C.MAX_DURATION):s=Math.abs(s):s=t.C.DEFAULT_DURATION,this.duration=s,o&&!e.Utils.isDecimal(o))throw new TypeError("Invalid interToneGap: "+o);o?o<t.C.MIN_INTER_TONE_GAP?(this.logger.warn('"interToneGap" value is lower than the minimum allowed, setting it to '+t.C.MIN_INTER_TONE_GAP+" milliseconds"),o=t.C.MIN_INTER_TONE_GAP):o=Math.abs(o):o=t.C.DEFAULT_INTER_TONE_GAP,this.interToneGap=o},t.prototype=Object.create(e.EventEmitter.prototype),t.prototype.send=function(t){var i,n;if(this.direction="outgoing",this.owner.status!==e.Session.C.STATUS_CONFIRMED&&this.owner.status!==e.Session.C.STATUS_WAITING_FOR_ACK)throw new e.Exceptions.InvalidStateError(this.owner.status);t=t||{},i=t.extraHeaders?t.extraHeaders.slice():[],i.push("Content-Type: application/dtmf-relay"),n="Signal= "+this.tone+"\r\n",n+="Duration= "+this.duration,this.request=this.owner.dialog.sendRequest(this,e.C.INFO,{extraHeaders:i,body:n}),this.owner.emit("dtmf",this.request,this)},t.prototype.receiveResponse=function(t){var i;switch(!0){case/^1[0-9]{2}$/.test(t.status_code):break;case/^2[0-9]{2}$/.test(t.status_code):this.emit("succeeded",{originator:"remote",response:t});break;default:i=e.Utils.sipErrorCause(t.status_code),this.emit("failed",t,i)}},t.prototype.onRequestTimeout=function(){this.emit("failed",null,e.C.causes.REQUEST_TIMEOUT),this.owner.onRequestTimeout()},t.prototype.onTransportError=function(){this.emit("failed",null,e.C.causes.CONNECTION_ERROR),this.owner.onTransportError()},t.prototype.onDialogError=function(t){this.emit("failed",t,e.C.causes.DIALOG_ERROR),this.owner.onDialogError(t)},t.prototype.init_incoming=function(e){this.direction="incoming",this.request=e,e.reply(200),this.tone&&this.duration?this.owner.emit("dtmf",e,this):this.logger.warn("invalid INFO DTMF received, discarded");
},t.C=i,t}},{}],91:[function(e,t,i){"use strict";t.exports=function(e){e.Subscription=function(t,i,n,r){if(r=Object.create(r||Object.prototype),this.extraHeaders=r.extraHeaders=(r.extraHeaders||[]).slice(),this.id=null,this.state="init",!n)throw new TypeError("Event necessary to create a subscription.");this.event=n,"number"!=typeof r.expires?(t.logger.warn("expires must be a number. Using default of 3600."),this.expires=3600):this.expires=r.expires,r.extraHeaders.push("Event: "+this.event),r.extraHeaders.push("Expires: "+this.expires),r.body&&(this.body=r.body),this.contact=t.contact.toString(),r.extraHeaders.push("Contact: "+this.contact),r.extraHeaders.push("Allow: "+e.UA.C.ALLOWED_METHODS.toString()),e.Utils.augment(this,e.ClientContext,[t,e.C.SUBSCRIBE,i,r]),this.logger=t.getLogger("sip.subscription"),this.dialog=null,this.timers={N:null,sub_duration:null},this.errorCodes=[404,405,410,416,480,481,482,483,484,485,489,501,604]},e.Subscription.prototype={subscribe:function(){var t=this;return"active"===this.state?(this.refresh(),this):"notify_wait"===this.state?this:(e.Timers.clearTimeout(this.timers.sub_duration),e.Timers.clearTimeout(this.timers.N),this.timers.N=e.Timers.setTimeout(t.timer_fire.bind(t),e.Timers.TIMER_N),this.send(),this.state="notify_wait",this)},refresh:function(){"terminated"!==this.state&&"pending"!==this.state&&"notify_wait"!==this.state&&this.dialog.sendRequest(this,e.C.SUBSCRIBE,{extraHeaders:this.extraHeaders,body:this.body})},receiveResponse:function(t){var i,n=this,r=e.Utils.getReasonPhrase(t.status_code);"notify_wait"===this.state&&t.status_code>=300||"notify_wait"!==this.state&&-1!==this.errorCodes.indexOf(t.status_code)?this.failed(t,null):/^2[0-9]{2}$/.test(t.status_code)&&(i=t.getHeader("Expires"),e.Timers.clearTimeout(this.timers.N),this.createConfirmedDialog(t,"UAC")&&(this.id=this.dialog.id.toString(),this.ua.subscriptions[this.id]=this,this.emit("accepted",t,r)),i&&i<=this.expires?(this.expires=i,this.timers.sub_duration=e.Timers.setTimeout(n.refresh.bind(n),900*i)):i?(this.logger.warn("Expires header in a 200-class response to SUBSCRIBE with a higher value than the one in the request"),this.failed(t,e.C.INVALID_EXPIRES_HEADER)):(this.logger.warn("Expires header missing in a 200-class response to SUBSCRIBE"),this.failed(t,e.C.EXPIRES_HEADER_MISSING)))},unsubscribe:function(){var t=[],i=this;this.state="terminated",t.push("Event: "+this.event),t.push("Expires: 0"),t.push("Contact: "+this.contact),t.push("Allow: "+e.UA.C.ALLOWED_METHODS.toString()),this.receiveResponse=function(){},this.dialog.sendRequest(this,this.method,{extraHeaders:t,body:this.body}),e.Timers.clearTimeout(this.timers.sub_duration),e.Timers.clearTimeout(this.timers.N),this.timers.N=e.Timers.setTimeout(i.timer_fire.bind(i),e.Timers.TIMER_N)},timer_fire:function(){"terminated"===this.state?(this.terminateDialog(),e.Timers.clearTimeout(this.timers.N),e.Timers.clearTimeout(this.timers.sub_duration),delete this.ua.subscriptions[this.id]):"pending"===this.state||"notify_wait"===this.state?this.close():this.refresh()},close:function(){"notify_wait"!==this.state&&"terminated"!==this.state&&this.unsubscribe()},createConfirmedDialog:function(t,i){var n;return this.terminateDialog(),n=new e.Dialog(this,t,i),n.error?!1:(this.dialog=n,!0)},terminateDialog:function(){this.dialog&&(delete this.ua.subscriptions[this.id],this.dialog.terminate(),delete this.dialog)},receiveRequest:function(t){function i(){n.expires&&(e.Timers.clearTimeout(r.timers.sub_duration),n.expires=Math.min(r.expires,Math.max(n.expires,0)),r.timers.sub_duration=e.Timers.setTimeout(r.refresh.bind(r),900*n.expires))}var n,r=this;if(!this.matchEvent(t))return void t.reply(489);if(n=t.parseHeader("Subscription-State"),t.reply(200,e.C.REASON_200),e.Timers.clearTimeout(this.timers.N),this.emit("notify",{request:t}),"terminated"===this.state)return void("terminated"===n.state&&(this.terminateDialog(),e.Timers.clearTimeout(this.timers.N),e.Timers.clearTimeout(this.timers.sub_duration),delete this.ua.subscriptions[this.id]));switch(n.state){case"active":this.state="active",i();break;case"pending":"notify_wait"===this.state&&i(),this.state="pending";break;case"terminated":if(e.Timers.clearTimeout(this.timers.sub_duration),n.reason)switch(this.logger.log("terminating subscription with reason "+n.reason),n.reason){case"deactivated":case"timeout":return void this.subscribe();case"probation":case"giveup":return void(n.params&&n.params["retry-after"]?this.timers.sub_duration=e.Timers.setTimeout(r.subscribe.bind(r),n.params["retry-after"]):this.subscribe());case"rejected":case"noresource":case"invariant":}this.close()}},failed:function(e,t){return this.close(),this.emit("failed",e,t),this},onDialogError:function(t){this.failed(t,e.C.causes.DIALOG_ERROR)},matchEvent:function(e){var t;return e.hasHeader("Event")?e.hasHeader("Subscription-State")?(t=e.parseHeader("event").event,this.event!==t?(this.logger.warn("event match failed"),e.reply(481,"Event Match Failed"),!1):!0):(this.logger.warn("missing Subscription-State header"),!1):(this.logger.warn("missing Event header"),!1)}}}},{}],92:[function(e,t,i){"use strict";var n=500,r=4e3,s=5e3;t.exports=function(e){var t={T1:n,T2:r,T4:s,TIMER_B:64*n,TIMER_D:0*n,TIMER_F:64*n,TIMER_H:64*n,TIMER_I:0*n,TIMER_J:0*n,TIMER_K:0*s,TIMER_L:64*n,TIMER_M:64*n,TIMER_N:64*n,PROVISIONAL_RESPONSE_INTERVAL:6e4};return["setTimeout","clearTimeout","setInterval","clearInterval"].forEach(function(i){t[i]=function(){return e[i].apply(e,arguments)}}),t}},{}],93:[function(e,t,i){"use strict";t.exports=function(e){function t(e,t,i){var n;return n="SIP/2.0/"+(e.ua.configuration.hackViaTcp?"TCP":t.server.scheme),n+=" "+e.ua.configuration.viaHost+";branch="+i,e.ua.configuration.forceRport&&(n+=";rport"),n}var i={STATUS_TRYING:1,STATUS_PROCEEDING:2,STATUS_CALLING:3,STATUS_ACCEPTED:4,STATUS_COMPLETED:5,STATUS_TERMINATED:6,STATUS_CONFIRMED:7,NON_INVITE_CLIENT:"nict",NON_INVITE_SERVER:"nist",INVITE_CLIENT:"ict",INVITE_SERVER:"ist"},n=function(e,n,r){var s;this.type=i.NON_INVITE_CLIENT,this.transport=r,this.id="z9hG4bK"+Math.floor(1e7*Math.random()),this.request_sender=e,this.request=n,this.logger=e.ua.getLogger("sip.transaction.nict",this.id),s=t(e,r,this.id),this.request.setHeader("via",s),this.request_sender.ua.newTransaction(this)};n.prototype=Object.create(e.EventEmitter.prototype),n.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},n.prototype.send=function(){var t=this;this.stateChanged(i.STATUS_TRYING),this.F=e.Timers.setTimeout(t.timer_F.bind(t),e.Timers.TIMER_F),this.transport.send(this.request)||this.onTransportError()},n.prototype.onTransportError=function(){this.logger.log("transport error occurred, deleting non-INVITE client transaction "+this.id),e.Timers.clearTimeout(this.F),e.Timers.clearTimeout(this.K),this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.request_sender.onTransportError()},n.prototype.timer_F=function(){this.logger.log("Timer F expired for non-INVITE client transaction "+this.id),this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.request_sender.onRequestTimeout()},n.prototype.timer_K=function(){this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this)},n.prototype.receiveResponse=function(t){var n=this,r=t.status_code;if(200>r)switch(this.state){case i.STATUS_TRYING:case i.STATUS_PROCEEDING:this.stateChanged(i.STATUS_PROCEEDING),this.request_sender.receiveResponse(t)}else switch(this.state){case i.STATUS_TRYING:case i.STATUS_PROCEEDING:this.stateChanged(i.STATUS_COMPLETED),e.Timers.clearTimeout(this.F),408===r?this.request_sender.onRequestTimeout():this.request_sender.receiveResponse(t),this.K=e.Timers.setTimeout(n.timer_K.bind(n),e.Timers.TIMER_K);break;case i.STATUS_COMPLETED:}};var r=function(e,n,r){var s,o=this;this.type=i.INVITE_CLIENT,this.transport=r,this.id="z9hG4bK"+Math.floor(1e7*Math.random()),this.request_sender=e,this.request=n,this.logger=e.ua.getLogger("sip.transaction.ict",this.id),s=t(e,r,this.id),this.request.setHeader("via",s),this.request_sender.ua.newTransaction(this),this.request.cancel=function(e){o.cancel_request(o,e)}};r.prototype=Object.create(e.EventEmitter.prototype),r.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},r.prototype.send=function(){var t=this;this.stateChanged(i.STATUS_CALLING),this.B=e.Timers.setTimeout(t.timer_B.bind(t),e.Timers.TIMER_B),this.transport.send(this.request)||this.onTransportError()},r.prototype.onTransportError=function(){this.logger.log("transport error occurred, deleting INVITE client transaction "+this.id),e.Timers.clearTimeout(this.B),e.Timers.clearTimeout(this.D),e.Timers.clearTimeout(this.M),this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.state!==i.STATUS_ACCEPTED&&this.request_sender.onTransportError()},r.prototype.timer_M=function(){this.logger.log("Timer M expired for INVITE client transaction "+this.id),this.state===i.STATUS_ACCEPTED&&(e.Timers.clearTimeout(this.B),this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this))},r.prototype.timer_B=function(){this.logger.log("Timer B expired for INVITE client transaction "+this.id),this.state===i.STATUS_CALLING&&(this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.request_sender.onRequestTimeout())},r.prototype.timer_D=function(){this.logger.log("Timer D expired for INVITE client transaction "+this.id),e.Timers.clearTimeout(this.B),this.stateChanged(i.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this)},r.prototype.sendACK=function(t){var i=this;this.ack="ACK "+this.request.ruri+" SIP/2.0\r\n",this.ack+="Via: "+this.request.headers.Via.toString()+"\r\n",this.request.headers.Route&&(this.ack+="Route: "+this.request.headers.Route.toString()+"\r\n"),this.ack+="To: "+t.getHeader("to")+"\r\n",this.ack+="From: "+this.request.headers.From.toString()+"\r\n",this.ack+="Call-ID: "+this.request.headers["Call-ID"].toString()+"\r\n",this.ack+="Content-Length: 0\r\n",this.ack+="CSeq: "+this.request.headers.CSeq.toString().split(" ")[0],this.ack+=" ACK\r\n\r\n",this.D=e.Timers.setTimeout(i.timer_D.bind(i),e.Timers.TIMER_D),this.transport.send(this.ack)},r.prototype.cancel_request=function(t,n){var r=t.request;this.cancel=e.C.CANCEL+" "+r.ruri+" SIP/2.0\r\n",this.cancel+="Via: "+r.headers.Via.toString()+"\r\n",this.request.headers.Route&&(this.cancel+="Route: "+r.headers.Route.toString()+"\r\n"),this.cancel+="To: "+r.headers.To.toString()+"\r\n",this.cancel+="From: "+r.headers.From.toString()+"\r\n",this.cancel+="Call-ID: "+r.headers["Call-ID"].toString()+"\r\n",this.cancel+="CSeq: "+r.headers.CSeq.toString().split(" ")[0]+" CANCEL\r\n",n&&(this.cancel+="Reason: "+n+"\r\n"),this.cancel+="Content-Length: 0\r\n\r\n",this.state===i.STATUS_PROCEEDING&&this.transport.send(this.cancel)},r.prototype.receiveResponse=function(t){var n=this,r=t.status_code;if(r>=100&&199>=r)switch(this.state){case i.STATUS_CALLING:this.stateChanged(i.STATUS_PROCEEDING),this.request_sender.receiveResponse(t),this.cancel&&this.transport.send(this.cancel);break;case i.STATUS_PROCEEDING:this.request_sender.receiveResponse(t)}else if(r>=200&&299>=r)switch(this.state){case i.STATUS_CALLING:case i.STATUS_PROCEEDING:this.stateChanged(i.STATUS_ACCEPTED),this.M=e.Timers.setTimeout(n.timer_M.bind(n),e.Timers.TIMER_M),this.request_sender.receiveResponse(t);break;case i.STATUS_ACCEPTED:this.request_sender.receiveResponse(t)}else if(r>=300&&699>=r)switch(this.state){case i.STATUS_CALLING:case i.STATUS_PROCEEDING:this.stateChanged(i.STATUS_COMPLETED),this.sendACK(t),this.request_sender.receiveResponse(t);break;case i.STATUS_COMPLETED:this.sendACK(t)}};var s=function(e,i,n){var r;this.transport=n,this.id="z9hG4bK"+Math.floor(1e7*Math.random()),this.request_sender=e,this.request=i,this.logger=e.ua.getLogger("sip.transaction.nict",this.id),r=t(e,n,this.id),this.request.setHeader("via",r)};s.prototype=Object.create(e.EventEmitter.prototype),s.prototype.send=function(){this.transport.send(this.request)||this.onTransportError()},s.prototype.onTransportError=function(){this.logger.log("transport error occurred, for an ACK client transaction "+this.id),this.request_sender.onTransportError()};var o=function(e,t){this.type=i.NON_INVITE_SERVER,this.id=e.via_branch,this.request=e,this.transport=e.transport,this.ua=t,this.last_response="",e.server_transaction=this,this.logger=t.getLogger("sip.transaction.nist",this.id),this.state=i.STATUS_TRYING,t.newTransaction(this)};o.prototype=Object.create(e.EventEmitter.prototype),o.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},o.prototype.timer_J=function(){this.logger.log("Timer J expired for non-INVITE server transaction "+this.id),this.stateChanged(i.STATUS_TERMINATED),this.ua.destroyTransaction(this)},o.prototype.onTransportError=function(){this.transportError||(this.transportError=!0,this.logger.log("transport error occurred, deleting non-INVITE server transaction "+this.id),e.Timers.clearTimeout(this.J),this.stateChanged(i.STATUS_TERMINATED),this.ua.destroyTransaction(this))},o.prototype.receiveResponse=function(t,n){var r=this,s=e.Utils.defer();if(100===t)switch(this.state){case i.STATUS_TRYING:this.stateChanged(i.STATUS_PROCEEDING),this.transport.send(n)||this.onTransportError();break;case i.STATUS_PROCEEDING:this.last_response=n,this.transport.send(n)?s.resolve():(this.onTransportError(),s.reject())}else if(t>=200&&699>=t)switch(this.state){case i.STATUS_TRYING:case i.STATUS_PROCEEDING:this.stateChanged(i.STATUS_COMPLETED),this.last_response=n,this.J=e.Timers.setTimeout(r.timer_J.bind(r),e.Timers.TIMER_J),this.transport.send(n)?s.resolve():(this.onTransportError(),s.reject());break;case i.STATUS_COMPLETED:}return s.promise};var a=function(e,t){this.type=i.INVITE_SERVER,this.id=e.via_branch,this.request=e,this.transport=e.transport,this.ua=t,this.last_response="",e.server_transaction=this,this.logger=t.getLogger("sip.transaction.ist",this.id),this.state=i.STATUS_PROCEEDING,t.newTransaction(this),this.resendProvisionalTimer=null,e.reply(100)};a.prototype=Object.create(e.EventEmitter.prototype),a.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},a.prototype.timer_H=function(){this.logger.log("Timer H expired for INVITE server transaction "+this.id),this.state===i.STATUS_COMPLETED&&this.logger.warn("transactions","ACK for INVITE server transaction was never received, call will be terminated"),this.stateChanged(i.STATUS_TERMINATED),this.ua.destroyTransaction(this)},a.prototype.timer_I=function(){this.stateChanged(i.STATUS_TERMINATED),this.ua.destroyTransaction(this)},a.prototype.timer_L=function(){this.logger.log("Timer L expired for INVITE server transaction "+this.id),this.state===i.STATUS_ACCEPTED&&(this.stateChanged(i.STATUS_TERMINATED),this.ua.destroyTransaction(this))},a.prototype.onTransportError=function(){this.transportError||(this.transportError=!0,this.logger.log("transport error occurred, deleting INVITE server transaction "+this.id),null!==this.resendProvisionalTimer&&(e.Timers.clearInterval(this.resendProvisionalTimer),this.resendProvisionalTimer=null),e.Timers.clearTimeout(this.L),e.Timers.clearTimeout(this.H),e.Timers.clearTimeout(this.I),this.stateChanged(i.STATUS_TERMINATED),this.ua.destroyTransaction(this))},a.prototype.resend_provisional=function(){this.transport.send(this.last_response)||this.onTransportError()},a.prototype.receiveResponse=function(t,n){var r=this,s=e.Utils.defer();if(t>=100&&199>=t)switch(this.state){case i.STATUS_PROCEEDING:this.transport.send(n)||this.onTransportError(),this.last_response=n}if(t>100&&199>=t&&this.state===i.STATUS_PROCEEDING)null===this.resendProvisionalTimer&&(this.resendProvisionalTimer=e.Timers.setInterval(r.resend_provisional.bind(r),e.Timers.PROVISIONAL_RESPONSE_INTERVAL));else if(t>=200&&299>=t)switch(this.state){case i.STATUS_PROCEEDING:this.stateChanged(i.STATUS_ACCEPTED),this.last_response=n,this.L=e.Timers.setTimeout(r.timer_L.bind(r),e.Timers.TIMER_L),null!==this.resendProvisionalTimer&&(e.Timers.clearInterval(this.resendProvisionalTimer),this.resendProvisionalTimer=null);case i.STATUS_ACCEPTED:this.transport.send(n)?s.resolve():(this.onTransportError(),s.reject())}else if(t>=300&&699>=t)switch(this.state){case i.STATUS_PROCEEDING:null!==this.resendProvisionalTimer&&(e.Timers.clearInterval(this.resendProvisionalTimer),this.resendProvisionalTimer=null),this.transport.send(n)?(this.stateChanged(i.STATUS_COMPLETED),this.H=e.Timers.setTimeout(r.timer_H.bind(r),e.Timers.TIMER_H),s.resolve()):(this.onTransportError(),s.reject())}return s.promise};var c=function(t,n){var r;switch(n.method){case e.C.INVITE:if(r=t.transactions.ist[n.via_branch]){switch(r.state){case i.STATUS_PROCEEDING:r.transport.send(r.last_response);break;case i.STATUS_ACCEPTED:}return!0}break;case e.C.ACK:if(r=t.transactions.ist[n.via_branch],!r)return!1;if(r.state===i.STATUS_ACCEPTED)return!1;if(r.state===i.STATUS_COMPLETED)return r.stateChanged(i.STATUS_CONFIRMED),r.I=e.Timers.setTimeout(r.timer_I.bind(r),e.Timers.TIMER_I),!0;break;case e.C.CANCEL:return r=t.transactions.ist[n.via_branch],r?(n.reply_sl(200),r.state!==i.STATUS_PROCEEDING):(n.reply_sl(481),!0);default:if(r=t.transactions.nist[n.via_branch]){switch(r.state){case i.STATUS_TRYING:break;case i.STATUS_PROCEEDING:case i.STATUS_COMPLETED:r.transport.send(r.last_response)}return!0}}};e.Transactions={C:i,checkTransaction:c,NonInviteClientTransaction:n,InviteClientTransaction:r,AckClientTransaction:s,NonInviteServerTransaction:o,InviteServerTransaction:a}}},{}],94:[function(e,t,i){"use strict";t.exports=function(e,t){function i(e){var t=.8*e;return 1e3*(Math.random()*(e-t)+t)}var n,r={STATUS_READY:0,STATUS_DISCONNECTED:1,STATUS_ERROR:2};return n=function(e,t){this.logger=e.getLogger("sip.transport"),this.ua=e,this.ws=null,this.server=t,this.reconnection_attempts=0,this.closed=!1,this.connected=!1,this.reconnectTimer=null,this.lastTransportError={},this.keepAliveInterval=e.configuration.keepAliveInterval,this.keepAliveTimeout=null,this.keepAliveTimer=null,this.ua.transport=this,this.connect()},n.prototype={send:function(e){var i=e.toString();return this.ws&&this.ws.readyState===t.OPEN?(this.ua.configuration.traceSip===!0&&this.logger.log("sending WebSocket message:\n\n"+i+"\n"),this.ws.send(i),!0):(this.logger.warn("unable to send message, WebSocket is not open"),!1)},sendKeepAlive:function(){return this.keepAliveTimeout?void 0:(this.keepAliveTimeout=e.Timers.setTimeout(function(){this.ua.emit("keepAliveTimeout")}.bind(this),1e4),this.send("\r\n\r\n"))},startSendingKeepAlives:function(){this.keepAliveInterval&&!this.keepAliveTimer&&(this.keepAliveTimer=e.Timers.setTimeout(function(){this.sendKeepAlive(),this.keepAliveTimer=null,this.startSendingKeepAlives()}.bind(this),i(this.keepAliveInterval)))},stopSendingKeepAlives:function(){e.Timers.clearTimeout(this.keepAliveTimer),e.Timers.clearTimeout(this.keepAliveTimeout),this.keepAliveTimer=null,this.keepAliveTimeout=null},disconnect:function(){this.ws&&(e.Timers.clearTimeout(this.reconnectTimer),this.stopSendingKeepAlives(),this.closed=!0,this.logger.log("closing WebSocket "+this.server.ws_uri),this.ws.close()),null!==this.reconnectTimer&&(e.Timers.clearTimeout(this.reconnectTimer),this.reconnectTimer=null,this.ua.emit("disconnected",{transport:this,code:this.lastTransportError.code,reason:this.lastTransportError.reason}))},connect:function(){var e=this;if(this.ws&&(this.ws.readyState===t.OPEN||this.ws.readyState===t.CONNECTING))return this.logger.log("WebSocket "+this.server.ws_uri+" is already connected"),!1;this.ws&&this.ws.close(),this.logger.log("connecting to WebSocket "+this.server.ws_uri),this.ua.onTransportConnecting(this,0===this.reconnection_attempts?1:this.reconnection_attempts);try{this.ws=new t(this.server.ws_uri,"sip")}catch(i){this.logger.warn("error connecting to WebSocket "+this.server.ws_uri+": "+i)}this.ws.binaryType="arraybuffer",this.ws.onopen=function(){e.onOpen()},this.ws.onclose=function(t){e.onClose(t)},this.ws.onmessage=function(t){e.onMessage(t)},this.ws.onerror=function(t){e.onError(t)}},onOpen:function(){this.connected=!0,this.logger.log("WebSocket "+this.server.ws_uri+" connected"),null!==this.reconnectTimer&&(e.Timers.clearTimeout(this.reconnectTimer),this.reconnectTimer=null),this.reconnection_attempts=0,this.closed=!1,this.ua.onTransportConnected(this),this.startSendingKeepAlives()},onClose:function(e){var t=this.connected;this.lastTransportError.code=e.code,this.lastTransportError.reason=e.reason,this.stopSendingKeepAlives(),this.reconnection_attempts>0?(this.logger.log("Reconnection attempt "+this.reconnection_attempts+" failed (code: "+e.code+(e.reason?"| reason: "+e.reason:"")+")"),this.reconnect()):(this.connected=!1,this.logger.log("WebSocket disconnected (code: "+e.code+(e.reason?"| reason: "+e.reason:"")+")"),e.wasClean===!1&&this.logger.warn("WebSocket abrupt disconnection"),t===!0?(this.ua.onTransportClosed(this),this.closed?this.ua.emit("disconnected",{transport:this,code:this.lastTransportError.code,reason:this.lastTransportError.reason}):this.reconnect()):this.ua.onTransportError(this))},onMessage:function(t){var i,n,r=t.data;if("\r\n"===r)return e.Timers.clearTimeout(this.keepAliveTimeout),this.keepAliveTimeout=null,void(this.ua.configuration.traceSip===!0&&this.logger.log("received WebSocket message with CRLF Keep Alive response"));if("string"!=typeof r){try{r=String.fromCharCode.apply(null,new Uint8Array(r))}catch(s){return void this.logger.warn("received WebSocket binary message failed to be converted into string, message discarded")}this.ua.configuration.traceSip===!0&&this.logger.log("received WebSocket binary message:\n\n"+r+"\n")}else this.ua.configuration.traceSip===!0&&this.logger.log("received WebSocket text message:\n\n"+r+"\n");if(i=e.Parser.parseMessage(r,this.ua),i&&!(this.ua.status===e.UA.C.STATUS_USER_CLOSED&&i instanceof e.IncomingRequest)&&e.sanityCheck(i,this.ua,this))if(i instanceof e.IncomingRequest)i.transport=this,this.ua.receiveRequest(i);else if(i instanceof e.IncomingResponse)switch(i.method){case e.C.INVITE:n=this.ua.transactions.ict[i.via_branch],n&&n.receiveResponse(i);break;case e.C.ACK:break;default:n=this.ua.transactions.nict[i.via_branch],n&&n.receiveResponse(i)}},onError:function(e){this.logger.warn("WebSocket connection error: "+JSON.stringify(e))},reconnect:function(){var t=this;this.reconnection_attempts+=1,this.reconnection_attempts>this.ua.configuration.wsServerMaxReconnection?(this.logger.warn("maximum reconnection attempts for WebSocket "+this.server.ws_uri),this.ua.onTransportError(this)):1===this.reconnection_attempts?(this.logger.log("Connection to WebSocket "+this.server.ws_uri+" severed, attempting first reconnect"),t.connect()):(this.logger.log("trying to reconnect to WebSocket "+this.server.ws_uri+" (reconnection attempt "+this.reconnection_attempts+")"),this.reconnectTimer=e.Timers.setTimeout(function(){t.connect(),t.reconnectTimer=null},1e3*this.ua.configuration.wsServerReconnectionTimeout))}},n.C=r,n}},{}],95:[function(e,t,i){(function(e){"use strict";t.exports=function(t,i){function n(e){return e instanceof Function?(e.initialize||(e.initialize=function(){return t.Utils.Promise.resolve()}),e):void 0}var r,s={STATUS_INIT:0,STATUS_STARTING:1,STATUS_READY:2,STATUS_USER_CLOSED:3,STATUS_NOT_READY:4,CONFIGURATION_ERROR:1,NETWORK_ERROR:2,ALLOWED_METHODS:["ACK","CANCEL","INVITE","MESSAGE","BYE","OPTIONS","INFO","NOTIFY","REFER"],ACCEPTED_BODY_TYPES:["application/sdp","application/dtmf-relay"],MAX_FORWARDS:70,TAG_LENGTH:10};r=function(n){function r(e){return o.emit.bind(o,e)}var o=this;s.ACCEPTED_BODY_TYPES=s.ACCEPTED_BODY_TYPES.toString(),this.log=new t.LoggerFactory,this.logger=this.getLogger("sip.ua"),this.cache={credentials:{}},this.configuration={},this.dialogs={},this.applicants={},this.data={},this.sessions={},this.subscriptions={},this.transport=null,this.contact=null,this.status=s.STATUS_INIT,this.error=null,this.transactions={nist:{},nict:{},ist:{},ict:{}},this.transportRecoverAttempts=0,this.transportRecoveryTimer=null,Object.defineProperties(this,{transactionsCount:{get:function(){var e,t=["nist","nict","ist","ict"],i=0;for(e in t)i+=Object.keys(this.transactions[t[e]]).length;return i}},nictTransactionsCount:{get:function(){return Object.keys(this.transactions.nict).length}},nistTransactionsCount:{get:function(){return Object.keys(this.transactions.nist).length}},ictTransactionsCount:{get:function(){return Object.keys(this.transactions.ict).length}},istTransactionsCount:{get:function(){return Object.keys(this.transactions.ist).length}}}),void 0===n?n={}:("string"==typeof n||n instanceof String)&&(n={uri:n}),n.log&&(n.log.hasOwnProperty("builtinEnabled")&&(this.log.builtinEnabled=n.log.builtinEnabled),n.log.hasOwnProperty("level")&&(this.log.level=n.log.level),n.log.hasOwnProperty("connector")&&(this.log.connector=n.log.connector));try{this.loadConfig(n)}catch(a){throw this.status=s.STATUS_NOT_READY,this.error=s.CONFIGURATION_ERROR,a}this.registerContext=new t.RegisterContext(this),this.registerContext.on("failed",r("registrationFailed")),this.registerContext.on("registered",r("registered")),this.registerContext.on("unregistered",r("unregistered")),this.configuration.autostart&&this.start(),"function"==typeof i.addEventListener&&(e.chrome&&e.chrome.app&&e.chrome.app.runtime||i.addEventListener("unload",this.stop.bind(this)))},r.prototype=Object.create(t.EventEmitter.prototype),r.prototype.register=function(e){return this.configuration.register=!0,this.registerContext.register(e),this},r.prototype.unregister=function(e){this.configuration.register=!1;var t=this.registerContext;return this.afterConnected(t.unregister.bind(t,e)),this},r.prototype.isRegistered=function(){return this.registerContext.registered},r.prototype.isConnected=function(){return this.transport?this.transport.connected:!1},r.prototype.afterConnected=function(e){this.isConnected()?e():this.once("connected",e)},r.prototype.invite=function(e,i){var n=new t.InviteClientContext(this,e,i);return this.afterConnected(n.invite.bind(n)),n},r.prototype.subscribe=function(e,i,n){var r=new t.Subscription(this,e,i,n);return this.afterConnected(r.subscribe.bind(r)),r},r.prototype.message=function(e,i,n){if(void 0===i)throw new TypeError("Not enough arguments");return n=Object.create(n||Object.prototype),n.contentType||(n.contentType="text/plain"),n.body=i,this.request(t.C.MESSAGE,e,n)},r.prototype.request=function(e,i,n){var r=new t.ClientContext(this,e,i,n);return this.afterConnected(r.send.bind(r)),r},r.prototype.stop=function(){function e(){0===o.nistTransactionsCount&&0===o.nictTransactionsCount&&(o.removeListener("transactionDestroyed",e),o.transport.disconnect())}var i,n,r,o=this;if(this.logger.log("user requested closure..."),this.status===s.STATUS_USER_CLOSED)return this.logger.warn("UA already closed"),this;t.Timers.clearTimeout(this.transportRecoveryTimer),this.logger.log("closing registerContext"),this.registerContext.close();for(i in this.sessions)this.logger.log("closing session "+i),this.sessions[i].terminate();for(n in this.subscriptions)this.logger.log("unsubscribing from subscription "+n),this.subscriptions[n].close();for(r in this.applicants)this.applicants[r].close();return this.status=s.STATUS_USER_CLOSED,0===this.nistTransactionsCount&&0===this.nictTransactionsCount?this.transport.disconnect():this.on("transactionDestroyed",e),this},r.prototype.start=function(){var e;return this.logger.log("user requested startup..."),this.status===s.STATUS_INIT?(e=this.getNextWsServer(),this.status=s.STATUS_STARTING,new t.Transport(this,e)):this.status===s.STATUS_USER_CLOSED?(this.logger.log("resuming"),this.status=s.STATUS_READY,this.transport.connect()):this.status===s.STATUS_STARTING?this.logger.log("UA is in STARTING status, not opening new connection"):this.status===s.STATUS_READY?this.logger.log("UA is in READY status, not resuming"):this.logger.error("Connection is down. Auto-Recovery system is trying to connect"),this},r.prototype.normalizeTarget=function(e){return t.Utils.normalizeTarget(e,this.configuration.hostportParams)},r.prototype.saveCredentials=function(e){return this.cache.credentials[e.realm]=this.cache.credentials[e.realm]||{},this.cache.credentials[e.realm][e.uri]=e,this},r.prototype.getCredentials=function(e){var t,i;return t=e.ruri.host,this.cache.credentials[t]&&this.cache.credentials[t][e.ruri]&&(i=this.cache.credentials[t][e.ruri],i.method=e.method),i},r.prototype.getLogger=function(e,t){return this.log.getLogger(e,t)},r.prototype.onTransportClosed=function(e){var i,n,r,s=["nict","ict","nist","ist"];for(e.server.status=t.Transport.C.STATUS_DISCONNECTED,this.logger.log("connection state set to "+t.Transport.C.STATUS_DISCONNECTED),r=s.length,i=0;r>i;i++)for(n in this.transactions[s[i]])this.transactions[s[i]][n].onTransportError();this.contact.pub_gruu||this.closeSessionsOnTransportError()},r.prototype.onTransportError=function(e){var i;this.logger.log("transport "+e.server.ws_uri+" failed | connection state set to "+t.Transport.C.STATUS_ERROR),e.server.status=t.Transport.C.STATUS_ERROR,this.emit("disconnected",{transport:e}),this.status!==s.STATUS_USER_CLOSED&&(i=this.getNextWsServer(),i?new t.Transport(this,i):(this.closeSessionsOnTransportError(),this.error&&this.error===s.NETWORK_ERROR||(this.status=s.STATUS_NOT_READY,this.error=s.NETWORK_ERROR),this.recoverTransport()))},r.prototype.onTransportConnected=function(e){this.transport=e,this.transportRecoverAttempts=0,e.server.status=t.Transport.C.STATUS_READY,this.logger.log("connection state set to "+t.Transport.C.STATUS_READY),this.status!==s.STATUS_USER_CLOSED&&(this.status=s.STATUS_READY,this.error=null,this.configuration.register&&this.configuration.authenticationFactory.initialize().then(function(){this.registerContext.onTransportConnected()}.bind(this)),this.emit("connected",{transport:e}))},r.prototype.onTransportConnecting=function(e,t){this.emit("connecting",{transport:e,attempts:t})},r.prototype.newTransaction=function(e){this.transactions[e.type][e.id]=e,this.emit("newTransaction",{transaction:e})},r.prototype.destroyTransaction=function(e){delete this.transactions[e.type][e.id],this.emit("transactionDestroyed",{transaction:e})},r.prototype.receiveRequest=function(e){function i(t){return t&&t.user===e.ruri.user}var n,r,o,a,c,u,l=e.method,h=this;if(!(i(this.configuration.uri)||i(this.contact.uri)||i(this.contact.pub_gruu)||i(this.contact.temp_gruu)))return this.logger.warn("Request-URI does not point to us"),void(e.method!==t.C.ACK&&e.reply_sl(404));if(e.ruri.scheme===t.C.SIPS)return void e.reply_sl(416);if(!t.Transactions.checkTransaction(this,e))if(l===t.C.OPTIONS?(new t.Transactions.NonInviteServerTransaction(e,this),e.reply(200,null,["Allow: "+t.UA.C.ALLOWED_METHODS.toString(),"Accept: "+s.ACCEPTED_BODY_TYPES])):l===t.C.MESSAGE?(o=new t.ServerContext(this,e),o.body=e.body,o.content_type=e.getHeader("Content-Type")||"text/plain",e.reply(200,null),this.emit("message",o)):l!==t.C.INVITE&&l!==t.C.ACK&&(a=new t.ServerContext(this,e)),e.to_tag)n=this.findDialog(e),n?(l===t.C.INVITE&&new t.Transactions.InviteServerTransaction(e,this),n.receiveRequest(e)):l===t.C.NOTIFY?(r=this.findSession(e),r?r.receiveRequest(e):(this.logger.warn("received NOTIFY request for a non existent session"),e.reply(481,"Subscription does not exist"))):l!==t.C.ACK&&e.reply(481);else switch(l){case t.C.INVITE:if(c=this.configuration.replaces!==t.C.supported.UNSUPPORTED&&e.parseHeader("replaces")){if(u=this.dialogs[c.call_id+c.replaces_to_tag+c.replaces_from_tag],!u)return void e.reply_sl(481,null);if(u.owner.status===t.Session.C.STATUS_TERMINATED)return void e.reply_sl(603,null);if(u.state===t.Dialog.C.STATUS_CONFIRMED&&c.early_only)return void e.reply_sl(486,null)}var d=this.configuration.mediaHandlerFactory.isSupported;!d||d()?(r=new t.InviteServerContext(this,e),
r.replacee=u&&u.owner,r.on("invite",function(){h.emit("invite",this)})):(this.logger.warn("INVITE received but WebRTC is not supported"),e.reply(488));break;case t.C.BYE:e.reply(481);break;case t.C.CANCEL:r=this.findSession(e),r?r.receiveRequest(e):this.logger.warn("received CANCEL request for a non existent session");break;case t.C.ACK:break;default:e.reply(405)}},r.prototype.findSession=function(e){return this.sessions[e.call_id+e.from_tag]||this.sessions[e.call_id+e.to_tag]||null},r.prototype.findDialog=function(e){return this.dialogs[e.call_id+e.from_tag+e.to_tag]||this.dialogs[e.call_id+e.to_tag+e.from_tag]||null},r.prototype.getNextWsServer=function(){var e,i,n,r=[];for(i=this.configuration.wsServers.length,e=0;i>e;e++)n=this.configuration.wsServers[e],n.status!==t.Transport.C.STATUS_ERROR&&(0===r.length?r.push(n):n.weight>r[0].weight?r=[n]:n.weight===r[0].weight&&r.push(n));return e=Math.floor(Math.random()*r.length),r[e]},r.prototype.closeSessionsOnTransportError=function(){var e;for(e in this.sessions)this.sessions[e].onTransportError();this.registerContext.onTransportClosed()},r.prototype.recoverTransport=function(e){var i,n,r,s,o,a;for(e=e||this,o=e.transportRecoverAttempts,n=e.configuration.wsServers.length,i=0;n>i;i++)e.configuration.wsServers[i].status=0;a=e.getNextWsServer(),r=Math.floor(Math.random()*Math.pow(2,o)+1),s=r*e.configuration.connectionRecoveryMinInterval,s>e.configuration.connectionRecoveryMaxInterval&&(this.logger.log("time for next connection attempt exceeds connectionRecoveryMaxInterval, resetting counter"),s=e.configuration.connectionRecoveryMinInterval,o=0),this.logger.log("next connection attempt in "+s+" seconds"),this.transportRecoveryTimer=t.Timers.setTimeout(function(){e.transportRecoverAttempts=o+1,new t.Transport(e,a)},1e3*s)},r.prototype.loadConfig=function(e){function i(t,i){var n=t.replace(/([a-z][A-Z])/g,function(e){return e[0]+"_"+e[1].toLowerCase()});if(t!==n){var r=e.hasOwnProperty(t);e.hasOwnProperty(n)&&(i.warn(n+" is deprecated, please use "+t),r&&i.warn(t+" overriding "+n)),e[t]=r?e[t]:e[n]}}var s,o,a,c,u,l={viaHost:t.Utils.createRandomToken(12)+".invalid",uri:new t.URI("sip","anonymous."+t.Utils.createRandomToken(6),"anonymous.invalid",null,null),wsServers:[{scheme:"WSS",sip_uri:"<sip:edge.sip.onsip.com;transport=ws;lr>",status:0,weight:0,ws_uri:"wss://edge.sip.onsip.com"}],password:null,registerExpires:600,register:!0,registrarServer:null,wsServerMaxReconnection:3,wsServerReconnectionTimeout:4,connectionRecoveryMinInterval:2,connectionRecoveryMaxInterval:30,keepAliveInterval:0,extraSupported:[],usePreloadedRoute:!1,userAgentString:t.C.USER_AGENT,iceCheckingTimeout:5e3,noAnswerTimeout:60,stunServers:["stun:stun.l.google.com:19302"],turnServers:[],traceSip:!1,hackViaTcp:!1,hackIpInContact:!1,hackWssInTransport:!1,hackAllowUnregisteredOptionTags:!1,contactTransport:"ws",forceRport:!1,autostart:!0,rel100:t.C.supported.UNSUPPORTED,replaces:t.C.supported.UNSUPPORTED,mediaHandlerFactory:t.WebRTC.MediaHandler.defaultFactory,authenticationFactory:n(function(e){return new t.DigestAuthentication(e)})};for(s in r.configuration_check.mandatory){if(i(s,this.logger),!e.hasOwnProperty(s))throw new t.Exceptions.ConfigurationError(s);if(o=e[s],a=r.configuration_check.mandatory[s](o),void 0===a)throw new t.Exceptions.ConfigurationError(s,o);l[s]=a}t.Utils.optionsOverride(e,"rel100","reliable",!0,this.logger,t.C.supported.UNSUPPORTED);var h=["stunServers","turnServers"];for(s in r.configuration_check.optional)if(i(s,this.logger),e.hasOwnProperty(s)){if(o=e[s],o instanceof Array&&0===o.length&&h.indexOf(s)<0)continue;if(null===o||""===o||void 0===o)continue;if("number"==typeof o&&isNaN(o))continue;if(a=r.configuration_check.optional[s](o),void 0===a)throw new t.Exceptions.ConfigurationError(s,o);l[s]=a}if(l.connectionRecoveryMaxInterval<l.connectionRecoveryMinInterval)throw new t.Exceptions.ConfigurationError("connectionRecoveryMaxInterval",l.connectionRecoveryMaxInterval);0===l.displayName&&(l.displayName="0"),l.instanceId||(l.instanceId=t.Utils.newUUID()),l.sipjsId=t.Utils.createRandomToken(5),c=l.uri.clone(),c.user=null,l.hostportParams=c.toRaw().replace(/^sip:/i,""),l.authorizationUser||(l.authorizationUser=l.uri.user),l.registrarServer||(u=l.uri.clone(),u.user=null,l.registrarServer=u),l.noAnswerTimeout=1e3*l.noAnswerTimeout,l.hackIpInContact&&("boolean"==typeof l.hackIpInContact?l.viaHost=t.Utils.getRandomTestNetIP():"string"==typeof l.hackIpInContact&&(l.viaHost=l.hackIpInContact)),l.hackWssInTransport&&(l.contactTransport="wss"),this.contact={pub_gruu:null,temp_gruu:null,uri:new t.URI("sip",t.Utils.createRandomToken(8),l.viaHost,null,{transport:l.contactTransport}),toString:function(e){e=e||{};var t=e.anonymous||null,i=e.outbound||null,n="<";return n+=t?(this.temp_gruu||"sip:anonymous@anonymous.invalid;transport="+l.contactTransport).toString():(this.pub_gruu||this.uri).toString(),i&&(n+=";ob"),n+=">"}},t.Utils.optionsOverride(l,"media","mediaConstraints",!0,this.logger);for(s in l)r.configuration_skeleton[s].value=l[s];Object.defineProperties(this.configuration,r.configuration_skeleton);for(s in l)r.configuration_skeleton[s].value="";this.logger.log("configuration parameters after validation:");for(s in l)switch(s){case"uri":case"registrarServer":case"mediaHandlerFactory":this.logger.log("\xb7 "+s+": "+l[s]);break;case"password":this.logger.log("\xb7 "+s+": NOT SHOWN");break;default:this.logger.log("\xb7 "+s+": "+JSON.stringify(l[s]))}},r.configuration_skeleton=function(){var e,t,i={},n=["sipjsId","hostportParams","uri","wsServers","authorizationUser","connectionRecoveryMaxInterval","connectionRecoveryMinInterval","keepAliveInterval","extraSupported","displayName","hackViaTcp","hackIpInContact","hackWssInTransport","hackAllowUnregisteredOptionTags","contactTransport","forceRport","iceCheckingTimeout","instanceId","noAnswerTimeout","password","registerExpires","registrarServer","reliable","rel100","replaces","userAgentString","autostart","stunServers","traceSip","turnServers","usePreloadedRoute","wsServerMaxReconnection","wsServerReconnectionTimeout","mediaHandlerFactory","media","mediaConstraints","authenticationFactory","via_core_value","viaHost"];for(e in n)t=n[e],i[t]={value:"",writable:!1,configurable:!1};return i.register={value:"",writable:!0,configurable:!1},i}(),r.configuration_check={mandatory:{},optional:{uri:function(e){var i;return/^sip:/i.test(e)||(e=t.C.SIP+":"+e),i=t.URI.parse(e),i&&i.user?i:void 0},wsServers:function(e){var i,n,r;if("string"==typeof e)e=[{ws_uri:e}];else{if(!(e instanceof Array))return;for(n=e.length,i=0;n>i;i++)"string"==typeof e[i]&&(e[i]={ws_uri:e[i]})}if(0===e.length)return!1;for(n=e.length,i=0;n>i;i++){if(!e[i].ws_uri)return;if(e[i].weight&&!Number(e[i].weight))return;if(r=t.Grammar.parse(e[i].ws_uri,"absoluteURI"),-1===r)return;if(["wss","ws","udp"].indexOf(r.scheme)<0)return;e[i].sip_uri="<sip:"+r.host+(r.port?":"+r.port:"")+";transport="+r.scheme.replace(/^wss$/i,"ws")+";lr>",e[i].weight||(e[i].weight=0),e[i].status=0,e[i].scheme=r.scheme.toUpperCase()}return e},authorizationUser:function(e){return-1===t.Grammar.parse('"'+e+'"',"quoted_string")?void 0:e},connectionRecoveryMaxInterval:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},connectionRecoveryMinInterval:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},displayName:function(e){return-1===t.Grammar.parse('"'+e+'"',"displayName")?void 0:e},hackViaTcp:function(e){return"boolean"==typeof e?e:void 0},hackIpInContact:function(e){return"boolean"==typeof e?e:"string"==typeof e&&-1!==t.Grammar.parse(e,"host")?e:void 0},iceCheckingTimeout:function(e){return t.Utils.isDecimal(e)?Math.max(500,e):void 0},hackWssInTransport:function(e){return"boolean"==typeof e?e:void 0},hackAllowUnregisteredOptionTags:function(e){return"boolean"==typeof e?e:void 0},contactTransport:function(e){return"string"==typeof e?e:void 0},forceRport:function(e){return"boolean"==typeof e?e:void 0},instanceId:function(e){return"string"==typeof e?(/^uuid:/i.test(e)&&(e=e.substr(5)),-1===t.Grammar.parse(e,"uuid")?void 0:e):void 0},keepAliveInterval:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},extraSupported:function(e){var t,i;if(e instanceof Array){for(i=e.length,t=0;i>t;t++)if("string"!=typeof e[t])return;return e}},noAnswerTimeout:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},password:function(e){return String(e)},rel100:function(e){return e===t.C.supported.REQUIRED?t.C.supported.REQUIRED:e===t.C.supported.SUPPORTED?t.C.supported.SUPPORTED:t.C.supported.UNSUPPORTED},replaces:function(e){return e===t.C.supported.REQUIRED?t.C.supported.REQUIRED:e===t.C.supported.SUPPORTED?t.C.supported.SUPPORTED:t.C.supported.UNSUPPORTED},register:function(e){return"boolean"==typeof e?e:void 0},registerExpires:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},registrarServer:function(e){var i;if("string"==typeof e)return/^sip:/i.test(e)||(e=t.C.SIP+":"+e),i=t.URI.parse(e),i?i.user?void 0:i:void 0},stunServers:function(e){var i,n,r;if("string"==typeof e)e=[e];else if(!(e instanceof Array))return;for(n=e.length,i=0;n>i;i++){if(r=e[i],/^stuns?:/.test(r)||(r="stun:"+r),-1===t.Grammar.parse(r,"stun_URI"))return;e[i]=r}return e},traceSip:function(e){return"boolean"==typeof e?e:void 0},turnServers:function(e){var i,n,r,s,o,a;for(e instanceof Array||(e=[e]),r=e.length,i=0;r>i;i++){if(s=e[i],s.server&&(s.urls=[s.server]),!s.urls||!s.username||!s.password)return;for(s.urls instanceof Array?o=s.urls.length:(s.urls=[s.urls],o=1),n=0;o>n;n++)if(a=s.urls[n],/^turns?:/.test(a)||(a="turn:"+a),-1===t.Grammar.parse(a,"turn_URI"))return}return e},userAgentString:function(e){return"string"==typeof e?e:void 0},usePreloadedRoute:function(e){return"boolean"==typeof e?e:void 0},wsServerMaxReconnection:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},wsServerReconnectionTimeout:function(e){var i;return t.Utils.isDecimal(e)&&(i=Number(e),i>0)?i:void 0},autostart:function(e){return"boolean"==typeof e?e:void 0},mediaHandlerFactory:function(e){if(e instanceof Function){var i=function(){function i(e){var i=n[e];if(i.length>1){var r="getDescription"===e;n[e]=t.Utils.promisify(n,e,r)}}var n=e.apply(this,arguments);return i("getDescription"),i("setDescription"),n};return i.isSupported=e.isSupported,i}},authenticationFactory:n}},r.C=s,t.UA=r}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],96:[function(e,t,i){"use strict";t.exports=function(e){var t;t=function(t,i,n,r,s,o){var a,c,u,l;if(!n)throw new TypeError('missing or invalid "host" parameter');t=t||e.C.SIP,this.parameters={},this.headers={};for(a in s)this.setParam(a,s[a]);for(c in o)this.setHeader(c,o[c]);u={scheme:t,user:i,host:n,port:r},l={scheme:t.toLowerCase(),user:i,host:n.toLowerCase(),port:r},Object.defineProperties(this,{_normal:{get:function(){return l}},_raw:{get:function(){return u}},scheme:{get:function(){return l.scheme},set:function(e){u.scheme=e,l.scheme=e.toLowerCase()}},user:{get:function(){return l.user},set:function(e){l.user=u.user=e}},host:{get:function(){return l.host},set:function(e){u.host=e,l.host=e.toLowerCase()}},aor:{get:function(){return l.user+"@"+l.host}},port:{get:function(){return l.port},set:function(e){l.port=u.port=0===e?e:parseInt(e,10)||null}}})},t.prototype={setParam:function(e,t){e&&(this.parameters[e.toLowerCase()]="undefined"==typeof t||null===t?null:t.toString().toLowerCase())},getParam:function(e){return e?this.parameters[e.toLowerCase()]:void 0},hasParam:function(e){return e?this.parameters.hasOwnProperty(e.toLowerCase())&&!0||!1:void 0},deleteParam:function(e){var t;return e=e.toLowerCase(),this.parameters.hasOwnProperty(e)?(t=this.parameters[e],delete this.parameters[e],t):void 0},clearParams:function(){this.parameters={}},setHeader:function(t,i){this.headers[e.Utils.headerize(t)]=i instanceof Array?i:[i]},getHeader:function(t){return t?this.headers[e.Utils.headerize(t)]:void 0},hasHeader:function(t){return t?this.headers.hasOwnProperty(e.Utils.headerize(t))&&!0||!1:void 0},deleteHeader:function(t){var i;return t=e.Utils.headerize(t),this.headers.hasOwnProperty(t)?(i=this.headers[t],delete this.headers[t],i):void 0},clearHeaders:function(){this.headers={}},clone:function(){return new t(this._raw.scheme,this._raw.user,this._raw.host,this._raw.port,JSON.parse(JSON.stringify(this.parameters)),JSON.parse(JSON.stringify(this.headers)))},toRaw:function(){return this._toString(this._raw)},toString:function(){return this._toString(this._normal)},_toString:function(t){var i,n,r,s,o=[];s=t.scheme+":",t.scheme.toLowerCase().match("^sips?$")||(s+="//"),t.user&&(s+=e.Utils.escapeUser(t.user)+"@"),s+=t.host,(t.port||0===t.port)&&(s+=":"+t.port);for(n in this.parameters)s+=";"+n,null!==this.parameters[n]&&(s+="="+this.parameters[n]);for(i in this.headers)for(r in this.headers[i])o.push(i+"="+this.headers[i][r]);return o.length>0&&(s+="?"+o.join("&")),s}},t.parse=function(t){return t=e.Grammar.parse(t,"SIP_URI"),-1!==t?t:void 0},e.URI=t}},{}],97:[function(e,t,i){"use strict";t.exports=function(e,t){var i;i={Promise:t.Promise,defer:function(){var e={};return e.promise=new i.Promise(function(t,i){e.resolve=t,e.reject=i}),e},promisify:function(e,t,n){var r=e[t];return function(t,s,o){return new i.Promise(function(i,s){var o=[t,i,s];n&&(o=[i,s,t]),r.apply(e,o)}).then(s,o)}},augment:function(e,t,i,n){var r,s;s=t.prototype;for(r in s)(n||void 0===e[r])&&(e[r]=s[r]);t.apply(e,i)},optionsOverride:function(e,t,i,n,r,s){n&&e[i]&&r.warn(i+" is deprecated, please use "+t+" instead"),e[t]&&e[i]&&r.warn(t+" overriding "+i),e[t]=e[t]||e[i]||s},str_utf8_length:function(e){return encodeURIComponent(e).replace(/%[A-F\d]{2}/g,"U").length},generateFakeSDP:function(e){if(e){var t=e.indexOf("o="),i=e.indexOf("\r\n",t);return"v=0\r\n"+e.slice(t,i)+"\r\ns=-\r\nt=0 0\r\nc=IN IP4 0.0.0.0"}},isFunction:function(e){return void 0!==e?"[object Function]"===Object.prototype.toString.call(e):!1},isDecimal:function(e){return!isNaN(e)&&parseFloat(e)===parseInt(e,10)},createRandomToken:function(e,t){var i,n,r="";for(t=t||32,i=0;e>i;i++)n=Math.random()*t|0,r+=n.toString(t);return r},newTag:function(){return e.Utils.createRandomToken(e.UA.C.TAG_LENGTH)},newUUID:function(){var e="xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0,i="x"===e?t:3&t|8;return i.toString(16)});return e},hostType:function(t){return t?(t=e.Grammar.parse(t,"host"),-1!==t?t.host_type:void 0):void 0},normalizeTarget:function(t,i){var n,r,s,o;if(t){if(t instanceof e.URI)return t;if("string"==typeof t){switch(r=t.split("@"),r.length){case 1:if(!i)return;s=t,o=i;break;case 2:s=r[0],o=r[1];break;default:s=r.slice(0,r.length-1).join("@"),o=r[r.length-1]}return s=s.replace(/^(sips?|tel):/i,""),/^[\-\.\(\)]*\+?[0-9\-\.\(\)]+$/.test(s)&&(s=s.replace(/[\-\.\(\)]/g,"")),t=e.C.SIP+":"+e.Utils.escapeUser(s)+"@"+o,(n=e.URI.parse(t))?n:void 0}}else;},escapeUser:function(e){return encodeURIComponent(decodeURIComponent(e)).replace(/%3A/gi,":").replace(/%2B/gi,"+").replace(/%3F/gi,"?").replace(/%2F/gi,"/")},headerize:function(e){var t,i={"Call-Id":"Call-ID",Cseq:"CSeq","Min-Se":"Min-SE",Rack:"RAck",Rseq:"RSeq","Www-Authenticate":"WWW-Authenticate"},n=e.toLowerCase().replace(/_/g,"-").split("-"),r="",s=n.length;for(t=0;s>t;t++)0!==t&&(r+="-"),r+=n[t].charAt(0).toUpperCase()+n[t].substring(1);return i[r]&&(r=i[r]),r},sipErrorCause:function(t){var i;for(i in e.C.SIP_ERROR_CAUSES)if(-1!==e.C.SIP_ERROR_CAUSES[i].indexOf(t))return e.C.causes[i];return e.C.causes.SIP_FAILURE_CODE},getReasonPhrase:function(t,i){return i||e.C.REASON_PHRASE[t]||""},getReasonHeaderValue:function(t,i){return i=e.Utils.getReasonPhrase(t,i),"SIP ;cause="+t+' ;text="'+i+'"'},getCancelReason:function(t,i){if(t&&200>t||t>699)throw new TypeError("Invalid status_code: "+t);return t?e.Utils.getReasonHeaderValue(t,i):void 0},buildStatusLine:function(e,t){if(e=e||null,t=t||null,!e||100>e||e>699)throw new TypeError("Invalid status_code: "+e);if(t&&"string"!=typeof t&&!(t instanceof String))throw new TypeError("Invalid reason_phrase: "+t);return t=i.getReasonPhrase(e,t),"SIP/2.0 "+e+" "+t+"\r\n"},getRandomTestNetIP:function(){function e(e,t){return Math.floor(Math.random()*(t-e+1)+e)}return"192.0.2."+e(1,254)},calculateMD5:function(e){function t(e,t){return e<<t|e>>>32-t}function i(e,t){var i,n,r,s,o;return r=2147483648&e,s=2147483648&t,i=1073741824&e,n=1073741824&t,o=(1073741823&e)+(1073741823&t),i&n?2147483648^o^r^s:i|n?1073741824&o?3221225472^o^r^s:1073741824^o^r^s:o^r^s}function n(e,t,i){return e&t|~e&i}function r(e,t,i){return e&i|t&~i}function s(e,t,i){return e^t^i}function o(e,t,i){return t^(e|~i)}function a(e,r,s,o,a,c,u){return e=i(e,i(i(n(r,s,o),a),u)),i(t(e,c),r)}function c(e,n,s,o,a,c,u){return e=i(e,i(i(r(n,s,o),a),u)),i(t(e,c),n)}function u(e,n,r,o,a,c,u){return e=i(e,i(i(s(n,r,o),a),u)),i(t(e,c),n)}function l(e,n,r,s,a,c,u){return e=i(e,i(i(o(n,r,s),a),u)),i(t(e,c),n)}function h(e){for(var t,i=e.length,n=i+8,r=(n-n%64)/64,s=16*(r+1),o=Array(s-1),a=0,c=0;i>c;)t=(c-c%4)/4,a=c%4*8,o[t]=o[t]|e.charCodeAt(c)<<a,c++;return t=(c-c%4)/4,a=c%4*8,o[t]=o[t]|128<<a,o[s-2]=i<<3,o[s-1]=i>>>29,o}function d(e){var t,i,n="",r="";for(i=0;3>=i;i++)t=e>>>8*i&255,r="0"+t.toString(16),n+=r.substr(r.length-2,2);return n}function p(e){e=e.replace(/\r\n/g,"\n");for(var t="",i=0;i<e.length;i++){var n=e.charCodeAt(i);128>n?t+=String.fromCharCode(n):n>127&&2048>n?(t+=String.fromCharCode(n>>6|192),t+=String.fromCharCode(63&n|128)):(t+=String.fromCharCode(n>>12|224),t+=String.fromCharCode(n>>6&63|128),t+=String.fromCharCode(63&n|128))}return t}var f,g,m,v,_,T,E,y,S,C=[],R=7,A=12,I=17,b=22,w=5,D=9,N=14,O=20,k=4,U=11,$=16,X=23,P=6,x=10,M=15,L=21;for(e=p(e),C=h(e),T=1732584193,E=4023233417,y=2562383102,S=271733878,f=0;f<C.length;f+=16)g=T,m=E,v=y,_=S,T=a(T,E,y,S,C[f+0],R,3614090360),S=a(S,T,E,y,C[f+1],A,3905402710),y=a(y,S,T,E,C[f+2],I,606105819),E=a(E,y,S,T,C[f+3],b,3250441966),T=a(T,E,y,S,C[f+4],R,4118548399),S=a(S,T,E,y,C[f+5],A,1200080426),y=a(y,S,T,E,C[f+6],I,2821735955),E=a(E,y,S,T,C[f+7],b,4249261313),T=a(T,E,y,S,C[f+8],R,1770035416),S=a(S,T,E,y,C[f+9],A,2336552879),y=a(y,S,T,E,C[f+10],I,4294925233),E=a(E,y,S,T,C[f+11],b,2304563134),T=a(T,E,y,S,C[f+12],R,1804603682),S=a(S,T,E,y,C[f+13],A,4254626195),y=a(y,S,T,E,C[f+14],I,2792965006),E=a(E,y,S,T,C[f+15],b,1236535329),T=c(T,E,y,S,C[f+1],w,4129170786),S=c(S,T,E,y,C[f+6],D,3225465664),y=c(y,S,T,E,C[f+11],N,643717713),E=c(E,y,S,T,C[f+0],O,3921069994),T=c(T,E,y,S,C[f+5],w,3593408605),S=c(S,T,E,y,C[f+10],D,38016083),y=c(y,S,T,E,C[f+15],N,3634488961),E=c(E,y,S,T,C[f+4],O,3889429448),T=c(T,E,y,S,C[f+9],w,568446438),S=c(S,T,E,y,C[f+14],D,3275163606),y=c(y,S,T,E,C[f+3],N,4107603335),E=c(E,y,S,T,C[f+8],O,1163531501),T=c(T,E,y,S,C[f+13],w,2850285829),S=c(S,T,E,y,C[f+2],D,4243563512),y=c(y,S,T,E,C[f+7],N,1735328473),E=c(E,y,S,T,C[f+12],O,2368359562),T=u(T,E,y,S,C[f+5],k,4294588738),S=u(S,T,E,y,C[f+8],U,2272392833),y=u(y,S,T,E,C[f+11],$,1839030562),E=u(E,y,S,T,C[f+14],X,4259657740),T=u(T,E,y,S,C[f+1],k,2763975236),S=u(S,T,E,y,C[f+4],U,1272893353),y=u(y,S,T,E,C[f+7],$,4139469664),E=u(E,y,S,T,C[f+10],X,3200236656),T=u(T,E,y,S,C[f+13],k,681279174),S=u(S,T,E,y,C[f+0],U,3936430074),y=u(y,S,T,E,C[f+3],$,3572445317),E=u(E,y,S,T,C[f+6],X,76029189),T=u(T,E,y,S,C[f+9],k,3654602809),S=u(S,T,E,y,C[f+12],U,3873151461),y=u(y,S,T,E,C[f+15],$,530742520),E=u(E,y,S,T,C[f+2],X,3299628645),T=l(T,E,y,S,C[f+0],P,4096336452),S=l(S,T,E,y,C[f+7],x,1126891415),y=l(y,S,T,E,C[f+14],M,2878612391),E=l(E,y,S,T,C[f+5],L,4237533241),T=l(T,E,y,S,C[f+12],P,1700485571),S=l(S,T,E,y,C[f+3],x,2399980690),y=l(y,S,T,E,C[f+10],M,4293915773),E=l(E,y,S,T,C[f+1],L,2240044497),T=l(T,E,y,S,C[f+8],P,1873313359),S=l(S,T,E,y,C[f+15],x,4264355552),y=l(y,S,T,E,C[f+6],M,2734768916),E=l(E,y,S,T,C[f+13],L,1309151649),T=l(T,E,y,S,C[f+4],P,4149444226),S=l(S,T,E,y,C[f+11],x,3174756917),y=l(y,S,T,E,C[f+2],M,718787259),E=l(E,y,S,T,C[f+9],L,3951481745),T=i(T,g),E=i(E,m),y=i(y,v),S=i(S,_);var H=d(T)+d(E)+d(y)+d(S);return H.toLowerCase()},getDescriptionHeaders:function(e){var t=["Content-Type: "+e.contentType];return e.extraHeaders&&(t=t.concat(e.extraHeaders)),t}},e.Utils=i}},{}],98:[function(e,t,i){"use strict";t.exports=function(t,i){var n;n={},n.MediaHandler=e("./WebRTC/MediaHandler")(t),n.MediaStreamManager=e("./WebRTC/MediaStreamManager")(t,i);var r;return n.isSupported=function(){return void 0!==r?r:(n.MediaStream=i.MediaStream,n.getUserMedia=i.getUserMedia,n.RTCPeerConnection=i.RTCPeerConnection,n.RTCSessionDescription=i.RTCSessionDescription,n.RTCPeerConnection&&n.RTCSessionDescription?(n.getUserMedia&&(n.getUserMedia=t.Utils.promisify(i,"getUserMedia")),r=!0):r=!1,r)},n}},{"./WebRTC/MediaHandler":99,"./WebRTC/MediaStreamManager":100}],99:[function(e,t,i){"use strict";t.exports=function(e){var t=function(t,i){function n(e,t){e.mediaStreamManager.on&&e.mediaStreamManager.on(t,function(){e.emit.apply(e,[t].concat(Array.prototype.slice.call(arguments)))})}i=i||{},this.logger=t.ua.getLogger("sip.invitecontext.mediahandler",t.id),this.session=t,this.localMedia=null,this.ready=!0,this.mediaStreamManager=i.mediaStreamManager||new e.WebRTC.MediaStreamManager(this.logger),this.audioMuted=!1,this.videoMuted=!1,this.local_hold=!1,this.remote_hold=!1;var r=this.prepareIceServers(i.stunServers,i.turnServers);this.RTCConstraints=i.RTCConstraints||{},this.initPeerConnection(r,this.RTCConstraints),n(this,"userMediaRequest"),n(this,"userMedia"),n(this,"userMediaFailed")};return t.defaultFactory=function(e,i){return new t(e,i)},t.defaultFactory.isSupported=function(){return e.WebRTC.isSupported()},t.prototype=Object.create(e.MediaHandler.prototype,{isReady:{writable:!0,value:function(){return this.ready}},close:{writable:!0,value:function(){this.logger.log("closing PeerConnection"),this._remoteStreams=[],this.peerConnection&&"closed"!==this.peerConnection.signalingState&&(this.peerConnection.close(),this.localMedia&&this.mediaStreamManager.release(this.localMedia))}},getDescription:{writable:!0,value:function(t){var i=this,n=i.mediaStreamManager.acquire;n.length>1&&(n=e.Utils.promisify(this.mediaStreamManager,"acquire",!0)),t=t||{},t.dataChannel===!0&&(t.dataChannel={}),this.mediaHint=t;var r;return i.localMedia?(i.logger.log("already have local media"),r=e.Utils.Promise.resolve(i.localMedia)):(i.logger.log("acquiring local media"),r=n.call(i.mediaStreamManager,t).then(function(e){return i.logger.log("acquired local media streams"),i.localMedia=e,i.session.connecting(),e},function(e){throw i.logger.error("unable to acquire streams"),i.logger.error(e),i.session.connecting(),e}).then(this.addStreams.bind(this))),r.then(function(){return i.hasOffer("remote")?i.peerConnection.ondatachannel=function(e){i.dataChannel=e.channel,i.emit("dataChannel",i.dataChannel)}:t.dataChannel&&i.peerConnection.createDataChannel&&(i.dataChannel=i.peerConnection.createDataChannel("sipjs",t.dataChannel),i.emit("dataChannel",i.dataChannel)),i.render(),i.createOfferOrAnswer(i.RTCConstraints)}).then(function(t){return t=e.Hacks.Firefox.hasMissingCLineInSDP(t),i.local_hold&&(/a=(sendrecv|sendonly|recvonly|inactive)/.test(t)?(t=t.replace(/a=sendrecv\r\n/g,"a=sendonly\r\n"),t=t.replace(/a=recvonly\r\n/g,"a=inactive\r\n")):t=t.replace(/(m=[^\r]*\r\n)/g,"$1a=sendonly\r\n")),{body:t,contentType:"application/sdp"}})}},hasDescription:{writeable:!0,value:function(e){return"application/sdp"===e.getHeader("Content-Type")&&!!e.body}},setDescription:{writable:!0,value:function(t){var i=t.body;this.remote_hold=/a=(sendonly|inactive)/.test(i),i=e.Hacks.Firefox.cannotHandleExtraWhitespace(i),i=e.Hacks.AllBrowsers.maskDtls(i);var n={type:this.hasOffer("local")?"answer":"offer",sdp:i};this.emit("setDescription",n);var r=new e.WebRTC.RTCSessionDescription(n);return e.Utils.promisify(this.peerConnection,"setRemoteDescription")(r)}},getReferMedia:{writable:!0,value:function(){function e(e,t){return t[e]().length>0}function t(t){return this.getLocalStreams().some(e.bind(null,t))&&this.getRemoteStreams().some(e.bind(null,t))}return{constraints:{audio:t.call(this,"getAudioTracks"),video:t.call(this,"getVideoTracks")}}}},updateIceServers:{writeable:!0,value:function(e){var t=this.prepareIceServers(e.stunServers,e.turnServers);this.RTCConstraints=e.RTCConstraints||this.RTCConstraints,this.initPeerConnection(t,this.RTCConstraints)}},isMuted:{writable:!0,value:function(){return{audio:this.audioMuted,video:this.videoMuted}}},mute:{writable:!0,value:function(e){if(0!==this.getLocalStreams().length){e=e||{audio:this.getLocalStreams()[0].getAudioTracks().length>0,video:this.getLocalStreams()[0].getVideoTracks().length>0};var t=!1,i=!1;return e.audio&&!this.audioMuted&&(t=!0,this.audioMuted=!0,this.toggleMuteAudio(!0)),e.video&&!this.videoMuted&&(i=!0,this.videoMuted=!0,this.toggleMuteVideo(!0)),t||i?{audio:t,video:i}:void 0}}},unmute:{writable:!0,value:function(e){if(0!==this.getLocalStreams().length){e=e||{audio:this.getLocalStreams()[0].getAudioTracks().length>0,video:this.getLocalStreams()[0].getVideoTracks().length>0};var t=!1,i=!1;return e.audio&&this.audioMuted&&(t=!0,this.audioMuted=!1,this.toggleMuteAudio(!1)),e.video&&this.videoMuted&&(i=!0,this.videoMuted=!1,this.toggleMuteVideo(!1)),t||i?{audio:t,video:i}:void 0}}},hold:{writable:!0,value:function(){this.local_hold=!0,this.toggleMuteAudio(!0),this.toggleMuteVideo(!0)}},unhold:{writable:!0,value:function(){this.local_hold=!1,this.audioMuted||this.toggleMuteAudio(!1),this.videoMuted||this.toggleMuteVideo(!1)}},getLocalStreams:{writable:!0,value:function(){var e=this.peerConnection;return e&&"closed"===e.signalingState?(this.logger.warn("peerConnection is closed, getLocalStreams returning []"),[]):e.getLocalStreams&&e.getLocalStreams()||e.localStreams||[]}},getRemoteStreams:{writable:!0,value:function(){var e=this.peerConnection;return e&&"closed"===e.signalingState?(this.logger.warn("peerConnection is closed, getRemoteStreams returning this._remoteStreams"),this._remoteStreams):e.getRemoteStreams&&e.getRemoteStreams()||e.remoteStreams||[]}},render:{writable:!0,value:function(t){if(t=t||this.mediaHint&&this.mediaHint.render,!t)return!1;var i={local:"getLocalStreams",remote:"getRemoteStreams"};Object.keys(i).forEach(function(n){var r=i[n],s=this[r]();e.WebRTC.MediaStreamManager.render(s,t[n])}.bind(this))}},hasOffer:{writable:!0,value:function(e){var t="have-"+e+"-offer";return this.peerConnection.signalingState===t}},prepareIceServers:{writable:!0,value:function(e,t){var i=[],n=this.session.ua.configuration;return e=e||n.stunServers,t=t||n.turnServers,[].concat(e).forEach(function(e){i.push({urls:e})}),[].concat(t).forEach(function(e){i.push({urls:e.urls,username:e.username,credential:e.password})}),i}},initPeerConnection:{writable:!0,value:function(t,i){var n=this,r=this.session.ua.configuration;this.onIceCompleted=e.Utils.defer(),this.onIceCompleted.promise.then(function(t){n.emit("iceGatheringComplete",t),n.iceCheckingTimer&&(e.Timers.clearTimeout(n.iceCheckingTimer),n.iceCheckingTimer=null)}),this.peerConnection&&this.peerConnection.close(),this.peerConnection=new e.WebRTC.RTCPeerConnection({iceServers:t},i),this._remoteStreams=[],this.peerConnection.onaddstream=function(e){n.logger.log("stream added: "+e.stream.id),n._remoteStreams.push(e.stream),n.render(),n.emit("addStream",e)},this.peerConnection.onremovestream=function(e){n.logger.log("stream removed: "+e.stream.id)},this.startIceCheckingTimer=function(){n.iceCheckingTimer||(n.iceCheckingTimer=e.Timers.setTimeout(function(){n.logger.log("RTCIceChecking Timeout Triggered after "+r.iceCheckingTimeout+" milliseconds"),n.onIceCompleted.resolve(this)}.bind(this.peerConnection),r.iceCheckingTimeout))},this.peerConnection.onicecandidate=function(e){n.emit("iceCandidate",e),e.candidate?(n.logger.log("ICE candidate received: "+(null===e.candidate.candidate?null:e.candidate.candidate.trim())),n.startIceCheckingTimer()):n.onIceCompleted.resolve(this)},this.peerConnection.onicegatheringstatechange=function(){n.logger.log("RTCIceGatheringState changed: "+this.iceGatheringState),"gathering"===this.iceGatheringState&&n.emit("iceGathering",this),"complete"===this.iceGatheringState&&n.onIceCompleted.resolve(this)},this.peerConnection.oniceconnectionstatechange=function(){var e;switch("checking"===this.iceConnectionState&&n.startIceCheckingTimer(),this.iceConnectionState){case"new":e="iceConnection";break;case"checking":e="iceConnectionChecking";break;case"connected":e="iceConnectionConnected";break;case"completed":e="iceConnectionCompleted";break;case"failed":e="iceConnectionFailed";break;case"disconnected":e="iceConnectionDisconnected";break;case"closed":e="iceConnectionClosed";break;default:return void n.logger.warn("Unknown iceConnection state:",this.iceConnectionState)}n.emit(e,this)},this.peerConnection.onstatechange=function(){n.logger.log('PeerConnection state changed to "'+this.readyState+'"')}}},createOfferOrAnswer:{writable:!0,value:function(t){var i,n=this,r=n.peerConnection;return n.ready=!1,i=n.hasOffer("remote")?"createAnswer":"createOffer",e.Utils.promisify(r,i,!0)(t).then(e.Utils.promisify(r,"setLocalDescription")).then(function(){var t=e.Utils.defer();return"complete"===r.iceConnectionState||"completed"===r.iceConnectionState?t.resolve():n.onIceCompleted.promise.then(t.resolve),t.promise}).then(function(){var t=r.localDescription.sdp;t=e.Hacks.Chrome.needsExplicitlyInactiveSDP(t),t=e.Hacks.AllBrowsers.unmaskDtls(t);var s={type:"createOffer"===i?"offer":"answer",sdp:t};return n.emit("getDescription",s),n.ready=!0,s.sdp})["catch"](function(t){throw n.logger.error(t),n.ready=!0,new e.Exceptions.GetDescriptionError(t)})}},addStreams:{writable:!0,value:function(t){try{t=[].concat(t),t.forEach(function(e){this.peerConnection.addStream(e)},this)}catch(i){return this.logger.error("error adding stream"),this.logger.error(i),e.Utils.Promise.reject(i)}return e.Utils.Promise.resolve()}},toggleMuteHelper:{writable:!0,value:function(e,t){this.getLocalStreams().forEach(function(i){i[e]().forEach(function(e){e.enabled=!t})})}},toggleMuteAudio:{writable:!0,value:function(e){this.toggleMuteHelper("getAudioTracks",e)}},toggleMuteVideo:{writable:!0,value:function(e){this.toggleMuteHelper("getVideoTracks",e)}}}),t}},{}],100:[function(e,t,i){"use strict";t.exports=function(e,t){var i=function(t,i){if(!e.WebRTC.isSupported())throw new e.Exceptions.NotSupportedError("Media not supported");this.mediaHint=i||{constraints:{audio:!0,video:!0}},this.acquisitions={}};return i.streamId=function(e){return e.getAudioTracks().concat(e.getVideoTracks()).map(function(e){return e.id}).join("")},i.render=function(i,n){function r(e,i){if("undefined"!=typeof e.src)t.revokeObjectURL(e.src),e.src=t.createObjectURL(i);else{if("undefined"==typeof(e.srcObject||e.mozSrcObject))return!1;e.srcObject=e.mozSrcObject=i}return!0}function s(t){var i=100;t.ensurePlayingIntervalId=e.Timers.setInterval(function(){t.paused?t.play():e.Timers.clearInterval(t.ensurePlayingIntervalId)},i)}function o(e,i,n){"function"==typeof e&&(e=e());var o=e[n%e.length];(t.attachMediaStream||r)(o,i),s(o)}if(!n)return!1;if(Array.isArray(n)&&!n.length)throw new TypeError("elements must not be empty");n=[].concat(n),[].concat(i).forEach(o.bind(null,n))},i.prototype=Object.create(e.EventEmitter.prototype,{acquire:{writable:!0,value:function(t){t=Object.keys(t||{}).length?t:this.mediaHint;var n=function(t,n){return n=[].concat(n),n.forEach(function(e){var n=i.streamId(e);this.acquisitions[n]=!!t},this),e.Utils.Promise.resolve(n)}.bind(this);if(t.stream)return n(!0,t.stream);var r=t.constraints||this.mediaHint&&this.mediaHint.constraints||{audio:!0,video:!0},s=e.Utils.defer();return e.Timers.setTimeout(function(){this.emit("userMediaRequest",r);var t=function(e,t){var i=Array.prototype.slice.call(arguments,2),n=[e].concat(i);return this.emit.apply(this,n),t.apply(null,i)}.bind(this);
r.audio||r.video?s.resolve(e.WebRTC.getUserMedia(r).then(t.bind(this,"userMedia",n.bind(null,!1)),t.bind(this,"userMediaFailed",function(e){throw e}))):s.resolve([])}.bind(this),0),s.promise}},release:{writable:!0,value:function(e){e=[].concat(e),e.forEach(function(e){var t=i.streamId(e);this.acquisitions[t]===!1&&e.getTracks().forEach(function(e){e.stop()}),delete this.acquisitions[t]},this)}}}),i}},{}],101:[function(e,t,i){(function(i){"use strict";function n(e,t){if(null!=e){var i=t.charAt(0).toUpperCase()+t.slice(1),n=[t,"webkit"+i,"moz"+i];for(var r in n){var s=e[n[r]];if(s)return s.bind(e)}}}var r=i.window||i;t.exports={WebSocket:r.WebSocket,Transport:e("./Transport"),open:r.open,Promise:r.Promise,timers:r,console:r.console||{debug:function(){},log:function(){},warn:function(){},error:function(){}},MediaStream:n(r,"MediaStream"),getUserMedia:n(r.navigator,"getUserMedia"),RTCPeerConnection:n(r,"RTCPeerConnection"),RTCSessionDescription:n(r,"RTCSessionDescription"),addEventListener:n(r,"addEventListener"),HTMLMediaElement:r.HTMLMediaElement,attachMediaStream:r.attachMediaStream,createObjectURL:r.URL&&r.URL.createObjectURL,revokeObjectURL:r.URL&&r.URL.revokeObjectURL}}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./Transport":94}],102:[function(e,t,i){"use strict";t.exports=e("./SIP")(e("./environment"))},{"./SIP":85,"./environment":101}],103:[function(e,t,i){(function(i,n){"use strict";function r(e){if(!(this instanceof r))return new r(e);d.call(this);var t=null,i=null,n=!1,s=null,o=e,a=null,c=null,u=null;Object.defineProperties(this,{_expires:{get:function(){return t},set:function(e){t=e}},_identity:{get:function(){return i},set:function(e){i=e}},_isExpired:{get:function(){return n},set:function(e){n=e}},_pendingUpdate:{get:function(){return s},set:function(e){s=e}},_token:{get:function(){return o},set:function(e){o=e}},_tokenExpiredTimer:{get:function(){return a},set:function(e){a=e}},_tokenUpdatedTimer:{get:function(){return c},set:function(e){c=e}},_tokenPayload:{get:function(){return u},set:function(e){u=e}},expires:{enumerable:!0,get:function(){return t}},identity:{enumerable:!0,get:function(){return i}},isExpired:{enumerable:!0,get:function(){return n}},token:{enumerable:!0,get:function(){return o}}});var l=this.updateToken(e);l["catch"](function(e){this._pendingUpdate===l&&this.emit("error",e)}.bind(this))}function s(e){var t=e.split(".");if(3!==t.length)throw new Error("Token is invalid or malformed");var i=t[1],n=o(i),r=JSON.parse(n);return r}function o(e){var t=e.length%4;if(t>0){var i=4-t;e+=new Array(i+1).join("=")}return e=e.replace(/-/g,"+").replace(/_/g,"/"),a(e)}function a(e){return new n(e,"base64").toString()}function c(e){var t=null;return!e.grants&&e.scope?t=u(e.scope):e.grants instanceof Array?t=l(e.grants):"object"==typeof e.grants&&(t=h(e.grants)),t}function u(e){var t=decodeURIComponent(e).match(/identity=(.*?)(&|$)/i);return t&&decodeURIComponent(t[1])}function l(e){for(var t=null,i=0;i<e.length;i++){var n=e[i];if(n&&"string"==typeof n.res){var r=n.res.match(/^sip:(.*)@/);if(r){t=decodeURIComponent(r[1]);break}}}return t}function h(e){return e.identity||null}var d=e("events").EventEmitter,p=e("util").inherits,f=i.Promise||e("es6-promise").Promise;p(r,d),r.prototype.updateToken=function(e){var t=this,i=new f(function(i){var n=s(e);t._identity=c(n),clearTimeout(t._tokenUpdatedTimer),t._tokenUpdatedTimer=setTimeout(function(){t._tokenUpdatedTimer=null,t.emit("tokenUpdated",t)}),t._expires=new Date(1e3*n.exp),t._isExpired=Date.now()>=t.expires,clearTimeout(t._tokenExpiredTimer),t._tokenExpiredTimer=setTimeout(function(){t._isExpired=!0,t._tokenExpiredTimer=null,t.emit("tokenExpired",t)},t.expires-Date.now()),t._token=e,t._tokenPayload=n,i(t)});return this._pendingUpdate=i,i},t.exports=r}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{},e("buffer").Buffer)},{buffer:58,"es6-promise":105,events:62,util:66}],104:[function(e,t,i){"use strict";t.exports.AccessManager=e("./accessmanager")},{"./accessmanager":103}],105:[function(e,t,i){(function(i,n){(function(){"use strict";function r(e){return"function"==typeof e||"object"==typeof e&&null!==e}function s(e){return"function"==typeof e}function o(e){K=e}function a(e){Z=e}function c(){return function(){i.nextTick(p)}}function u(){return function(){V(p)}}function l(){var e=0,t=new te(p),i=document.createTextNode("");return t.observe(i,{characterData:!0}),function(){i.data=e=++e%2}}function h(){var e=new MessageChannel;return e.port1.onmessage=p,function(){e.port2.postMessage(0)}}function d(){return function(){setTimeout(p,1)}}function p(){for(var e=0;z>e;e+=2){var t=re[e],i=re[e+1];t(i),re[e]=void 0,re[e+1]=void 0}z=0}function f(){try{var t=e,i=t("vertx");return V=i.runOnLoop||i.runOnContext,u()}catch(n){return d()}}function g(e,t){var i=this,n=new this.constructor(v);void 0===n[ae]&&P(n);var r=i._state;if(r){var s=arguments[r-1];Z(function(){U(r,n,s,i._result)})}else D(i,n,e,t);return n}function m(e){var t=this;if(e&&"object"==typeof e&&e.constructor===t)return e;var i=new t(v);return A(i,e),i}function v(){}function _(){return new TypeError("You cannot resolve a promise with itself")}function T(){return new TypeError("A promises callback cannot return that same promise.")}function E(e){try{return e.then}catch(t){return he.error=t,he}}function y(e,t,i,n){try{e.call(t,i,n)}catch(r){return r}}function S(e,t,i){Z(function(e){var n=!1,r=y(i,t,function(i){n||(n=!0,t!==i?A(e,i):b(e,i))},function(t){n||(n=!0,w(e,t))},"Settle: "+(e._label||" unknown promise"));!n&&r&&(n=!0,w(e,r))},e)}function C(e,t){t._state===ue?b(e,t._result):t._state===le?w(e,t._result):D(t,void 0,function(t){A(e,t)},function(t){w(e,t)})}function R(e,t,i){t.constructor===e.constructor&&i===se&&constructor.resolve===oe?C(e,t):i===he?w(e,he.error):void 0===i?b(e,t):s(i)?S(e,t,i):b(e,t)}function A(e,t){e===t?w(e,_()):r(t)?R(e,t,E(t)):b(e,t)}function I(e){e._onerror&&e._onerror(e._result),N(e)}function b(e,t){e._state===ce&&(e._result=t,e._state=ue,0!==e._subscribers.length&&Z(N,e))}function w(e,t){e._state===ce&&(e._state=le,e._result=t,Z(I,e))}function D(e,t,i,n){var r=e._subscribers,s=r.length;e._onerror=null,r[s]=t,r[s+ue]=i,r[s+le]=n,0===s&&e._state&&Z(N,e)}function N(e){var t=e._subscribers,i=e._state;if(0!==t.length){for(var n,r,s=e._result,o=0;o<t.length;o+=3)n=t[o],r=t[o+i],n?U(i,n,r,s):r(s);e._subscribers.length=0}}function O(){this.error=null}function k(e,t){try{return e(t)}catch(i){return de.error=i,de}}function U(e,t,i,n){var r,o,a,c,u=s(i);if(u){if(r=k(i,n),r===de?(c=!0,o=r.error,r=null):a=!0,t===r)return void w(t,T())}else r=n,a=!0;t._state!==ce||(u&&a?A(t,r):c?w(t,o):e===ue?b(t,r):e===le&&w(t,r))}function $(e,t){try{t(function(t){A(e,t)},function(t){w(e,t)})}catch(i){w(e,i)}}function X(){return pe++}function P(e){e[ae]=pe++,e._state=void 0,e._result=void 0,e._subscribers=[]}function x(e){return new _e(this,e).promise}function M(e){var t=this;return new t(J(e)?function(i,n){for(var r=e.length,s=0;r>s;s++)t.resolve(e[s]).then(i,n)}:function(e,t){t(new TypeError("You must pass an array to race."))})}function L(e){var t=this,i=new t(v);return w(i,e),i}function H(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function q(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}function F(e){this[ae]=X(),this._result=this._state=void 0,this._subscribers=[],v!==e&&("function"!=typeof e&&H(),this instanceof F?$(this,e):q())}function j(e,t){this._instanceConstructor=e,this.promise=new e(v),this.promise[ae]||P(this.promise),J(t)?(this._input=t,this.length=t.length,this._remaining=t.length,this._result=new Array(this.length),0===this.length?b(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&b(this.promise,this._result))):w(this.promise,G())}function G(){return new Error("Array Methods must be provided an Array")}function B(){var e;if("undefined"!=typeof n)e=n;else if("undefined"!=typeof self)e=self;else try{e=Function("return this")()}catch(t){throw new Error("polyfill failed because global object is unavailable in this environment")}var i=e.Promise;i&&"[object Promise]"===Object.prototype.toString.call(i.resolve())&&!i.cast||(e.Promise=ve)}var W;W=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)};var V,K,Y,J=W,z=0,Z=function(e,t){re[z]=e,re[z+1]=t,z+=2,2===z&&(K?K(p):Y())},Q="undefined"!=typeof window?window:void 0,ee=Q||{},te=ee.MutationObserver||ee.WebKitMutationObserver,ie="undefined"==typeof self&&"undefined"!=typeof i&&"[object process]"==={}.toString.call(i),ne="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel,re=new Array(1e3);Y=ie?c():te?l():ne?h():void 0===Q&&"function"==typeof e?f():d();var se=g,oe=m,ae=Math.random().toString(36).substring(16),ce=void 0,ue=1,le=2,he=new O,de=new O,pe=0,fe=x,ge=M,me=L,ve=F;F.all=fe,F.race=ge,F.resolve=oe,F.reject=me,F._setScheduler=o,F._setAsap=a,F._asap=Z,F.prototype={constructor:F,then:se,"catch":function(e){return this.then(null,e)}};var _e=j;j.prototype._enumerate=function(){for(var e=this.length,t=this._input,i=0;this._state===ce&&e>i;i++)this._eachEntry(t[i],i)},j.prototype._eachEntry=function(e,t){var i=this._instanceConstructor,n=i.resolve;if(n===oe){var r=E(e);if(r===se&&e._state!==ce)this._settledAt(e._state,t,e._result);else if("function"!=typeof r)this._remaining--,this._result[t]=e;else if(i===ve){var s=new i(v);R(s,e,r),this._willSettleAt(s,t)}else this._willSettleAt(new i(function(t){t(e)}),t)}else this._willSettleAt(n(e),t)},j.prototype._settledAt=function(e,t,i){var n=this.promise;n._state===ce&&(this._remaining--,e===le?w(n,i):this._result[t]=i),0===this._remaining&&b(n,this._result)},j.prototype._willSettleAt=function(e,t){var i=this;D(e,void 0,function(e){i._settledAt(ue,t,e)},function(e){i._settledAt(le,t,e)})};var Te=B,Ee={Promise:ve,polyfill:Te};"function"==typeof define&&define.amd?define(function(){return Ee}):"undefined"!=typeof t&&t.exports?t.exports=Ee:"undefined"!=typeof this&&(this.ES6Promise=Ee),Te()}).call(this)}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{_process:64}],106:[function(e,t,i){t.exports={name:"twilio-conversations",title:"Twilio Conversations",description:"Twilio Conversations JavaScript library",version:"0.13.6",homepage:"https://twilio.com",author:"Mark Andrus Roberts <mroberts@twilio.com>",contributors:["Ryan Rowland <rrowland@twilio.com>"],keywords:["twilio","webrtc","library","javascript","conversations"],repository:{type:"git",url:"https://github.com/twilio/twilio-conversations.git"},devDependencies:{browserify:"^9.0.3",cheerio:"^0.18.0",del:"^2.0.2",eslint:"^1.8.0",gulp:"^3.9.0","gulp-insert":"^0.5.0","gulp-istanbul":"^0.10.3","gulp-mocha":"^2.2.0","gulp-newer":"^1.0.0","gulp-rename":"^1.2.2","gulp-replace":"^0.5.4","gulp-uglify":"^1.4.2","gulp-util":"^3.0.7",jsdoc:"https://github.com/jsdoc3/jsdoc.git#e2fd9e75de9617aadfc3120331f020b2d66cff86",jshint:"^2.6.3","jshint-stylish":"^1.0.0",mkdirp:"^0.5.1",mocha:"^2.2.5","mock-browser":"^0.91.34",promptly:"^0.2.0","release-tool":"^0.2.2","run-sequence":"^1.1.4",sinon:"^1.15.3","stream-from-promise":"^0.1.0",through2:"^2.0.0",twilio:"^2.8.0","vinyl-source-stream":"^1.1.0"},engines:{node:">=0.12"},license:"BSD-3-Clause",main:"./lib/index.js",scripts:{test:"gulp test"},dependencies:{"sip.js":"https://github.com/twilio/SIP.js.git#342d3b78e2922adf6ff51e5b6efc804b92566b0d","twilio-common":"^0.1.4",ws:"^0.6.3",xmlhttprequest:"^1.8.0"},browser:{xmlhttprequest:"./src/xmlhttprequest.js"}}},{}],107:[function(e,t,i){i.XMLHttpRequest=window.XMLHttpRequest},{}]},{},[1]);return t(e)}();if("function"==typeof define&&define.amd)define([],function(){return t});else{var i=e.Twilio=e.Twilio||{};i.Conversations=i.Conversations||t}}("undefined"!=typeof window?window:"undefined"!=typeof global?global:this);